# include "stdio.h"
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
extern int yylook();
#ifdef __cplusplus
extern "C" {
#endif
extern int yywrap();
extern int yylex();
extern int yyreject();
extern int yyracc(int);
extern int yyless(int);
#ifdef __cplusplus
}
#endif
/* ----------------------------------------------------------------------------------
   Description : Routine to process raw f2c translated files. This routine generates
   macros for vectors and matrices, and also changes the K&R argument list
   so that arrays are changed from * notation to [] notation.

   It is used in conjunction with the yacc routine yacc_for_tool.y

   Note : It is assumed that the files have Nag type names.


   The following script can be used to process all the *[et].f files in the
   current directory :

===========================================================================================

#!/bin/sh
#------------------------------------------------------
# process all the x04 routines in the fortran library
#------------------------------------------------------

fortran_preprocess.exe  "name_list.dat" *[et].f

#-----------------------------------------------------
# Now f2c, do macro-processing and compile.
#-----------------------------------------------------
for k in *[et].f
do
   fname=`basename $k '\.f'`
   echo "-----"
   f2c ${fname}_c.f
   rm ${fname}_c1.f 
   echo "macro processing ${fname}"
   substitute_locals.exe < ${fname}_c.c > gtemp2_${fname}.c
   test_tool.exe gtemp2_${fname}.c | comment1.exe | comment2.exe > gl_${fname}.c
   echo "compiling gl_${fname}.c"
   cc -c gl_${fname}.c
   rm gtemp2_${fname}.c ${fname}_c.c 
   echo "-----"
done
===========================================================================================

   ----------------------------------------------------------------------------------
   Author : George Levy                      Date : 28/2/1994
   ----------------------------------------------------------------------------------- */

#include <string.h>
#include <stdio.h>
#include <ctype.h>

char *output_upper(char *name);

int i, j, k, l, state;

static struct vec_type {
  char name[80];
  char dim[20];
  char local_array;
} vector_table[100];

static struct mat_type {
  char name[80];
  char leading_dim[20];
  char local_array;
} matrix_table[100];

static struct no_process_type {
  char name[80];
} no_process_list[100];

char lex_buf[400];
char char_names[40][15];
static char array_name[80];
static char temp_array_name[80];
int no_process_index = 0;
int char_index = 0;
int vec_index = 0;
int mat_index = 0;
int bra_count;
int not_param_adjustments = 0;
#define USE_ADJUSTMENTS 0
#define USE_DECLARATION 1
#define YYLMAX 30000
# define PARAM 2
# define VECTOR 4
# define MATRIX 6
# define LOCALS 8
# define BODY 10
# define HEADER 12
# define NO_PROCESS_TABLE 14
# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:
{
   BEGIN NO_PROCESS_TABLE;
}
break;
case 2:
{
  if(!strstr(yytext,"773678 End of C tool no_process")) {
    if (!second_pass) {
      i = 0;
      while(!isalnum(yytext[i])) ++i;
      j = 0;
      while (isalnum(yytext[i])) {
       no_process_list[no_process_index].name[j] = tolower(yytext[i]);
        ++i;
        ++j;
      }
      no_process_list[no_process_index].name[j] = '\0';
      ++no_process_index;
     }
  }
  else {
    REJECT;
   }
 }
break;
case 3:
{
   BEGIN 0;
}
break;
case 4:
{

        BEGIN HEADER;

        if (second_pass) {
          printf("%s",yytext);
        }

     }
break;
case 5:
{

      BEGIN HEADER;

      if (second_pass) {
        printf("%s",yytext);
      }
      ;
     }
break;
case 6:
{

      if (second_pass) {
        printf("%s",yytext);
      }

      ;

     }
break;
case 7:
{
        /* just echo char arguments but also load name into array
         * because won't create macros for any char variables.
         */

        if (!second_pass) {
          load_char_types ();
        }
        else
          ECHO;

       }
break;
case 8:
{

        if (second_pass) create_brackets(yytext);

       }
break;
case 9:
{

        if (second_pass) create_brackets(yytext);

       }
break;
case 10:
{

        if (second_pass) create_brackets(yytext);

       }
break;
case 11:
{

       if (second_pass) ECHO;
       BEGIN 0;

      }
break;
case 12:
{

     BEGIN 0;
     BEGIN LOCALS;     
    }
break;
case 13:
{
        /* System locals */

      /*  printf("\n found start of locals section \n"); */
         if(second_pass) {
           strcpy(yylval.buf, yytext);
           return(OTHER);
         }
       }
break;
case 14:
{
          
          if(second_pass) printf("%s\n",yytext);

          BEGIN 0;
          BEGIN PARAM;
       }
break;
case 15:
{

        if (not_param_adjustments) {

          /* printf("Executable Statements Section found (no Parameter Adjustments) \n"); */
           if(second_pass) ECHO;
            BEGIN 0;
            BEGIN BODY;
        }
        else {
           if(second_pass) ECHO;
        }

       }
break;
case 16:
{
        /* In parameter adjustments section. Can use the information here
           to work out the vectors and matrices contained in the routine. */

        if (strstr(yytext, "Function Body */")) {

          if (!second_pass) {
            fseek(file,0L,SEEK_SET);
            second_pass = 1;
            BEGIN 0;
          }

          else {
            BEGIN 0;
            BEGIN BODY;
            ECHO;
            define_macros();

          }

        }
        else 
        {

       /* ECHO; */
          i = 0;
          while(!isalnum(yytext[i])) ++i;
          k = i;
          while(isalnum(yytext[i])) ++i;

          l = 0;
          for (j = k;j < i; ++j) {
            array_name[l] = yytext[j];
            ++l;
          }
         
          array_name[l] = '\0';

          if(lookup_char_types(array_name) || lookup_no_process(array_name)){
             if (second_pass) {
               ECHO;             
             }
           }
           else {
             if (!second_pass) create_tables(USE_ADJUSTMENTS);
           }
	 }

      /*  printf("In parameter adjustments section \n");  */
      /*
         strcpy(yylval.buf, yytext);
         return(OTHER); */

      }
break;
case 17:
{
        /* Comment statement in locals area */

        if(second_pass) {
          ECHO;
         }

       }
break;
case 18:
{
        /* General comment statement */

         if(second_pass) {
           ECHO;
         }

       }
break;
case 19:
{

        if(second_pass) ECHO;

       }
break;
case 20:
{
        /* In local doublereal declaration section. */

        if(second_pass) ECHO;

        if(strstr(yytext,"[") && (!strstr(yytext,"__"))) { 

     /*      printf("local double array declaration found \n");   */
           if (!second_pass) create_tables(USE_DECLARATION);
        }


       }
break;
case 21:
{
        /* In local integer declaration section. */

        if(second_pass) ECHO;

        if(strstr(yytext,"[") && (!strstr(yytext,"__"))) { 

           if(!second_pass) create_tables(USE_DECLARATION);
        }


       }
break;
case 22:
{ /* select start of array statement */

        strcpy(array_name, yytext);
        bra_count = 1;        

        if(lookup_vector(array_name))  /* have a vector */
        {
         /* create vector macro here because it should be easy */

        i = 0;
        while (array_name[i] != '[') {
          lex_buf[i] = toupper(array_name[i]);
          ++i;
        }
        lex_buf[i] = '\0';
        strcat(lex_buf,"(");
        printf("%s",lex_buf);         

         /* printf("have found the C representation of an f77 vector \n");  */
        /*  ECHO; */

         BEGIN 0;
         BEGIN VECTOR;

        }

        else if(lookup_matrix(array_name))
 
           /* matrix recognized from parameter adjustment */

        {    

    /*      ECHO; */

         if(!strstr(array_name,"__")) /* ignore system generated arrays */
            BEGIN MATRIX;
          else
            ECHO;
  
        }

        else  {
  
             /* not recognized as either a matrix or vector 
                from parameter adjustment section so simply echo. */

          ECHO;

        }

    }
break;
case 23:
{ 

      strcpy(yylval.buf, yytext);

      if(strstr(yytext,"_dim1")) { 

         /* have found leading dimension variable _dim1 */

         return(LEADING_DIMENSION); 

      }

      else if(strstr(yytext,"_offset")) { 

         /* have found variable _offset */

         return(OFFSET); 
      }
      else { 

         /* have found another expression */

         return(INDEX_VARIABLE);  

      }

    }
break;
case 24:
{ 

      /* have found a function macro */

      strcpy(yylval.buf, yytext);

      return(FUNCTION_MACRO);  

    }
break;
case 25:
{ 

      /* matrix index is an array element so just treat like a 
       * function macro, but do macro substitution if a vector.
       */

      i = 0;
      while (yytext[i] != '[') {
        temp_array_name[i] = yytext[i];
        ++i;
      }
      temp_array_name[i] = '[';
      ++i;
      temp_array_name[i] = '\0';

      if(lookup_vector(temp_array_name)) {
    
        /* have a vector index */
    
        for (i = 0; i < strlen(temp_array_name)-1; ++i) {
          yytext[i] = toupper(temp_array_name[i]);
        }
        yytext[i] = '(';
        yytext[yyleng-1] = ')';
      }

      strcpy(yylval.buf, yytext);

      return(FUNCTION_MACRO);  

    }
break;
case 26:
{ 
       return(PLUS); 
    }
break;
case 27:
{ 
       return(MINUS); 
    }
break;
case 28:
{ 
       return(DIVIDE); 
    }
break;
case 29:
{ 
       return(TIMES); 
    }
break;
case 30:
{ 
       return(C_SHIFT); 
    }
break;
case 31:
{ 
       return(OPEN_BRACKET); 
    }
break;
case 32:
{ 
       return(CLOSE_BRACKET); 
    }
break;
case 33:
{  /*   have found end of matrix */
       BEGIN 0;
       BEGIN BODY; 
       strcpy(yylval.buf, yytext);

       return(END_MATRIX); 

    }
break;
case 34:
{ /* skip spaces, tabs and new lines */
     ;
    }
break;
case 35:
{ /* a vector with an array index
                           e.g. a sparse vector */

   ++bra_count;
   strcpy(array_name, yytext);

   if(lookup_vector(array_name))  /* have a vector */
   {
     /* create vector macro here because it should be easy */

    i = 0;
    while (array_name[i] != '[') {
     lex_buf[i] = toupper(array_name[i]);
     ++i;
    }
    lex_buf[i] = '\0';
    strcat(lex_buf,"(");
    printf("%s",lex_buf);         
   }
   else {

    ECHO;

   }

}
break;
case 36:
{   /* any character in vector */
    
      if(strstr(yytext,"]")) {
        --bra_count;
        printf(")");
        
        if(!bra_count) {
          BEGIN 0;
          BEGIN BODY;
        }

      }
      else
        ECHO;

    }
break;
case 37:
  {
     if(second_pass) {
       strcpy(yylval.buf, yytext);
       return(OTHER);
     }
     ;

    }
break;
case 38:
  {
       if(second_pass) {
         strcpy(yylval.buf, yytext);
         return(OTHER);
       }
       ;

    }
break;
case -1:
break;
default:
fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
 
create_tables(int call_type)
{
 /* ------------------------------------------------------------------------

    Note : Looks in the parameter adjustment section and then
    creates a table of array names  the format is "array_name["  i.e d1[
    etc. This is so that can easily look up array from the pattern match 

   --------------------------------------------------------------------------
*/

char *ptr, *ptr1;
char *null = (char *)0;
char buf[80];
int i,k;

   buf[0] = '\0';

   if(call_type == USE_ADJUSTMENTS) { /* then in parameter adjustment section */

    /* deal with vectors  - i.e put them in the vector_table array */

    if (ptr = strstr(yytext, "--")) {
      ptr = strtok(ptr,"-; ");
   
      strcpy(vector_table[vec_index].name, strcat(ptr,"["));
      vec_index++;
    }

  /*   deal with matrices   - i.e put them in the matrix_table array  */

    if (strstr(yytext, "_dim1") && !strstr(yytext, "_offset")) {

      ptr = strtok(yytext," _=;");
      strcpy(lex_buf,ptr);
      
      ptr = strtok(null,"=;");
      ptr = strtok(null,";");

      strcpy(matrix_table[mat_index].name, strcat(lex_buf,"["));
      strcpy(matrix_table[mat_index].leading_dim, ptr);
      matrix_table[mat_index].local_array = 'F';      
    
      mat_index++;

    }

  }
  else { /* in array declaration section */

      ptr = strtok(yytext," ");
      ptr = strtok(null," ");

      while (ptr) {

       if ((ptr) && strstr(ptr,"/*") && strstr(ptr,"*/") && strstr(ptr,"was")) 
       {
         /* have matrix declaration .... code needs to be included */

        ;

      /*  printf("have matrix declaration token is >>%s<<\n",ptr); */

       }

       else if ((ptr) && strstr(ptr,"["))
       {
       
        k = 0;
        for (i = 0; i < strlen(ptr); ++i) 
          if (!isspace(ptr[i])) {
             buf[k] = ptr[i];
            ++k;
          }

        buf[k] = '\0';

        /* put the vector name in vector_table */

         k = 0;
         while(buf[k] != '[') {
           vector_table[vec_index].name[k] = buf[k];
           ++k;
         }
         vector_table[vec_index].name[k] = '[';
         vector_table[vec_index].name[k+1] = '\0';
         vector_table[vec_index].local_array = 'T';     

         
    /*  printf("vector local decl vector_table  is >>%s<<\n",vector_table[vec_index].name);
        printf("vector local_array is >>%c<<\n",vector_table[vec_index].local_array);
    */

         vec_index++;
       }
    
       ptr = strtok(null,",;");

     }
  }

}

/* ---------------------------------------------------------------------- */

int lookup_vector(char *name)
{

int i;

  /* search through table to see if have a vector  */

/*  printf("in vector_table name is >>%s<<  \n",name); */

  for (i = 0; i < vec_index; ++i) {
   /*  printf("searching vector_table >>%s<<  \n",vector_table[i].name); */
     if (!strcmp(vector_table[i].name,name)) return 1;
  }

  return 0;

}


/* ---------------------------------------------------------------------- */

int lookup_matrix(char *name)
{

int i;

  /* search through table to see if have a matrix  */

/*  printf("in matrix_table name is >>%s<<  \n",name); */

  for (i = 0; i < mat_index; ++i) {
   /*  printf("searching matrx_table >>%s<<  \n",matrix_table[i].name); */
     if (!strcmp(matrix_table[i].name,name)) return 1;
  }

  return 0;

}

/* ---------------------------------------------------------------------- */

int define_macros()
{

int i;

  /* output vector macros  */

  for (i = 0; i < vec_index; ++i) {
    printf("\n#define %s(I) ",output_upper(vector_table[i].name));

    if (vector_table[i].local_array == 'T')
       printf("%s(I)]",vector_table[i].name);
    else 
       printf("%s(I)-1]",vector_table[i].name);

  }
  printf("\n");

  /* output matrix macros  */

  for (i = 0; i < mat_index; ++i) {
    printf("\n#define %s(I,J) ",output_upper(matrix_table[i].name));
    printf("%s(I)-1 + ((J)-1)* ",matrix_table[i].name);
    printf("(%s)]",matrix_table[i].leading_dim);
  }
  printf("\n");

  return 0;

}

/* ---------------------------------------------------------------------- */

char* output_upper(char *name)
{

int i;

  /* change string to upper case  */
  i = 0;
  while (name[i] != '[') {
   lex_buf[i] = toupper(name[i]);
   ++i;
  }

  lex_buf[i] = '\0';

  return lex_buf;

}

/* ----------------------------------------------------------- */

int create_brackets(char *arg_list)
{

char search_name[100];
char temp_name[100];
char *null = (char *)0;
char *ptr;
int i,k;

   /* printf("in create_brackets \n"); */

   ptr = strtok(arg_list," ");
   printf("%s ",ptr);
   ptr = strtok(null,";,");

   while (ptr) {

     
    /* printf("ptr is >>%s<<\n",ptr);  */

     if(!strstr(ptr,"(")) { 
    
      /* then not a function argument */
   
       k = 0;
       for (i=0; i < strlen(ptr); ++i) {
         if((!isspace(ptr[i])) && (ptr[i] != '*')) {
           search_name[k] = ptr[i];
           ++k;
         }
       }   

       search_name[k] = '\0';     
       strcpy(temp_name, search_name);

       if(lookup_matrix(strcat(temp_name,"["))) {

         printf("%s[]",search_name);
       }
       else if (lookup_vector(temp_name)) {
 
         printf("%s[]",search_name);

       }
       else 
         printf("*%s",search_name);
     }
     else {
 
       /* a function argument so just print it unchanged */

         printf("%s",ptr);
     }


     ptr = strtok(null,";,");

     if (ptr) 
       printf(", ");
     else
       printf(";");

   }


}

/* ----------------------------------------------------------- */

int load_char_types ()

{

 char buf[80];
 char *null = (char *)0;
 char *ptr;
 int k;

  /* load char_names array (from function argument list) */

  ptr = strtok(yytext," ");
  ptr = strtok(null,",; ");

  while(ptr) {
    k = 0;
    for (i = 0; i < strlen(ptr); ++i)
      if(!isspace(ptr[i]) && (ptr[i] != '*')) {
        buf[k] = ptr[i];
        ++k;
      }

     buf[k] = '\0';
   /*  printf("buf is >>%s<<\n",buf); */
     strcpy(char_names[char_index],buf);
     ptr = strtok(null,";,");
   
     ++char_index;
 }

/* for (k = 0; k < char_index; ++k)
     printf(">>%s<<",char_names[k]);
 */


}

/* ----------------------------------------------------------- */

int lookup_char_types(char *name)
{

int i;

  /* search through table to see if have a char type  */

  for (i = 0; i < char_index; ++i) {
   /*  printf("searching char_names >>%s<<  \n",char_names[i]); */
     if (!strcmp(char_names[i],name)) return 1;
  }

  return 0;

}

/* ----------------------------------------------------------- */

int lookup_no_process(char *name)
{

int i;

  /* search through table to see should not process  */

  for (i = 0; i < no_process_index; ++i) {
   /*  printf("searching no_process >>%s<<  \n",no_process_list[i].name); */
     if (!strcmp(no_process_list[i].name,name)) return 1;
  }

  return 0;

}

int yyvstop[] = {
0,

34,
0,

34,
0,

34,
-16,
0,

34,
-16,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

34,
0,

37,
0,

38,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
-16,
0,

16,
38,
0,

37,
-16,
0,

37,
-16,
0,

37,
-16,
0,

37,
-16,
0,

37,
-16,
0,

37,
-16,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

36,
37,
0,

34,
37,
0,

34,
38,
0,

31,
37,
0,

32,
37,
0,

29,
37,
0,

26,
37,
0,

27,
37,
0,

23,
37,
0,

28,
37,
0,

23,
37,
0,

37,
0,

33,
37,
0,

23,
37,
0,

23,
37,
0,

23,
37,
0,

23,
37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

11,
37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

37,
0,

-16,
0,

16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

35,
0,

34,
0,

34,
0,

23,
0,

23,
0,

30,
0,

23,
0,

23,
0,

23,
0,

23,
0,

22,
0,

2,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

23,
0,

23,
0,

23,
0,

23,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

25,
0,

25,
0,

24,
0,

24,
0,

23,
0,

23,
0,

23,
0,

23,
0,

17,
0,

18,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

23,
0,

23,
0,

23,
0,

23,
0,

17,
0,

18,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

23,
0,

23,
0,

23,
0,

23,
0,

7,
0,

7,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

23,
0,

23,
0,

23,
0,

23,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

16,
0,

-16,
0,

-16,
0,

23,
0,

23,
0,

19,
0,

-19,
0,

2,
0,

6,
0,

6,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

6,
-16,
0,

-16,
0,

-16,
0,

23,
0,

23,
0,

21,
0,

21,
0,

-19,
0,

8,
0,

8,
0,

9,
0,

9,
0,

6,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

23,
0,

23,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

23,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

23,
0,

20,
0,

20,
0,

-19,
0,

10,
0,

10,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

16,
0,

-16,
0,

23,
0,

21,
0,

-19,
0,

8,
0,

9,
0,

2,
0,

-5,
0,

-5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-5,
-16,
0,

-16,
0,

-5,
0,

-5,
0,

21,
0,

-19,
0,

-5,
0,

-5,
0,

8,
0,

-5,
0,

-5,
0,

9,
0,

-5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

16,
0,

-16,
0,

-16,
0,

17,
0,

21,
0,

21,
0,

-19,
0,

18,
0,

8,
0,

8,
0,

9,
0,

9,
0,

2,
0,

5,
0,

5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

5,
-16,
0,

-16,
0,

-16,
0,

20,
0,

5,
0,

5,
0,

-19,
0,

10,
0,

5,
0,

5,
0,

5,
0,

5,
0,

5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-5,
0,

-5,
0,

20,
0,

-19,
0,

-5,
0,

-5,
0,

10,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

20,
0,

20,
0,

-19,
0,

10,
0,

10,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

5,
0,

5,
0,

-19,
0,

5,
0,

5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

12,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

12,
-16,
0,

-16,
0,

-16,
0,

-16,
0,

12,
17,
0,

-19,
0,

12,
18,
0,

12,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

2,
0,

-4,
0,

-4,
0,

-16,
0,

-16,
0,

-16,
0,

-4,
-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-4,
0,

17,
0,

-19,
0,

-4,
0,

18,
0,

-4,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

17,
0,

14,
17,
0,

-19,
0,

18,
0,

2,
0,

4,
0,

4,
0,

-16,
0,

-16,
0,

-16,
0,

4,
-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

4,
0,

17,
0,

-19,
0,

4,
0,

18,
0,

4,
0,

13,
0,

13,
16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

17,
0,

17,
0,

-19,
0,

18,
0,

18,
0,

2,
13,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
0,

-19,
0,

13,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
0,

25,
0,

13,
0,

24,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
0,

15,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

13,
0,

7,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

3,
0,

13,
0,

6,
0,

-16,
0,

3,
16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
16,
0,

-16,
0,

6,
-16,
0,

-16,
0,

-16,
0,

3,
0,

17,
0,

13,
0,

21,
0,

13,
19,
0,

-19,
0,

3,
0,

18,
0,

13,
0,

8,
0,

13,
0,

9,
0,

2,
3,
0,

2,
13,
0,

6,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

1,
0,

-16,
0,

-16,
0,

1,
16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

1,
0,

17,
0,

-19,
0,

1,
0,

18,
0,

1,
2,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
0,

20,
0,

-19,
0,

13,
0,

10,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

13,
0,

-5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
16,
0,

-5,
-16,
0,

-16,
0,

13,
0,

-5,
0,

21,
0,

-19,
0,

13,
0,

-5,
0,

8,
0,

13,
0,

-5,
0,

9,
0,

2,
13,
0,

-5,
0,

13,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
16,
0,

-16,
0,

-16,
0,

13,
0,

21,
0,

-19,
0,

13,
0,

8,
0,

13,
0,

9,
0,

2,
13,
0,

5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

5,
-16,
0,

-16,
0,

-16,
0,

5,
0,

-19,
0,

5,
0,

5,
0,

5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
0,

-5,
0,

20,
0,

-19,
0,

13,
0,

-5,
0,

10,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
0,

20,
0,

-19,
0,

13,
0,

10,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

5,
0,

-19,
0,

5,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

17,
0,

-19,
0,

18,
0,

13,
0,

-4,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
16,
0,

-4,
-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
0,

-4,
0,

-19,
0,

13,
0,

-4,
0,

2,
13,
0,

-4,
0,

13,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

13,
16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

17,
0,

13,
0,

-19,
0,

18,
0,

13,
0,

2,
13,
0,

4,
0,

-16,
0,

-16,
0,

-16,
0,

4,
-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

4,
0,

-19,
0,

4,
0,

4,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-19,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

17,
0,

-19,
0,

18,
0,

3,
13,
0,

3,
13,
16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

3,
13,
0,

3,
13,
0,

2,
3,
13,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

17,
0,

18,
0,

1,
13,
0,

-16,
0,

1,
13,
16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

1,
13,
0,

1,
13,
0,

1,
2,
13,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,

-16,
0,
0};
# define YYTYPE int
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,17,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,17,	1,18,	
0,0,	0,0,	0,0,	0,0,	
0,0,	19,82,	19,0,	20,0,	
0,0,	0,0,	27,91,	0,0,	
22,0,	0,0,	21,0,	0,0,	
0,0,	3,25,	33,0,	0,0,	
23,0,	36,0,	24,0,	0,0,	
1,17,	3,25,	3,26,	0,0,	
34,82,	34,0,	1,17,	1,19,	
0,0,	1,17,	74,133,	1,17,	
1,20,	1,17,	19,81,	20,83,	
2,19,	0,0,	4,27,	27,90,	
22,81,	2,20,	21,81,	4,28,	
1,17,	28,92,	33,81,	3,25,	
23,81,	36,83,	24,81,	30,90,	
0,0,	3,25,	3,27,	31,90,	
3,25,	34,81,	3,25,	3,28,	
3,25,	29,90,	32,90,	74,132,	
75,134,	41,103,	41,104,	88,90,	
42,104,	42,104,	77,132,	3,25,	
76,132,	130,132,	0,0,	78,132,	
94,90,	90,91,	1,17,	9,57,	
1,17,	5,33,	1,17,	0,0,	
9,58,	1,21,	1,22,	79,132,	
95,90,	5,33,	1,23,	42,104,	
152,90,	1,24,	2,21,	2,22,	
4,29,	4,30,	41,81,	2,23,	
43,0,	4,31,	2,24,	93,90,	
4,32,	3,25,	6,33,	3,25,	
1,17,	3,25,	90,90,	21,84,	
3,29,	3,30,	6,33,	5,33,	
23,86,	3,31,	22,85,	24,87,	
3,32,	5,33,	5,34,	31,95,	
5,33,	44,0,	5,35,	5,36,	
5,35,	30,94,	29,93,	32,96,	
43,81,	45,82,	45,0,	3,25,	
46,0,	9,59,	9,22,	5,33,	
6,33,	76,135,	9,60,	78,137,	
47,0,	9,24,	6,33,	6,34,	
77,136,	6,33,	94,150,	6,35,	
6,36,	6,35,	49,0,	152,215,	
79,138,	44,81,	7,41,	7,42,	
10,61,	51,0,	95,151,	10,17,	
6,33,	206,90,	45,81,	10,57,	
46,81,	52,0,	238,311,	96,90,	
10,58,	5,33,	209,90,	5,35,	
47,81,	5,35,	93,149,	146,90,	
5,37,	5,38,	13,19,	8,41,	
8,42,	5,39,	49,83,	13,20,	
5,40,	7,43,	7,44,	7,45,	
7,46,	51,81,	7,47,	7,48,	
7,49,	7,50,	6,33,	195,132,	
6,35,	52,81,	6,35,	5,33,	
136,132,	6,37,	6,38,	14,19,	
241,172,	7,51,	6,39,	51,109,	
14,20,	6,40,	8,43,	8,44,	
8,45,	8,46,	135,132,	8,47,	
8,48,	8,49,	8,50,	57,114,	
57,0,	10,59,	10,22,	58,0,	
6,33,	60,0,	10,60,	11,19,	
96,152,	10,24,	8,51,	91,91,	
11,62,	11,63,	206,281,	13,68,	
13,69,	13,22,	7,52,	209,284,	
7,50,	13,70,	7,50,	12,19,	
13,71,	7,53,	7,54,	59,0,	
12,62,	12,63,	7,55,	62,0,	
57,81,	7,56,	146,206,	58,115,	
35,0,	60,81,	195,270,	13,72,	
14,68,	14,69,	14,22,	8,52,	
91,90,	8,50,	14,70,	8,50,	
72,0,	14,71,	8,53,	8,54,	
80,0,	15,73,	136,193,	8,55,	
61,0,	132,133,	8,56,	59,81,	
11,63,	15,73,	11,63,	62,119,	
14,72,	11,64,	11,65,	16,73,	
35,81,	135,192,	11,66,	69,0,	
35,97,	11,67,	35,97,	16,73,	
12,63,	87,0,	12,63,	249,322,	
72,81,	12,64,	12,65,	70,0,	
80,81,	91,146,	12,66,	15,73,	
61,81,	12,67,	132,132,	81,82,	
81,0,	15,73,	15,74,	98,0,	
15,73,	37,0,	15,73,	15,75,	
15,73,	16,73,	109,0,	69,81,	
71,0,	60,117,	38,0,	16,73,	
16,74,	87,81,	16,73,	15,73,	
16,73,	16,75,	16,73,	70,81,	
68,0,	35,98,	82,82,	82,0,	
137,132,	35,97,	84,0,	35,97,	
81,81,	16,73,	85,0,	98,81,	
59,116,	37,81,	121,0,	252,180,	
213,90,	37,97,	109,81,	37,97,	
71,81,	116,0,	38,81,	138,132,	
103,103,	103,104,	38,97,	585,90,	
38,97,	15,73,	61,118,	15,73,	
68,81,	15,73,	637,132,	82,81,	
15,76,	15,77,	84,81,	189,132,	
17,80,	15,78,	85,81,	16,73,	
15,79,	16,73,	121,81,	16,73,	
17,80,	17,0,	16,76,	16,77,	
25,88,	116,81,	87,145,	16,78,	
69,127,	103,81,	16,79,	15,73,	
25,88,	25,89,	37,98,	149,90,	
170,170,	150,90,	37,97,	70,128,	
37,97,	39,0,	40,0,	38,98,	
129,0,	16,73,	17,80,	38,97,	
82,139,	38,97,	137,194,	48,0,	
17,80,	17,81,	37,99,	17,80,	
138,195,	17,80,	25,88,	17,80,	
213,288,	71,129,	86,0,	50,0,	
25,88,	25,90,	68,126,	25,88,	
170,238,	25,88,	17,80,	25,88,	
38,100,	39,81,	40,81,	53,0,	
129,81,	39,97,	40,97,	39,97,	
40,97,	133,133,	25,88,	48,81,	
159,222,	84,142,	92,147,	48,105,	
85,143,	48,105,	189,261,	149,212,	
63,0,	50,107,	86,81,	50,81,	
150,213,	207,90,	212,90,	50,105,	
116,173,	50,108,	83,140,	83,0,	
17,80,	53,107,	17,80,	53,81,	
17,80,	92,148,	207,282,	53,105,	
282,90,	53,108,	133,132,	54,0,	
25,88,	159,159,	25,88,	92,90,	
25,88,	282,356,	39,98,	40,98,	
63,81,	83,141,	39,97,	40,97,	
39,97,	40,97,	63,120,	55,0,	
48,106,	268,132,	17,80,	83,81,	
48,105,	129,188,	48,105,	208,90,	
151,90,	39,101,	56,0,	40,102,	
50,106,	54,107,	25,88,	54,81,	
50,108,	64,0,	50,108,	54,105,	
65,0,	54,108,	118,0,	133,189,	
53,106,	66,0,	860,939,	877,951,	
53,108,	55,107,	53,108,	55,81,	
212,287,	117,0,	67,0,	55,105,	
86,144,	55,108,	286,90,	97,0,	
56,107,	63,121,	56,81,	162,227,	
53,110,	63,120,	56,105,	63,120,	
56,108,	64,81,	128,0,	100,0,	
65,81,	178,178,	118,81,	64,120,	
145,0,	66,81,	65,120,	114,114,	
114,0,	233,172,	127,0,	66,120,	
54,106,	117,81,	67,81,	151,214,	
54,108,	208,283,	54,108,	97,81,	
67,120,	268,342,	233,305,	97,97,	
162,162,	97,97,	356,90,	286,360,	
55,106,	192,132,	128,81,	100,81,	
55,108,	178,249,	55,108,	100,97,	
145,81,	100,97,	356,425,	56,106,	
114,81,	54,111,	127,81,	56,108,	
114,167,	56,108,	64,121,	55,112,	
73,130,	65,121,	64,120,	235,172,	
64,120,	65,120,	66,121,	65,120,	
73,130,	73,131,	66,120,	56,113,	
66,120,	118,175,	99,0,	67,121,	
215,90,	101,0,	64,122,	67,120,	
97,98,	67,120,	142,0,	193,132,	
97,97,	66,124,	97,97,	102,0,	
105,0,	147,147,	65,123,	194,132,	
100,98,	114,139,	73,130,	67,125,	
100,97,	192,267,	100,97,	117,174,	
73,130,	73,132,	139,0,	73,130,	
134,190,	73,130,	99,81,	73,130,	
108,0,	101,81,	99,97,	145,205,	
99,97,	101,97,	142,81,	101,97,	
128,187,	100,154,	73,130,	102,81,	
105,81,	143,0,	147,90,	102,97,	
105,105,	102,97,	105,105,	134,191,	
144,0,	127,186,	234,172,	211,90,	
235,307,	215,290,	139,81,	147,207,	
245,180,	134,132,	108,107,	270,132,	
108,81,	261,132,	193,268,	246,180,	
108,105,	185,0,	108,108,	147,208,	
147,209,	245,317,	194,269,	211,286,	
73,130,	143,81,	73,130,	99,98,	
73,130,	106,157,	101,98,	99,97,	
144,81,	99,97,	101,97,	147,210,	
101,97,	106,157,	106,158,	894,966,	
102,98,	105,106,	142,202,	110,0,	
102,97,	105,105,	102,97,	105,105,	
107,160,	185,81,	214,90,	202,0,	
102,156,	99,153,	73,130,	101,155,	
107,160,	107,161,	111,0,	140,140,	
140,0,	108,106,	499,90,	106,157,	
234,306,	108,108,	167,0,	108,108,	
270,344,	106,157,	106,159,	112,0,	
106,157,	110,107,	106,157,	110,81,	
106,157,	246,318,	113,0,	110,105,	
220,0,	110,108,	107,160,	202,81,	
143,203,	139,196,	261,335,	106,157,	
111,107,	107,162,	111,81,	144,204,	
140,81,	107,160,	111,105,	107,160,	
111,108,	175,0,	167,81,	120,0,	
174,0,	112,107,	167,232,	112,81,	
917,986,	140,197,	107,160,	112,105,	
113,107,	112,108,	113,81,	214,289,	
220,81,	247,180,	113,105,	172,240,	
113,108,	140,198,	140,199,	499,579,	
1000,1077,	185,257,	180,251,	106,157,	
110,106,	106,157,	281,90,	210,90,	
110,108,	175,81,	110,108,	120,81,	
174,81,	140,200,	173,0,	263,132,	
122,0,	120,120,	115,168,	111,106,	
107,160,	186,0,	107,160,	111,108,	
107,160,	111,108,	115,169,	115,170,	
172,172,	202,277,	110,163,	106,157,	
112,106,	172,241,	1011,1077,	180,180,	
112,108,	169,169,	112,108,	113,106,	
180,252,	123,0,	188,0,	113,108,	
111,164,	113,108,	173,81,	119,176,	
122,81,	115,171,	107,160,	113,166,	
115,168,	186,81,	122,120,	119,177,	
119,178,	112,165,	115,168,	115,172,	
120,121,	115,168,	247,319,	115,168,	
120,120,	115,168,	120,120,	187,0,	
124,0,	175,244,	169,172,	174,243,	
197,0,	123,81,	188,81,	125,0,	
115,168,	263,337,	119,179,	123,120,	
281,355,	119,176,	210,285,	169,233,	
886,958,	886,888,	210,206,	119,176,	
119,180,	200,0,	119,176,	331,399,	
119,176,	196,0,	119,176,	169,234,	
169,235,	122,121,	199,0,	187,81,	
124,81,	122,120,	173,242,	122,120,	
197,81,	119,176,	124,120,	125,81,	
169,236,	186,258,	115,168,	169,237,	
115,168,	125,120,	115,168,	239,172,	
153,0,	197,272,	198,0,	201,0,	
267,132,	200,81,	123,121,	122,181,	
331,331,	196,81,	123,120,	203,0,	
123,120,	204,0,	199,81,	223,0,	
141,140,	141,0,	148,147,	239,312,	
126,80,	188,260,	237,172,	119,176,	
115,168,	119,176,	222,222,	119,176,	
126,80,	126,0,	250,180,	123,182,	
153,81,	124,121,	198,81,	201,81,	
153,97,	124,120,	153,97,	124,120,	
125,121,	264,132,	187,259,	203,81,	
125,120,	204,81,	125,120,	223,81,	
266,132,	141,81,	250,323,	148,90,	
125,184,	119,176,	126,80,	201,276,	
1031,1077,	205,0,	124,183,	222,159,	
126,80,	126,81,	141,197,	126,80,	
148,207,	126,80,	154,0,	126,80,	
266,340,	141,201,	267,341,	148,211,	
792,90,	155,0,	141,198,	141,199,	
148,208,	148,209,	126,80,	1048,1077,	
200,275,	153,98,	196,271,	199,274,	
200,196,	153,97,	262,132,	153,97,	
153,216,	205,81,	141,200,	248,180,	
148,210,	285,90,	269,132,	288,90,	
198,273,	237,309,	154,81,	262,336,	
222,295,	237,310,	154,97,	342,132,	
154,97,	155,81,	204,279,	364,90,	
1055,1077,	155,97,	264,338,	155,97,	
126,80,	242,0,	126,80,	203,278,	
126,185,	126,80,	126,80,	126,80,	
126,80,	126,80,	126,80,	126,80,	
126,80,	126,80,	126,80,	126,80,	
126,80,	126,80,	126,80,	126,80,	
126,80,	126,80,	126,80,	126,80,	
126,80,	126,80,	126,80,	126,80,	
126,80,	126,80,	126,80,	156,0,	
163,0,	242,81,	205,280,	154,98,	
287,90,	285,359,	792,864,	154,97,	
243,0,	154,97,	155,98,	269,343,	
164,0,	154,217,	155,97,	157,157,	
155,97,	941,90,	227,227,	288,362,	
155,218,	232,0,	248,320,	157,157,	
157,158,	158,158,	248,321,	342,410,	
240,240,	364,434,	163,107,	156,81,	
163,81,	158,158,	158,158,	156,97,	
163,105,	156,97,	163,108,	166,0,	
243,81,	251,251,	164,107,	232,304,	
164,81,	941,1008,	1066,1077,	275,0,	
164,105,	157,157,	164,108,	227,162,	
295,159,	232,81,	289,90,	157,157,	
157,159,	181,0,	157,157,	158,158,	
157,157,	240,172,	157,157,	287,361,	
428,90,	158,158,	259,0,	242,314,	
158,158,	166,107,	158,158,	166,81,	
158,158,	157,157,	251,180,	166,105,	
165,0,	166,108,	244,0,	275,81,	
156,98,	163,106,	160,160,	158,158,	
156,97,	163,108,	156,97,	163,108,	
163,228,	181,81,	160,160,	160,161,	
227,299,	164,106,	156,219,	181,120,	
161,161,	164,108,	259,81,	164,108,	
258,0,	243,315,	240,313,	164,229,	
161,161,	161,161,	165,107,	157,220,	
165,81,	157,157,	244,81,	157,157,	
165,105,	289,363,	165,108,	251,324,	
160,160,	158,221,	276,0,	158,158,	
166,106,	158,158,	160,223,	160,162,	
166,108,	160,224,	166,108,	160,160,	
272,0,	160,160,	161,161,	295,369,	
258,81,	428,501,	166,231,	275,349,	
161,225,	157,157,	181,121,	161,226,	
160,160,	161,161,	181,120,	161,161,	
181,120,	181,253,	284,90,	158,158,	
260,0,	271,0,	276,81,	955,172,	
274,0,	171,169,	161,161,	304,0,	
265,132,	165,106,	1087,90,	259,333,	
272,81,	165,108,	168,168,	165,108,	
177,177,	299,162,	305,172,	165,230,	
278,0,	272,346,	168,168,	168,170,	
433,509,	244,316,	160,160,	305,377,	
160,160,	307,172,	160,160,	955,1024,	
260,81,	271,81,	433,90,	179,177,	
274,81,	176,176,	171,172,	304,81,	
161,161,	308,172,	161,161,	276,350,	
161,161,	176,176,	176,178,	313,172,	
168,168,	177,180,	258,332,	171,233,	
278,81,	182,0,	168,168,	168,172,	
160,160,	168,168,	171,239,	168,168,	
183,0,	168,168,	177,245,	171,234,	
171,235,	184,0,	304,376,	277,0,	
179,180,	190,190,	161,161,	176,176,	
168,168,	284,358,	177,246,	177,247,	
171,236,	176,176,	176,180,	171,237,	
176,176,	179,245,	176,176,	265,339,	
176,176,	182,81,	216,0,	265,261,	
179,250,	260,334,	177,248,	182,120,	
183,81,	179,246,	179,247,	176,176,	
299,371,	184,81,	183,120,	277,81,	
309,172,	312,172,	190,132,	184,120,	
307,379,	310,172,	168,168,	271,345,	
168,168,	179,248,	168,168,	274,348,	
317,180,	308,380,	321,180,	190,262,	
191,190,	724,794,	216,81,	724,90,	
278,352,	317,387,	216,97,	279,0,	
216,97,	217,0,	313,310,	190,263,	
190,264,	176,176,	319,180,	176,176,	
218,0,	176,176,	182,121,	335,132,	
168,168,	320,180,	182,120,	323,180,	
182,120,	183,121,	312,383,	190,265,	
182,254,	183,120,	184,121,	183,120,	
338,132,	191,132,	184,120,	183,255,	
184,120,	219,0,	1124,547,	279,81,	
309,381,	217,81,	277,351,	176,176,	
184,256,	217,97,	191,262,	217,97,	
218,81,	314,0,	228,0,	216,98,	
218,97,	191,266,	218,97,	216,97,	
336,132,	216,97,	191,263,	191,264,	
315,0,	340,132,	310,382,	332,0,	
323,392,	336,404,	324,180,	333,0,	
216,291,	219,81,	224,296,	321,391,	
362,432,	219,97,	191,265,	219,97,	
226,297,	320,390,	224,296,	224,297,	
228,107,	314,81,	228,81,	339,132,	
226,297,	226,297,	228,105,	348,0,	
228,108,	319,389,	217,98,	430,90,	
315,81,	335,403,	217,97,	332,81,	
217,97,	218,98,	279,353,	333,81,	
229,0,	218,97,	340,408,	218,97,	
224,296,	362,90,	341,132,	338,406,	
360,90,	218,293,	226,297,	224,298,	
343,132,	217,292,	230,0,	224,296,	
424,90,	224,296,	219,98,	348,81,	
369,159,	226,297,	219,97,	226,297,	
219,97,	231,0,	219,294,	345,0,	
224,296,	382,172,	229,107,	228,106,	
229,81,	236,168,	226,297,	228,108,	
229,105,	228,108,	229,108,	339,407,	
314,384,	236,168,	236,170,	355,90,	
230,107,	324,321,	230,81,	357,90,	
228,300,	358,90,	230,105,	315,385,	
230,108,	410,481,	332,400,	231,107,	
316,0,	231,81,	333,401,	345,81,	
430,503,	231,105,	224,296,	231,108,	
224,296,	341,409,	224,296,	236,168,	
226,297,	969,180,	226,297,	343,411,	
226,297,	236,168,	236,172,	348,416,	
236,168,	253,0,	236,168,	346,0,	
236,168,	229,106,	360,429,	424,497,	
254,0,	229,108,	410,132,	229,108,	
316,81,	359,90,	371,162,	236,168,	
224,296,	369,439,	347,0,	230,106,	
377,172,	969,1040,	226,297,	230,108,	
363,90,	230,108,	355,424,	382,452,	
229,301,	358,427,	231,106,	230,302,	
377,447,	253,81,	231,108,	346,81,	
231,108,	361,90,	231,303,	253,120,	
254,81,	383,172,	345,413,	357,426,	
378,172,	791,90,	254,120,	346,414,	
379,172,	236,168,	347,81,	236,168,	
255,0,	236,308,	236,168,	236,168,	
236,168,	236,168,	236,168,	236,168,	
236,168,	236,168,	236,168,	236,168,	
236,168,	236,168,	236,168,	236,168,	
236,168,	236,168,	236,168,	236,168,	
236,168,	236,168,	236,168,	236,168,	
236,168,	236,168,	236,168,	236,168,	
316,386,	256,0,	253,121,	257,329,	
255,81,	359,428,	253,120,	371,441,	
253,120,	254,121,	255,120,	257,329,	
257,330,	254,120,	361,430,	254,120,	
363,433,	349,0,	403,132,	253,325,	
291,0,	352,421,	352,0,	325,0,	
379,449,	791,863,	387,180,	412,132,	
354,0,	361,431,	381,172,	293,0,	
254,326,	256,81,	427,90,	383,453,	
378,448,	257,329,	387,458,	256,120,	
273,0,	397,0,	347,415,	257,329,	
257,331,	493,493,	257,329,	388,180,	
257,329,	349,81,	257,329,	988,132,	
291,81,	255,121,	352,81,	325,81,	
291,97,	255,120,	291,97,	255,120,	
354,81,	325,120,	422,0,	293,81,	
389,180,	255,327,	280,0,	293,97,	
404,132,	293,97,	495,575,	1129,551,	
273,81,	397,81,	350,0,	1141,132,	
425,90,	403,473,	493,495,	988,1063,	
404,474,	353,0,	256,121,	376,0,	
422,496,	385,0,	256,120,	1239,1077,	
256,120,	425,498,	256,328,	386,0,	
351,0,	412,483,	422,81,	257,329,	
447,172,	257,329,	280,81,	257,329,	
427,500,	291,98,	381,451,	495,495,	
325,121,	291,97,	350,81,	291,97,	
325,120,	447,518,	325,120,	291,365,	
293,98,	353,81,	325,393,	376,81,	
293,97,	385,81,	293,97,	388,459,	
389,460,	349,417,	293,367,	386,81,	
351,81,	257,329,	354,423,	273,347,	
273,80,	273,80,	273,80,	273,80,	
273,80,	273,80,	273,80,	273,80,	
273,80,	273,80,	273,80,	273,80,	
273,80,	273,80,	273,80,	273,80,	
273,80,	273,80,	273,80,	273,80,	
273,80,	273,80,	273,80,	273,80,	
273,80,	280,354,	280,80,	280,80,	
280,80,	280,80,	280,80,	280,80,	
280,80,	280,80,	280,80,	280,80,	
280,80,	280,80,	280,80,	280,80,	
280,80,	280,80,	280,80,	280,80,	
280,80,	280,80,	280,80,	280,80,	
280,80,	280,80,	280,80,	283,88,	
350,418,	351,419,	386,457,	290,90,	
414,0,	353,422,	423,0,	283,88,	
283,89,	385,456,	458,180,	434,509,	
474,132,	376,446,	390,180,	391,180,	
351,420,	482,564,	401,0,	483,564,	
392,180,	434,90,	497,577,	458,533,	
417,0,	474,553,	1256,1077,	482,132,	
423,496,	483,132,	1314,760,	498,90,	
497,90,	283,88,	1401,1457,	1414,1470,	
414,81,	552,629,	423,81,	283,88,	
283,90,	761,831,	283,88,	761,547,	
283,88,	498,578,	283,88,	552,132,	
468,331,	414,485,	401,81,	405,132,	
292,0,	384,0,	407,132,	400,0,	
417,81,	283,88,	290,364,	290,88,	
290,88,	290,88,	290,88,	290,88,	
290,88,	290,88,	290,88,	290,88,	
290,88,	290,88,	290,88,	290,88,	
290,88,	290,88,	290,88,	290,88,	
290,88,	290,88,	290,88,	290,88,	
290,88,	290,88,	290,88,	290,88,	
292,81,	384,81,	390,461,	400,81,	
292,97,	391,462,	292,97,	283,88,	
294,0,	283,88,	392,463,	283,357,	
283,88,	283,88,	283,88,	283,88,	
283,88,	283,88,	283,88,	283,88,	
283,88,	283,88,	283,88,	283,88,	
283,88,	283,88,	283,88,	283,88,	
283,88,	283,88,	283,88,	283,88,	
283,88,	283,88,	283,88,	283,88,	
283,88,	283,88,	401,471,	405,475,	
294,81,	417,488,	407,477,	468,541,	
294,97,	413,0,	294,97,	420,0,	
402,0,	292,98,	419,0,	399,399,	
408,132,	292,97,	506,506,	292,97,	
300,0,	518,172,	384,454,	416,0,	
400,469,	439,159,	411,132,	763,833,	
533,180,	763,551,	1426,1482,	406,132,	
292,366,	431,90,	409,132,	518,596,	
774,844,	384,455,	774,132,	400,470,	
441,162,	413,81,	533,610,	420,81,	
402,81,	1441,1497,	419,81,	449,172,	
399,331,	1513,90,	300,107,	506,508,	
300,81,	294,98,	451,172,	416,81,	
300,105,	294,97,	300,108,	294,368,	
294,97,	294,97,	294,97,	294,97,	
294,97,	294,97,	294,97,	294,97,	
294,97,	294,97,	294,97,	294,97,	
294,97,	294,97,	294,97,	294,97,	
294,97,	294,97,	294,97,	294,97,	
294,97,	294,97,	294,97,	294,97,	
294,97,	296,296,	326,0,	406,476,	
297,297,	399,468,	408,478,	409,479,	
431,504,	296,296,	296,297,	298,296,	
297,297,	297,297,	411,482,	439,512,	
461,180,	300,106,	420,491,	298,370,	
298,297,	300,108,	409,480,	300,108,	
413,484,	301,0,	402,472,	300,372,	
327,0,	449,520,	441,514,	419,490,	
394,421,	394,0,	326,81,	296,296,	
446,0,	416,487,	297,297,	451,522,	
326,120,	501,90,	296,298,	302,0,	
296,296,	298,296,	296,296,	297,297,	
296,296,	297,297,	303,0,	297,297,	
298,298,	553,132,	298,296,	301,107,	
298,296,	301,81,	298,296,	296,296,	
327,81,	301,105,	297,297,	301,108,	
519,172,	394,81,	327,120,	553,630,	
446,81,	298,296,	1526,172,	394,120,	
484,0,	302,107,	653,90,	302,81,	
1538,180,	452,172,	508,586,	302,105,	
303,107,	302,108,	303,81,	326,121,	
532,609,	461,536,	303,105,	326,120,	
303,108,	326,120,	454,0,	578,651,	
1553,132,	296,296,	484,565,	296,296,	
297,297,	296,296,	297,297,	653,719,	
297,297,	578,90,	326,394,	298,296,	
484,81,	298,296,	301,106,	298,296,	
306,172,	327,121,	301,108,	508,508,	
301,108,	327,120,	394,121,	327,120,	
501,581,	532,532,	394,120,	327,395,	
394,120,	519,597,	454,81,	296,296,	
302,106,	301,373,	297,297,	446,517,	
302,108,	450,172,	302,108,	303,106,	
473,132,	298,296,	302,374,	303,108,	
452,523,	303,375,	303,108,	303,108,	
303,108,	303,108,	303,108,	303,108,	
303,108,	303,108,	303,108,	303,108,	
303,108,	303,108,	303,108,	303,108,	
303,108,	303,108,	303,108,	303,108,	
303,108,	303,108,	303,108,	303,108,	
303,108,	303,108,	303,108,	306,378,	
306,168,	306,168,	306,168,	306,168,	
306,168,	306,168,	306,168,	306,168,	
306,168,	306,168,	306,168,	306,168,	
306,168,	306,168,	306,168,	306,168,	
306,168,	306,168,	306,168,	306,168,	
306,168,	306,168,	306,168,	306,168,	
306,168,	318,176,	437,0,	454,525,	
460,180,	455,0,	462,180,	466,0,	
450,521,	318,176,	318,178,	473,552,	
476,132,	477,132,	480,132,	479,132,	
509,90,	485,0,	488,0,	502,90,	
500,90,	512,159,	546,547,	503,90,	
437,496,	469,0,	514,162,	547,624,	
551,628,	466,496,	566,0,	561,561,	
1635,1696,	563,638,	437,81,	318,176,	
470,0,	455,81,	437,97,	466,81,	
437,97,	318,176,	318,180,	328,0,	
318,176,	466,120,	318,176,	670,172,	
318,176,	485,81,	488,81,	682,180,	
566,641,	971,1042,	489,0,	971,760,	
1221,90,	469,81,	1678,1740,	318,176,	
547,547,	551,551,	566,81,	485,566,	
561,563,	462,537,	563,563,	1512,1567,	
470,81,	1512,90,	460,535,	509,587,	
670,734,	480,559,	1221,1285,	328,81,	
682,750,	546,623,	476,555,	500,580,	
512,590,	328,120,	477,556,	437,98,	
479,558,	514,592,	489,81,	437,97,	
466,121,	437,97,	503,583,	502,582,	
466,120,	318,176,	466,120,	318,176,	
455,526,	318,388,	318,176,	318,176,	
318,176,	318,176,	318,176,	318,176,	
318,176,	318,176,	318,176,	318,176,	
318,176,	318,176,	318,176,	318,176,	
318,176,	318,176,	318,176,	318,176,	
318,176,	318,176,	318,176,	318,176,	
318,176,	318,176,	318,176,	318,176,	
328,121,	488,569,	469,542,	470,543,	
328,120,	486,0,	328,396,	328,120,	
328,120,	328,120,	328,120,	328,120,	
328,120,	328,120,	328,120,	328,120,	
328,120,	328,120,	328,120,	328,120,	
328,120,	328,120,	328,120,	328,120,	
328,120,	328,120,	328,120,	328,120,	
328,120,	328,120,	328,120,	328,120,	
329,329,	365,0,	489,570,	573,0,	
465,0,	486,81,	487,0,	523,172,	
329,329,	329,330,	330,330,	520,172,	
521,172,	535,180,	550,551,	524,172,	
496,0,	490,0,	330,330,	330,330,	
525,0,	555,132,	517,0,	522,172,	
534,180,	536,180,	537,180,	366,421,	
366,0,	542,0,	1693,1759,	1679,90,	
558,132,	365,81,	329,329,	573,81,	
465,81,	365,97,	487,81,	365,97,	
329,329,	329,331,	465,120,	329,329,	
330,330,	329,329,	334,0,	329,329,	
496,81,	490,81,	330,330,	538,180,	
525,81,	330,330,	517,81,	330,330,	
541,331,	330,330,	329,397,	557,132,	
366,81,	542,81,	486,567,	554,132,	
366,97,	577,90,	366,97,	337,130,	
330,398,	550,627,	520,598,	521,599,	
535,612,	580,653,	523,601,	337,130,	
337,131,	1523,1577,	334,81,	1523,172,	
555,632,	534,611,	365,98,	580,90,	
1679,1741,	465,121,	365,97,	524,602,	
365,97,	465,120,	365,435,	465,120,	
329,329,	537,614,	329,329,	465,540,	
329,329,	487,568,	522,600,	558,635,	
536,613,	337,130,	330,330,	496,576,	
330,330,	365,436,	330,330,	337,130,	
337,132,	366,98,	337,130,	517,595,	
337,130,	366,97,	337,130,	366,97,	
490,571,	556,132,	1027,1029,	525,603,	
554,631,	579,90,	329,329,	538,615,	
1695,1634,	337,130,	577,650,	581,90,	
542,619,	541,618,	582,90,	557,634,	
330,330,	334,402,	334,80,	334,80,	
334,80,	334,80,	334,80,	334,80,	
334,80,	334,80,	334,80,	334,80,	
334,80,	334,80,	334,80,	334,80,	
334,80,	334,80,	334,80,	334,80,	
334,80,	334,80,	334,80,	334,80,	
334,80,	334,80,	334,80,	337,130,	
344,132,	337,130,	367,0,	337,405,	
337,130,	337,130,	337,130,	337,130,	
337,130,	337,130,	337,130,	337,130,	
337,130,	337,130,	337,130,	337,130,	
337,130,	337,130,	337,130,	337,130,	
337,130,	337,130,	337,130,	337,130,	
337,130,	337,130,	337,130,	337,130,	
337,130,	337,130,	583,90,	584,90,	
556,633,	596,668,	367,81,	579,652,	
590,159,	564,132,	367,97,	1027,1106,	
367,97,	581,654,	592,162,	596,172,	
582,655,	636,132,	629,132,	587,90,	
635,132,	567,0,	368,0,	650,90,	
1536,1589,	587,659,	1536,180,	344,412,	
344,130,	344,130,	344,130,	344,130,	
344,130,	344,130,	344,130,	344,130,	
344,130,	344,130,	344,130,	344,130,	
344,130,	344,130,	344,130,	344,130,	
344,130,	344,130,	344,130,	344,130,	
344,130,	344,130,	344,130,	344,130,	
344,130,	567,81,	368,81,	367,98,	
372,0,	370,296,	368,97,	367,97,	
368,97,	367,97,	373,421,	373,0,	
564,639,	370,370,	370,297,	598,670,	
648,495,	584,657,	601,673,	654,90,	
583,656,	565,0,	587,659,	590,662,	
374,0,	598,172,	367,437,	629,695,	
601,172,	592,664,	650,715,	636,702,	
572,0,	575,575,	372,107,	375,0,	
372,81,	568,0,	635,701,	370,296,	
372,105,	373,107,	372,108,	373,81,	
605,0,	370,223,	370,298,	373,105,	
370,296,	373,108,	370,296,	368,98,	
370,296,	565,81,	374,107,	368,97,	
374,81,	368,97,	571,0,	568,643,	
374,105,	698,132,	374,108,	370,296,	
572,81,	375,107,	575,495,	375,81,	
368,438,	568,81,	569,0,	375,105,	
570,0,	375,108,	610,680,	567,642,	
605,81,	760,830,	612,682,	380,172,	
393,0,	395,0,	654,720,	576,0,	
610,180,	372,106,	698,769,	370,440,	
612,180,	372,108,	571,81,	372,108,	
373,106,	372,442,	396,0,	648,713,	
373,108,	370,296,	373,108,	370,296,	
597,172,	370,296,	569,81,	599,172,	
570,81,	374,106,	600,172,	575,648,	
372,443,	374,108,	760,760,	374,108,	
393,81,	395,81,	565,640,	576,81,	
375,106,	602,172,	393,120,	395,120,	
375,108,	576,649,	375,108,	611,180,	
613,180,	672,172,	396,81,	370,296,	
374,444,	615,180,	572,647,	415,0,	
396,120,	375,445,	380,450,	380,168,	
380,168,	380,168,	380,168,	380,168,	
380,168,	380,168,	380,168,	380,168,	
380,168,	380,168,	380,168,	380,168,	
380,168,	380,168,	380,168,	380,168,	
380,168,	380,168,	380,168,	380,168,	
380,168,	380,168,	380,168,	380,168,	
571,646,	393,121,	395,121,	415,81,	
418,0,	393,120,	395,120,	393,120,	
395,120,	393,464,	576,649,	586,586,	
1708,1775,	595,0,	597,669,	396,121,	
569,644,	599,671,	570,645,	396,120,	
600,672,	396,120,	603,0,	604,0,	
393,465,	395,466,	1710,1648,	1722,1788,	
672,736,	614,684,	630,696,	602,674,	
396,467,	1552,1604,	1734,1802,	1552,132,	
418,81,	611,681,	613,683,	614,180,	
630,132,	632,698,	1744,1802,	615,685,	
586,508,	595,81,	1107,0,	1761,172,	
618,331,	1107,0,	658,508,	632,132,	
435,0,	609,609,	603,81,	604,81,	
631,132,	621,0,	415,486,	415,80,	
415,80,	415,80,	415,80,	415,80,	
415,80,	415,80,	415,80,	415,80,	
415,80,	415,80,	415,80,	415,80,	
415,80,	415,80,	415,80,	415,80,	
415,80,	415,80,	415,80,	415,80,	
415,80,	415,80,	415,80,	415,80,	
435,81,	586,658,	609,532,	625,0,	
435,97,	621,81,	435,97,	418,489,	
418,80,	418,80,	418,80,	418,80,	
418,80,	418,80,	418,80,	418,80,	
418,80,	418,80,	418,80,	418,80,	
418,80,	418,80,	418,80,	418,80,	
418,80,	418,80,	418,80,	418,80,	
418,80,	418,80,	418,80,	418,80,	
418,80,	421,492,	426,90,	625,81,	
595,667,	604,676,	618,688,	438,0,	
603,675,	421,493,	421,494,	609,679,	
633,132,	658,723,	631,697,	436,0,	
655,721,	435,98,	640,0,	1762,1828,	
620,0,	435,97,	1234,172,	435,97,	
619,0,	1777,1843,	655,90,	634,132,	
657,509,	438,496,	623,547,	679,532,	
652,90,	692,547,	1792,1802,	421,492,	
623,691,	435,510,	657,90,	438,81,	
1234,1298,	421,492,	421,495,	438,97,	
421,492,	438,97,	421,492,	436,81,	
421,492,	627,551,	640,81,	436,97,	
620,81,	436,97,	624,624,	627,693,	
619,81,	426,499,	426,88,	426,88,	
426,88,	426,88,	426,88,	426,88,	
426,88,	426,88,	426,88,	426,88,	
426,88,	426,88,	426,88,	426,88,	
426,88,	426,88,	426,88,	426,88,	
426,88,	426,88,	426,88,	426,88,	
426,88,	426,88,	426,88,	429,90,	
442,0,	623,691,	633,699,	624,547,	
438,98,	443,0,	432,505,	652,718,	
438,97,	421,492,	438,97,	421,492,	
436,98,	421,492,	432,506,	432,507,	
436,97,	634,700,	436,97,	628,628,	
627,693,	662,726,	436,511,	673,172,	
713,495,	640,705,	679,746,	639,132,	
692,762,	656,90,	442,107,	662,159,	
442,81,	639,704,	620,690,	443,107,	
442,105,	443,81,	442,108,	421,492,	
432,505,	443,105,	619,689,	443,108,	
624,692,	684,180,	432,505,	432,508,	
683,180,	432,505,	699,132,	432,505,	
628,551,	432,505,	429,502,	429,88,	
429,88,	429,88,	429,88,	429,88,	
429,88,	429,88,	429,88,	429,88,	
429,88,	429,88,	429,88,	429,88,	
429,88,	429,88,	429,88,	429,88,	
429,88,	429,88,	429,88,	429,88,	
429,88,	429,88,	429,88,	429,88,	
440,296,	442,106,	639,704,	643,0,	
673,737,	442,108,	443,106,	442,108,	
440,296,	440,297,	443,108,	448,172,	
443,108,	628,694,	444,0,	656,722,	
443,516,	713,783,	432,505,	642,0,	
432,505,	442,515,	432,505,	644,0,	
649,0,	1811,90,	684,752,	445,0,	
638,638,	664,728,	1817,1881,	683,751,	
645,0,	699,770,	440,296,	643,81,	
444,496,	1819,1883,	694,551,	664,162,	
440,223,	440,298,	1823,172,	440,296,	
444,107,	440,296,	444,81,	440,296,	
432,505,	445,496,	444,105,	642,81,	
444,108,	701,132,	645,711,	644,81,	
649,81,	445,107,	440,296,	445,81,	
643,709,	638,563,	649,649,	445,105,	
645,81,	445,108,	448,519,	448,168,	
448,168,	448,168,	448,168,	448,168,	
448,168,	448,168,	448,168,	448,168,	
448,168,	448,168,	448,168,	448,168,	
448,168,	448,168,	448,168,	448,168,	
448,168,	448,168,	448,168,	448,168,	
448,168,	448,168,	448,168,	448,168,	
440,296,	453,172,	440,296,	444,106,	
440,296,	456,527,	646,0,	444,108,	
651,90,	444,108,	638,703,	647,0,	
667,0,	456,527,	456,528,	464,0,	
445,106,	649,714,	642,708,	649,649,	
445,108,	715,90,	445,108,	669,172,	
674,738,	694,764,	644,710,	701,772,	
440,513,	671,172,	440,296,	659,90,	
685,753,	647,496,	674,172,	651,716,	
456,529,	659,659,	646,81,	681,180,	
755,331,	703,563,	685,180,	647,81,	
667,81,	456,527,	456,530,	464,81,	
456,527,	651,717,	456,527,	688,331,	
456,527,	464,120,	695,132,	697,132,	
453,524,	453,168,	453,168,	453,168,	
453,168,	453,168,	453,168,	453,168,	
453,168,	453,168,	453,168,	453,168,	
453,168,	453,168,	453,168,	453,168,	
453,168,	453,168,	453,168,	453,168,	
453,168,	453,168,	453,168,	453,168,	
453,168,	453,168,	669,733,	457,457,	
659,724,	700,771,	659,659,	459,180,	
671,735,	715,785,	675,0,	457,457,	
457,531,	467,0,	668,172,	700,132,	
464,121,	456,527,	681,749,	456,527,	
464,120,	456,527,	464,120,	719,90,	
646,712,	1826,1758,	1838,180,	755,825,	
689,0,	702,564,	688,755,	723,508,	
717,90,	695,765,	697,768,	467,496,	
464,539,	457,457,	667,730,	702,132,	
703,773,	668,731,	675,81,	457,457,	
457,532,	467,81,	457,457,	456,527,	
457,457,	732,172,	457,457,	467,120,	
691,547,	716,90,	720,90,	668,732,	
722,90,	641,0,	691,691,	726,159,	
689,81,	457,457,	459,534,	459,176,	
459,176,	459,176,	459,176,	459,176,	
459,176,	459,176,	459,176,	459,176,	
459,176,	459,176,	459,176,	459,176,	
459,176,	459,176,	459,176,	459,176,	
459,176,	459,176,	459,176,	459,176,	
459,176,	459,176,	459,176,	459,176,	
463,180,	641,81,	680,180,	696,132,	
719,789,	472,548,	467,121,	457,457,	
705,0,	457,457,	467,120,	457,457,	
467,120,	472,548,	472,549,	510,0,	
723,793,	691,761,	717,787,	691,691,	
675,739,	718,90,	712,0,	721,90,	
737,172,	746,532,	731,172,	722,792,	
641,706,	680,747,	696,766,	733,172,	
726,796,	716,786,	720,790,	732,802,	
472,550,	457,457,	689,756,	472,548,	
705,81,	940,90,	641,707,	680,748,	
696,767,	472,548,	472,551,	510,81,	
472,548,	728,162,	472,548,	510,97,	
472,548,	510,97,	712,81,	463,538,	
463,176,	463,176,	463,176,	463,176,	
463,176,	463,176,	463,176,	463,176,	
463,176,	463,176,	463,176,	463,176,	
463,176,	463,176,	463,176,	463,176,	
463,176,	463,176,	463,176,	463,176,	
463,176,	463,176,	463,176,	463,176,	
463,176,	471,544,	693,551,	737,807,	
706,0,	475,132,	707,0,	515,0,	
693,693,	471,544,	471,545,	1841,1774,	
721,791,	718,788,	731,801,	788,860,	
510,98,	472,548,	746,816,	472,548,	
510,97,	472,548,	510,97,	733,803,	
789,90,	788,90,	710,0,	940,1007,	
705,775,	735,172,	728,798,	734,172,	
471,546,	712,782,	510,588,	471,544,	
706,81,	515,107,	707,81,	515,81,	
738,172,	471,544,	471,547,	515,105,	
471,544,	515,108,	471,544,	472,548,	
471,544,	736,172,	704,132,	748,180,	
747,180,	750,180,	900,331,	693,763,	
704,704,	693,693,	710,81,	471,80,	
475,554,	475,130,	475,130,	475,130,	
475,130,	475,130,	475,130,	475,130,	
475,130,	475,130,	475,130,	475,130,	
475,130,	475,130,	475,130,	475,130,	
475,130,	475,130,	475,130,	475,130,	
475,130,	475,130,	475,130,	475,130,	
475,130,	475,130,	478,132,	708,0,	
515,106,	539,0,	481,560,	789,861,	
515,108,	471,544,	515,108,	471,544,	
588,0,	471,544,	481,561,	481,562,	
734,804,	735,805,	753,180,	704,774,	
706,776,	704,704,	515,593,	709,0,	
711,0,	738,808,	751,180,	765,132,	
707,777,	749,180,	752,180,	900,970,	
762,547,	736,806,	767,132,	708,81,	
747,817,	539,81,	750,820,	471,544,	
481,560,	748,818,	710,780,	539,120,	
588,81,	764,551,	481,560,	481,563,	
588,97,	481,560,	588,97,	481,560,	
491,0,	481,560,	759,760,	709,81,	
711,81,	478,557,	478,130,	478,130,	
478,130,	478,130,	478,130,	478,130,	
478,130,	478,130,	478,130,	478,130,	
478,130,	478,130,	478,130,	478,130,	
478,130,	478,130,	478,130,	478,130,	
478,130,	478,130,	478,130,	478,130,	
478,130,	478,130,	478,130,	714,0,	
491,81,	1857,132,	539,121,	753,823,	
739,0,	752,822,	539,120,	589,0,	
539,120,	588,98,	751,821,	765,835,	
768,132,	588,97,	481,560,	588,97,	
481,560,	749,819,	481,560,	756,0,	
539,616,	762,832,	775,0,	708,778,	
767,837,	759,829,	772,132,	785,90,	
766,132,	714,784,	588,660,	714,81,	
769,132,	771,132,	764,834,	770,132,	
739,81,	1887,1802,	773,563,	589,81,	
709,779,	711,781,	783,495,	589,97,	
481,560,	589,97,	786,90,	790,90,	
796,159,	793,508,	1300,0,	756,81,	
1900,1802,	1300,0,	775,81,	491,572,	
491,80,	491,80,	491,80,	491,80,	
491,80,	491,80,	491,80,	491,80,	
491,80,	491,80,	491,80,	491,80,	
491,80,	491,80,	491,80,	491,80,	
491,80,	491,80,	491,80,	491,80,	
491,80,	491,80,	491,80,	491,80,	
491,80,	492,492,	593,0,	798,162,	
768,838,	772,842,	785,857,	801,172,	
589,98,	492,492,	492,494,	494,494,	
589,97,	804,172,	589,97,	739,809,	
766,836,	778,0,	779,0,	494,494,	
494,494,	769,839,	771,841,	770,840,	
786,858,	589,661,	790,862,	796,870,	
776,0,	616,0,	756,826,	773,843,	
593,107,	775,845,	593,81,	492,492,	
783,853,	803,877,	593,105,	778,848,	
593,108,	492,492,	492,495,	793,865,	
492,492,	494,494,	492,492,	803,172,	
492,492,	778,81,	779,81,	494,494,	
808,172,	782,0,	494,494,	1947,1949,	
494,494,	1250,180,	494,494,	492,573,	
776,81,	616,81,	798,872,	805,879,	
807,172,	801,875,	806,172,	616,120,	
505,505,	494,574,	1961,1963,	819,894,	
825,900,	805,172,	781,0,	1250,1312,	
505,505,	505,507,	1964,2024,	504,90,	
804,878,	819,180,	825,331,	593,106,	
838,917,	782,81,	2000,1864,	593,108,	
780,0,	593,108,	617,0,	858,937,	
800,0,	492,492,	838,132,	492,492,	
816,532,	492,492,	809,0,	972,760,	
832,547,	858,90,	505,505,	494,494,	
593,665,	494,494,	781,81,	494,494,	
505,505,	505,508,	616,121,	505,505,	
808,882,	505,505,	616,120,	505,505,	
616,120,	779,849,	776,846,	820,180,	
780,81,	822,180,	617,81,	492,492,	
800,81,	806,880,	505,585,	817,180,	
617,120,	511,0,	809,81,	616,686,	
807,881,	494,494,	504,584,	504,88,	
504,88,	504,88,	504,88,	504,88,	
504,88,	504,88,	504,88,	504,88,	
504,88,	504,88,	504,88,	504,88,	
504,88,	504,88,	504,88,	504,88,	
504,88,	504,88,	504,88,	504,88,	
504,88,	504,88,	504,88,	504,88,	
505,505,	511,81,	505,505,	782,852,	
505,505,	511,97,	781,851,	511,97,	
594,0,	810,0,	816,891,	617,121,	
972,1043,	660,0,	832,908,	617,120,	
1269,132,	617,120,	839,132,	780,850,	
800,874,	826,0,	834,551,	827,0,	
823,180,	817,892,	820,895,	821,180,	
617,687,	822,897,	505,505,	842,132,	
2003,1864,	843,563,	1269,1329,	903,760,	
2104,2160,	829,760,	594,107,	841,132,	
594,81,	810,81,	835,132,	829,902,	
594,105,	660,81,	594,108,	861,90,	
809,883,	660,97,	511,98,	660,97,	
836,132,	826,81,	511,97,	827,81,	
511,589,	511,97,	511,97,	511,97,	
511,97,	511,97,	511,97,	511,97,	
511,97,	511,97,	511,97,	511,97,	
511,97,	511,97,	511,97,	511,97,	
511,97,	511,97,	511,97,	511,97,	
511,97,	511,97,	511,97,	511,97,	
511,97,	511,97,	513,296,	661,0,	
823,898,	839,918,	821,896,	840,132,	
686,0,	594,106,	513,296,	513,297,	
829,902,	594,108,	660,98,	594,108,	
834,913,	830,830,	660,97,	841,920,	
660,97,	835,914,	846,0,	665,0,	
754,0,	661,496,	594,666,	843,922,	
853,495,	842,921,	836,915,	660,725,	
848,0,	865,508,	903,972,	661,81,	
513,296,	861,940,	516,0,	661,97,	
686,81,	661,97,	513,223,	513,298,	
846,927,	513,296,	686,120,	513,296,	
857,90,	513,296,	830,760,	826,901,	
878,172,	665,107,	846,81,	665,81,	
754,81,	862,860,	1004,90,	665,105,	
513,296,	665,108,	754,120,	863,941,	
848,929,	526,0,	840,919,	862,90,	
516,107,	868,944,	516,81,	1076,0,	
864,509,	863,90,	516,105,	1154,90,	
516,108,	2112,2168,	2129,2185,	859,90,	
849,0,	845,0,	864,90,	1285,90,	
661,98,	847,0,	2137,1864,	853,932,	
661,97,	686,121,	661,97,	830,903,	
865,942,	686,120,	513,296,	686,120,	
513,296,	526,81,	513,296,	2143,2197,	
1154,1218,	1285,1345,	868,868,	1076,81,	
665,106,	754,121,	686,754,	2146,2200,	
665,108,	754,120,	665,108,	754,120,	
849,81,	845,81,	2152,2206,	754,824,	
513,591,	847,81,	1004,1081,	516,106,	
857,936,	665,729,	878,952,	516,108,	
513,296,	516,594,	516,108,	516,108,	
516,108,	516,108,	516,108,	516,108,	
516,108,	516,108,	516,108,	516,108,	
516,108,	516,108,	516,108,	516,108,	
516,108,	516,108,	516,108,	516,108,	
516,108,	516,108,	516,108,	516,108,	
516,108,	516,108,	516,108,	859,938,	
526,604,	526,80,	526,80,	526,80,	
526,80,	526,80,	526,80,	526,80,	
526,80,	526,80,	526,80,	526,80,	
526,80,	526,80,	526,80,	526,80,	
526,80,	526,80,	526,80,	526,80,	
526,80,	526,80,	526,80,	526,80,	
526,80,	526,80,	527,527,	687,0,	
850,0,	851,0,	849,930,	852,0,	
666,0,	845,926,	527,527,	527,528,	
870,159,	847,928,	528,528,	872,162,	
881,172,	891,532,	875,949,	897,180,	
2276,1864,	874,0,	528,528,	528,528,	
529,527,	687,496,	850,848,	851,931,	
875,172,	852,496,	666,496,	876,172,	
529,527,	529,528,	895,180,	687,81,	
850,81,	851,81,	666,107,	852,81,	
666,81,	687,120,	527,527,	527,530,	
666,105,	527,527,	666,108,	527,527,	
528,0,	527,527,	893,180,	528,0,	
880,877,	874,81,	528,528,	2287,1873,	
882,955,	528,528,	892,964,	528,528,	
527,605,	528,528,	880,172,	896,894,	
529,527,	529,530,	882,172,	529,527,	
892,180,	529,527,	914,132,	529,527,	
528,606,	896,180,	2295,2231,	881,954,	
891,963,	725,0,	897,968,	888,961,	
870,945,	906,976,	529,605,	872,947,	
687,121,	908,547,	913,551,	898,969,	
687,120,	666,106,	687,120,	729,0,	
530,527,	666,108,	527,527,	666,108,	
527,527,	898,180,	527,527,	902,760,	
530,608,	530,528,	916,132,	876,950,	
895,967,	902,902,	528,528,	901,759,	
528,528,	725,81,	528,528,	888,958,	
888,888,	725,97,	906,906,	725,97,	
529,527,	901,760,	529,527,	874,948,	
529,607,	729,107,	893,965,	729,81,	
527,527,	869,0,	911,981,	729,105,	
540,0,	729,108,	915,984,	918,132,	
530,527,	530,530,	901,80,	530,527,	
528,528,	530,527,	919,917,	530,527,	
915,132,	920,988,	914,983,	921,564,	
908,977,	913,982,	529,527,	869,496,	
919,132,	922,563,	530,605,	920,132,	
902,971,	921,132,	902,902,	543,0,	
925,991,	869,81,	725,98,	911,911,	
540,81,	869,97,	725,97,	869,97,	
725,97,	1012,1088,	540,120,	928,0,	
725,795,	998,1075,	927,0,	930,0,	
729,106,	1005,1082,	916,985,	994,0,	
729,108,	2307,1864,	729,108,	998,495,	
1006,1083,	1009,1086,	729,799,	1005,90,	
530,527,	1019,1095,	530,527,	543,81,	
530,527,	925,925,	1006,90,	1009,508,	
2312,2244,	2320,2385,	1020,1096,	1019,172,	
938,90,	994,1071,	1012,1012,	928,81,	
2325,1864,	918,987,	927,81,	930,81,	
1020,172,	932,495,	869,98,	994,81,	
922,989,	540,121,	869,97,	937,90,	
869,97,	540,120,	530,527,	540,617,	
540,120,	540,120,	540,120,	540,120,	
540,120,	540,120,	540,120,	540,120,	
540,120,	540,120,	540,120,	540,120,	
540,120,	540,120,	540,120,	540,120,	
540,120,	540,120,	540,120,	540,120,	
540,120,	540,120,	540,120,	540,120,	
540,120,	945,159,	543,620,	543,80,	
543,80,	543,80,	543,80,	543,80,	
543,80,	543,80,	543,80,	543,80,	
543,80,	543,80,	543,80,	543,80,	
543,80,	543,80,	543,80,	543,80,	
543,80,	543,80,	543,80,	543,80,	
543,80,	543,80,	543,80,	543,80,	
544,544,	930,996,	938,1005,	927,993,	
932,998,	928,994,	931,0,	942,508,	
544,544,	544,545,	545,545,	950,172,	
937,1004,	949,172,	899,0,	953,172,	
948,0,	946,298,	545,545,	545,545,	
548,548,	947,162,	1075,495,	1008,90,	
824,0,	952,172,	929,82,	929,0,	
548,548,	548,549,	1024,172,	954,172,	
945,1014,	963,532,	544,544,	1098,172,	
899,496,	939,91,	931,81,	944,944,	
544,544,	544,547,	967,180,	544,544,	
545,545,	544,544,	899,81,	544,544,	
948,81,	964,180,	545,545,	968,180,	
899,120,	545,545,	548,548,	545,545,	
824,81,	545,545,	544,621,	929,81,	
548,548,	548,551,	824,120,	548,548,	
929,995,	548,548,	931,997,	548,548,	
545,622,	987,132,	939,90,	984,132,	
944,868,	953,1022,	942,1009,	939,1006,	
946,1015,	1018,172,	548,625,	970,331,	
947,1016,	549,549,	949,1018,	1075,1150,	
2330,1864,	950,1019,	1008,1085,	951,240,	
559,132,	549,549,	549,549,	952,1021,	
544,544,	1024,1100,	544,544,	899,121,	
544,544,	961,961,	965,180,	899,120,	
963,1034,	899,120,	545,545,	954,1023,	
545,545,	824,121,	545,545,	948,1017,	
967,1038,	824,120,	1098,1170,	824,120,	
548,548,	944,1013,	548,548,	549,549,	
548,548,	977,547,	964,1035,	985,132,	
951,172,	549,549,	544,544,	968,1039,	
549,549,	951,1020,	549,549,	982,551,	
549,549,	961,958,	961,888,	1003,90,	
545,545,	989,563,	824,899,	987,1062,	
966,251,	1018,1094,	970,1041,	549,626,	
984,1059,	1035,180,	548,548,	559,636,	
559,130,	559,130,	559,130,	559,130,	
559,130,	559,130,	559,130,	559,130,	
559,130,	559,130,	559,130,	559,130,	
559,130,	559,130,	559,130,	559,130,	
559,130,	559,130,	559,130,	559,130,	
559,130,	559,130,	559,130,	559,130,	
559,130,	966,180,	560,560,	961,1032,	
965,1036,	549,549,	966,1037,	549,549,	
976,976,	549,549,	560,560,	560,562,	
591,296,	1014,159,	1007,90,	981,981,	
977,1050,	1021,172,	795,0,	992,0,	
591,296,	591,297,	607,527,	1016,162,	
1022,172,	985,1060,	982,1057,	1038,180,	
986,133,	1034,1111,	607,527,	607,528,	
989,1064,	1035,1112,	1013,868,	549,549,	
560,560,	1003,1080,	991,991,	1034,532,	
996,0,	976,906,	560,560,	560,563,	
1029,1108,	560,560,	591,296,	560,560,	
981,911,	560,560,	795,81,	992,81,	
591,223,	591,298,	795,97,	591,296,	
795,97,	591,296,	997,0,	591,296,	
560,637,	986,132,	607,527,	607,530,	
1036,1113,	607,527,	986,1061,	607,527,	
1037,1114,	607,677,	591,296,	991,925,	
996,81,	1007,1084,	1036,180,	993,0,	
1021,1097,	1029,1029,	1037,180,	2339,1915,	
607,605,	1062,132,	976,1049,	1040,180,	
1046,1126,	1014,1090,	1038,1115,	995,0,	
1022,1098,	981,1056,	997,81,	1041,331,	
608,527,	2418,2477,	560,560,	1016,1092,	
560,560,	1049,906,	560,560,	795,98,	
608,608,	608,528,	663,296,	795,97,	
591,296,	795,97,	591,296,	993,81,	
591,296,	995,1072,	663,296,	663,297,	
991,1068,	1013,1089,	607,527,	1043,760,	
607,527,	1046,1046,	607,677,	995,81,	
1056,911,	676,740,	1063,132,	1053,1131,	
560,560,	992,1069,	608,80,	591,663,	
795,869,	676,740,	676,741,	996,1073,	
608,527,	608,530,	591,296,	608,527,	
663,296,	608,527,	1058,132,	608,527,	
1062,1138,	1050,1128,	663,223,	663,298,	
607,527,	663,296,	1040,1117,	663,296,	
1017,0,	663,296,	608,605,	1050,547,	
676,742,	997,1074,	1032,958,	1032,888,	
1053,1053,	1068,925,	1029,1106,	1041,1118,	
663,296,	676,740,	676,743,	677,527,	
676,740,	1057,1133,	676,740,	993,1070,	
676,740,	1060,1136,	1017,1093,	677,527,	
677,528,	1061,1137,	608,678,	1057,551,	
1049,1127,	1064,1140,	1059,132,	1060,132,	
1017,81,	1083,90,	678,527,	1061,132,	
608,527,	1063,1139,	608,527,	1064,563,	
608,527,	1043,1123,	678,527,	678,528,	
727,296,	1084,90,	663,296,	1067,1142,	
663,296,	1081,1154,	663,296,	1056,1132,	
727,296,	727,297,	663,727,	677,527,	
677,530,	1080,90,	677,527,	1081,90,	
677,527,	1070,0,	677,677,	690,757,	
1058,1134,	676,740,	608,527,	676,740,	
678,80,	676,740,	1082,90,	690,757,	
690,758,	677,605,	678,527,	678,530,	
663,296,	678,527,	727,296,	678,527,	
1067,1067,	678,527,	1069,0,	1070,1145,	
727,223,	727,298,	1032,1109,	727,296,	
1068,1143,	727,296,	1059,1135,	727,296,	
678,605,	1070,81,	690,759,	676,740,	
1083,1156,	690,757,	1097,172,	730,0,	
1086,508,	1088,1088,	727,296,	690,757,	
690,760,	1095,172,	690,757,	677,527,	
690,757,	677,744,	690,757,	677,677,	
1085,90,	1071,0,	1069,81,	1073,0,	
1080,1153,	1072,0,	1091,298,	1074,0,	
1096,172,	1114,180,	1118,331,	1084,1157,	
740,740,	1094,1166,	678,527,	2425,2365,	
678,527,	2439,2378,	678,527,	730,81,	
740,740,	740,741,	1088,1012,	1094,172,	
727,296,	677,527,	727,296,	1082,1155,	
727,296,	2305,0,	1089,868,	1112,1182,	
2305,0,	1071,81,	2448,2507,	1073,81,	
2451,2510,	1072,81,	1099,172,	1074,81,	
727,797,	1112,180,	678,745,	690,757,	
678,527,	690,757,	1113,180,	690,757,	
1100,172,	1086,1159,	1109,958,	1109,888,	
740,740,	740,743,	727,296,	740,740,	
1117,180,	740,740,	1115,180,	740,740,	
1127,906,	1069,1144,	1095,1167,	1088,1160,	
1097,1169,	1091,1163,	1085,1158,	1111,532,	
1116,180,	1118,1188,	740,810,	1096,1168,	
1114,1184,	690,757,	730,800,	730,80,	
730,80,	730,80,	730,80,	730,80,	
730,80,	730,80,	730,80,	730,80,	
730,80,	730,80,	730,80,	730,80,	
730,80,	730,80,	730,80,	730,80,	
730,80,	730,80,	730,80,	730,80,	
730,80,	730,80,	730,80,	730,80,	
1072,1147,	741,741,	1071,1146,	1089,1161,	
740,740,	1074,1149,	740,740,	1093,0,	
740,740,	741,741,	741,741,	742,740,	
1099,1171,	1073,1148,	1100,1172,	1113,1183,	
1123,760,	799,0,	1134,132,	742,740,	
742,741,	743,740,	1117,1187,	1128,547,	
1109,1179,	1136,132,	1133,551,	1121,1192,	
1111,1181,	743,813,	743,741,	1140,563,	
1126,1126,	1127,1195,	740,740,	741,0,	
1115,1185,	2461,2519,	741,0,	1093,81,	
1131,1131,	741,741,	1116,1186,	1138,132,	
741,741,	2490,1864,	741,741,	799,107,	
741,741,	799,81,	1147,0,	742,740,	
742,743,	799,105,	742,740,	799,108,	
742,740,	1254,1316,	742,740,	741,811,	
1121,1121,	743,740,	743,743,	1108,1108,	
743,740,	1126,1046,	743,740,	1132,911,	
743,740,	742,810,	1150,495,	1135,1201,	
2505,1864,	1131,1053,	1143,925,	1123,1193,	
1137,132,	1134,1200,	1157,860,	743,810,	
1093,1165,	1135,132,	1147,81,	2534,2590,	
1128,1196,	1156,90,	873,0,	1133,1199,	
1157,90,	1139,132,	1254,1254,	744,527,	
1140,1206,	741,741,	1136,1202,	741,741,	
1108,1029,	741,741,	799,106,	744,527,	
744,528,	745,527,	799,108,	742,740,	
799,108,	742,740,	1126,1194,	742,812,	
873,496,	745,527,	745,528,	757,757,	
1153,90,	743,740,	1131,1197,	743,740,	
873,107,	743,740,	873,81,	757,757,	
757,758,	1138,1204,	873,105,	741,741,	
873,108,	744,80,	1161,868,	799,873,	
1142,1142,	1150,1214,	744,814,	744,527,	
744,530,	742,740,	744,527,	745,80,	
744,527,	1108,1178,	744,527,	1137,1203,	
1132,1198,	745,527,	745,530,	743,740,	
745,527,	757,757,	745,527,	1143,1208,	
745,527,	744,605,	1147,1212,	757,757,	
757,760,	1156,1220,	757,757,	1139,1205,	
757,757,	777,0,	757,757,	745,605,	
1145,0,	1142,1067,	1158,90,	1160,1012,	
1148,0,	1159,508,	1168,172,	873,106,	
1155,90,	757,827,	1153,1217,	873,108,	
1167,172,	873,108,	1169,877,	1184,180,	
1166,172,	1108,1106,	1165,0,	1171,172,	
1144,0,	1183,180,	758,758,	744,527,	
1169,172,	744,527,	1148,848,	744,527,	
2560,2621,	777,81,	758,758,	758,758,	
1145,81,	745,527,	1146,0,	745,527,	
1148,81,	745,527,	1149,0,	1162,159,	
1161,1224,	1166,1229,	1142,1207,	757,757,	
1170,172,	757,757,	1178,1029,	757,757,	
1164,162,	2563,2627,	1165,81,	1188,331,	
1144,81,	744,527,	1182,180,	745,815,	
758,758,	1145,1210,	1179,958,	1179,888,	
1194,1046,	1158,1221,	758,758,	745,527,	
1159,1222,	758,758,	1146,81,	758,758,	
1155,1219,	758,758,	1149,81,	1172,172,	
1167,1230,	757,757,	1168,1231,	1180,530,	
1181,532,	1186,180,	1171,1233,	1182,1246,	
758,828,	1183,1247,	1160,1223,	1184,1248,	
777,847,	777,80,	777,80,	777,80,	
777,80,	777,80,	777,80,	777,80,	
777,80,	777,80,	777,80,	777,80,	
777,80,	777,80,	777,80,	777,80,	
777,80,	777,80,	777,80,	777,80,	
777,80,	777,80,	777,80,	777,80,	
777,80,	777,80,	1144,1209,	784,854,	
1344,90,	1162,1225,	758,758,	787,90,	
758,758,	1170,1232,	758,758,	784,854,	
784,855,	1185,894,	1164,1227,	1188,1251,	
1165,1228,	1178,1242,	1146,1211,	1178,1106,	
1192,1192,	1149,1213,	1172,1234,	1185,180,	
1193,760,	1179,1243,	1180,1244,	1181,1245,	
1186,1249,	1187,180,	1195,906,	1194,1259,	
1198,911,	1197,1053,	1196,547,	1201,132,	
758,758,	784,854,	1200,132,	1199,551,	
1203,132,	1204,917,	1202,132,	1207,1067,	
784,856,	2572,2639,	784,854,	1208,925,	
784,854,	1214,495,	784,854,	1204,132,	
1233,172,	1192,1121,	1205,132,	1206,563,	
1223,1012,	1212,0,	1220,90,	1344,1400,	
1201,1266,	784,854,	787,859,	787,88,	
787,88,	787,88,	787,88,	787,88,	
787,88,	787,88,	787,88,	787,88,	
787,88,	787,88,	787,88,	787,88,	
787,88,	787,88,	787,88,	787,88,	
787,88,	787,88,	787,88,	787,88,	
787,88,	787,88,	787,88,	787,88,	
1187,1250,	1212,81,	2609,2583,	1193,1258,	
794,866,	1196,1261,	1192,1257,	784,854,	
1200,1265,	784,854,	1199,1264,	784,854,	
794,866,	794,867,	1202,1267,	1222,508,	
1195,1260,	1224,868,	1198,1263,	1225,159,	
1203,1268,	1209,0,	1233,1297,	797,296,	
1197,1262,	1205,1269,	1206,1270,	1213,0,	
1210,0,	1214,1278,	1217,1281,	797,296,	
797,297,	1208,1272,	1207,1271,	1227,162,	
1218,1282,	784,854,	794,866,	1211,0,	
1217,90,	1223,1287,	1219,1283,	1209,1273,	
1220,1284,	794,868,	1218,90,	794,866,	
1229,1293,	794,866,	1210,1274,	794,866,	
1219,90,	1209,81,	797,871,	1230,1294,	
1231,172,	797,296,	1229,172,	1213,81,	
1210,81,	1211,1275,	794,866,	797,223,	
797,298,	1230,172,	797,296,	1232,172,	
797,296,	1245,532,	797,296,	1211,81,	
1243,958,	1243,888,	1246,1308,	1212,1276,	
1224,1288,	1213,1277,	1225,1289,	1318,760,	
812,740,	797,296,	1247,1309,	1222,1286,	
1246,180,	1249,180,	1289,159,	1258,1318,	
812,740,	812,741,	1274,0,	802,172,	
1247,180,	1265,1325,	1227,1291,	1266,1326,	
794,866,	1258,760,	794,866,	1257,1121,	
794,866,	1248,180,	2619,2688,	1265,132,	
1242,1029,	1266,132,	1259,1046,	1273,0,	
2433,958,	2433,2492,	2488,0,	1262,1053,	
1261,547,	2488,0,	1267,1327,	797,296,	
1268,132,	797,296,	1264,551,	797,296,	
812,740,	812,743,	1274,81,	812,740,	
1267,132,	812,740,	794,866,	812,884,	
1260,906,	1263,911,	1231,1295,	1270,563,	
1243,1305,	1271,1067,	1272,925,	1278,495,	
1282,90,	1245,1307,	812,810,	1273,81,	
1318,1374,	1232,1296,	1281,90,	1249,1311,	
1289,1349,	797,296,	802,876,	802,168,	
802,168,	802,168,	802,168,	802,168,	
802,168,	802,168,	802,168,	802,168,	
802,168,	802,168,	802,168,	802,168,	
802,168,	802,168,	802,168,	802,168,	
802,168,	802,168,	802,168,	802,168,	
802,168,	802,168,	802,168,	802,168,	
812,740,	813,740,	812,740,	1248,1310,	
812,884,	1242,1304,	1257,1317,	1259,1319,	
1261,1321,	813,813,	813,741,	814,886,	
1262,1322,	1242,1106,	1264,1324,	1260,1320,	
1263,1323,	1275,0,	1268,1328,	814,886,	
814,887,	1272,1332,	1278,1338,	815,527,	
1274,1334,	1284,1344,	1286,508,	1270,1330,	
1276,0,	1277,0,	812,740,	815,527,	
815,528,	1273,1333,	1271,1331,	1284,90,	
1281,1341,	1283,90,	1282,1342,	1287,1012,	
1290,298,	813,740,	813,743,	1288,868,	
813,740,	814,854,	813,740,	1293,172,	
813,740,	1275,81,	1276,1336,	814,527,	
814,888,	1291,162,	814,886,	1294,172,	
814,886,	815,80,	814,886,	813,810,	
1276,81,	1277,81,	1283,1343,	815,527,	
815,530,	1295,1355,	815,527,	1292,0,	
815,527,	814,889,	815,527,	1298,172,	
1296,172,	1306,530,	1275,1335,	1295,172,	
1297,1357,	1307,532,	1310,1368,	1277,1337,	
1294,1354,	815,605,	1311,1369,	813,885,	
1312,180,	1286,1346,	1297,172,	1309,180,	
1310,180,	1298,1358,	2625,2583,	818,180,	
1311,180,	813,740,	2631,2583,	813,740,	
2650,1077,	813,740,	1372,1254,	1292,81,	
1308,180,	2660,1077,	1312,1370,	814,886,	
1304,1029,	814,886,	1327,132,	814,886,	
1305,958,	1305,888,	1288,1348,	1291,1351,	
1309,1367,	1287,1347,	1290,1350,	815,527,	
1313,331,	815,527,	1317,1121,	815,527,	
1319,1046,	1293,1353,	1320,906,	813,740,	
1322,1053,	1323,911,	1326,132,	1321,547,	
1324,551,	1325,132,	1328,1384,	1327,1383,	
1306,1364,	814,886,	1331,1067,	1332,925,	
1307,1365,	1330,563,	815,890,	1296,1356,	
1328,132,	1341,90,	1347,1012,	1342,90,	
1350,298,	815,527,	818,893,	818,176,	
818,176,	818,176,	818,176,	818,176,	
818,176,	818,176,	818,176,	818,176,	
818,176,	818,176,	818,176,	818,176,	
818,176,	818,176,	818,176,	818,176,	
818,176,	818,176,	818,176,	818,176,	
818,176,	818,176,	818,176,	818,176,	
831,904,	1292,1352,	1308,1366,	833,909,	
1305,1363,	1372,1428,	1304,1362,	837,132,	
831,904,	831,905,	1335,0,	833,909,	
833,910,	1304,1106,	1321,1377,	1324,1380,	
1316,1316,	1320,1376,	1313,1371,	1317,1373,	
1323,1379,	1329,132,	1319,1375,	1325,1381,	
1330,1386,	1333,0,	1322,1378,	1334,0,	
1326,1382,	1347,1403,	1332,1388,	1350,1406,	
1335,1391,	1338,495,	831,904,	2709,1077,	
1331,1387,	833,909,	1341,1397,	1329,1385,	
1342,1398,	831,906,	1335,81,	831,904,	
833,911,	831,904,	833,909,	831,904,	
833,909,	1316,1254,	833,909,	2718,1864,	
1357,172,	2727,1873,	2752,2812,	2755,2324,	
2759,2329,	1333,81,	831,907,	1334,81,	
1346,508,	833,912,	837,916,	837,130,	
837,130,	837,130,	837,130,	837,130,	
837,130,	837,130,	837,130,	837,130,	
837,130,	837,130,	837,130,	837,130,	
837,130,	837,130,	837,130,	837,130,	
837,130,	837,130,	837,130,	837,130,	
837,130,	837,130,	837,130,	837,130,	
1336,0,	1352,0,	1316,1372,	1373,1121,	
831,904,	844,923,	831,904,	833,909,	
831,904,	833,909,	1343,1399,	833,909,	
1345,1401,	844,923,	844,924,	854,854,	
1348,1404,	1338,1394,	1349,1405,	1337,0,	
1343,90,	1351,1407,	1345,90,	854,854,	
854,855,	1353,172,	1348,868,	855,855,	
1349,159,	1356,172,	1357,1413,	1351,162,	
1336,81,	1352,81,	831,904,	855,855,	
855,855,	833,909,	1333,1389,	844,923,	
1334,1390,	1337,1393,	1365,532,	1354,1410,	
1346,1402,	1355,172,	844,925,	1358,1414,	
844,923,	1362,1029,	844,923,	1337,81,	
844,923,	1354,172,	1367,1423,	854,933,	
854,856,	1358,172,	854,854,	1363,1419,	
854,854,	855,855,	854,854,	844,923,	
1367,180,	1366,180,	1369,180,	855,934,	
1363,958,	1363,888,	855,855,	1370,1426,	
855,855,	854,854,	855,855,	856,854,	
1368,180,	1373,1429,	1377,547,	1376,1432,	
1371,331,	1370,180,	1374,760,	856,935,	
856,855,	855,855,	1375,1046,	1336,1392,	
1356,1412,	1376,906,	1381,132,	1380,551,	
1352,1408,	1378,1053,	1353,1409,	866,866,	
1379,1435,	844,923,	1386,563,	844,923,	
1355,1411,	844,923,	1383,1439,	866,866,	
866,867,	1382,132,	1379,911,	854,854,	
1362,1418,	854,854,	1384,132,	854,854,	
1383,132,	1387,1067,	1365,1421,	856,933,	
856,856,	871,296,	856,854,	855,855,	
856,854,	855,855,	856,854,	855,855,	
1397,90,	871,296,	871,297,	844,923,	
1399,90,	866,866,	1362,1106,	1368,1424,	
1369,1425,	856,854,	1366,1422,	866,943,	
866,868,	854,854,	866,866,	1371,1427,	
866,866,	1374,1430,	866,866,	1398,90,	
1385,1441,	1375,1431,	1388,1444,	1389,0,	
1393,0,	855,855,	1377,1433,	871,296,	
1378,1434,	866,866,	1385,132,	1400,90,	
1388,925,	871,223,	871,298,	1381,1437,	
871,296,	1400,1456,	871,296,	1380,1436,	
871,296,	1384,1440,	1391,0,	856,854,	
1409,172,	856,854,	1386,1442,	856,854,	
1387,1443,	1459,1515,	1382,1438,	871,296,	
1390,0,	2769,1915,	1462,1518,	1389,81,	
1393,1449,	1397,1453,	2800,2583,	1459,1012,	
883,740,	879,172,	1408,0,	866,866,	
1462,298,	866,866,	2816,2583,	866,866,	
883,740,	883,741,	2930,2504,	1613,1674,	
1483,1539,	856,854,	1391,81,	3114,3168,	
1392,0,	1403,1012,	1399,1455,	3122,3176,	
1405,159,	1410,172,	1483,331,	1423,180,	
1390,81,	871,296,	1400,1456,	871,296,	
1398,1454,	871,296,	1404,868,	883,742,	
3132,3186,	866,866,	1408,81,	871,946,	
3144,3198,	1412,172,	1407,162,	1413,172,	
883,740,	883,743,	884,740,	883,740,	
1613,1613,	883,740,	1428,1254,	883,740,	
1392,81,	1422,180,	884,740,	884,741,	
1389,1445,	1409,1465,	1392,1448,	871,296,	
879,953,	879,168,	879,168,	879,168,	
879,168,	879,168,	879,168,	879,168,	
879,168,	879,168,	879,168,	879,168,	
879,168,	879,168,	879,168,	879,168,	
879,168,	879,168,	879,168,	879,168,	
879,168,	879,168,	879,168,	879,168,	
879,168,	879,168,	884,740,	884,743,	
1403,1459,	884,740,	1405,1461,	884,740,	
1391,1447,	884,884,	885,740,	1404,1460,	
883,740,	1390,1446,	883,740,	1410,1466,	
883,740,	1423,1479,	885,740,	885,741,	
884,810,	1408,1464,	887,887,	1392,1448,	
1407,1463,	1412,1468,	1418,1029,	1411,172,	
1413,1469,	1425,180,	887,887,	887,887,	
889,854,	1411,1467,	1419,958,	1419,888,	
1427,331,	1424,180,	1422,1478,	1428,1484,	
889,854,	889,855,	883,740,	1424,1480,	
1429,1121,	1430,760,	1452,856,	3160,3214,	
1431,1046,	1432,906,	885,740,	885,743,	
1434,1053,	885,740,	884,740,	885,740,	
884,956,	885,740,	884,884,	1447,0,	
1437,132,	1435,911,	887,959,	1446,0,	
1438,132,	887,887,	1444,925,	887,887,	
885,810,	887,887,	1440,132,	1487,1543,	
889,933,	889,856,	1439,132,	889,854,	
1440,1496,	889,854,	3221,3275,	889,854,	
887,960,	1487,1046,	1411,1467,	1443,1067,	
884,740,	1454,90,	3229,3285,	1455,90,	
1450,495,	1490,1546,	889,854,	1447,81,	
1424,1480,	1418,1474,	1427,1483,	1446,81,	
1419,1475,	1461,159,	1425,1481,	1490,1053,	
890,527,	1458,508,	885,740,	1429,1485,	
885,740,	1452,1508,	885,740,	1418,1106,	
890,527,	890,528,	1432,1488,	1485,1121,	
904,904,	1430,1486,	887,887,	1431,1487,	
887,887,	1437,1493,	887,887,	1434,1490,	
904,904,	904,905,	1435,1491,	1460,868,	
889,854,	1440,1496,	889,854,	1444,1500,	
889,854,	905,905,	885,957,	1469,172,	
885,740,	1438,1494,	890,80,	1449,82,	
1449,0,	905,905,	905,905,	1465,172,	
890,527,	890,530,	1592,1254,	890,527,	
887,887,	890,527,	904,904,	890,527,	
1439,1495,	1464,0,	1443,1499,	1454,1510,	
904,973,	904,906,	889,854,	904,904,	
1455,1511,	904,904,	890,605,	904,904,	
1447,1503,	1446,1502,	1450,1506,	905,905,	
3239,3297,	1448,0,	1461,1517,	1463,162,	
1449,81,	905,974,	904,907,	907,854,	
905,905,	1449,1505,	905,905,	1458,1514,	
905,905,	1457,91,	1485,1541,	907,854,	
907,855,	1464,81,	1460,1516,	1468,172,	
1476,530,	1466,172,	1479,180,	905,975,	
1469,1525,	1456,90,	909,909,	3251,3312,	
890,527,	3267,3331,	890,527,	1456,1456,	
890,527,	1448,81,	909,909,	909,910,	
890,962,	1475,958,	1475,888,	1448,1448,	
904,904,	1465,1521,	904,904,	1474,1530,	
904,904,	1592,1651,	1457,90,	907,933,	
907,856,	1477,532,	907,854,	1457,1513,	
907,854,	1474,1029,	907,854,	910,910,	
1467,172,	905,905,	890,527,	905,905,	
909,909,	905,905,	1467,1467,	910,910,	
910,910,	907,854,	909,978,	909,911,	
1486,760,	909,909,	904,904,	909,909,	
1463,1519,	909,909,	912,854,	3298,3301,	
1464,1520,	1495,132,	1456,1512,	1484,1254,	
1456,1456,	1489,547,	912,854,	912,855,	
909,912,	1481,180,	1448,1504,	905,905,	
1448,1448,	910,910,	1466,1522,	1479,1535,	
1478,180,	1468,1524,	1476,1532,	910,979,	
923,923,	1475,1531,	910,910,	907,854,	
910,910,	907,854,	910,910,	907,854,	
923,923,	923,924,	1492,551,	1470,240,	
1488,906,	1467,1523,	1494,132,	1467,1467,	
1491,911,	910,980,	912,933,	912,856,	
933,999,	912,854,	909,909,	912,854,	
909,909,	912,854,	909,909,	1477,1533,	
933,999,	933,1000,	1500,925,	1486,1542,	
1498,563,	907,854,	923,923,	1482,251,	
912,854,	926,0,	1474,1106,	1509,90,	
923,990,	923,925,	1480,180,	923,923,	
1470,172,	923,923,	1481,1537,	923,923,	
1480,1480,	1470,1526,	1495,1551,	910,910,	
909,909,	910,910,	933,999,	910,910,	
1499,1555,	1484,1540,	923,923,	1489,1545,	
933,999,	933,1001,	1478,1534,	933,999,	
3313,3316,	933,999,	1499,1067,	933,999,	
1482,180,	926,81,	912,854,	1488,1544,	
912,854,	1482,1538,	912,854,	1491,1547,	
1505,0,	1497,133,	933,999,	1501,0,	
1494,1550,	910,910,	1524,172,	3338,3404,	
1492,1548,	1502,0,	1503,0,	1511,90,	
1520,0,	1500,1556,	3342,1802,	1504,0,	
923,923,	1506,495,	923,923,	1480,1536,	
923,923,	1480,1480,	1496,132,	1510,1565,	
912,854,	1514,508,	1515,1012,	1516,868,	
1496,1496,	1509,1564,	1498,1554,	1502,1558,	
1505,81,	1510,90,	1497,132,	1501,81,	
933,999,	1517,159,	933,999,	1497,1553,	
933,999,	1502,81,	1503,81,	1519,162,	
1520,81,	1504,1560,	923,923,	1504,81,	
926,992,	926,80,	926,80,	926,80,	
926,80,	926,80,	926,80,	926,80,	
926,80,	926,80,	926,80,	926,80,	
926,80,	926,80,	926,80,	926,80,	
926,80,	926,80,	926,80,	926,80,	
926,80,	926,80,	926,80,	926,80,	
926,80,	926,80,	934,1000,	1496,1552,	
1506,1561,	1496,1496,	1521,1575,	1524,1578,	
1511,1566,	1522,172,	934,1000,	934,1000,	
1514,1568,	1531,958,	1531,888,	1515,1569,	
1521,172,	1544,906,	935,854,	1535,180,	
1530,1029,	1532,530,	1517,1571,	1516,1570,	
1534,1587,	1539,331,	935,935,	935,855,	
1519,1573,	1501,1557,	1533,532,	1540,1254,	
1542,760,	1541,1593,	1534,180,	1558,0,	
934,1000,	1547,911,	1543,1046,	1503,1559,	
1520,1574,	1546,1053,	934,1000,	1541,1121,	
1545,547,	934,1000,	1550,1602,	934,1000,	
1548,551,	934,1000,	1551,132,	1549,132,	
935,854,	1556,925,	1554,563,	3348,3413,	
1550,132,	1564,90,	935,933,	935,856,	
934,1000,	935,854,	1555,1067,	935,854,	
1565,90,	935,854,	1575,172,	1558,81,	
1561,495,	1562,1001,	1563,856,	1566,90,	
3352,1802,	1568,508,	1557,0,	943,1010,	
935,854,	1569,1012,	1522,1576,	1570,868,	
1532,1585,	1530,1583,	1531,1584,	943,1010,	
943,1011,	1544,1596,	936,90,	1578,1635,	
1535,1588,	1533,1586,	1540,1592,	1539,1591,	
3364,3366,	1559,0,	934,1000,	1574,0,	
934,1000,	1578,172,	934,1000,	1543,1595,	
935,1002,	1530,1106,	1546,1598,	1545,1597,	
1542,1594,	1547,1599,	1557,81,	1548,1600,	
1576,172,	943,1010,	935,854,	1583,1029,	
935,854,	1554,1605,	935,854,	943,1010,	
943,1012,	1549,1601,	943,1010,	1551,1603,	
943,1010,	1556,1607,	943,1010,	1555,1606,	
934,0,	1559,81,	1561,1614,	1574,81,	
1562,1615,	1563,1616,	1564,1617,	1568,1623,	
1565,1618,	943,1010,	1575,1630,	1558,1609,	
1569,1624,	1566,1619,	1570,1625,	1579,172,	
935,854,	936,1003,	936,88,	936,88,	
936,88,	936,88,	936,88,	936,88,	
936,88,	936,88,	936,88,	936,88,	
936,88,	936,88,	936,88,	936,88,	
936,88,	936,88,	936,88,	936,88,	
936,88,	936,88,	936,88,	936,88,	
936,88,	936,88,	936,88,	943,1010,	
956,740,	943,1010,	1583,1640,	943,1010,	
1584,958,	1584,888,	1576,1631,	1587,180,	
956,740,	956,741,	957,740,	1557,1608,	
1586,532,	1588,180,	1591,331,	1590,180,	
1593,1121,	1595,1046,	957,740,	957,741,	
958,1027,	1603,132,	1601,132,	1559,1610,	
1583,1106,	1596,906,	1614,1675,	1597,547,	
958,1027,	958,1028,	1602,132,	1598,1053,	
1599,911,	1574,1629,	1608,0,	1600,551,	
1614,495,	1579,1636,	1606,1067,	956,1025,	
956,740,	956,743,	1607,925,	956,740,	
1618,90,	956,740,	1630,172,	956,740,	
3379,3381,	1605,563,	957,740,	957,743,	
1617,1678,	957,740,	958,999,	957,740,	
1608,1669,	957,740,	956,810,	1619,1680,	
958,1027,	958,1029,	1617,90,	958,1027,	
1584,1641,	958,1027,	1608,81,	958,1027,	
957,810,	1619,90,	1586,1643,	1626,159,	
1622,1682,	3394,3454,	1625,868,	1587,1644,	
1595,1654,	1593,1652,	958,1030,	1588,1645,	
959,1028,	1590,1649,	1624,1012,	1591,1650,	
1596,1655,	1597,1656,	1609,0,	1603,1662,	
959,1028,	959,1028,	1598,1657,	1599,1658,	
956,740,	1600,1659,	956,740,	1601,1660,	
956,740,	1606,1667,	1602,1661,	1628,162,	
962,527,	1607,1668,	957,740,	1633,1633,	
957,740,	1622,1622,	957,740,	1605,1666,	
962,527,	962,528,	1636,172,	1644,180,	
958,1027,	1618,1679,	958,1027,	1630,1690,	
958,1027,	1610,0,	1609,81,	1629,0,	
959,1028,	973,1044,	956,740,	959,1028,	
957,1026,	959,1028,	1623,1683,	959,1028,	
3398,1802,	973,1044,	973,1045,	1649,180,	
957,740,	1653,760,	962,80,	1633,1693,	
1623,508,	1626,1686,	959,1031,	1610,1671,	
962,527,	962,530,	958,527,	962,527,	
1631,1691,	962,527,	1625,1685,	962,527,	
974,1045,	1610,81,	1624,1684,	1629,81,	
1634,1694,	1642,1703,	1631,172,	973,1044,	
974,1045,	974,1045,	962,605,	1652,1121,	
1640,1029,	973,1044,	973,1046,	1642,530,	
973,1044,	1628,1688,	973,1044,	1647,1647,	
973,1044,	978,1051,	1641,958,	1641,888,	
959,1028,	1655,906,	959,1028,	3407,1864,	
959,1028,	978,1051,	978,1052,	973,1047,	
1644,1705,	1654,1046,	974,1045,	1636,1697,	
1657,1053,	1634,1634,	1658,911,	1609,1670,	
974,1045,	979,1052,	1634,1695,	974,1045,	
962,527,	974,1045,	962,527,	974,1045,	
962,527,	979,1052,	979,1052,	1647,1708,	
1648,1709,	1643,1704,	959,528,	978,1051,	
1649,1711,	1650,331,	974,1048,	1653,1715,	
962,1033,	978,1051,	978,1053,	1643,532,	
978,1051,	973,1044,	978,1051,	973,1044,	
978,1051,	973,1044,	1652,1714,	1676,1001,	
1645,1706,	3416,1873,	962,527,	979,1052,	
1629,1689,	1651,1713,	1665,1726,	978,1054,	
1640,1701,	979,1052,	1645,180,	983,132,	
979,1052,	1648,1648,	979,1052,	1651,1254,	
979,1052,	1669,0,	1648,1710,	1670,0,	
974,1045,	1640,1106,	974,1045,	1641,1702,	
974,1045,	1655,1717,	1656,1718,	979,1055,	
1661,132,	1654,1716,	1659,1721,	1667,1067,	
1657,1719,	1668,925,	1660,1722,	1680,90,	
1656,547,	1662,1724,	1658,1720,	1665,1665,	
1659,551,	978,1051,	1650,1712,	978,1051,	
1660,132,	978,1051,	1666,1727,	1662,132,	
1675,495,	1669,1730,	1683,508,	1670,81,	
1686,159,	1690,172,	1684,1012,	1688,162,	
1666,563,	1704,532,	1676,1738,	1691,172,	
1674,1674,	979,1052,	1682,1682,	979,1052,	
1671,0,	979,1052,	983,1058,	983,130,	
983,130,	983,130,	983,130,	983,130,	
983,130,	983,130,	983,130,	983,130,	
983,130,	983,130,	983,130,	983,130,	
983,130,	983,130,	983,130,	983,130,	
983,130,	983,130,	983,130,	983,130,	
983,130,	983,130,	983,130,	983,130,	
990,1065,	1674,1613,	1748,1012,	1682,1622,	
1671,81,	1661,1723,	1697,1762,	1667,1728,	
990,1065,	990,1066,	999,999,	1680,1742,	
1670,1731,	1668,1729,	1690,1754,	1694,1694,	
1697,172,	1718,547,	999,999,	999,1000,	
1001,999,	1684,1748,	1675,1737,	1705,180,	
1683,1747,	1706,180,	1701,1029,	1689,0,	
1001,1078,	1001,1000,	1002,854,	1704,1769,	
1715,760,	1686,1750,	990,1065,	1691,1755,	
1688,1752,	1714,1121,	1002,854,	1002,855,	
990,1065,	990,1067,	1674,1736,	990,1065,	
1682,1746,	990,1065,	1696,240,	990,1065,	
1694,1634,	1689,1753,	999,999,	999,1001,	
1713,1254,	999,999,	1721,551,	999,999,	
1711,1777,	999,999,	990,1065,	1689,81,	
1001,999,	1001,1001,	1709,1709,	1001,999,	
1002,854,	1001,999,	1711,180,	1001,999,	
999,999,	1737,495,	1002,933,	1002,856,	
1671,1732,	1002,854,	1748,1815,	1002,854,	
1705,1770,	1002,854,	1001,999,	1696,172,	
1716,1046,	1724,132,	1726,1726,	1718,1784,	
1696,1761,	1701,1766,	1736,1613,	1719,1053,	
1002,854,	1694,1760,	1025,1101,	1715,1781,	
990,1065,	1706,1771,	990,1065,	1709,1648,	
990,1065,	1727,563,	1025,1101,	1025,1102,	
1010,1010,	1723,132,	999,999,	1741,90,	
999,999,	1714,1780,	999,999,	1701,1106,	
1010,1010,	1010,1011,	1728,1067,	1735,1803,	
1001,999,	1713,1779,	1001,999,	1726,1665,	
1001,999,	1739,856,	1745,1812,	1015,296,	
1721,1787,	1781,760,	1002,854,	1732,0,	
1002,854,	1746,1622,	1002,854,	1015,296,	
1015,297,	1731,0,	1025,740,	1025,1103,	
999,1076,	1025,1101,	1010,1010,	1025,1101,	
1709,1776,	1025,1101,	1737,1805,	1716,1782,	
1010,1010,	1010,1012,	1001,1076,	1010,1010,	
1735,1735,	1010,1010,	1719,1785,	1010,1010,	
1025,1104,	1724,1790,	1002,1079,	1745,1745,	
1002,854,	1015,296,	1723,1789,	1732,81,	
1726,1794,	1740,91,	1010,1010,	1015,223,	
1015,298,	1731,81,	1015,296,	1727,1795,	
1015,296,	1736,1804,	1015,296,	1730,82,	
1730,0,	1728,1796,	1742,90,	1747,508,	
3427,1949,	1741,1809,	1753,0,	1750,1817,	
1757,1757,	1015,296,	1779,1254,	1781,1847,	
1026,740,	1758,1825,	1025,1101,	1752,1819,	
1025,1101,	1750,159,	1025,1101,	1023,172,	
1026,740,	1026,741,	1740,90,	1739,1807,	
1010,1010,	1752,162,	1010,1010,	1740,1808,	
1010,1010,	1749,868,	3430,3484,	3440,1963,	
1730,81,	1755,172,	1751,298,	1754,172,	
1746,1813,	1730,1798,	1753,81,	1760,1634,	
1757,1824,	1766,1029,	1753,1820,	1015,296,	
1025,1101,	1015,296,	1758,1758,	1015,296,	
1767,958,	1767,888,	1776,1648,	1758,1826,	
1026,740,	1026,743,	1010,1087,	1026,740,	
1732,1800,	1026,740,	1770,180,	1026,740,	
1015,1091,	1783,906,	1769,532,	1731,1799,	
1771,180,	1780,1121,	1778,331,	1784,547,	
1786,911,	1779,1845,	1026,810,	1742,1810,	
1747,1814,	1015,296,	1023,1099,	1023,168,	
1023,168,	1023,168,	1023,168,	1023,168,	
1023,168,	1023,168,	1023,168,	1023,168,	
1023,168,	1023,168,	1023,168,	1023,168,	
1023,168,	1023,168,	1023,168,	1023,168,	
1023,168,	1023,168,	1023,168,	1023,168,	
1023,168,	1023,168,	1023,168,	1023,168,	
1751,1818,	1028,1028,	1755,1822,	1749,1816,	
1026,740,	1754,1821,	1026,740,	1774,1840,	
1026,740,	1028,1028,	1028,1028,	1030,999,	
1782,1046,	1766,1832,	1785,1053,	1773,1773,	
1787,551,	1788,133,	1760,1827,	1030,999,	
1030,1000,	1757,1802,	1766,1106,	1767,1833,	
1780,1846,	1790,132,	1789,132,	1026,1105,	
1770,1836,	1776,1842,	1033,527,	1769,1835,	
1778,1844,	1771,1837,	1026,740,	1783,1849,	
1784,1850,	1794,1665,	1033,527,	1033,528,	
1774,1774,	1028,1028,	1786,1852,	1793,1858,	
1028,1028,	1774,1841,	1028,1028,	1773,1839,	
1028,1028,	1795,563,	1788,132,	1030,999,	
1030,1001,	1797,925,	1030,999,	1788,1854,	
1030,999,	1796,1067,	1030,999,	1028,1031,	
1800,0,	1033,1110,	1804,1613,	1805,495,	
1033,80,	1809,90,	1810,90,	1813,1622,	
1803,1803,	1030,999,	1033,527,	1033,530,	
1801,0,	1033,527,	1814,508,	1033,527,	
1793,1793,	1033,527,	1799,0,	1820,0,	
1807,856,	1864,1923,	1816,868,	1845,1254,	
1782,1848,	1787,1853,	1785,1851,	1835,532,	
1033,605,	3443,3496,	1822,172,	1042,1119,	
1800,81,	1028,1028,	1790,1856,	1028,1028,	
1789,1855,	1028,1028,	1039,180,	1042,1119,	
1042,1120,	1803,1735,	1847,1907,	1030,999,	
1801,81,	1030,999,	1818,298,	1030,999,	
1824,1887,	1821,172,	1799,81,	1820,81,	
1847,760,	1827,1634,	1864,1864,	1820,1884,	
1794,1859,	1812,1812,	1795,1860,	1810,1875,	
1805,1869,	1839,1900,	1033,527,	1028,1107,	
1033,527,	1042,1119,	1033,527,	1797,1862,	
1773,1802,	1796,1861,	1836,180,	1814,1878,	
1042,1121,	1030,1076,	1042,1119,	1804,1868,	
1042,1119,	1809,1874,	1042,1119,	1807,1871,	
1813,1877,	1816,1880,	1803,1867,	1822,1886,	
1835,1897,	1800,1866,	1833,958,	1833,888,	
1837,180,	1042,1122,	1812,1745,	1845,1905,	
1033,527,	1039,1116,	1039,176,	1039,176,	
1039,176,	1039,176,	1039,176,	1039,176,	
1039,176,	1039,176,	1039,176,	1039,176,	
1039,176,	1039,176,	1039,176,	1039,176,	
1039,176,	1039,176,	1039,176,	1039,176,	
1039,176,	1039,176,	1039,176,	1039,176,	
1039,176,	1039,176,	1039,176,	1818,1882,	
1044,1044,	1821,1885,	1799,1865,	1042,1119,	
1824,1802,	1042,1119,	1827,1889,	1042,1119,	
1044,1044,	1044,1045,	1045,1045,	1812,1876,	
1842,1648,	1825,1825,	1846,1121,	1849,906,	
1828,240,	1839,1802,	1045,1045,	1045,1045,	
1047,999,	1837,1899,	1836,1898,	1840,1840,	
1850,547,	1852,911,	1833,1895,	1865,0,	
1047,999,	1047,1000,	1844,331,	1843,251,	
1859,1665,	1042,1119,	1044,1044,	1855,132,	
1853,551,	1858,1858,	1856,132,	1866,0,	
1044,1044,	1044,1046,	1862,925,	1044,1044,	
1045,1045,	1044,1044,	1825,1758,	1044,1044,	
1874,90,	1828,172,	1045,1045,	3457,1915,	
1868,1613,	1045,1045,	1828,1890,	1045,1045,	
1840,1774,	1045,1045,	1044,1047,	1865,81,	
1047,999,	1047,1001,	1860,563,	1047,999,	
1843,180,	1047,999,	1875,90,	1047,999,	
1045,1048,	1843,1903,	1858,1793,	1866,81,	
1867,1735,	1876,1745,	1849,1909,	1870,1001,	
1877,1622,	1873,1931,	1047,999,	1879,1012,	
1054,999,	1850,1910,	1888,1758,	1889,1634,	
1852,1912,	1842,1902,	1846,1906,	1825,1888,	
1054,999,	1054,1000,	1051,1051,	1856,1917,	
1044,1044,	1853,1913,	1044,1044,	1885,172,	
1044,1044,	1840,1901,	1051,1051,	1051,1052,	
1052,1052,	1862,1922,	1045,1045,	1844,1904,	
1045,1045,	1859,1919,	1045,1045,	1855,1916,	
1052,1052,	1052,1052,	1873,1873,	1858,1918,	
1047,999,	1880,868,	1047,999,	1886,172,	
1047,999,	1874,1932,	1898,180,	1860,1920,	
1054,999,	1054,1001,	1044,1124,	1054,999,	
1051,1051,	1054,999,	1868,1927,	1054,999,	
1865,1924,	1881,222,	1051,1051,	1051,1053,	
1045,1125,	1051,1051,	1052,1052,	1051,1051,	
1875,1933,	1051,1051,	1054,999,	1899,180,	
1052,1052,	1866,1925,	1047,1076,	1052,1052,	
1882,1940,	1052,1052,	1901,1774,	1052,1052,	
1051,1054,	1870,1929,	1877,1935,	1867,1926,	
1876,1934,	1879,1937,	1882,298,	1883,227,	
1909,906,	1889,1946,	1052,1055,	1884,0,	
1905,1254,	1888,1945,	1881,159,	1902,1648,	
1885,1943,	1895,958,	1895,888,	1881,1939,	
1915,1974,	1894,1029,	1065,1065,	1880,1938,	
1054,999,	1904,1964,	1054,999,	1907,760,	
1054,999,	1908,1046,	1065,1065,	1065,1066,	
1911,1053,	1884,1942,	1051,1051,	1904,331,	
1051,1051,	1886,1944,	1051,1051,	1898,1957,	
1883,162,	1078,999,	1912,911,	1884,81,	
1052,1052,	1883,1941,	1052,1052,	1918,1793,	
1052,1052,	1078,1078,	1078,1000,	1079,854,	
1917,132,	1915,1915,	1054,1076,	1916,132,	
1065,1065,	1919,1665,	1921,1067,	1079,854,	
1079,855,	1899,1958,	1065,1065,	1065,1067,	
1051,1129,	1065,1065,	1909,1969,	1065,1065,	
1923,1923,	1065,1065,	1101,1101,	1905,1965,	
1922,925,	1925,0,	1052,1130,	1078,999,	
1895,1954,	1901,1959,	1101,1101,	1101,1102,	
1065,1065,	1078,999,	1078,1001,	1926,1735,	
1078,999,	1079,854,	1078,999,	1924,0,	
1078,999,	1902,1960,	1927,1613,	1079,933,	
1079,856,	1907,1967,	1079,854,	1894,1953,	
1079,854,	1930,1989,	1079,854,	1078,999,	
1912,1972,	1923,1864,	1894,1106,	1908,1968,	
1932,90,	1925,81,	1911,1971,	1930,856,	
1928,495,	1079,854,	1101,1173,	1101,1103,	
1090,157,	1101,1101,	1065,1065,	1101,1101,	
1065,1065,	1101,1101,	1065,1065,	1924,81,	
1090,157,	1090,158,	1917,1976,	1078,1151,	
1916,1975,	1929,1001,	1918,1977,	1931,1931,	
1101,1104,	1934,1745,	1922,1981,	1919,1978,	
1921,1980,	1078,999,	1935,1622,	1078,999,	
1937,1012,	1078,999,	1938,1997,	1936,508,	
1942,0,	1943,172,	1923,1982,	1079,854,	
1065,1141,	1079,854,	1090,157,	1079,854,	
1938,868,	1927,1986,	1949,2011,	3477,3528,	
1090,157,	1090,159,	3478,3529,	1090,157,	
1926,1985,	1090,157,	3593,3639,	1090,157,	
1931,1873,	1932,1991,	1101,1101,	1078,1076,	
1101,1101,	1079,1152,	1101,1101,	1967,760,	
1933,90,	1944,172,	1090,157,	1954,2016,	
1942,2006,	1079,854,	1928,1987,	1945,1758,	
1924,1983,	1925,1984,	1946,1634,	1953,1029,	
1954,958,	1954,888,	1958,180,	1949,1949,	
1929,1988,	1955,530,	1956,532,	1965,1254,	
1949,1890,	1957,180,	1959,1774,	1960,1648,	
1101,1101,	1935,1994,	1966,1121,	1937,1996,	
1968,1046,	1971,1053,	1943,2007,	1970,547,	
1973,551,	1931,1990,	1934,1993,	1978,1665,	
1090,220,	1936,1995,	1090,157,	1228,0,	
1090,1162,	1090,157,	1090,157,	1090,157,	
1090,157,	1090,157,	1090,157,	1090,157,	
1090,157,	1090,157,	1090,157,	1090,157,	
1090,157,	1090,157,	1090,157,	1090,157,	
1090,157,	1090,157,	1090,157,	1090,157,	
1090,157,	1090,157,	1090,157,	1090,157,	
1090,157,	1090,157,	1090,157,	1092,160,	
1967,2027,	1946,2010,	1953,2015,	1228,81,	
1933,1992,	1944,2008,	3663,3708,	1092,160,	
1092,161,	1982,1864,	1957,2019,	1969,2029,	
1945,2009,	1977,1793,	1960,2022,	1955,2017,	
1956,2018,	1963,2023,	1958,2020,	1968,2028,	
1971,2031,	1969,906,	1976,132,	1965,2025,	
1953,1106,	1972,2032,	1978,2038,	1959,2021,	
1975,132,	1970,2030,	1973,2033,	1980,1067,	
1966,2026,	1092,160,	3670,3715,	1972,911,	
3681,3726,	1981,2041,	2046,2103,	1092,223,	
1092,162,	3694,3739,	1092,224,	2047,2104,	
1092,160,	3705,3750,	1092,160,	1981,925,	
2046,1613,	1985,1735,	1963,1963,	1974,1974,	
3712,3757,	2047,495,	1987,495,	1963,1903,	
1990,1873,	1092,160,	1228,1292,	1228,80,	
1228,80,	1228,80,	1228,80,	1228,80,	
1228,80,	1228,80,	1228,80,	1228,80,	
1228,80,	1228,80,	1228,80,	1228,80,	
1228,80,	1228,80,	1228,80,	1228,80,	
1228,80,	1228,80,	1228,80,	1228,80,	
1228,80,	1228,80,	1228,80,	1228,80,	
1974,1915,	1975,2035,	1977,2037,	1979,563,	
1982,2042,	1991,90,	1980,2040,	1092,160,	
1986,1613,	1092,160,	1976,2036,	1092,1164,	
1092,160,	1092,160,	1092,160,	1092,160,	
1092,160,	1092,160,	1092,160,	1092,160,	
1092,160,	1092,160,	1092,160,	1092,160,	
1092,160,	1092,160,	1092,160,	1092,160,	
1092,160,	1092,160,	1092,160,	1092,160,	
1092,160,	1092,160,	1092,160,	1092,160,	
1092,160,	1092,160,	1102,1102,	1985,2045,	
1983,0,	1974,2034,	1984,0,	1987,2047,	
1992,90,	1993,1745,	1102,1102,	1102,1102,	
1103,1101,	1995,508,	1994,1622,	1990,2050,	
1996,1012,	1999,2058,	1997,868,	2008,172,	
1103,1176,	1103,1102,	1104,854,	2004,2060,	
2017,530,	2009,1758,	2007,172,	2048,2105,	
1991,2051,	2015,1029,	1104,854,	1104,855,	
2018,532,	1979,2039,	2019,180,	2010,1634,	
1983,81,	2048,1001,	1984,81,	1986,2046,	
2006,82,	2006,0,	1102,1174,	2011,2011,	
2020,180,	1102,1102,	2029,906,	1102,1102,	
2022,1648,	1102,1102,	1999,1999,	2034,1915,	
1103,1173,	1103,1103,	2021,1774,	1103,1101,	
2004,2004,	1103,1101,	2030,547,	1103,1101,	
1102,1175,	3725,3770,	1104,933,	1104,856,	
2027,760,	1104,854,	3735,3780,	1104,854,	
2028,1046,	1104,854,	1103,1104,	2016,958,	
2016,888,	2006,81,	1996,2056,	3738,3783,	
2011,1949,	1992,2052,	2006,2063,	2038,1665,	
1104,854,	1994,2054,	1105,740,	1993,2053,	
1997,2057,	2007,2064,	1995,2055,	2015,2072,	
2008,2065,	2026,1121,	1105,740,	1105,741,	
1106,527,	2019,2076,	1102,1102,	1983,2043,	
1102,1102,	2017,2074,	1102,1102,	2009,2066,	
1106,527,	1106,528,	2010,2067,	2023,2023,	
1103,1101,	2018,2075,	1103,1101,	1984,2044,	
1103,1101,	2024,399,	2015,1106,	1110,527,	
2029,2086,	2020,2077,	1104,854,	2022,2079,	
1104,854,	2011,2068,	1104,854,	1110,527,	
1110,528,	2027,2084,	1105,740,	1105,743,	
1102,1102,	1105,740,	2028,2085,	1105,740,	
2021,2078,	1105,740,	2034,2091,	2030,2087,	
1106,527,	1106,530,	1103,1101,	1106,527,	
2023,1963,	1106,527,	2016,2073,	1106,527,	
1105,810,	2031,1053,	2024,331,	2033,551,	
1104,854,	1110,80,	2038,2095,	2024,2081,	
2026,2083,	2035,132,	1106,605,	1110,527,	
1110,530,	1119,1119,	1110,527,	2032,911,	
1110,527,	2036,132,	1110,527,	2039,563,	
2037,1793,	1119,1119,	1119,1120,	2042,1864,	
2040,1067,	2041,925,	2045,1735,	2050,1873,	
2057,868,	1110,605,	2052,90,	3743,3788,	
1120,1120,	3754,3800,	1105,740,	2054,2111,	
1105,740,	2023,2080,	1105,740,	2053,1745,	
1120,1120,	1120,1120,	1105,1177,	2051,90,	
1106,527,	2054,1622,	1106,527,	1119,1119,	
1106,527,	3761,3808,	2102,1735,	2043,0,	
2044,0,	1119,1189,	1119,1121,	2068,1949,	
1119,1119,	3772,3819,	1119,1119,	2031,2088,	
1119,1119,	1122,854,	2058,2058,	1110,527,	
1105,740,	1110,527,	1120,1120,	1110,527,	
2035,2092,	1122,854,	1122,855,	1119,1122,	
1120,1190,	1110,1180,	1106,527,	1120,1120,	
2033,2090,	1120,1120,	2063,0,	1120,1120,	
1151,999,	2032,2089,	2040,2097,	2043,81,	
2044,81,	2045,2102,	2036,2093,	2052,2109,	
1151,999,	1151,1000,	1120,1191,	2041,2098,	
2039,2096,	1110,527,	2037,2094,	2058,1999,	
2042,2099,	2057,2114,	2053,2110,	2066,1758,	
2050,2107,	1122,933,	1122,856,	1152,854,	
1122,854,	1119,1119,	1122,854,	1119,1119,	
1122,854,	1119,1119,	2063,81,	1152,854,	
1152,855,	2064,172,	1151,999,	2076,180,	
2051,2108,	2102,2158,	2065,172,	1122,854,	
1151,999,	1151,1001,	2055,2112,	1151,999,	
1120,1120,	1151,999,	1120,1120,	1151,999,	
1120,1120,	2056,2113,	2060,2060,	2080,1963,	
2055,508,	2077,180,	2068,2122,	1119,1119,	
2058,2115,	1152,854,	1151,999,	2056,1012,	
2091,1915,	2044,2101,	2067,2121,	1152,933,	
1152,856,	2082,1254,	1152,854,	2078,1774,	
1152,854,	2083,1121,	1152,854,	1163,296,	
2067,1634,	1122,854,	1120,1120,	1122,854,	
2043,2100,	1122,854,	2066,2120,	1163,296,	
1163,297,	1152,854,	2086,906,	2060,2004,	
2073,958,	2073,888,	2089,911,	2072,2126,	
2074,2128,	2075,2129,	2079,2133,	2085,2141,	
1151,999,	2092,132,	1151,999,	2065,2119,	
1151,999,	2072,1029,	2074,530,	2075,532,	
2079,1648,	2085,1046,	2093,132,	1122,854,	
2113,1012,	1163,296,	2064,2118,	2098,925,	
2076,2130,	2099,1864,	2077,2131,	1163,223,	
1163,298,	2087,2143,	1163,296,	1152,854,	
1163,296,	1152,854,	1163,296,	1152,854,	
1151,1215,	2088,2144,	1151,1076,	2087,547,	
2060,2116,	2090,2146,	2078,2132,	2083,2139,	
1173,1235,	1163,296,	2080,2134,	2088,1053,	
2100,0,	2091,2147,	1174,1236,	2090,551,	
1173,1235,	1173,1236,	1152,1216,	2082,2138,	
2095,2151,	2103,1613,	1174,1236,	1174,1236,	
2094,1793,	1152,854,	2096,2152,	2097,2153,	
2101,0,	2107,1873,	2095,1665,	2086,2142,	
2108,90,	2109,90,	2073,2127,	2089,2145,	
2096,563,	2097,1067,	2111,1622,	2093,2149,	
2110,1745,	2114,868,	2118,172,	1163,296,	
2100,81,	1163,296,	2092,2148,	1163,296,	
1173,1235,	1173,1237,	2113,2169,	1173,1235,	
2115,1999,	1173,1235,	1174,1236,	1173,1235,	
2098,2154,	1174,1236,	2072,1106,	1174,1236,	
2101,81,	1174,1236,	2116,2004,	2099,2155,	
1163,1226,	2120,1758,	1173,1238,	2122,1949,	
2119,172,	3785,3831,	3805,3807,	1176,1101,	
1174,1239,	1163,296,	2121,1634,	2130,180,	
2126,1029,	2132,1774,	2131,180,	1176,1176,	
1176,1102,	1177,740,	2103,2159,	2094,2150,	
2133,1648,	2127,958,	2127,888,	2136,2191,	
2150,1793,	1177,740,	1177,741,	2134,1963,	
2109,2165,	2140,760,	2142,906,	2138,1254,	
2141,1046,	2147,1915,	2114,2170,	2111,2167,	
1173,1235,	2145,911,	1173,1235,	2107,2163,	
1173,1235,	2108,2164,	1174,1236,	2110,2166,	
1174,1236,	2149,132,	1174,1236,	1176,1173,	
1176,1103,	2139,2193,	1176,1101,	2118,2174,	
1176,1101,	2100,2156,	1176,1101,	2101,2157,	
2136,2136,	1177,740,	1177,743,	2139,1121,	
1177,740,	2148,132,	1177,740,	2119,2175,	
1177,740,	1176,1104,	1173,740,	2115,2171,	
2120,2176,	2151,1665,	2144,1053,	2121,2177,	
1174,741,	2131,2187,	1189,1252,	1177,810,	
2122,2178,	2116,2172,	2126,2182,	2127,2183,	
2132,2188,	2133,2189,	1189,1252,	1189,1253,	
2130,2186,	2153,1067,	2154,925,	2142,2196,	
1190,1253,	1176,1240,	2138,2192,	2150,2204,	
2157,0,	2126,1106,	2145,2199,	2140,2194,	
1190,1253,	1190,1253,	2141,2195,	1176,1101,	
2134,2190,	1176,1101,	2158,2213,	1176,1101,	
2149,2203,	2165,90,	3816,3818,	2147,2201,	
1189,1252,	1177,740,	2155,1864,	1177,740,	
2158,1735,	1177,740,	1189,1252,	1189,1254,	
2159,1613,	1189,1252,	1215,999,	1189,1252,	
3863,3907,	1189,1252,	1190,1253,	3889,3891,	
2157,81,	1177,1241,	1215,999,	1215,1000,	
1190,1253,	1176,1101,	2151,2205,	1190,1253,	
1189,1255,	1190,1253,	2148,2202,	1190,1253,	
2144,2198,	2163,1873,	2166,2222,	1177,740,	
2167,1622,	2177,1634,	2171,1999,	2154,2208,	
2169,1012,	1216,854,	1190,1256,	2172,2004,	
2166,1745,	2182,1029,	2175,172,	2153,2207,	
1215,999,	1216,854,	1216,855,	2178,1949,	
2160,575,	2176,2233,	1215,999,	1215,1001,	
2168,586,	1215,999,	2187,180,	1215,999,	
1235,1235,	1215,999,	1189,1252,	2176,1758,	
1189,1252,	2155,2209,	1189,1252,	2188,2246,	
1235,1235,	1235,1236,	2190,1963,	2159,2214,	
1215,999,	2189,1648,	2165,2221,	1216,854,	
1190,1253,	2188,1774,	1190,1253,	2195,1046,	
1190,1253,	1216,933,	1216,856,	2201,1915,	
1216,854,	2160,495,	1216,854,	2191,2191,	
1216,854,	2168,508,	2160,2215,	2185,609,	
2163,2218,	2157,2212,	2168,2224,	2167,2223,	
2177,2234,	2192,1254,	2193,1121,	1216,854,	
1235,1235,	1235,1237,	2194,760,	1235,1235,	
1226,296,	1235,1235,	1215,999,	1235,1235,	
1215,999,	2169,2225,	1215,999,	2171,2227,	
1226,296,	1226,297,	2182,2239,	2198,1053,	
2172,2228,	2203,132,	1235,1238,	2175,2232,	
2191,2136,	2205,1665,	2207,1067,	2217,856,	
2185,532,	2178,2235,	2182,1106,	2197,624,	
1215,1279,	2185,2242,	2204,2263,	2187,2245,	
2189,2247,	1216,854,	2200,628,	1216,854,	
1215,1076,	1216,854,	1226,296,	2210,2269,	
2204,1793,	1216,1280,	2201,2259,	2206,638,	
2190,2248,	1226,298,	2212,0,	1226,296,	
2195,2253,	1226,296,	2220,2281,	1226,296,	
1235,1235,	3900,3902,	1235,1235,	2192,2250,	
1235,1235,	3924,3960,	2221,90,	2231,2294,	
2197,547,	2191,2249,	1226,296,	1216,854,	
2193,2251,	2197,2255,	2209,1864,	2200,551,	
2232,172,	2213,1735,	2214,1613,	2210,2211,	
2200,2258,	2218,1873,	2223,1622,	2194,2252,	
2206,563,	2225,1012,	2212,81,	2227,1999,	
2205,2264,	2206,2265,	1235,1299,	2220,2220,	
2198,2256,	2228,2004,	2226,868,	2222,1745,	
2233,1758,	2217,2278,	2203,2262,	2207,2266,	
2231,2231,	2245,180,	2234,1634,	2235,1949,	
1226,296,	2231,2295,	1226,296,	2246,1774,	
1226,1290,	1226,296,	1226,296,	1226,296,	
1226,296,	1226,296,	1226,296,	1226,296,	
1226,296,	1226,296,	1226,296,	1226,296,	
1226,296,	1226,296,	1226,296,	1226,296,	
1226,296,	1226,296,	1226,296,	1226,296,	
1226,296,	1226,296,	1226,296,	1226,296,	
1226,296,	1226,296,	1226,296,	1236,1236,	
2211,2270,	2211,2269,	2213,2272,	2221,2282,	
2239,1029,	2209,2268,	2225,2288,	1236,1236,	
1236,1236,	1237,1235,	2214,2273,	2248,1963,	
2218,2279,	2232,2296,	2223,2284,	2240,958,	
2240,888,	1237,1301,	1237,1236,	1238,999,	
2222,2283,	2233,2297,	2247,1648,	2212,2271,	
2226,2289,	2227,2290,	2235,2299,	1238,999,	
1238,1000,	2251,1121,	2244,2311,	2228,2291,	
2246,2314,	2211,2211,	2234,2298,	2249,2136,	
2254,906,	2250,2318,	2245,2313,	1236,1236,	
2253,1046,	2252,2320,	1236,1236,	2256,1053,	
1236,1236,	2259,1915,	1236,1236,	2250,1254,	
2261,2333,	1237,1235,	1237,1237,	2252,760,	
1237,1235,	2266,1067,	1237,1235,	2262,132,	
1237,1235,	1236,1239,	2272,1735,	1238,999,	
1238,1001,	2239,2303,	1238,999,	2244,2244,	
1238,999,	2264,1665,	1238,999,	1237,1238,	
2244,2312,	2257,911,	2248,2316,	2263,1793,	
2267,925,	2268,2342,	2278,856,	2273,1613,	
2275,2348,	1238,999,	3930,3966,	1240,1101,	
3946,3982,	2261,2261,	2240,2304,	2268,1864,	
2279,2351,	2239,1106,	2289,868,	1240,1101,	
1240,1102,	2283,1745,	2247,2315,	1236,1236,	
2281,2281,	1236,1236,	2279,1873,	1236,1236,	
2284,1622,	2253,2321,	2251,2319,	1241,740,	
2256,2326,	1237,1235,	2254,2322,	1237,1235,	
2290,1999,	1237,1235,	2291,2004,	1241,740,	
1241,741,	2275,2275,	2266,2340,	1238,999,	
2259,2331,	1238,999,	2249,2317,	1238,999,	
2299,1949,	2272,2346,	2286,2357,	1240,1173,	
1240,1103,	1236,1300,	1240,1101,	2294,2294,	
1240,1101,	2281,2220,	1240,1101,	2316,1963,	
2262,2334,	2309,2375,	1241,1303,	1237,1299,	
2263,2335,	2264,2336,	2273,2347,	2257,2327,	
2311,2311,	1240,1104,	2267,2341,	1241,740,	
1241,743,	1238,1076,	1241,740,	2297,1758,	
1241,740,	1244,527,	1241,740,	2278,2350,	
2283,2355,	2270,2270,	2270,2269,	2286,2286,	
2298,1634,	1244,527,	1244,528,	2284,2356,	
2294,2231,	1241,810,	2317,2136,	2289,2359,	
2304,958,	2304,888,	2309,2309,	2290,2360,	
2342,1864,	2291,2361,	2281,2352,	2314,1774,	
2315,1648,	2311,2244,	2318,1254,	1240,1101,	
1251,329,	1240,1101,	2322,906,	1240,1101,	
2319,1121,	2327,911,	2341,925,	1244,80,	
1251,329,	1251,330,	2270,2211,	2299,2368,	
2335,1793,	1244,527,	1244,530,	2324,2388,	
1244,527,	2329,2391,	1244,527,	1241,740,	
1244,527,	1241,740,	2316,2381,	1241,740,	
2336,1665,	2294,2363,	2331,2392,	1240,1302,	
2343,2269,	1240,1101,	2297,2366,	1244,605,	
2351,1873,	2338,2398,	1251,329,	3948,3984,	
2331,1915,	3954,3990,	2311,2376,	2298,2367,	
1251,329,	1251,331,	2344,2403,	1251,329,	
2354,2413,	1251,329,	2352,2220,	1251,329,	
2324,2324,	1241,740,	2329,2329,	2270,2343,	
2333,2333,	2342,2401,	2314,2379,	2315,2380,	
2345,2404,	2345,2403,	1251,397,	2317,2382,	
2343,2211,	2319,2384,	2304,2373,	2347,1613,	
2318,2383,	1244,527,	2338,2338,	1244,527,	
2346,1735,	1244,527,	2350,2409,	2335,2396,	
2349,1001,	2356,1622,	2344,2345,	2322,2387,	
2355,1745,	2354,2354,	2327,2390,	2341,2400,	
2350,856,	2358,1012,	1244,1306,	2336,2397,	
3965,4000,	2333,2261,	2360,1999,	2361,2004,	
2366,1758,	2345,2345,	2363,2231,	2348,2348,	
1251,329,	2351,2410,	1251,329,	1244,527,	
1251,1313,	1251,329,	1251,329,	1251,329,	
1251,329,	1251,329,	1251,329,	1251,329,	
1251,329,	1251,329,	1251,329,	1251,329,	
1251,329,	1251,329,	1251,329,	1251,329,	
1251,329,	1251,329,	1251,329,	1251,329,	
1251,329,	1251,329,	1251,329,	1251,329,	
1251,329,	1251,329,	1251,329,	1252,1252,	
2348,2275,	2352,2411,	2333,2393,	2359,2418,	
2357,2357,	2372,1029,	2368,2428,	1252,1252,	
1252,1253,	1253,1253,	2367,1634,	2347,2406,	
2346,2405,	2359,868,	2349,2408,	2343,2402,	
2368,1949,	1253,1253,	1253,1253,	1255,999,	
2355,2414,	2356,2415,	2375,2375,	2358,2417,	
2379,1774,	2365,2424,	2373,2433,	1255,999,	
1255,1000,	2360,2419,	2361,2420,	2376,2244,	
2366,2426,	1252,1252,	2380,1648,	2373,958,	
2373,888,	2357,2286,	2381,2442,	1252,1252,	
1252,1254,	2348,2407,	1252,1252,	1253,1253,	
1252,1252,	2363,2422,	1252,1252,	2378,2438,	
2381,1963,	1253,1253,	2386,1046,	2382,2136,	
1253,1253,	3981,4014,	1253,1253,	2375,2309,	
1253,1253,	1252,1255,	2365,2365,	1255,999,	
1255,1001,	2388,2388,	1255,999,	2365,2425,	
1255,999,	2387,2448,	1255,999,	1253,1256,	
2401,1864,	2383,1254,	2408,1001,	2372,2432,	
3983,4015,	2393,2261,	2390,2451,	2387,906,	
2385,830,	1255,999,	2357,2416,	1299,740,	
2378,2378,	2397,1665,	2367,2427,	2389,1053,	
2390,911,	2378,2439,	2372,1106,	1299,740,	
1299,741,	1279,999,	2392,1915,	1252,1252,	
2379,2440,	1252,1252,	2388,2324,	1252,1252,	
2375,2435,	1279,999,	1279,1000,	1280,854,	
2396,1793,	1253,1253,	2428,1949,	1253,1253,	
2399,1067,	1253,1253,	2380,2441,	1280,854,	
1280,855,	2385,760,	2376,2436,	1255,999,	
2391,2391,	1255,999,	2385,2446,	1255,999,	
2386,2447,	2395,2456,	2407,2275,	1299,740,	
1299,743,	1252,1314,	1299,740,	1279,999,	
1299,740,	2382,2443,	1299,740,	2401,2462,	
2398,2398,	1279,999,	1279,1001,	1253,1315,	
1279,999,	1280,854,	1279,999,	2388,2449,	
1279,999,	1299,810,	2383,2444,	1280,933,	
1280,856,	1255,1076,	1280,854,	2408,2468,	
1280,854,	2391,2329,	1280,854,	1279,999,	
2400,2461,	2389,2450,	2395,2395,	2392,2453,	
2393,2454,	2397,2458,	2405,1735,	2411,2220,	
2410,1873,	1280,854,	2400,925,	2404,2404,	
2404,2403,	2398,2338,	2416,2286,	2428,2485,	
2402,2269,	2413,2413,	2414,1745,	2417,1012,	
2396,2457,	1301,1235,	2399,2460,	1299,740,	
2419,2478,	1299,740,	2420,2479,	1299,740,	
2422,2231,	1301,1301,	1301,1236,	1302,1101,	
2436,2244,	1279,999,	2419,1999,	1279,999,	
2420,2004,	1279,999,	2391,2452,	1302,1101,	
1302,1102,	2426,1758,	2424,2424,	1280,854,	
2404,2345,	1280,854,	2442,1963,	1280,854,	
2402,2211,	2407,2467,	2413,2354,	2432,1029,	
2444,1254,	1299,740,	2398,2459,	2435,2309,	
1279,1339,	2449,2324,	2452,2329,	1280,1340,	
2445,1121,	1301,1235,	1301,1237,	1279,1076,	
1301,1235,	2405,2465,	1301,1235,	2410,2470,	
1301,1235,	2459,2338,	2463,2269,	1302,1173,	
1302,1103,	1280,854,	1302,1101,	2424,2365,	
1302,1101,	2414,2473,	1302,1101,	1301,1238,	
2411,2471,	2438,2438,	2440,1774,	2443,2136,	
3989,4020,	2404,2464,	2447,1046,	2450,1053,	
1303,740,	1302,1104,	2453,1915,	2413,2472,	
2417,2476,	2416,2475,	2454,2261,	2460,1067,	
1303,740,	1303,741,	2466,1613,	4040,4064,	
2426,2483,	2422,2481,	2463,2211,	1301,1359,	
2457,1793,	2436,2495,	2462,1864,	2442,2499,	
2467,2275,	2444,2501,	2472,2354,	1359,1235,	
2468,2526,	1301,1235,	2438,2378,	1301,1235,	
2424,2482,	1301,1235,	2471,2220,	1359,1235,	
1359,1236,	2402,2463,	2468,1001,	1302,1101,	
2432,2491,	1302,1101,	2445,2502,	1302,1101,	
1303,740,	1303,743,	1339,999,	1303,740,	
2432,1106,	1303,740,	2435,2494,	1303,740,	
2449,2508,	2452,2511,	1339,999,	1339,1000,	
2470,1873,	2440,2497,	2443,2500,	1301,1299,	
2465,1735,	1302,1360,	1303,810,	2464,2403,	
2459,2517,	2453,2512,	2478,1999,	1359,1235,	
1359,1237,	1302,1101,	1359,1235,	2438,2496,	
1359,1235,	1361,740,	1359,1235,	2447,2506,	
2450,2509,	2456,2456,	2473,1745,	2457,2515,	
1339,999,	1361,740,	1361,741,	2454,2513,	
2460,2518,	1359,1238,	1339,999,	1339,1001,	
2466,2524,	1339,999,	2462,2520,	1339,999,	
2463,2521,	1339,999,	1340,854,	2464,2345,	
1303,740,	2467,2525,	1303,740,	2476,2534,	
1303,740,	2474,1622,	1340,854,	1340,855,	
1339,999,	2472,2530,	1303,1361,	2475,2286,	
2471,2529,	2476,1012,	2456,2395,	2481,2231,	
2482,2365,	1361,740,	1361,743,	2477,944,	
1361,740,	2479,2004,	1361,740,	1359,1235,	
1361,740,	1359,1235,	2484,1634,	1359,1235,	
2470,2528,	1340,1396,	1303,740,	2478,2536,	
1340,854,	2483,1758,	2485,1949,	1361,810,	
2465,2523,	2491,2547,	1340,933,	1340,856,	
1360,1101,	1340,854,	1339,999,	1340,854,	
1339,999,	1340,854,	1339,999,	2491,1029,	
1360,1101,	1360,1102,	1339,1395,	1359,1415,	
2477,868,	1359,1299,	2473,2531,	2456,2514,	
1340,854,	2477,2535,	2494,2309,	2495,2244,	
2496,2378,	4063,4086,	2499,1963,	2497,1774,	
2492,961,	2502,1121,	2498,1648,	1364,527,	
2508,2324,	1361,740,	2500,2136,	1361,740,	
1339,1076,	1361,740,	2511,2329,	1364,527,	
1364,528,	1361,1417,	2464,2522,	2474,2532,	
1360,1173,	1360,1103,	2479,2537,	1360,1101,	
2475,2533,	1360,1101,	2504,2559,	1360,1101,	
2515,1793,	2481,2539,	1340,854,	2507,976,	
1340,854,	2485,2543,	1340,854,	2482,2540,	
2492,958,	2492,888,	1360,1104,	1361,740,	
2484,2542,	1364,80,	2492,2548,	2506,2560,	
2512,1915,	2483,2541,	2509,2563,	1364,527,	
1364,530,	1394,492,	1364,527,	2513,2261,	
1364,527,	2506,1046,	1364,527,	2510,981,	
2509,1053,	1394,492,	1394,494,	2504,2504,	
1340,854,	2499,2555,	2516,1665,	2514,2395,	
2507,906,	1364,605,	2517,2338,	2520,1864,	
2491,1106,	2507,2561,	2543,1949,	2494,2550,	
1360,1101,	2495,2551,	1360,1101,	2497,2553,	
1360,1101,	2500,2556,	2502,2558,	2496,2552,	
2498,2554,	2508,2562,	2521,2269,	1394,492,	
2519,991,	2524,1613,	4214,4234,	2511,2565,	
2510,911,	1394,492,	1394,495,	2522,2403,	
1394,492,	2510,2564,	1394,492,	1360,1416,	
1394,492,	4218,4238,	2518,2572,	1364,527,	
2515,2569,	1364,527,	1360,1101,	1364,527,	
2525,2275,	4222,4242,	2530,2354,	1394,573,	
2518,1067,	2533,2286,	2557,1254,	2540,2365,	
2512,2566,	2547,2605,	2521,2211,	2528,1873,	
2529,2220,	2519,925,	2532,1622,	2550,2309,	
1364,1420,	2556,2617,	2519,2573,	2522,2345,	
2552,2378,	2513,2567,	2520,2574,	2536,1999,	
2537,2004,	1364,527,	2539,2231,	2556,2136,	
2555,1963,	2542,1634,	2562,2324,	4226,4246,	
2516,2570,	2565,2329,	2543,2601,	2517,2571,	
2551,2244,	1394,492,	2514,2568,	1394,492,	
2524,2578,	1394,1450,	1394,492,	1394,492,	
1394,492,	1394,492,	1394,492,	1394,492,	
1394,492,	1394,492,	1394,492,	1394,492,	
1394,492,	1394,492,	1394,492,	1394,492,	
1394,492,	1394,492,	1394,492,	1394,492,	
1394,492,	1394,492,	1394,492,	1394,492,	
1394,492,	1394,492,	1394,492,	1394,492,	
1395,999,	2521,2575,	2528,2584,	2529,2585,	
2557,2618,	2532,2588,	2525,2579,	2530,2586,	
1395,999,	1395,1000,	1396,854,	2533,2589,	
2540,2598,	2558,2619,	2536,2594,	2537,2595,	
2554,1648,	2539,2597,	1396,854,	1396,855,	
2542,2600,	2550,2611,	2547,1106,	2558,1121,	
2522,2576,	2552,2613,	2559,2559,	2551,2612,	
2555,2616,	1406,296,	2566,1915,	2567,2261,	
2568,2395,	2576,2403,	1395,999,	2571,2338,	
2562,2626,	1406,296,	1406,297,	2565,2632,	
1395,999,	1395,1001,	2570,1665,	1395,999,	
1396,854,	1395,999,	2575,2269,	1395,999,	
2585,2220,	4230,4250,	1396,933,	1396,856,	
2574,1864,	1396,854,	2836,1613,	1396,854,	
2577,1735,	1396,854,	1395,999,	2559,2504,	
2583,2652,	2578,1613,	2584,1873,	1406,296,	
2586,2354,	2576,2345,	2587,1745,	2579,2275,	
1396,854,	1406,223,	1406,298,	2588,1622,	
1406,296,	1402,505,	1406,296,	2554,2615,	
1406,296,	2589,2286,	2575,2211,	2594,1999,	
2598,2365,	1402,505,	1402,507,	2596,2062,	
2593,2662,	2595,2004,	2599,1758,	1406,296,	
2597,2231,	2566,2633,	2567,2634,	2600,1634,	
1395,999,	2583,2583,	1395,999,	2612,2244,	
1395,999,	2601,1949,	2611,2309,	2616,1963,	
2559,2620,	2570,2637,	1396,854,	2615,1648,	
1396,854,	2568,2635,	1396,854,	1402,505,	
1395,1451,	2571,2638,	2590,1088,	2836,2896,	
1396,1452,	1402,505,	1402,508,	2585,2654,	
1402,505,	2593,2593,	1402,505,	2578,2647,	
1402,505,	1406,296,	1395,1076,	1406,296,	
2574,2643,	1406,296,	2579,2648,	2613,2378,	
1406,1462,	2588,2657,	2577,2646,	1402,585,	
1396,854,	2614,1774,	2584,2653,	2618,1254,	
2589,2658,	2617,2136,	2586,2655,	2576,2645,	
2587,2656,	2626,2324,	2596,2665,	2590,1012,	
2620,2504,	2575,2644,	2633,1915,	2594,2663,	
2590,2659,	2600,2669,	2635,2395,	1406,296,	
2632,2329,	2595,2664,	2598,2667,	2597,2666,	
2601,2670,	2611,2680,	2616,2685,	2634,2261,	
2599,2668,	2615,2684,	2612,2681,	2637,1665,	
2621,1126,	1402,505,	2624,2694,	1402,505,	
2638,2338,	1402,1458,	1402,505,	1402,505,	
1402,505,	1402,505,	1402,505,	1402,505,	
1402,505,	1402,505,	1402,505,	1402,505,	
1402,505,	1402,505,	1402,505,	1402,505,	
1402,505,	1402,505,	1402,505,	1402,505,	
1402,505,	1402,505,	1402,505,	1402,505,	
1402,505,	1402,505,	1402,505,	1402,505,	
1415,1235,	2621,1046,	2617,2686,	2624,2624,	
2626,2695,	2613,2682,	2621,2690,	2645,2403,	
1415,1235,	1415,1236,	1416,1101,	2614,2683,	
2618,2687,	2630,2700,	2636,1793,	2632,2701,	
2642,2711,	2648,2275,	1416,1101,	1416,1102,	
2646,1735,	2605,1108,	2633,2702,	2627,1131,	
1417,740,	2637,2706,	2647,2716,	2620,2689,	
2635,2704,	2005,2059,	2634,2703,	2638,2707,	
1417,740,	1417,741,	2654,2722,	2712,1864,	
2647,1613,	2005,2059,	2005,2061,	2645,2345,	
1415,1235,	1415,1237,	2655,2354,	1415,1235,	
2654,2220,	1415,1235,	2630,2630,	1415,1235,	
2656,1745,	2642,2642,	1416,1173,	1416,1103,	
2639,1142,	1416,1101,	2605,1029,	1416,1101,	
2627,1053,	1416,1101,	1415,1238,	2605,2674,	
2652,2652,	2627,2696,	2658,2286,	2005,2059,	
1417,740,	1417,743,	2674,2676,	1417,740,	
1416,1104,	1417,740,	2005,2062,	1417,740,	
1420,527,	2644,2269,	2005,2059,	2661,2728,	
2005,2059,	2663,1999,	2662,2662,	2646,2715,	
1420,527,	1420,528,	1417,810,	2664,2004,	
2648,2717,	2639,1067,	2667,2365,	2005,2059,	
2636,2705,	2657,2725,	2639,2708,	2668,1758,	
1415,1235,	2652,2583,	1415,1235,	2644,2713,	
1415,1235,	2682,2378,	2645,2714,	2657,1622,	
2683,1774,	2655,2723,	1416,1101,	2686,2136,	
1416,1101,	2644,2211,	1416,1101,	2656,2724,	
2661,2661,	2712,2772,	1416,1472,	2662,2593,	
1420,527,	1420,530,	1415,1471,	1420,527,	
1417,740,	1420,527,	1417,740,	1420,527,	
1417,740,	2005,2059,	1415,1299,	2005,2059,	
2670,1949,	2005,2059,	2720,2583,	2666,2733,	
2669,2736,	2658,2726,	1420,605,	2680,2309,	
1416,1101,	1417,1473,	2652,2720,	2605,1106,	
2663,2730,	2666,2231,	2669,1634,	2681,2746,	
2685,1963,	2689,2504,	2664,2731,	2684,2749,	
2687,2752,	2667,2734,	1417,740,	2674,2741,	
2695,2324,	2681,2244,	2668,2735,	2005,2059,	
2662,2729,	2684,1648,	2687,1254,	2701,2329,	
2682,2747,	2704,2395,	2707,2338,	2683,2748,	
2705,1793,	2716,1613,	2686,2751,	2715,1735,	
1420,527,	2722,2220,	1420,527,	1445,0,	
1420,1476,	1420,527,	1420,527,	1420,527,	
1420,527,	1420,527,	1420,527,	1420,527,	
1420,527,	1420,527,	1420,527,	1420,527,	
1420,527,	1420,527,	1420,527,	1420,527,	
1420,527,	1420,527,	1420,527,	1420,527,	
1420,527,	1420,527,	1420,527,	1420,527,	
1420,527,	1420,527,	1420,527,	1421,457,	
2670,2737,	2692,2756,	2680,2745,	1445,81,	
2698,2760,	2710,2770,	4233,4253,	1421,457,	
1421,531,	2720,2779,	2676,2742,	2703,2764,	
2688,1192,	2721,1873,	2694,2694,	2700,2700,	
2685,2750,	2706,2767,	2689,2754,	2695,2758,	
2704,2765,	2703,2261,	2717,2777,	2705,2766,	
2714,2403,	2715,2775,	2701,2762,	2706,1665,	
4237,4256,	2707,2768,	2722,2781,	2716,2776,	
2717,2275,	1421,457,	2692,2692,	4241,4259,	
2724,1745,	2698,2698,	2710,2710,	1421,457,	
1421,532,	4245,4262,	1421,457,	2676,2676,	
1421,457,	2688,1121,	1421,457,	2694,2624,	
2700,2630,	2729,2593,	2688,2753,	2711,2711,	
4249,4265,	2713,2269,	4336,4346,	2757,2624,	
2714,2345,	1421,457,	1445,1501,	1445,80,	
1445,80,	1445,80,	1445,80,	1445,80,	
1445,80,	1445,80,	1445,80,	1445,80,	
1445,80,	1445,80,	1445,80,	1445,80,	
1445,80,	1445,80,	1445,80,	1445,80,	
1445,80,	1445,80,	1445,80,	1445,80,	
1445,80,	1445,80,	1445,80,	1445,80,	
2711,2642,	2713,2211,	2723,2354,	2721,2780,	
2694,2757,	2700,2761,	2732,2062,	1421,457,	
2725,1622,	1421,457,	2724,2783,	1421,1477,	
1421,457,	1421,457,	1421,457,	1421,457,	
1421,457,	1421,457,	1421,457,	1421,457,	
1421,457,	1421,457,	1421,457,	1421,457,	
1421,457,	1421,457,	1421,457,	1421,457,	
1421,457,	1421,457,	1421,457,	1421,457,	
1421,457,	1421,457,	1421,457,	1421,457,	
1421,457,	1421,457,	1433,544,	2714,2774,	
2676,2741,	2711,2771,	1453,90,	2726,2785,	
2729,2787,	2745,2805,	1433,544,	1433,545,	
2758,2820,	2728,2728,	2757,2819,	2762,2823,	
2730,1999,	2726,2286,	2731,2004,	2745,2309,	
2768,2829,	2742,2742,	2758,2324,	2815,2876,	
2734,2365,	2762,2329,	2713,2773,	2736,1634,	
2733,2231,	2732,2790,	2768,2338,	2775,2835,	
4338,4348,	2723,2782,	2735,1758,	4340,4350,	
1433,544,	4342,4352,	2725,2784,	4344,4354,	
2782,2842,	2775,1735,	1433,544,	1433,547,	
4356,4361,	1433,544,	2728,2661,	1433,544,	
4357,4362,	1433,544,	2782,2354,	2761,2630,	
4358,4363,	2754,2504,	2742,2676,	2779,2583,	
2815,2815,	2763,1915,	2771,2642,	2747,2378,	
1433,621,	1453,1509,	1453,88,	1453,88,	
1453,88,	1453,88,	1453,88,	1453,88,	
1453,88,	1453,88,	1453,88,	1453,88,	
1453,88,	1453,88,	1453,88,	1453,88,	
1453,88,	1453,88,	1453,88,	1453,88,	
1453,88,	1453,88,	1453,88,	1453,88,	
1453,88,	1453,88,	1453,88,	2728,2786,	
2730,2788,	2733,2791,	2731,2789,	2734,2792,	
2735,2793,	2736,2794,	1433,544,	2742,2802,	
1433,544,	2746,2244,	1433,1489,	1433,544,	
1433,544,	1433,544,	1433,544,	1433,544,	
1433,544,	1433,544,	1433,544,	1433,544,	
1433,544,	1433,544,	1433,544,	1433,544,	
1433,544,	1433,544,	1433,544,	1433,544,	
1433,544,	1433,544,	1433,544,	1433,544,	
1433,544,	1433,544,	1433,544,	1433,544,	
1433,544,	1436,548,	2747,2807,	2754,2817,	
2779,2839,	1493,132,	2761,2822,	2763,2824,	
2783,2843,	1436,548,	1436,549,	2742,2741,	
2874,2931,	2771,2831,	2792,2852,	2774,2403,	
2756,2756,	2760,2760,	2783,1745,	2793,2853,	
2751,2136,	2749,1648,	2765,2395,	2807,2867,	
2792,2365,	4359,4364,	4360,4365,	0,0,	
2748,1774,	2793,1758,	2767,1665,	2764,2261,	
0,0,	2807,2378,	2746,2806,	1436,548,	
2766,1793,	2774,2834,	0,0,	0,0,	
0,0,	1436,548,	1436,551,	2808,2868,	
1436,548,	2874,2874,	1436,548,	2774,2345,	
1436,548,	2756,2692,	2760,2698,	2786,2661,	
2818,2692,	2808,1774,	2787,2593,	2795,1949,	
2776,1613,	2784,1622,	2802,2676,	1436,625,	
1493,1549,	1493,130,	1493,130,	1493,130,	
1493,130,	1493,130,	1493,130,	1493,130,	
1493,130,	1493,130,	1493,130,	1493,130,	
1493,130,	1493,130,	1493,130,	1493,130,	
1493,130,	1493,130,	1493,130,	1493,130,	
1493,130,	1493,130,	1493,130,	1493,130,	
1493,130,	1493,130,	2748,2808,	2749,2809,	
2751,2811,	2765,2826,	2756,2818,	2760,2821,	
2764,2825,	1436,548,	2766,2827,	1436,548,	
2767,2828,	1436,1492,	1436,548,	1436,548,	
1436,548,	1436,548,	1436,548,	1436,548,	
1436,548,	1436,548,	1436,548,	1436,548,	
1436,548,	1436,548,	1436,548,	1436,548,	
1436,548,	1436,548,	1436,548,	1436,548,	
1436,548,	1436,548,	1436,548,	1436,548,	
1436,548,	1436,548,	1436,548,	1436,548,	
1442,560,	2776,2836,	2784,2844,	2787,2847,	
1525,172,	2795,2855,	2786,2846,	2818,2878,	
1442,560,	1442,562,	2826,2886,	2770,2770,	
2827,2887,	2802,2862,	3299,1633,	2802,2741,	
2812,1316,	0,0,	3278,3344,	0,0,	
2826,2395,	3314,1647,	2827,1793,	2892,2948,	
2794,1634,	2900,2956,	0,0,	2772,1864,	
2777,2275,	2780,1873,	2785,2286,	2781,2220,	
2933,2987,	2892,1864,	1442,560,	2900,1873,	
2791,2231,	0,0,	2940,2994,	0,0,	
1442,560,	1442,563,	2933,2504,	1442,560,	
2770,2710,	1442,560,	3299,1693,	1442,560,	
2940,1915,	2812,1254,	2821,2698,	3278,3278,	
2810,1963,	3314,1708,	2812,2872,	2773,2269,	
2809,1648,	0,0,	1442,637,	1525,1579,	
1525,168,	1525,168,	1525,168,	1525,168,	
1525,168,	1525,168,	1525,168,	1525,168,	
1525,168,	1525,168,	1525,168,	1525,168,	
1525,168,	1525,168,	1525,168,	1525,168,	
1525,168,	1525,168,	1525,168,	1525,168,	
1525,168,	1525,168,	1525,168,	1525,168,	
1525,168,	2770,2830,	2772,2832,	2773,2211,	
2780,2840,	2777,2837,	2781,2841,	2785,2845,	
1442,560,	2794,2854,	1442,560,	2791,2851,	
1442,1498,	1442,560,	1442,560,	1442,560,	
1442,560,	1442,560,	1442,560,	1442,560,	
1442,560,	1442,560,	1442,560,	1442,560,	
1442,560,	1442,560,	1442,560,	1442,560,	
1442,560,	1442,560,	1442,560,	1442,560,	
1442,560,	1442,560,	1442,560,	1442,560,	
1442,560,	1442,560,	1442,560,	1451,999,	
2805,2309,	2809,2869,	2810,2870,	2819,2624,	
2806,2244,	2821,2881,	2811,2136,	1451,999,	
1451,1000,	1471,1235,	2817,2504,	2820,2324,	
2822,2630,	2823,2329,	2824,1915,	2828,1665,	
2825,2261,	1471,1235,	1471,1236,	1472,1101,	
2829,2338,	2830,2710,	2773,2833,	2831,2642,	
2832,1864,	2840,1873,	2833,2269,	1472,1101,	
1472,1102,	2837,2275,	1451,1507,	2842,2354,	
2839,2583,	1451,999,	0,0,	0,0,	
2835,1735,	2844,1622,	2843,1745,	1451,999,	
1451,1001,	2841,2220,	1451,999,	2846,2661,	
1451,999,	2847,2593,	1451,999,	2862,2676,	
2848,1999,	1471,1235,	1471,1237,	2845,2286,	
1471,1235,	2852,2365,	1471,1235,	2834,2403,	
1471,1235,	1451,999,	2833,2211,	1472,1173,	
1472,1103,	2805,2865,	1472,1101,	2806,2866,	
1472,1101,	2811,2871,	1472,1101,	1471,1238,	
2854,1634,	2817,2877,	2851,2231,	2849,2004,	
2820,2880,	2824,2884,	2823,2883,	2825,2885,	
2819,2879,	1472,1104,	2855,1949,	2871,2136,	
2879,2624,	2829,2889,	2832,2892,	2840,2900,	
2828,2888,	2822,2882,	2853,1758,	2834,2345,	
2837,2897,	1473,740,	2864,2306,	1451,999,	
2842,2902,	1451,999,	2844,2904,	1451,999,	
2831,2891,	1473,740,	1473,741,	1507,999,	
2830,2890,	1471,1235,	2835,2895,	1471,1235,	
2843,2903,	1471,1235,	2839,2899,	1507,999,	
1507,1000,	2841,2901,	2845,2905,	1472,1101,	
2866,2244,	1472,1101,	2852,2912,	1472,1101,	
2846,2906,	2865,2309,	2867,2378,	2847,2907,	
2862,2920,	1451,1076,	2848,2908,	2870,1963,	
1471,1527,	2854,2914,	2833,2893,	1472,1528,	
2862,2741,	1473,740,	1473,743,	1471,1299,	
1473,740,	1507,999,	1473,740,	2869,1648,	
1473,740,	2855,2915,	2851,2911,	1507,999,	
1507,1001,	1472,1101,	1507,999,	2877,2504,	
1507,999,	2849,2909,	1507,999,	1473,810,	
2834,2894,	2864,2922,	2868,1774,	2871,2929,	
2853,2913,	2876,2876,	2879,2935,	2878,2692,	
2880,2324,	1507,999,	2883,2329,	0,0,	
2884,1915,	2881,2698,	1508,854,	2882,2630,	
2886,2395,	2888,1665,	2891,2642,	2885,2261,	
2893,2269,	2906,2661,	1508,854,	1508,855,	
0,0,	2887,1793,	2894,2403,	2890,2710,	
2865,2923,	2889,2338,	2897,2275,	2867,2925,	
2866,2924,	1473,740,	2870,2928,	1473,740,	
2895,1735,	1473,740,	2876,2815,	2905,2286,	
0,0,	1473,1529,	0,0,	1507,999,	
2869,2927,	1507,999,	0,0,	1507,999,	
1508,854,	0,0,	2899,2583,	0,0,	
2893,2211,	1507,1562,	1508,933,	1508,856,	
1518,296,	1508,854,	2894,2345,	1508,854,	
2903,1745,	1508,854,	2877,2933,	1473,740,	
1518,296,	1518,297,	2901,2220,	2880,2936,	
2868,2926,	2883,2939,	2884,2940,	0,0,	
1508,854,	1507,1076,	2888,2944,	1527,1235,	
2915,1949,	2886,2942,	2902,2354,	2876,2932,	
2878,2934,	2907,2593,	2908,1999,	1527,1235,	
1527,1236,	1560,1611,	2881,2937,	2885,2941,	
2889,2945,	2882,2938,	1518,296,	2887,2943,	
2891,2947,	1560,1611,	1560,1612,	2906,2962,	
1518,223,	1518,298,	2897,2953,	1518,296,	
2890,2946,	1518,296,	2909,2004,	1518,296,	
1528,1101,	2895,2951,	1508,854,	2905,2961,	
1508,854,	2899,2955,	1508,854,	2893,2949,	
1528,1101,	1528,1102,	1518,296,	1527,1235,	
1527,1237,	2894,2950,	1527,1235,	1560,1611,	
1527,1235,	2910,2062,	1527,1235,	1508,1563,	
2911,2231,	2901,2957,	1560,1613,	2928,1963,	
1560,1611,	2903,2959,	1560,1611,	2912,2365,	
1560,1611,	1527,1238,	2915,2971,	1528,1581,	
1508,854,	2902,2958,	2923,2309,	2913,1758,	
2907,2963,	2908,2964,	2920,2676,	1560,1611,	
1528,1173,	1528,1103,	1529,740,	1528,1101,	
1518,296,	1528,1101,	1518,296,	1528,1101,	
1518,296,	2926,1774,	1529,740,	1529,741,	
2924,2244,	2932,2815,	2934,2692,	2931,2931,	
2925,2378,	2909,2965,	1528,1104,	1518,1572,	
2971,3025,	2935,2624,	2936,2324,	1527,1235,	
2938,2630,	1527,1235,	2941,2261,	1527,1235,	
2942,2395,	2937,2698,	2971,1949,	1527,1580,	
2943,1793,	1560,1611,	1518,296,	1560,1611,	
2947,2642,	1560,1611,	0,0,	2911,2967,	
2946,2710,	2928,2983,	1529,740,	1529,743,	
2955,2583,	1529,740,	2912,2968,	1529,740,	
2931,2874,	1529,740,	2939,2329,	2910,2966,	
1528,1101,	1527,1299,	1528,1101,	2948,1864,	
1528,1101,	2953,2275,	0,0,	1567,1620,	
1529,810,	0,0,	2923,2978,	1560,1611,	
2913,2969,	1612,1612,	2983,3037,	1567,1620,	
1567,1621,	0,0,	1537,180,	2924,2979,	
2920,2975,	1612,1612,	1612,1612,	2925,2980,	
2983,1963,	2950,2403,	2926,2981,	2920,2741,	
2935,2989,	2949,2269,	1528,1101,	2938,2992,	
2957,2220,	2941,2995,	2945,2338,	2942,2996,	
2934,2988,	2931,2985,	2936,2990,	2963,2593,	
2932,2986,	1567,1620,	1529,740,	2947,3001,	
1529,740,	2952,1613,	1529,740,	1612,1612,	
1567,1622,	2943,2997,	1567,1620,	2937,2991,	
1567,1620,	1612,1673,	1567,1620,	2951,1735,	
1612,1612,	2950,2345,	1612,1612,	2955,3009,	
1612,1612,	2949,2211,	2946,3000,	1529,1582,	
2953,3007,	1567,1620,	2939,2993,	2959,1745,	
2956,1873,	2948,3002,	2958,2354,	1612,1612,	
1529,740,	1537,1590,	1537,176,	1537,176,	
1537,176,	1537,176,	1537,176,	1537,176,	
1537,176,	1537,176,	1537,176,	1537,176,	
1537,176,	1537,176,	1537,176,	1537,176,	
1537,176,	1537,176,	1537,176,	1537,176,	
1537,176,	1537,176,	1537,176,	1537,176,	
1537,176,	1537,176,	1537,176,	1567,1620,	
1571,159,	1567,1620,	2945,2999,	1567,1620,	
2957,3011,	1612,1612,	2963,3017,	1612,1612,	
3009,3063,	1612,1612,	0,0,	2952,3006,	
2951,3005,	0,0,	0,0,	2968,2365,	
2960,1622,	3288,3354,	3009,2583,	0,0,	
2967,2231,	2984,2136,	2979,2244,	2985,2874,	
2959,3013,	2950,3004,	2964,1999,	2961,2286,	
2962,2661,	1567,1620,	2965,2004,	2970,1634,	
2966,2062,	2949,3003,	2956,3010,	1612,1612,	
2969,1758,	2975,2676,	2958,3012,	2977,2306,	
2978,2309,	2980,2378,	2982,1648,	2981,1774,	
2986,2815,	2987,2504,	2988,2692,	2989,2624,	
2990,2324,	2992,2630,	3288,3288,	2991,2698,	
2993,2329,	2994,1915,	2998,1665,	1571,1626,	
1571,157,	1571,157,	1571,157,	1571,157,	
1571,157,	1571,157,	1571,157,	1571,157,	
1571,157,	1571,157,	1571,157,	1571,157,	
1571,157,	1571,157,	1571,157,	1571,157,	
1571,157,	1571,157,	1571,157,	1571,157,	
1571,157,	1571,157,	1571,157,	1571,157,	
1571,157,	1572,296,	2960,3014,	2968,3022,	
2964,3018,	1573,162,	2961,3015,	2962,3016,	
2965,3019,	1572,296,	1572,297,	2966,3020,	
2967,3021,	2969,3023,	2979,3033,	2984,3038,	
2975,3029,	2970,3024,	2977,3031,	2978,3032,	
2981,3035,	2996,2395,	2985,3039,	3004,2403,	
2995,2261,	2988,3042,	2987,3041,	2990,3044,	
2982,3036,	2980,3034,	2991,3045,	2993,3047,	
2999,2338,	3000,2710,	2989,3043,	1572,296,	
2992,3046,	2986,3040,	2975,2741,	2994,3048,	
2998,3052,	1572,223,	1572,298,	3001,2642,	
1572,296,	2997,1793,	1572,296,	3002,1864,	
1572,296,	3006,1613,	3016,2661,	3010,1873,	
3025,1949,	3007,2275,	3012,2354,	3004,2345,	
3014,1622,	0,0,	3015,2286,	1572,296,	
1573,1628,	1573,160,	1573,160,	1573,160,	
1573,160,	1573,160,	1573,160,	1573,160,	
1573,160,	1573,160,	1573,160,	1573,160,	
1573,160,	1573,160,	1573,160,	1573,160,	
1573,160,	1573,160,	1573,160,	1573,160,	
1573,160,	1573,160,	1573,160,	1573,160,	
1573,160,	1573,160,	3029,2676,	3022,2365,	
3024,1634,	2996,3050,	1577,1632,	2999,3053,	
3000,3054,	1572,296,	3017,3071,	1572,296,	
2995,3049,	1572,296,	1577,1632,	1577,1633,	
1580,1235,	3032,2309,	2997,3051,	3036,1648,	
3017,2593,	3018,3072,	3034,2378,	3040,2815,	
1580,1235,	1580,1236,	3001,3055,	1572,1627,	
3037,1963,	3012,3066,	3004,3058,	3018,1999,	
3002,3056,	3016,3070,	3025,3079,	1581,1101,	
3010,3064,	3038,2136,	3006,3060,	1572,296,	
1577,1632,	3007,3061,	3019,3073,	1581,1101,	
1581,1102,	3014,3068,	3015,3069,	1577,1634,	
3039,2874,	1577,1632,	3043,3097,	1577,1632,	
3019,2004,	1577,1632,	3044,2324,	3042,2692,	
1580,1235,	1580,1237,	3041,2504,	1580,1235,	
3043,2624,	1580,1235,	3022,3076,	1580,1235,	
1577,1632,	3045,2698,	3048,1915,	3047,2329,	
3052,1665,	3029,3083,	3053,2338,	3050,2395,	
3063,2583,	3054,2710,	1580,1238,	1581,1173,	
1581,1103,	3024,3078,	1581,1101,	3056,1864,	
1581,1101,	3034,3088,	1581,1101,	3029,2741,	
3057,2269,	3046,3100,	3064,1873,	3058,2403,	
3059,1735,	3032,3086,	3066,2354,	3055,3109,	
3036,3090,	1581,1104,	3037,3091,	3046,2630,	
3038,3092,	3040,3094,	1577,1632,	3071,2593,	
1577,1632,	3055,2642,	1577,1632,	0,0,	
0,0,	1582,740,	0,0,	0,0,	
1580,1235,	1712,331,	1580,1235,	3334,3400,	
1580,1235,	1582,740,	1582,741,	3060,3114,	
3057,2211,	3041,3095,	3065,2220,	3058,2345,	
3168,1674,	3039,3093,	3042,3096,	3076,2365,	
1580,1637,	3060,1613,	3044,3098,	1581,1101,	
1577,1632,	1581,1101,	3050,3104,	1581,1101,	
3045,3099,	3063,3117,	3067,1745,	3048,3102,	
3056,3110,	1581,1638,	1580,1299,	3047,3101,	
3054,3108,	3052,3106,	3053,3107,	3064,3118,	
3334,3334,	1582,740,	1582,743,	0,0,	
1582,740,	3068,3122,	1582,740,	3070,3124,	
1582,740,	3168,1613,	3059,3113,	0,0,	
3075,2231,	1581,1101,	3168,3222,	3068,1622,	
3071,3125,	3070,2661,	3066,3120,	1582,810,	
1712,1778,	1712,329,	1712,329,	1712,329,	
1712,329,	1712,329,	1712,329,	1712,329,	
1712,329,	1712,329,	1712,329,	1712,329,	
1712,329,	1712,329,	1712,329,	1712,329,	
1712,329,	1712,329,	1712,329,	1712,329,	
1712,329,	1712,329,	1712,329,	1712,329,	
1712,329,	1712,329,	3057,3111,	3058,3112,	
3065,3119,	3072,1999,	3073,2004,	3076,3130,	
3079,1949,	1582,740,	3077,1758,	1582,740,	
3067,3121,	1582,1639,	1582,740,	1582,740,	
1582,740,	1582,740,	1582,740,	1582,740,	
1582,740,	1582,740,	1582,740,	1582,740,	
1582,740,	1582,740,	1582,740,	1582,740,	
1582,740,	1582,740,	1582,740,	1582,740,	
1582,740,	1582,740,	1582,740,	1582,740,	
1582,740,	1582,740,	1582,740,	1582,740,	
1585,527,	3074,3128,	3075,3129,	3078,3132,	
3083,3137,	3087,2244,	3089,1774,	3090,3144,	
1585,527,	1585,528,	1589,1646,	3074,2062,	
3088,2378,	3078,1634,	3083,2676,	3092,2136,	
3091,1963,	3090,1648,	1589,1646,	1589,1647,	
3095,2504,	3094,2815,	3097,2624,	3093,2874,	
3102,1915,	3096,3150,	3100,2630,	3105,1793,	
3099,3153,	3103,2261,	3109,2642,	3072,3126,	
3073,3127,	3104,2395,	1585,80,	3096,2692,	
3077,3131,	3079,3133,	3099,2698,	3106,3160,	
1585,527,	1585,530,	3108,3162,	1585,527,	
1589,1646,	1585,527,	3113,1735,	1585,527,	
3121,1745,	3106,1665,	3115,2275,	1589,1648,	
3108,2710,	1589,1646,	3117,2583,	1589,1646,	
3119,2220,	1589,1646,	1585,605,	3124,2661,	
3126,1999,	3146,3200,	3127,2004,	0,0,	
3125,2593,	3150,2692,	3656,2269,	1594,757,	
1589,1646,	3129,2231,	3133,1949,	3146,2136,	
3089,3143,	3092,3146,	0,0,	1594,757,	
1594,758,	3747,2403,	1869,495,	3087,3141,	
3094,3148,	3102,3156,	0,0,	3097,3151,	
3088,3142,	3091,3145,	3123,2286,	3100,3154,	
3095,3149,	0,0,	3167,3221,	3109,3163,	
1585,527,	3105,3159,	1585,527,	3083,2741,	
1585,527,	3093,3147,	3656,3701,	1585,1642,	
3167,1735,	1594,757,	1589,1646,	3103,3157,	
1589,1646,	3104,3158,	1589,1646,	1594,757,	
1594,760,	3747,3793,	1594,757,	0,0,	
1594,757,	3117,3171,	1594,757,	3119,3173,	
0,0,	0,0,	3131,1758,	3113,3167,	
3124,3178,	3121,3175,	1585,527,	3125,3179,	
3115,3169,	1594,827,	3150,3204,	3133,3187,	
3129,3183,	3126,3180,	3111,2269,	3127,3181,	
1589,1646,	1869,1928,	1869,492,	1869,492,	
1869,492,	1869,492,	1869,492,	1869,492,	
1869,492,	1869,492,	1869,492,	1869,492,	
1869,492,	1869,492,	1869,492,	1869,492,	
1869,492,	1869,492,	1869,492,	1869,492,	
1869,492,	1869,492,	1869,492,	1869,492,	
1869,492,	1869,492,	1869,492,	1594,757,	
3123,3177,	1594,757,	3111,2211,	1594,1653,	
1594,757,	1594,757,	1594,757,	1594,757,	
1594,757,	1594,757,	1594,757,	1594,757,	
1594,757,	1594,757,	1594,757,	1594,757,	
1594,757,	1594,757,	1594,757,	1594,757,	
1594,757,	1594,757,	1594,757,	1594,757,	
1594,757,	1594,757,	1594,757,	1594,757,	
1594,757,	1594,757,	1604,1663,	3131,3185,	
3139,2306,	3137,2676,	3143,1774,	3140,2309,	
3148,2815,	3138,2608,	1604,1663,	1604,1664,	
1611,1611,	3141,2244,	3145,1963,	3147,2874,	
3152,2324,	3149,2504,	3151,2624,	3155,2329,	
1611,1611,	1611,1612,	1615,999,	3153,2698,	
3154,2630,	3161,2338,	3157,2261,	3162,2710,	
3163,2642,	3164,1864,	1615,999,	1615,1000,	
3159,1793,	3111,3165,	0,0,	3174,2354,	
1604,1663,	0,0,	3169,2275,	3171,2583,	
0,0,	0,0,	0,0,	1604,1665,	
3170,2651,	1604,1663,	1611,1611,	1604,1663,	
3175,3229,	1604,1663,	3165,2269,	3172,1873,	
1611,1672,	1611,1613,	3177,2286,	1611,1611,	
1615,999,	1611,1611,	3175,1745,	1611,1611,	
1604,1663,	3173,2220,	1615,999,	1615,1001,	
3184,2365,	1615,999,	3137,3191,	1615,999,	
3138,3192,	1615,999,	1611,1611,	3145,3199,	
3141,3195,	3179,2593,	3147,3201,	3148,3202,	
3149,3203,	3151,3205,	3139,3193,	3143,3197,	
1615,999,	3140,3194,	3165,2211,	3154,3208,	
3153,3207,	3157,3211,	3137,2741,	3163,3217,	
3162,3216,	3176,1682,	3152,3206,	3166,2403,	
1616,854,	3155,3209,	1604,1663,	3164,3218,	
1604,1663,	3169,3223,	1604,1663,	3161,3215,	
1616,854,	1616,855,	1620,1620,	3170,3224,	
1611,1611,	3159,3213,	1611,1611,	3171,3225,	
1611,1611,	3174,3228,	1620,1620,	1620,1621,	
1627,296,	3177,3231,	1615,999,	3178,2661,	
1615,999,	3172,3226,	1615,999,	3173,3227,	
1627,296,	1627,297,	3176,1622,	3166,2345,	
1604,1663,	3183,2231,	1616,854,	3176,3230,	
3180,1999,	3186,1694,	3181,2004,	1615,1676,	
1616,933,	1616,856,	1611,1611,	1616,854,	
1620,1620,	1616,854,	3184,3238,	1616,854,	
3165,3219,	3179,3233,	1620,1681,	1620,1622,	
1615,1076,	1620,1620,	1627,296,	1620,1620,	
3185,3239,	1620,1620,	1616,854,	3195,2244,	
1627,223,	1627,298,	3201,2874,	1627,296,	
3197,3251,	1627,296,	3185,1758,	1627,296,	
1620,1620,	3191,2676,	3186,1634,	3202,3256,	
3196,2378,	0,0,	3197,1774,	3186,3240,	
0,0,	3193,2306,	1627,296,	3203,2504,	
1637,1235,	3202,2815,	3178,3232,	3200,2136,	
3205,2624,	3194,2309,	3208,2630,	3210,1915,	
1637,1235,	1637,1236,	1632,1632,	3183,3237,	
1616,854,	3180,3234,	1616,854,	3181,3235,	
1616,854,	3204,2692,	1632,1632,	1632,1633,	
1638,1101,	3198,1709,	1620,1620,	3206,2324,	
1620,1620,	3166,3220,	1620,1620,	3207,2698,	
1638,1101,	1638,1102,	3209,2329,	1637,1698,	
1627,296,	1616,1677,	1627,296,	3211,2261,	
1627,296,	3195,3249,	1627,1687,	3212,2395,	
1637,1235,	1637,1237,	1616,854,	1637,1235,	
1632,1632,	1637,1235,	3214,1726,	1637,1235,	
3191,3245,	3201,3255,	1632,1692,	1632,1634,	
1620,1620,	1632,1632,	3198,1648,	1632,1632,	
3193,3247,	1632,1632,	1637,1238,	3198,3252,	
1638,1173,	1638,1103,	1627,296,	1638,1101,	
3194,3248,	1638,1101,	3196,3250,	1638,1101,	
1632,1632,	3200,3254,	3191,2741,	3203,3257,	
3205,3259,	3210,3264,	3208,3262,	3213,3267,	
3204,3258,	3215,2338,	1638,1104,	3214,1665,	
3216,2710,	3217,2642,	3206,3260,	3218,1864,	
3214,3268,	3213,1793,	3207,3261,	3227,3283,	
3223,2275,	3209,3263,	1639,740,	3226,1873,	
1637,1235,	3211,3265,	1637,1235,	3219,2269,	
1637,1235,	3227,2220,	1639,740,	1639,741,	
1646,1646,	3231,2286,	1632,1632,	3225,2583,	
1632,1632,	3232,2661,	1632,1632,	3228,2354,	
1646,1646,	1646,1647,	1663,1663,	3233,2593,	
1638,1101,	3212,3266,	1638,1101,	3237,3295,	
1638,1101,	3219,3273,	1663,1663,	1663,1664,	
1638,1699,	3241,1949,	1637,1299,	3248,2309,	
3238,2365,	3237,2231,	3246,2608,	3219,2211,	
3220,2403,	3245,2676,	1639,740,	1639,743,	
1632,1632,	1639,740,	1646,1646,	1639,740,	
3215,3269,	1639,740,	3254,2136,	3216,3270,	
1646,1707,	1646,1648,	1638,1101,	1646,1646,	
1663,1663,	1646,1646,	3223,3279,	1646,1646,	
1639,810,	3217,3271,	1663,1725,	1663,1665,	
3250,2378,	1663,1663,	3256,2815,	1663,1663,	
3218,3272,	1663,1663,	1646,1646,	3231,3289,	
3220,2345,	3249,3310,	3225,3281,	3253,1963,	
3226,3282,	3255,3319,	3228,3284,	3259,2624,	
1663,1663,	3262,2630,	3233,3291,	3249,2244,	
3258,2692,	3232,3290,	3261,2698,	3255,2874,	
3260,2324,	3264,1915,	3263,2329,	0,0,	
1672,1733,	3248,3309,	1639,740,	3238,3296,	
1639,740,	3246,3307,	1639,740,	3241,3302,	
1672,1733,	1672,1734,	1673,1734,	3265,3329,	
1646,1646,	3266,2395,	1646,1646,	3269,2338,	
1646,1646,	3245,3306,	1673,1734,	1673,1734,	
3270,2710,	3265,2261,	1663,1663,	3271,2642,	
1663,1663,	1639,1700,	1663,1663,	3254,3318,	
3272,3338,	3273,2269,	3245,2741,	3250,3311,	
1639,740,	3274,2403,	1672,1733,	3256,3320,	
3275,1803,	3281,2583,	3272,1864,	3220,3274,	
1672,1733,	1672,1735,	1646,1646,	1672,1733,	
1673,1734,	1672,1733,	3259,3323,	1672,1733,	
3262,3326,	3253,3317,	1673,1734,	3283,2220,	
1663,1663,	1673,1734,	3260,3324,	1673,1734,	
3263,3327,	1673,1734,	1672,1733,	3280,2651,	
3258,3322,	3273,2211,	3261,3325,	3284,2354,	
3292,1999,	3274,2345,	3343,3408,	1677,854,	
1673,1734,	3275,1735,	3264,3328,	3279,3345,	
3266,3330,	3269,3335,	3275,3341,	1677,854,	
1677,855,	3282,3348,	1878,508,	3289,3355,	
3308,3374,	3279,2275,	3271,3337,	3353,3417,	
0,0,	3309,3375,	3285,1812,	3282,1873,	
3270,3336,	3289,2286,	3308,2306,	0,0,	
1672,1733,	3297,1825,	1672,1733,	3309,2309,	
1672,1733,	0,0,	0,0,	3343,3343,	
0,0,	1677,854,	1673,1734,	3290,2661,	
1673,1734,	3324,3390,	1673,1734,	1677,933,	
1677,856,	3281,3347,	1677,854,	0,0,	
1677,854,	0,0,	1677,854,	3324,2324,	
3353,3353,	3283,3349,	3280,3346,	3285,1745,	
3291,2593,	3284,3350,	0,0,	3274,3340,	
3285,3351,	1677,854,	3297,1758,	3273,3339,	
3293,2004,	3295,2231,	3292,3358,	3297,3363,	
1673,0,	1878,1936,	1878,505,	1878,505,	
1878,505,	1878,505,	1878,505,	1878,505,	
1878,505,	1878,505,	1878,505,	1878,505,	
1878,505,	1878,505,	1878,505,	1878,505,	
1878,505,	1878,505,	1878,505,	1878,505,	
1878,505,	1878,505,	1878,505,	1878,505,	
1878,505,	1878,505,	1878,505,	1677,854,	
3296,2365,	1677,854,	3290,3356,	1677,1739,	
1677,854,	1677,854,	1677,854,	1677,854,	
1677,854,	1677,854,	1677,854,	1677,854,	
1677,854,	1677,854,	1677,854,	1677,854,	
1677,854,	1677,854,	1677,854,	1677,854,	
1677,854,	1677,854,	1677,854,	1677,854,	
1677,854,	1677,854,	1677,854,	1677,854,	
1677,854,	1677,854,	1681,1743,	3302,1949,	
3291,3357,	3306,2676,	3293,3359,	3295,3361,	
3310,2244,	3311,2378,	1681,1743,	1681,1744,	
1685,866,	3323,2624,	3317,1963,	3318,2136,	
3319,2874,	3321,2504,	3301,3367,	3320,2815,	
1685,866,	1685,867,	3322,2692,	3325,2698,	
3327,3393,	3312,1840,	3329,2261,	3326,2630,	
3316,3382,	3328,3394,	3296,3362,	3330,2395,	
3349,2220,	3337,2642,	3327,2329,	3331,1858,	
1681,1743,	3339,2269,	3335,3401,	3328,1915,	
3350,3415,	3336,2710,	1681,1743,	1681,1745,	
3362,3426,	1681,1743,	1685,866,	1681,1743,	
3335,2338,	1681,1743,	3350,2354,	3301,3301,	
1685,943,	1685,868,	3362,2365,	1685,866,	
3301,3240,	1685,866,	3312,1774,	1685,866,	
1681,1743,	3316,3316,	3344,3344,	3312,3378,	
3306,3372,	3356,2661,	3316,3252,	3311,3377,	
3331,1793,	3339,2211,	1685,866,	3340,2403,	
3318,3384,	3331,3397,	3310,3376,	3345,2275,	
3302,3368,	3319,3385,	3320,3386,	3355,2286,	
3358,1999,	3322,3388,	3325,3391,	3359,2004,	
3360,2062,	3323,3389,	3306,2741,	3317,3383,	
3361,2231,	3330,3396,	3372,2676,	3321,3387,	
3329,3395,	3340,3406,	1681,1743,	3344,3278,	
1681,1743,	3375,2309,	1681,1743,	3326,3392,	
3336,3402,	3349,3414,	3385,2874,	3340,2345,	
1685,866,	3337,3403,	1685,866,	3354,3354,	
1685,1749,	1685,866,	1685,866,	1685,866,	
1685,866,	1685,866,	1685,866,	1685,866,	
1685,866,	1685,866,	1685,866,	1685,866,	
1685,866,	1685,866,	1685,866,	1685,866,	
1685,866,	1685,866,	1685,866,	1685,866,	
1685,866,	1685,866,	1685,866,	1685,866,	
1685,866,	1685,866,	1685,866,	1687,296,	
3344,3409,	3356,3420,	3339,3405,	3366,3428,	
3354,3288,	3345,3410,	3368,3430,	1687,296,	
1687,297,	3355,3419,	3367,3367,	3376,2244,	
3377,3439,	3386,2815,	3360,3424,	3365,1757,	
3368,1949,	3358,3422,	3381,3441,	3383,3443,	
3359,3423,	3361,3425,	3377,2378,	3380,1773,	
3387,2504,	3385,3445,	3372,3434,	3375,3437,	
3390,2324,	3383,1963,	1692,1756,	3446,2815,	
3399,3458,	1687,296,	0,0,	3372,2741,	
3366,3366,	0,0,	1692,1756,	1692,1757,	
1687,298,	3366,3363,	1687,296,	3367,3301,	
1687,296,	3354,3418,	1687,296,	3365,1824,	
0,0,	3404,1923,	0,0,	3381,3381,	
3396,3456,	3382,3382,	3413,1931,	3380,1839,	
3381,3378,	1687,296,	3388,2692,	3393,2329,	
3395,2261,	3391,2698,	3396,2395,	3409,3278,	
1692,1756,	3399,3399,	0,0,	3402,2710,	
3424,2062,	0,0,	1692,1756,	1692,1758,	
3401,2338,	1692,1756,	3412,2583,	1692,1756,	
3410,2275,	1692,1756,	3418,3288,	3421,2593,	
3376,3438,	3386,3446,	3404,1864,	3387,3447,	
3367,3429,	3419,2286,	3382,3316,	3413,1873,	
1692,1756,	3414,2220,	3446,3499,	1687,296,	
3415,2354,	1687,296,	3390,3450,	1687,1751,	
1687,296,	1687,296,	1687,296,	1687,296,	
1687,296,	1687,296,	1687,296,	1687,296,	
1687,296,	1687,296,	1687,296,	1687,296,	
1687,296,	1687,296,	1687,296,	1687,296,	
1687,296,	1687,296,	1687,296,	1687,296,	
1687,296,	1687,296,	1687,296,	1687,296,	
1687,296,	1687,296,	1692,1756,	1698,1235,	
1692,1756,	3393,3453,	1692,1756,	3382,3442,	
3365,1802,	3395,3455,	3388,3448,	1698,1235,	
1698,1236,	3391,3451,	3400,3400,	1699,1101,	
3380,1802,	3405,2269,	3401,3460,	3402,3461,	
3408,3408,	3424,3479,	3409,3466,	1699,1101,	
1699,1102,	3410,3467,	3414,3470,	1700,740,	
3412,3469,	3422,3477,	3423,3478,	3406,2403,	
3425,2231,	3421,3476,	3419,3474,	1700,740,	
1700,741,	3418,3473,	3415,3471,	3422,1999,	
3423,2004,	3437,2309,	3426,2365,	1698,1235,	
1698,1237,	3438,2244,	1698,1235,	3400,3334,	
1698,1235,	3405,2211,	1698,1235,	3429,3301,	
3435,2608,	3408,3343,	3417,3417,	1699,1173,	
1699,1103,	3428,3428,	1699,1101,	3442,3316,	
1699,1101,	1698,1238,	1699,1101,	3406,2345,	
3464,2403,	3441,3441,	3439,2378,	1700,740,	
1700,743,	3444,2136,	1700,740,	3449,2624,	
1700,740,	1699,1104,	1700,740,	1702,886,	
3445,2874,	3450,2324,	3447,2504,	3452,2630,	
3454,1974,	3453,2329,	3456,2395,	1702,886,	
1702,887,	1700,810,	3455,2261,	3417,3353,	
3400,3459,	3425,3480,	3428,3366,	3459,3334,	
3460,2338,	3469,2583,	3408,3465,	1698,1235,	
3464,2345,	1698,1235,	3441,3381,	1698,1235,	
3467,2275,	3474,2286,	3438,3492,	3476,2593,	
3479,3530,	1698,1763,	3405,3463,	1699,1101,	
3426,3481,	1699,1101,	3437,3491,	1699,1101,	
0,0,	3454,1915,	3479,2062,	1702,958,	
1702,888,	0,0,	1702,886,	1700,740,	
1702,886,	1700,740,	1702,886,	1700,740,	
1699,1764,	1698,1299,	3435,3489,	1700,1765,	
3417,3472,	3406,3464,	3429,3483,	3428,3482,	
3439,3493,	1702,889,	3465,3343,	3444,3497,	
3447,3500,	1699,1101,	3442,3495,	3441,3494,	
3462,2642,	3471,2354,	3466,3278,	3455,3507,	
3445,3498,	3449,3502,	3450,3503,	3468,2651,	
3456,3508,	1700,740,	3453,3506,	3472,3353,	
3469,3520,	3452,3505,	3481,2365,	3473,3288,	
3483,3301,	3467,3518,	3474,3525,	3475,2661,	
3501,2692,	3460,3511,	3476,3527,	3488,2676,	
0,0,	3464,3515,	3458,3458,	1702,886,	
3482,3366,	1702,886,	3459,3510,	1702,1767,	
1702,886,	1702,886,	1702,886,	1702,886,	
1702,886,	1702,886,	1702,886,	1702,886,	
1702,886,	1702,886,	1702,886,	1702,886,	
1702,886,	1702,886,	1702,886,	1702,886,	
1702,886,	1702,886,	1702,886,	1702,886,	
1702,886,	1702,886,	1702,886,	1702,886,	
1702,886,	1702,886,	1703,527,	3458,3399,	
3489,2608,	3491,2309,	3493,2378,	3494,3381,	
3495,3316,	3497,2136,	1703,527,	1703,528,	
1707,1772,	3499,2815,	3471,3522,	3508,2395,	
3500,3549,	3465,3516,	3462,3513,	3466,3517,	
1707,1772,	1707,1773,	3503,2324,	3484,2011,	
3498,2874,	3468,3519,	3500,2504,	3481,3532,	
3502,2624,	3504,2698,	0,0,	1717,904,	
3473,3524,	3483,3534,	3472,3523,	3496,2023,	
1703,80,	3475,3526,	3501,3550,	1717,904,	
1717,905,	3488,3538,	1703,527,	1703,530,	
3458,3509,	1703,527,	1707,1772,	1703,527,	
3488,2741,	1703,527,	3506,2329,	3482,3533,	
1707,1772,	1707,1774,	3505,2630,	1707,1772,	
3484,1949,	1707,1772,	3511,2338,	1707,1772,	
1703,605,	3484,1890,	3491,3541,	3489,3539,	
3520,2583,	1717,904,	0,0,	3513,2642,	
3496,1963,	3514,2269,	1707,1772,	1717,973,	
1717,906,	3496,1903,	1717,904,	3493,3543,	
1717,904,	3509,3399,	1717,904,	3503,3552,	
3515,2403,	3495,3545,	3497,3546,	3498,3547,	
3508,3557,	3499,3548,	3494,3544,	3502,3551,	
3510,3334,	1717,907,	3512,2710,	3521,2220,	
3516,3343,	3523,3353,	1703,527,	0,0,	
1703,527,	3517,3278,	1703,527,	3524,3288,	
3519,2651,	3514,2211,	3527,2593,	3504,3553,	
1707,1772,	3533,3366,	1707,1772,	3506,3555,	
1707,1772,	1703,1768,	3531,2231,	3522,2354,	
3515,2345,	3505,3554,	3544,3381,	3511,3560,	
3526,2661,	3532,2365,	3534,3301,	3542,2244,	
3543,2378,	3538,2676,	3520,3569,	1717,904,	
1703,527,	1717,904,	3513,3562,	1717,1783,	
1717,904,	1717,904,	1717,904,	1717,904,	
1717,904,	1717,904,	1717,904,	1717,904,	
1717,904,	1717,904,	1717,904,	1717,904,	
1717,904,	1717,904,	1717,904,	1717,904,	
1717,904,	1717,904,	1717,904,	1717,904,	
1717,904,	1717,904,	1717,904,	1717,904,	
1717,904,	1717,904,	1720,909,	0,0,	
3509,3558,	3521,3570,	1897,532,	3519,3568,	
3527,3576,	3510,3559,	1720,909,	1720,910,	
3512,3561,	3516,3565,	3523,3572,	3514,3563,	
3522,3571,	3515,3564,	3528,2058,	3517,3566,	
3529,2060,	3524,3573,	3532,3579,	3526,3575,	
3531,3578,	3543,3590,	3533,3580,	3546,3593,	
3538,3585,	3549,2504,	3550,2692,	3557,2395,	
3551,2624,	3542,3589,	3553,2698,	3544,3591,	
1720,909,	3546,2136,	3569,3616,	3554,2630,	
3534,3581,	0,0,	1720,978,	1720,911,	
0,0,	1720,909,	0,0,	1720,909,	
3569,2583,	1720,909,	3538,2741,	3528,1999,	
3545,3316,	3529,2004,	3559,3334,	3547,2874,	
3558,3399,	3565,3343,	0,0,	0,0,	
1720,912,	1897,1956,	1897,457,	1897,457,	
1897,457,	1897,457,	1897,457,	1897,457,	
1897,457,	1897,457,	1897,457,	1897,457,	
1897,457,	1897,457,	1897,457,	1897,457,	
1897,457,	1897,457,	1897,457,	1897,457,	
1897,457,	1897,457,	1897,457,	1897,457,	
1897,457,	1897,457,	1897,457,	3556,2261,	
3557,3604,	3550,3597,	3551,3598,	3561,2710,	
3566,3278,	3553,3600,	1720,909,	3549,3596,	
1720,909,	3554,3601,	1720,1786,	1720,909,	
1720,909,	1720,909,	1720,909,	1720,909,	
1720,909,	1720,909,	1720,909,	1720,909,	
1720,909,	1720,909,	1720,909,	1720,909,	
1720,909,	1720,909,	1720,909,	1720,909,	
1720,909,	1720,909,	1720,909,	1720,909,	
1720,909,	1720,909,	1720,909,	1720,909,	
1720,909,	1725,1791,	3545,3592,	3547,3594,	
3559,3606,	3558,3605,	3562,2642,	3565,3612,	
3567,2275,	1725,1791,	1725,1792,	1729,923,	
3570,2220,	3572,3353,	3573,3288,	3574,2286,	
3578,2231,	3575,2661,	3576,3623,	1729,923,	
1729,924,	3581,3301,	3580,3366,	3586,3632,	
3587,2306,	3585,2676,	3561,3608,	3566,3613,	
3576,2593,	3556,3603,	3563,2269,	3589,2244,	
3588,2309,	3586,2608,	3597,2692,	1725,1791,	
3599,2324,	3598,3644,	0,0,	3601,3647,	
3592,3316,	1725,1791,	1725,1793,	3600,2698,	
1725,1791,	1729,923,	1725,1791,	3598,2624,	
1725,1791,	3601,2630,	3609,3655,	1729,990,	
1729,925,	0,0,	1729,923,	0,0,	
1729,923,	0,0,	1729,923,	1725,1791,	
3609,2642,	3615,3661,	3563,2211,	3591,3381,	
3562,3609,	3595,2815,	3605,3399,	3596,2504,	
3603,2261,	1729,923,	0,0,	3615,2651,	
3602,2329,	3573,3620,	3567,3614,	3575,3622,	
3614,2275,	0,0,	0,0,	0,0,	
3581,3627,	3574,3621,	3607,2338,	3585,3631,	
0,0,	3570,3617,	3606,3334,	3572,3619,	
3608,2710,	3578,3624,	3587,3633,	3613,3278,	
3597,3643,	1725,1791,	3616,2583,	1725,1791,	
3580,3626,	1725,1791,	3588,3634,	3592,3638,	
3612,3343,	3600,3646,	3599,3645,	1729,923,	
3589,3635,	1729,923,	3585,2741,	1729,1797,	
1729,923,	1729,923,	1729,923,	1729,923,	
1729,923,	1729,923,	1729,923,	1729,923,	
1729,923,	1729,923,	1729,923,	1729,923,	
1729,923,	1729,923,	1729,923,	1729,923,	
1729,923,	1729,923,	1729,923,	1729,923,	
1729,923,	1729,923,	1729,923,	1729,923,	
1729,923,	1729,923,	1733,1733,	3563,3610,	
3596,3642,	3591,3637,	3602,3648,	3595,3641,	
3605,3651,	3603,3649,	1733,1733,	1733,1734,	
1738,999,	3606,3652,	3608,3654,	3617,3663,	
3607,3653,	3614,3660,	3610,2269,	3611,2403,	
1738,999,	1738,1000,	1743,1743,	3618,2354,	
3619,3353,	3617,2220,	3613,3659,	3612,3658,	
3616,3662,	3622,3668,	1743,1743,	1743,1744,	
3620,3288,	3642,2504,	3621,2286,	3640,2874,	
1733,1733,	3623,2593,	3624,3670,	3622,2661,	
3610,3656,	3639,2191,	1733,1733,	1733,1735,	
3874,3792,	1733,1733,	1738,999,	1733,1733,	
3624,2231,	1733,1733,	3610,2211,	3611,2345,	
1738,999,	1738,1001,	3626,3366,	1738,999,	
1743,1743,	1738,999,	0,0,	1738,999,	
1733,1733,	3625,2365,	1743,1743,	1743,1745,	
3627,3301,	1743,1743,	3635,3681,	1743,1743,	
3633,2306,	1743,1743,	1738,999,	3631,3677,	
3636,2378,	3634,2309,	3639,2136,	3643,3688,	
3635,2244,	3637,3381,	0,0,	0,0,	
1743,1743,	3631,2676,	3644,2624,	3619,3665,	
3638,3316,	3643,2692,	0,0,	3646,3691,	
3645,2324,	3618,3664,	3642,3687,	3648,2329,	
1756,1756,	3653,2338,	1733,1733,	3641,2815,	
1733,1733,	3646,2698,	1733,1733,	3620,3666,	
1756,1756,	1756,1757,	1763,1235,	3623,3669,	
1738,999,	3647,2630,	1738,999,	3621,3667,	
1738,999,	3640,3685,	1763,1235,	1763,1236,	
1764,1101,	3626,3672,	1743,1743,	3650,2395,	
1743,1743,	3611,3657,	1743,1743,	3649,3694,	
1764,1101,	1764,1102,	3652,3334,	3874,3919,	
1733,1801,	1738,1806,	1756,1756,	3625,3671,	
3651,3399,	3649,2261,	3654,3699,	3627,3673,	
1756,1756,	1756,1758,	1738,1076,	1756,1756,	
3637,3683,	1756,1756,	3636,3682,	1756,1756,	
3654,2710,	3633,3679,	1763,1235,	1763,1237,	
1743,1811,	1763,1235,	3634,3680,	1763,1235,	
3644,3689,	1763,1235,	1756,1756,	3638,3684,	
1764,1173,	1764,1103,	3641,3686,	1764,1101,	
3704,3278,	1764,1101,	3659,3704,	1764,1101,	
1763,1238,	3645,3690,	3631,2741,	3657,2403,	
3648,3693,	3655,2642,	3653,3698,	3660,3705,	
3659,3278,	3658,3343,	1764,1104,	3647,3692,	
3662,2583,	3664,2354,	3669,2593,	3665,3353,	
3671,2365,	3660,2275,	3668,2661,	3689,2624,	
3672,3366,	3650,3695,	1765,740,	3666,3711,	
1756,1756,	0,0,	1756,1756,	3651,3696,	
1756,1756,	3652,3697,	1765,740,	1765,741,	
1768,527,	3666,3288,	1763,1235,	3657,2345,	
1763,1235,	3667,3712,	1763,1235,	3673,3718,	
1768,527,	1768,528,	1763,1829,	3679,3724,	
1764,1101,	3680,3725,	1764,1101,	3667,2286,	
1764,1101,	3673,3301,	3682,2378,	1772,1772,	
1764,1830,	3679,2306,	1756,1823,	3680,2309,	
3685,2874,	3704,3749,	3683,3381,	1772,1772,	
1772,1773,	3686,2815,	1765,740,	1765,743,	
1763,1299,	1765,740,	1768,80,	1765,740,	
3684,3729,	1765,740,	3692,2630,	3655,3700,	
1768,527,	1768,530,	1764,1101,	1768,527,	
3658,3703,	1768,527,	3684,3316,	1768,527,	
1765,810,	3662,3707,	3665,3710,	3669,3714,	
3668,3713,	1772,1772,	3664,3709,	3672,3717,	
3689,3734,	3671,3716,	1768,605,	1772,1772,	
1772,1774,	1791,1791,	1772,1772,	3695,2395,	
1772,1772,	3690,3735,	1772,1772,	3730,2874,	
3693,3738,	1791,1791,	1791,1792,	2061,297,	
3688,2692,	3677,2676,	3691,2698,	3690,2324,	
3657,3702,	1772,1772,	3693,2329,	2061,297,	
2061,297,	3699,2710,	1765,740,	3685,3730,	
1765,740,	3696,3399,	1765,740,	3686,3731,	
3707,2583,	1765,1831,	1798,1798,	3682,3727,	
1768,527,	3683,3728,	1768,527,	1791,1791,	
1768,527,	3700,2642,	1798,1798,	1798,1863,	
3713,2661,	1791,1791,	1791,1793,	3711,3288,	
1791,1791,	2061,297,	1791,1791,	3692,3737,	
1791,1791,	4021,3792,	1768,1834,	1772,1772,	
1765,740,	1772,1772,	2061,297,	1772,1772,	
2061,297,	3697,3742,	2061,297,	1791,1791,	
0,0,	3722,2676,	1768,527,	0,0,	
1798,1798,	3730,3775,	0,0,	3697,3334,	
3702,2403,	2061,297,	1798,1798,	1798,1864,	
3714,2593,	1798,1798,	1806,999,	1798,1798,	
3695,3740,	1798,1798,	3688,3733,	3677,3722,	
3691,3736,	1772,1838,	1806,999,	1806,1000,	
3718,3301,	3707,3752,	3698,3743,	3699,3744,	
1798,1798,	3729,3316,	3702,3747,	3703,3748,	
3696,3741,	1791,1791,	3677,2741,	1791,1791,	
3698,2338,	1791,1791,	3701,2270,	3701,2269,	
3702,2345,	3703,3343,	3708,2281,	2061,297,	
3711,3756,	2061,297,	3700,3745,	2061,297,	
1806,999,	3713,3758,	3709,3754,	3715,2294,	
3734,2624,	3726,2311,	1806,999,	1806,1001,	
4021,4045,	1806,999,	3710,3755,	1806,999,	
3709,2354,	1806,999,	1798,1798,	1791,1857,	
1798,1798,	3739,2333,	1798,1798,	3716,3761,	
3710,3353,	3714,3759,	3722,3767,	3701,2211,	
1806,999,	2061,297,	3732,2504,	3708,2220,	
3701,3746,	3716,2365,	3717,3762,	3733,2692,	
3708,3753,	3736,2698,	3722,2741,	3727,3772,	
3715,2231,	3718,3763,	3726,2244,	3728,3773,	
3717,3366,	3715,3760,	3729,3774,	3726,3771,	
1798,1798,	3727,2378,	3731,3776,	3737,2630,	
3742,3334,	3728,3381,	3739,2261,	3744,2710,	
3748,3343,	3745,2642,	3755,3353,	3739,3784,	
3731,2815,	3750,2348,	1806,999,	3749,3278,	
1806,999,	3734,3779,	1806,1870,	1806,999,	
1806,999,	1806,999,	1806,999,	1806,999,	
1806,999,	1806,999,	1806,999,	1806,999,	
1806,999,	1806,999,	1806,999,	1806,999,	
1806,999,	1806,999,	1806,999,	1806,999,	
1806,999,	1806,999,	1806,999,	1806,999,	
1806,999,	1806,999,	1806,999,	1806,999,	
1806,1076,	1808,1808,	3750,2275,	3740,3785,	
3732,3777,	3741,3786,	3756,3288,	3757,2357,	
3763,3301,	1808,1808,	1808,1872,	3762,3366,	
3733,3778,	3740,2395,	3736,3781,	3741,3399,	
3737,3782,	3758,2661,	3770,2375,	3767,2676,	
3773,3381,	3742,3787,	3745,3790,	3774,3316,	
3775,3822,	3748,3794,	3776,2815,	3755,3801,	
1815,1010,	3777,2504,	3749,3795,	3778,2692,	
3744,3789,	3780,2388,	3775,2874,	1808,1808,	
1815,1010,	1815,1011,	3786,3399,	3781,2698,	
3757,2286,	1808,1808,	1808,1873,	3795,3278,	
1808,1808,	3783,2391,	1808,1808,	3787,3334,	
1808,1808,	3794,3343,	3788,2398,	3770,2309,	
3789,2710,	3797,2583,	3792,3836,	3801,3353,	
3793,2404,	3793,2403,	3799,3842,	1808,1808,	
3824,3863,	0,0,	1815,1010,	0,0,	
0,0,	3756,3802,	3780,2324,	3763,3810,	
1815,1010,	1815,1012,	3824,2504,	1815,1010,	
3762,3809,	1815,1010,	3758,3803,	1815,1010,	
3767,3814,	3800,2413,	3783,2329,	3807,3848,	
3808,2424,	3773,3820,	3774,3821,	3788,2338,	
3802,3288,	3810,3301,	1815,1010,	3792,3792,	
3778,3825,	3793,2345,	3804,2593,	3799,3799,	
3776,3823,	1808,1808,	3793,3837,	1808,1808,	
3781,3827,	1808,1808,	3809,3366,	3786,3832,	
3767,2741,	3815,2608,	3777,3824,	3821,3316,	
3820,3381,	3823,2815,	3787,3833,	3822,2874,	
3794,3838,	3789,3834,	3800,2354,	3795,3839,	
3807,3807,	3808,2365,	3801,3844,	3800,3843,	
3826,2624,	3807,3760,	3808,3849,	3797,3841,	
1815,1010,	3828,2630,	1815,1010,	1808,1808,	
1815,1879,	1815,1010,	1815,1010,	1815,1010,	
1815,1010,	1815,1010,	1815,1010,	1815,1010,	
1815,1010,	1815,1010,	1815,1010,	1815,1010,	
1815,1010,	1815,1010,	1815,1010,	1815,1010,	
1815,1010,	1815,1010,	1815,1010,	1815,1010,	
1815,1010,	1815,1010,	1815,1010,	1815,1010,	
1815,1010,	1815,1010,	1815,1087,	1829,1235,	
3802,3845,	3810,3851,	3832,3399,	3818,3857,	
3804,3847,	3809,3850,	3835,2642,	1829,1235,	
1829,1236,	1830,1101,	3819,2438,	3820,3859,	
3830,3868,	3833,3334,	3836,3836,	3815,3856,	
3838,3343,	1830,1101,	1830,1102,	3821,3860,	
3831,2456,	3822,3861,	3823,3862,	3839,3278,	
3840,2651,	3841,2583,	3842,3842,	3845,3288,	
3844,3353,	3847,2593,	3826,3865,	3856,2608,	
3862,2815,	3846,2661,	0,0,	3828,3867,	
3818,3818,	0,0,	3848,3848,	1829,1235,	
1829,1237,	3818,3771,	1829,1235,	3819,2378,	
1829,1235,	3830,3830,	1829,1235,	3836,3792,	
3819,3858,	1830,1173,	1830,1103,	3855,2676,	
1830,1101,	3831,2395,	1830,1101,	3850,3366,	
1830,1101,	1829,1238,	3831,3869,	3842,3799,	
3859,3381,	3832,3870,	3870,3399,	3865,2624,	
3861,2874,	3867,2630,	1831,740,	1830,1104,	
3851,3301,	3864,2692,	3860,3316,	3848,3807,	
3835,3873,	3866,2698,	1831,740,	1831,741,	
3872,2710,	3878,3278,	3871,3334,	3873,2642,	
3881,3799,	3833,3871,	3839,3878,	3876,3920,	
3838,3877,	3877,3343,	3845,3885,	3857,3857,	
3836,3874,	3862,3906,	3840,3879,	1829,1235,	
3868,3868,	1829,1235,	3879,2651,	1829,1235,	
3844,3884,	1831,1893,	3841,3880,	3846,3886,	
3842,3881,	1830,1101,	3847,3887,	1830,1101,	
3856,3898,	1830,1101,	1831,740,	1831,743,	
1829,1891,	1831,740,	1832,1027,	1831,740,	
3848,3888,	1831,740,	3883,3926,	3884,3353,	
3876,3876,	3855,3897,	1832,1027,	1832,1028,	
3857,3818,	1829,1299,	1830,1892,	3850,3892,	
1831,810,	3868,3830,	3885,3288,	3851,3893,	
3859,3903,	3860,3904,	3870,3915,	1830,1101,	
3855,2741,	3861,3905,	3892,3366,	3864,3908,	
3865,3909,	3871,3916,	3867,3911,	3866,3910,	
3891,3932,	3903,3381,	3872,3917,	3902,3940,	
3877,3921,	0,0,	3880,3924,	3883,3883,	
3905,2874,	3878,3922,	1832,1027,	1832,1029,	
3873,3918,	1832,1027,	3887,3930,	1832,1027,	
3880,2583,	1832,1027,	1831,740,	3881,3925,	
1831,740,	3857,3899,	1831,740,	3886,2661,	
3887,2593,	3888,3807,	3868,3912,	3879,3923,	
1832,1030,	3898,3938,	3899,3818,	3893,3301,	
3897,2676,	3891,3891,	3884,3927,	3904,3316,	
3902,3902,	3908,2692,	3891,3849,	3898,2608,	
3909,3946,	3902,3858,	3910,2698,	3912,3830,	
3911,3948,	3916,3334,	3917,2710,	3915,3399,	
1831,740,	3918,3954,	3909,2624,	3919,3792,	
3925,3799,	3892,3933,	3911,2630,	0,0,	
0,0,	0,0,	3885,3928,	3918,2642,	
3903,3941,	3907,2559,	1832,1027,	3921,3343,	
1832,1027,	3905,3943,	1832,1894,	1832,1027,	
1832,1027,	1832,1027,	1832,1027,	1832,1027,	
1832,1027,	1832,1027,	1832,1027,	1832,1027,	
1832,1027,	1832,1027,	1832,1027,	1832,1027,	
1832,1027,	1832,1027,	1832,1027,	1832,1027,	
1832,1027,	1832,1027,	1832,1027,	1832,1027,	
1832,1027,	1832,1027,	1832,1027,	1832,1027,	
1832,1106,	1834,527,	3907,2504,	3931,3807,	
3886,3929,	3914,3950,	3920,3920,	3926,3926,	
3944,2815,	1834,527,	1834,528,	3893,3934,	
3888,3931,	3897,3937,	3915,3951,	3904,3942,	
3923,3959,	3899,3939,	3908,3945,	3927,3353,	
3932,3932,	3897,2741,	3940,3940,	3910,3947,	
3929,3965,	3916,3952,	3923,2651,	3917,3953,	
1848,1044,	3933,3366,	3912,3949,	3939,3818,	
3919,3955,	3925,3961,	3929,2661,	1834,80,	
1848,1044,	1848,1045,	3914,3914,	3920,3876,	
3926,3883,	1834,527,	1834,530,	3921,3957,	
1834,527,	3941,3381,	1834,527,	3945,3981,	
1834,527,	3951,3399,	3947,3983,	3953,3989,	
3960,2652,	3932,3891,	3991,3792,	3940,3902,	
4013,4040,	3945,2692,	0,0,	1834,605,	
3947,2698,	3953,2710,	1848,1044,	0,0,	
0,0,	3966,2662,	4013,2815,	3937,3973,	
1848,1044,	1848,1046,	0,0,	1848,1044,	
3973,4007,	1848,1044,	3944,3980,	1848,1044,	
3931,3967,	3937,2676,	3982,2694,	3949,3830,	
3920,3956,	3926,3962,	3950,3950,	3955,3792,	
3956,3876,	3960,2583,	1848,1047,	3958,3278,	
3961,3799,	3962,3883,	3964,3288,	3927,3963,	
3967,3807,	1834,527,	3932,3968,	1834,527,	
3940,3976,	1834,527,	3966,2593,	1834,1896,	
3968,3891,	3933,3969,	3970,3301,	3975,3818,	
3939,3975,	3976,3902,	3978,3316,	3979,2874,	
3980,2815,	3985,3830,	3986,3914,	3982,2624,	
3988,3334,	3991,4021,	3993,3343,	3950,3914,	
3994,3278,	3941,3977,	4151,3792,	3996,3799,	
1848,1044,	3951,3987,	1848,1044,	1834,527,	
1848,1908,	1848,1044,	1848,1044,	1848,1044,	
1848,1044,	1848,1044,	1848,1044,	1848,1044,	
1848,1044,	1848,1044,	1848,1044,	1848,1044,	
1848,1044,	1848,1044,	1848,1044,	1848,1044,	
1848,1044,	1848,1044,	1848,1044,	1848,1044,	
1848,1044,	1848,1044,	1848,1044,	1848,1044,	
1848,1044,	1848,1044,	1848,1124,	1851,1051,	
3949,3985,	3973,2741,	3984,2700,	1910,547,	
3950,3986,	3955,3991,	3937,2741,	1851,1051,	
1851,1052,	3958,3994,	3961,3996,	3956,3992,	
3964,3999,	3992,3876,	3967,4001,	3990,2711,	
3962,3997,	3997,3883,	3998,3353,	4000,2728,	
4003,3366,	3979,4012,	4007,2742,	3994,4024,	
3970,4004,	3975,4008,	3996,4025,	3968,4002,	
3978,4011,	3980,4013,	3999,3288,	3985,4016,	
3976,4009,	1851,1051,	3988,4019,	3984,2630,	
3993,4023,	3986,4017,	4151,4171,	1851,1051,	
1851,1053,	0,0,	1851,1051,	0,0,	
1851,1051,	0,0,	1851,1051,	0,0,	
3990,2642,	0,0,	4002,3891,	4009,3902,	
4000,2661,	4010,3381,	0,0,	4007,2676,	
4012,2874,	1851,1054,	1910,1970,	1910,544,	
1910,544,	1910,544,	1910,544,	1910,544,	
1910,544,	1910,544,	1910,544,	1910,544,	
1910,544,	1910,544,	1910,544,	1910,544,	
1910,544,	1910,544,	1910,544,	1910,544,	
1910,544,	1910,544,	1910,544,	1910,544,	
1910,544,	1910,544,	1910,544,	1910,544,	
4001,3807,	4004,3301,	3992,4022,	4008,3818,	
4011,3316,	3999,4028,	3997,4026,	1851,1051,	
3998,4027,	1851,1051,	4003,4031,	1851,1911,	
1851,1051,	1851,1051,	1851,1051,	1851,1051,	
1851,1051,	1851,1051,	1851,1051,	1851,1051,	
1851,1051,	1851,1051,	1851,1051,	1851,1051,	
1851,1051,	1851,1051,	1851,1051,	1851,1051,	
1851,1051,	1851,1051,	1851,1051,	1851,1051,	
1851,1051,	1851,1051,	1851,1051,	1851,1051,	
1851,1051,	1851,1129,	1854,1854,	4002,4030,	
4009,4036,	4016,3830,	4014,2756,	4010,4037,	
4015,2760,	4012,4039,	1854,1854,	1854,1914,	
4017,3914,	4020,2770,	4018,3399,	4022,3876,	
4007,2741,	4024,3278,	4019,3334,	4023,3343,	
4027,3353,	4026,3883,	4028,3288,	4001,4029,	
4004,4032,	4025,3799,	4008,4035,	4011,4038,	
4030,3891,	1861,1065,	4029,3807,	4031,3366,	
4035,3818,	4032,3301,	4036,3902,	4038,3316,	
1854,1854,	1861,1065,	1861,1066,	4014,2692,	
4039,4063,	4015,2698,	1854,1854,	1854,1915,	
4037,3381,	1854,1854,	4020,2710,	1854,1854,	
4041,3830,	1854,1854,	4039,2874,	4043,3399,	
4045,4069,	4044,3334,	4046,3876,	4048,4072,	
4047,3343,	4049,4073,	4050,3883,	4054,3891,	
1854,1854,	4051,3353,	4045,3792,	1861,1065,	
4016,4041,	4048,3278,	0,0,	4049,3799,	
0,0,	1861,1065,	1861,1067,	4064,2876,	
1861,1065,	4052,4076,	1861,1065,	4024,4048,	
1861,1065,	4019,4044,	4023,4047,	4027,4051,	
4028,4052,	4042,3914,	0,0,	4052,3288,	
0,0,	4017,4042,	0,0,	1861,1065,	
4018,4043,	4022,4046,	4031,4055,	4032,4056,	
4025,4049,	4038,4062,	1854,1854,	4026,4050,	
1854,1854,	4029,4053,	1854,1854,	4035,4059,	
4055,3366,	4061,3381,	4030,4054,	4037,4061,	
4064,2815,	4060,3902,	4053,4077,	4067,3399,	
4036,4060,	4066,3914,	4043,4067,	4044,4068,	
4056,4080,	4046,4070,	4047,4071,	4041,4065,	
4053,3807,	4050,4074,	4054,4078,	4051,4075,	
4070,3876,	1861,1065,	4056,3301,	1861,1065,	
1854,1854,	1861,1921,	1861,1065,	1861,1065,	
1861,1065,	1861,1065,	1861,1065,	1861,1065,	
1861,1065,	1861,1065,	1861,1065,	1861,1065,	
1861,1065,	1861,1065,	1861,1065,	1861,1065,	
1861,1065,	1861,1065,	1861,1065,	1861,1065,	
1861,1065,	1861,1065,	1861,1065,	1861,1065,	
1861,1065,	1861,1065,	1861,1065,	1861,1141,	
1871,854,	4059,4082,	4074,3883,	4042,4066,	
4062,4085,	4065,4087,	4055,4079,	4061,4084,	
1871,854,	1871,855,	1890,1947,	4059,3818,	
4060,4083,	4067,4089,	4062,3316,	4065,3830,	
4066,4088,	4068,4090,	1890,1947,	1890,1948,	
1891,1235,	4069,3792,	4071,4093,	4072,3278,	
4073,3799,	4076,3288,	4075,4097,	4068,3334,	
1891,1235,	1891,1236,	4078,3891,	4086,2931,	
4071,3343,	0,0,	1871,854,	4070,4092,	
4075,3353,	4077,3807,	4079,4101,	4111,3792,	
1871,933,	1871,856,	4082,3818,	1871,854,	
1890,1947,	1871,854,	4083,3902,	1871,854,	
4079,3366,	4080,3301,	1890,1947,	1890,1949,	
4084,4105,	1890,1947,	4088,3914,	1890,1947,	
4087,3830,	1890,1947,	1871,854,	4085,3316,	
1891,1235,	1891,1237,	4084,3381,	1891,1235,	
4086,2874,	1891,1235,	4089,4109,	1891,1235,	
1890,1947,	4074,4096,	4090,3334,	4091,3792,	
4093,3343,	4092,4112,	4095,3799,	4094,3278,	
4089,3399,	4096,4116,	1891,1238,	4098,3288,	
4097,3353,	4155,3799,	4069,4091,	4092,3876,	
4101,3366,	4073,4095,	4102,3301,	4096,3883,	
4105,3381,	4072,4094,	4099,3807,	4076,4098,	
1871,854,	4103,3818,	1871,854,	4112,3876,	
1871,854,	4078,4100,	4077,4099,	1871,1930,	
1892,1101,	4100,4120,	1890,1947,	4082,4103,	
1890,1947,	1913,551,	1890,1947,	4111,4131,	
1892,1101,	1892,1102,	0,0,	4100,3891,	
1891,1235,	4083,4104,	1891,1235,	4080,4102,	
1891,1235,	4087,4107,	4104,4124,	4106,3316,	
1891,1950,	4088,4108,	1871,854,	4109,3399,	
4108,4128,	4085,4106,	4110,3334,	4107,3830,	
4104,3902,	4116,3883,	4091,4111,	0,0,	
1890,1947,	4095,4115,	4108,3914,	0,0,	
4090,4110,	0,0,	4093,4113,	0,0,	
1892,1173,	1892,1103,	1891,1299,	1892,1101,	
4094,4114,	1892,1101,	4097,4117,	1892,1101,	
4098,4118,	4099,4119,	4101,4121,	0,0,	
4103,4123,	4155,4175,	4105,4125,	4102,4122,	
4112,4132,	4113,3343,	1892,1104,	4115,3799,	
1913,1973,	1913,548,	1913,548,	1913,548,	
1913,548,	1913,548,	1913,548,	1913,548,	
1913,548,	1913,548,	1913,548,	1913,548,	
1913,548,	1913,548,	1913,548,	1913,548,	
1913,548,	1913,548,	1913,548,	1913,548,	
1913,548,	1913,548,	1913,548,	1913,548,	
1913,548,	1913,548,	4107,4127,	4114,3278,	
4106,4126,	4109,4129,	4116,4136,	4117,3353,	
1892,1101,	4119,3807,	1892,1101,	4110,4130,	
1892,1951,	1892,1101,	1892,1101,	1892,1101,	
1892,1101,	1892,1101,	1892,1101,	1892,1101,	
1892,1101,	1892,1101,	1892,1101,	1892,1101,	
1892,1101,	1892,1101,	1892,1101,	1892,1101,	
1892,1101,	1892,1101,	1892,1101,	1892,1101,	
1892,1101,	1892,1101,	1892,1101,	1892,1101,	
1892,1101,	1892,1101,	1892,1101,	1893,740,	
4120,3891,	4118,3288,	4113,4133,	4115,4135,	
4123,3818,	4121,3366,	4122,3301,	1893,740,	
1893,741,	4124,3902,	4125,3381,	4126,3316,	
4127,3830,	4129,3399,	4128,3914,	4159,3807,	
0,0,	0,0,	4131,3792,	4130,3334,	
4114,4134,	4133,3343,	4132,3876,	0,0,	
4135,3799,	0,0,	1896,527,	4136,3883,	
4137,3353,	4139,3807,	4140,3891,	4152,3876,	
4154,3278,	4141,3366,	1896,527,	1896,528,	
4117,4137,	4119,4139,	4143,3818,	1893,740,	
1893,743,	4144,3902,	1893,740,	4156,3883,	
1893,740,	4145,3381,	1893,740,	4149,3399,	
4147,3830,	4148,3914,	4158,3288,	4160,3891,	
4194,4214,	4286,3792,	4172,3876,	4198,4218,	
4176,3883,	1893,810,	4118,4138,	0,0,	
0,0,	4120,4140,	4194,3278,	4122,4142,	
0,0,	4198,3288,	1896,527,	1896,530,	
4126,4146,	1896,527,	4124,4144,	1896,527,	
4123,4143,	1896,527,	4121,4141,	4128,4148,	
4130,4150,	4131,4151,	4133,4153,	4125,4145,	
4127,4147,	4132,4152,	4129,4149,	4135,4155,	
1896,605,	4137,4157,	4136,4156,	4159,4179,	
4139,4159,	4140,4160,	4141,4161,	1893,740,	
4163,3818,	1893,740,	4162,3301,	1893,740,	
4166,3316,	4143,4163,	4154,4174,	4152,4172,	
4144,4164,	4164,3902,	4145,4165,	4167,3830,	
4149,4169,	4168,3914,	1893,1952,	4147,4167,	
4148,4168,	4174,3278,	4286,4296,	4156,4176,	
4170,3334,	4172,4192,	4173,3343,	4176,4196,	
4158,4178,	4191,3792,	1896,527,	4160,4180,	
1896,527,	1893,740,	1896,1955,	1896,527,	
1896,527,	1896,527,	1896,527,	1896,527,	
1896,527,	1896,527,	1896,527,	1896,527,	
1896,527,	1896,527,	1896,527,	1896,527,	
1896,527,	1896,527,	1896,527,	1896,527,	
1896,527,	1896,527,	1896,527,	1896,527,	
1896,527,	1896,527,	1896,527,	1896,527,	
1896,527,	1903,1961,	4180,3891,	4178,3288,	
4177,3353,	4182,3301,	4181,3366,	4184,3902,	
4185,3381,	1903,1961,	1903,1962,	4186,3316,	
4162,4182,	4189,3399,	4166,4186,	4190,3334,	
4163,4183,	4192,3876,	4188,3914,	4193,3343,	
4195,3799,	4164,4184,	4211,3792,	4215,3799,	
4219,3807,	4168,4188,	4196,3883,	4167,4187,	
1906,1119,	4197,3353,	4170,4190,	4199,3807,	
4173,4193,	4201,3366,	4174,4194,	1903,1961,	
1906,1119,	1906,1120,	4200,3891,	4202,4222,	
4203,3818,	1903,1961,	1903,1963,	4191,4211,	
1903,1961,	4204,3902,	1903,1961,	4206,4226,	
1903,1961,	4202,3301,	4210,4230,	0,0,	
4223,3818,	4213,4233,	4217,4237,	4221,4241,	
4227,3830,	4206,3316,	4231,3792,	1903,1961,	
4210,3334,	4180,4200,	1906,1119,	4213,3343,	
4217,3353,	4221,3366,	4184,4204,	4234,3344,	
1906,1189,	1906,1121,	4177,4197,	1906,1119,	
4181,4201,	1906,1119,	4185,4205,	1906,1119,	
4178,4198,	4188,4208,	4182,4202,	4189,4209,	
4225,4245,	4211,4231,	4215,4235,	4219,4239,	
4186,4206,	0,0,	1906,1122,	0,0,	
4190,4210,	4192,4212,	4225,3381,	4229,4249,	
4193,4213,	1903,1961,	4195,4215,	1903,1961,	
1920,563,	1903,1961,	4196,4216,	0,0,	
4234,3278,	4229,3399,	4197,4217,	0,0,	
4207,3830,	4199,4219,	4201,4221,	4208,3914,	
4205,3381,	4209,3399,	4200,4220,	4223,4243,	
0,0,	4232,3876,	4203,4223,	4227,4247,	
4231,4251,	4204,4224,	4236,3883,	0,0,	
1906,1119,	4240,3891,	1906,1119,	1903,1961,	
1906,1966,	1906,1119,	1906,1119,	1906,1119,	
1906,1119,	1906,1119,	1906,1119,	1906,1119,	
1906,1119,	1906,1119,	1906,1119,	1906,1119,	
1906,1119,	1906,1119,	1906,1119,	1906,1119,	
1906,1119,	1906,1119,	1906,1119,	1906,1119,	
1906,1119,	1906,1119,	1906,1119,	1906,1119,	
1906,1119,	1906,1119,	1906,1119,	1920,1979,	
1920,560,	1920,560,	1920,560,	1920,560,	
1920,560,	1920,560,	1920,560,	1920,560,	
1920,560,	1920,560,	1920,560,	1920,560,	
1920,560,	1920,560,	1920,560,	1920,560,	
1920,560,	1920,560,	1920,560,	1920,560,	
1920,560,	1920,560,	1920,560,	1920,560,	
1920,560,	1939,1939,	4207,4227,	4208,4228,	
1940,296,	4205,4225,	4209,4229,	4238,3354,	
4235,3799,	1939,1939,	1939,1998,	4232,4252,	
1940,296,	1940,297,	4244,3902,	4248,3914,	
4236,4255,	4239,3807,	4243,3818,	4240,4258,	
1941,1941,	4247,3830,	4250,3400,	4251,4266,	
4252,3876,	4253,3408,	0,0,	4254,4268,	
1941,1941,	1941,2002,	4276,3792,	0,0,	
4255,3883,	4251,3792,	0,0,	1939,1939,	
4242,3367,	4254,3799,	1940,296,	0,0,	
4238,3288,	1939,1939,	1939,1999,	4258,3891,	
1939,1939,	1940,2001,	1939,1939,	1940,296,	
1939,1939,	1940,296,	0,0,	1940,296,	
4246,3382,	4256,3417,	1941,1941,	4250,3334,	
4261,3902,	0,0,	4253,3343,	1939,1939,	
1941,2003,	1941,2004,	1940,296,	1941,2005,	
1950,1235,	1941,1941,	4235,4254,	1941,1941,	
4259,3428,	4242,3301,	4257,4270,	4260,4272,	
1950,1235,	1950,1236,	4242,3240,	4239,4257,	
4243,4260,	4264,3914,	1941,1941,	4247,4263,	
4257,3807,	4260,3818,	4263,4274,	4252,4267,	
4265,3458,	4246,3316,	4256,3353,	4262,3441,	
4244,4261,	4248,4264,	4246,3252,	4255,4269,	
4263,3830,	1939,2000,	4267,3876,	1939,1939,	
1940,296,	1939,1939,	1940,296,	4276,4286,	
1940,296,	4259,3366,	4258,4271,	4269,3883,	
1950,1235,	1950,1237,	4259,3363,	1950,1235,	
4266,3792,	1950,1235,	1951,1101,	1950,1235,	
1941,1941,	4268,3799,	1941,1941,	4261,4273,	
1941,1941,	4265,3399,	1951,1101,	1951,1102,	
4262,3381,	4270,3807,	1950,1238,	1939,1939,	
1952,740,	4262,3378,	1940,296,	4271,3891,	
4272,3818,	4274,3830,	4273,3902,	4277,4287,	
1952,740,	1952,741,	4275,3914,	4279,4289,	
4264,4275,	4281,4291,	4278,3799,	4280,3807,	
4282,3818,	4277,3876,	1941,1941,	4284,3830,	
4283,4293,	4279,3883,	4288,3799,	4281,3891,	
4297,3876,	4285,4295,	1951,1173,	1951,1103,	
4267,4277,	1951,1101,	4283,3902,	1951,1101,	
1950,1235,	1951,1101,	1950,1235,	4285,3914,	
1950,1235,	4269,4279,	4290,3807,	4287,3876,	
1952,740,	1952,743,	4292,3818,	1952,740,	
1951,1104,	1952,740,	0,0,	1952,740,	
4289,3883,	4294,3830,	4266,4276,	4291,3891,	
4293,3902,	1950,2012,	4295,3914,	4268,4278,	
4299,3883,	1988,999,	1952,810,	4307,3876,	
4301,3891,	4271,4281,	1950,1299,	4270,4280,	
4273,4283,	1988,999,	1988,1000,	4303,3902,	
4275,4285,	4305,3914,	4272,4282,	4274,4284,	
4316,3792,	4309,3883,	4306,3792,	4308,3799,	
4310,3807,	4311,3891,	1951,1101,	4288,4298,	
1951,1101,	2606,887,	1951,1101,	4278,4288,	
4280,4290,	4282,4292,	4312,3818,	4318,3799,	
4284,4294,	2606,887,	2606,887,	1988,999,	
1952,740,	4297,4307,	1952,740,	4290,4300,	
1952,740,	1988,999,	1988,1001,	4292,4302,	
1988,999,	1951,2013,	1988,999,	1989,854,	
1988,999,	4287,4297,	4294,4304,	4320,3807,	
1951,1101,	4322,3818,	1952,2014,	1989,854,	
1989,855,	4324,3830,	4289,4299,	1988,999,	
4307,4317,	4291,4301,	4293,4303,	4313,3902,	
4295,4305,	2606,959,	1952,740,	2001,296,	
2606,887,	4299,4309,	2606,887,	4315,3914,	
2606,887,	4301,4311,	4309,4319,	2001,370,	
2001,297,	4337,3876,	4311,4321,	4314,3830,	
4303,4313,	1989,854,	4305,4315,	2606,960,	
4306,4316,	4308,4318,	4310,4320,	1989,933,	
1989,856,	4316,4326,	1989,854,	4327,3876,	
1989,854,	1988,999,	1989,854,	1988,999,	
4312,4322,	1988,999,	4329,3883,	4326,4336,	
1988,2048,	2001,296,	4339,3883,	4341,3891,	
4318,4328,	1989,854,	4328,4338,	2001,223,	
2001,298,	4326,3792,	2001,296,	4331,3891,	
2001,296,	2001,2059,	2001,296,	4333,3902,	
4328,3799,	2606,887,	4335,3914,	2606,887,	
4313,4323,	2606,887,	4330,4340,	1988,1076,	
4320,4330,	2001,296,	4322,4332,	2012,1235,	
4315,4325,	4346,3836,	4324,4334,	0,0,	
4330,3807,	4348,3842,	4332,4342,	2012,1235,	
2012,1236,	2084,760,	4334,4344,	1989,854,	
0,0,	1989,854,	4347,4356,	1989,854,	
4332,3818,	4314,4324,	4349,4357,	2606,887,	
4334,3830,	4343,3902,	4337,4347,	0,0,	
4347,3876,	4350,3848,	1989,2049,	4351,4358,	
4349,3883,	4327,4337,	0,0,	2001,296,	
0,0,	2001,296,	4346,3792,	2001,296,	
4329,4339,	4351,3891,	4348,3799,	2012,1235,	
2012,1237,	1989,854,	2012,1235,	0,0,	
2012,1235,	4353,4359,	2012,1235,	4339,4349,	
4341,4351,	4331,4341,	4345,3914,	0,0,	
4355,4360,	4333,4343,	0,0,	4353,3902,	
4335,4345,	2012,1238,	4350,3807,	4354,3868,	
0,0,	2001,296,	4355,3914,	4350,3760,	
2084,2140,	2084,757,	2084,757,	2084,757,	
2084,757,	2084,757,	2084,757,	2084,757,	
2084,757,	2084,757,	2084,757,	2084,757,	
2084,757,	2084,757,	2084,757,	2084,757,	
2084,757,	2084,757,	2084,757,	2084,757,	
2084,757,	2084,757,	2084,757,	2084,757,	
2084,757,	2084,757,	0,0,	2012,1235,	
4354,3830,	2012,1235,	4343,4353,	2012,2069,	
2012,1235,	2012,1235,	2012,1235,	2012,1235,	
2012,1235,	2012,1235,	2012,1235,	2012,1235,	
2012,1235,	2012,1235,	2012,1235,	2012,1235,	
2012,1235,	2012,1235,	2012,1235,	2012,1235,	
2012,1235,	2012,1235,	2012,1235,	2012,1235,	
2012,1235,	2012,1235,	2012,1235,	2012,1235,	
2012,1235,	2012,1299,	2013,1101,	4345,4355,	
4361,3920,	4362,3926,	0,0,	0,0,	
4352,3857,	0,0,	2013,1101,	2013,1102,	
2014,740,	0,0,	0,0,	4365,3950,	
0,0,	0,0,	4363,3932,	0,0,	
2014,740,	2014,741,	0,0,	0,0,	
0,0,	4364,3940,	0,0,	0,0,	
0,0,	0,0,	0,0,	2059,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4361,3876,	4362,3883,	2059,2059,	
2059,2061,	4352,3818,	2013,1173,	2013,1103,	
0,0,	2013,1101,	4352,3771,	2013,1101,	
4365,3914,	2013,1101,	0,0,	4363,3891,	
2014,740,	2014,743,	0,0,	2014,740,	
4363,3849,	2014,740,	4364,3902,	2014,740,	
2013,1104,	0,0,	0,0,	4364,3858,	
0,0,	2059,2059,	0,0,	0,0,	
0,0,	0,0,	2014,810,	2025,1252,	
2059,2062,	0,0,	2059,2059,	0,0,	
2059,2059,	0,0,	2059,2059,	2025,1252,	
2025,1253,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2059,2059,	0,0,	0,0,	
0,0,	0,0,	2013,1101,	0,0,	
2013,1101,	0,0,	2013,1101,	0,0,	
0,0,	0,0,	2013,2070,	0,0,	
2014,740,	2025,1252,	2014,740,	0,0,	
2014,740,	0,0,	2014,2071,	2025,1252,	
2025,1254,	0,0,	2025,1252,	0,0,	
2025,1252,	0,0,	2025,1252,	0,0,	
0,0,	0,0,	0,0,	2059,2059,	
2013,1101,	2059,2059,	0,0,	2059,2059,	
0,0,	2025,1255,	0,0,	0,0,	
0,0,	0,0,	2014,740,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2059,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2025,1252,	
0,0,	2025,1252,	0,0,	2025,2082,	
2025,1252,	2025,1252,	2025,1252,	2025,1252,	
2025,1252,	2025,1252,	2025,1252,	2025,1252,	
2025,1252,	2025,1252,	2025,1252,	2025,1252,	
2025,1252,	2025,1252,	2025,1252,	2025,1252,	
2025,1252,	2025,1252,	2025,1252,	2025,1252,	
2025,1252,	2025,1252,	2025,1252,	2025,1252,	
2025,1252,	2025,1314,	2049,854,	0,0,	
0,0,	2062,2059,	0,0,	0,0,	
0,0,	0,0,	2049,854,	2049,855,	
0,0,	2062,2117,	2062,2061,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2069,1235,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2069,1235,	2069,1236,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2049,854,	0,0,	0,0,	2062,2059,	
0,0,	0,0,	2049,933,	2049,856,	
0,0,	2049,854,	2062,2062,	2049,854,	
2062,2059,	2049,854,	2062,2059,	0,0,	
2062,2059,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2049,854,	2069,1235,	2069,1237,	2062,2059,	
2069,1235,	0,0,	2069,1235,	0,0,	
2069,1235,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2069,1238,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2049,854,	0,0,	
2049,854,	2062,2059,	2049,854,	2062,2059,	
0,0,	2062,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2070,1101,	0,0,	
2049,2106,	2069,1235,	0,0,	2069,1235,	
0,0,	2069,1235,	2070,1101,	2070,1102,	
0,0,	0,0,	0,0,	0,0,	
2049,854,	0,0,	0,0,	2062,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2069,2123,	2071,740,	0,0,	0,0,	
0,0,	0,0,	0,0,	2069,1299,	
0,0,	2071,740,	2071,741,	0,0,	
0,0,	0,0,	2070,1173,	2070,1103,	
0,0,	2070,1101,	0,0,	2070,1101,	
0,0,	2070,1101,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2070,1104,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2071,740,	2071,743,	0,0,	
2071,740,	0,0,	2071,740,	0,0,	
2071,740,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2071,810,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2070,1101,	0,0,	
2070,1101,	0,0,	2070,1101,	0,0,	
0,0,	2070,2124,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2071,740,	0,0,	2071,740,	
2070,1101,	2071,2125,	2071,740,	2071,740,	
2071,740,	2071,740,	2071,740,	2071,740,	
2071,740,	2071,740,	2071,740,	2071,740,	
2071,740,	2071,740,	2071,740,	2071,740,	
2071,740,	2071,740,	2071,740,	2071,740,	
2071,740,	2071,740,	2071,740,	2071,740,	
2071,740,	2071,740,	2071,740,	2071,740,	
2081,2081,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2081,2081,	2081,2135,	2105,999,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2105,999,	2105,1000,	
2106,854,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2106,854,	2106,855,	0,0,	0,0,	
0,0,	0,0,	2081,2081,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2081,2081,	2081,2136,	0,0,	2081,2081,	
2105,999,	2081,2081,	0,0,	2081,2081,	
0,0,	0,0,	2105,999,	2105,1001,	
0,0,	2105,999,	2106,854,	2105,999,	
0,0,	2105,999,	2081,2137,	0,0,	
2106,933,	2106,856,	0,0,	2106,854,	
0,0,	2106,854,	0,0,	2106,854,	
2105,999,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2106,854,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2117,2059,	0,0,	
2081,2081,	0,0,	2081,2081,	0,0,	
2081,2081,	0,0,	2117,2117,	2117,2061,	
2123,1235,	0,0,	2105,999,	0,0,	
2105,999,	0,0,	2105,999,	0,0,	
2123,1235,	2123,1236,	0,0,	0,0,	
2106,854,	0,0,	2106,854,	0,0,	
2106,854,	2105,2161,	2106,2162,	2124,1101,	
0,0,	0,0,	2081,2081,	0,0,	
2117,2059,	0,0,	0,0,	2124,1101,	
2124,1102,	0,0,	2117,2003,	2117,2062,	
2105,1076,	2117,2059,	0,0,	2117,2059,	
0,0,	2117,2059,	0,0,	0,0,	
2123,1235,	2123,1237,	2106,854,	2123,1235,	
0,0,	2123,1235,	0,0,	2123,1235,	
2117,2059,	0,0,	2124,2180,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2123,1238,	2124,1173,	
2124,1103,	2125,740,	2124,1101,	0,0,	
2124,1101,	0,0,	2124,1101,	0,0,	
0,0,	2125,740,	2125,741,	0,0,	
2117,2173,	0,0,	0,0,	0,0,	
0,0,	2124,1104,	0,0,	0,0,	
2128,527,	0,0,	2117,2059,	0,0,	
2117,2059,	0,0,	2117,2059,	0,0,	
2128,527,	2128,528,	2156,2210,	0,0,	
2123,1235,	0,0,	2123,1235,	0,0,	
2123,1235,	0,0,	2156,2210,	2156,0,	
2123,2179,	2125,740,	2125,743,	0,0,	
2125,740,	0,0,	2125,740,	0,0,	
2125,740,	2161,999,	0,0,	2124,1101,	
2117,2059,	2124,1101,	0,0,	2124,1101,	
0,0,	2161,999,	2161,1000,	2125,810,	
2128,527,	2128,2184,	2123,1299,	2128,527,	
2156,2210,	2128,527,	0,0,	2128,527,	
0,0,	0,0,	2156,2210,	2156,2211,	
0,0,	2156,2210,	0,0,	2156,2210,	
0,0,	2156,2210,	2128,605,	0,0,	
0,0,	2124,1101,	0,0,	2161,999,	
0,0,	0,0,	0,0,	0,0,	
2156,2210,	2161,999,	2161,1001,	0,0,	
2161,999,	2125,740,	2161,999,	2125,740,	
2161,999,	2125,740,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2161,999,	
2125,2181,	0,0,	2164,2219,	0,0,	
2128,527,	0,0,	2128,527,	0,0,	
2128,527,	2162,856,	2164,2219,	0,0,	
0,0,	0,0,	2156,2210,	2125,740,	
2156,2210,	0,0,	2156,2210,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2161,999,	2128,527,	2161,999,	
2164,2219,	2161,999,	0,0,	0,0,	
0,0,	0,0,	2164,2219,	2164,2220,	
2156,2210,	2164,2219,	0,0,	2164,2219,	
0,0,	2164,2219,	0,0,	2161,2216,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2164,2219,	0,0,	0,0,	2161,1076,	
2162,2217,	2162,854,	2162,854,	2162,854,	
2162,854,	2162,854,	2162,854,	2162,854,	
2162,854,	2162,854,	2162,854,	2162,854,	
2162,854,	2162,854,	2162,854,	2162,854,	
2162,854,	2162,854,	2162,854,	2162,854,	
2162,854,	2162,854,	2162,854,	2162,854,	
2162,854,	2162,854,	2170,868,	0,0,	
0,0,	0,0,	2164,2219,	0,0,	
2164,2219,	0,0,	2164,2219,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2164,2219,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2170,2226,	2170,866,	2170,866,	
2170,866,	2170,866,	2170,866,	2170,866,	
2170,866,	2170,866,	2170,866,	2170,866,	
2170,866,	2170,866,	2170,866,	2170,866,	
2170,866,	2170,866,	2170,866,	2170,866,	
2170,866,	2170,866,	2170,866,	2170,866,	
2170,866,	2170,866,	2170,866,	2173,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2173,2059,	
2173,2061,	2174,2230,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2174,2230,	2179,1235,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2179,1235,	2179,1236,	
2180,1101,	0,0,	0,0,	0,0,	
0,0,	2173,2059,	0,0,	0,0,	
2180,1101,	2180,1102,	0,0,	2173,2003,	
2173,2062,	0,0,	2173,2059,	2174,2230,	
2173,2059,	0,0,	2173,2059,	0,0,	
0,0,	2174,2230,	2174,2231,	0,0,	
2174,2230,	0,0,	2174,2230,	0,0,	
2174,2230,	2173,2059,	2179,1235,	2179,1237,	
0,0,	2179,1235,	0,0,	2179,1235,	
0,0,	2179,1235,	0,0,	2174,2230,	
2180,1173,	2180,1103,	0,0,	2180,1101,	
0,0,	2180,1101,	0,0,	2180,1101,	
2179,1238,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2180,1104,	0,0,	
0,0,	2181,740,	0,0,	2173,2059,	
0,0,	2173,2059,	0,0,	2173,2059,	
0,0,	2181,740,	2181,741,	0,0,	
0,0,	2174,2230,	0,0,	2174,2230,	
0,0,	2174,2230,	0,0,	0,0,	
0,0,	0,0,	2179,1235,	0,0,	
2179,1235,	0,0,	2179,1235,	0,0,	
0,0,	2179,2236,	2183,886,	2173,2229,	
2180,1101,	2173,2059,	2180,1101,	0,0,	
2180,1101,	0,0,	2183,886,	2183,887,	
0,0,	2181,740,	2181,743,	2174,2230,	
2181,740,	0,0,	2181,740,	2180,2237,	
2181,740,	0,0,	0,0,	0,0,	
2179,1299,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2181,810,	
0,0,	0,0,	2180,1101,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2183,958,	2183,888,	
0,0,	2183,886,	0,0,	2183,886,	
0,0,	2183,886,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2183,889,	0,0,	0,0,	0,0,	
0,0,	2181,740,	0,0,	2181,740,	
0,0,	2181,740,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2181,2238,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2183,886,	2181,740,	
2183,886,	0,0,	2183,2240,	2183,886,	
2183,886,	2183,886,	2183,886,	2183,886,	
2183,886,	2183,886,	2183,886,	2183,886,	
2183,886,	2183,886,	2183,886,	2183,886,	
2183,886,	2183,886,	2183,886,	2183,886,	
2183,886,	2183,886,	2183,886,	2183,886,	
2183,886,	2183,886,	2183,886,	2183,886,	
2183,886,	2184,527,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2184,608,	2184,528,	2186,2243,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2186,2243,	
0,0,	0,0,	0,0,	2582,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2582,2649,	
2582,2650,	0,0,	0,0,	2184,80,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2184,527,	2184,530,	0,0,	
2184,527,	2186,2243,	2184,527,	2184,2241,	
2184,527,	0,0,	0,0,	2186,2243,	
2186,2244,	0,0,	2186,2243,	0,0,	
2186,2243,	2582,2649,	2186,2243,	2184,605,	
0,0,	0,0,	0,0,	2582,2649,	
2582,2651,	0,0,	2582,2649,	0,0,	
2582,2649,	2186,2243,	2582,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2196,906,	
0,0,	2582,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2184,527,	0,0,	2184,527,	
0,0,	2184,527,	0,0,	0,0,	
0,0,	0,0,	0,0,	2186,2243,	
0,0,	2186,2243,	2199,911,	2186,2243,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2582,2649,	
0,0,	2582,2649,	0,0,	2582,2649,	
0,0,	0,0,	0,0,	2184,527,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2186,2243,	2196,2254,	2196,904,	
2196,904,	2196,904,	2196,904,	2196,904,	
2196,904,	2196,904,	2196,904,	2196,904,	
2196,904,	2196,904,	2196,904,	2196,904,	
2196,904,	2196,904,	2196,904,	2196,904,	
2196,904,	2196,904,	2196,904,	2196,904,	
2196,904,	2196,904,	2196,904,	2196,904,	
0,0,	2199,2257,	2199,909,	2199,909,	
2199,909,	2199,909,	2199,909,	2199,909,	
2199,909,	2199,909,	2199,909,	2199,909,	
2199,909,	2199,909,	2199,909,	2199,909,	
2199,909,	2199,909,	2199,909,	2199,909,	
2199,909,	2199,909,	2199,909,	2199,909,	
2199,909,	2199,909,	2199,909,	2202,2260,	
0,0,	0,0,	0,0,	2208,925,	
0,0,	0,0,	0,0,	2202,2260,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2202,2260,	0,0,	0,0,	
0,0,	0,0,	0,0,	2202,2260,	
2202,2261,	0,0,	2202,2260,	0,0,	
2202,2260,	0,0,	2202,2260,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2202,2260,	2208,2267,	2208,923,	
2208,923,	2208,923,	2208,923,	2208,923,	
2208,923,	2208,923,	2208,923,	2208,923,	
2208,923,	2208,923,	2208,923,	2208,923,	
2208,923,	2208,923,	2208,923,	2208,923,	
2208,923,	2208,923,	2208,923,	2208,923,	
2208,923,	2208,923,	2208,923,	2208,923,	
0,0,	0,0,	0,0,	0,0,	
2215,2215,	0,0,	0,0,	2202,2260,	
0,0,	2202,2260,	0,0,	2202,2260,	
2215,2215,	2215,2274,	2216,999,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2216,999,	2216,1000,	
2219,2219,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2219,2219,	2219,2280,	0,0,	0,0,	
0,0,	2202,2260,	2215,2215,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2215,2215,	2215,2275,	0,0,	2215,2215,	
2216,999,	2215,2215,	0,0,	2215,2215,	
0,0,	0,0,	2216,999,	2216,1001,	
0,0,	2216,999,	2219,2219,	2216,999,	
0,0,	2216,999,	2215,2276,	0,0,	
2219,2219,	2219,2220,	0,0,	2219,2219,	
0,0,	2219,2219,	0,0,	2219,2219,	
2216,999,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2219,2219,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2224,2224,	0,0,	
2215,2215,	0,0,	2215,2215,	0,0,	
2215,2215,	0,0,	2224,2224,	2224,2285,	
0,0,	0,0,	2216,999,	0,0,	
2216,999,	0,0,	2216,999,	0,0,	
2216,2277,	2229,2059,	0,0,	0,0,	
2219,2219,	0,0,	2219,2219,	0,0,	
2219,2219,	2229,2059,	2229,2061,	2230,2230,	
0,0,	0,0,	2215,2215,	0,0,	
2224,2224,	0,0,	0,0,	2230,2230,	
2230,2293,	0,0,	2224,2224,	2224,2286,	
2216,1076,	2224,2224,	0,0,	2224,2224,	
0,0,	2224,2224,	2236,1235,	0,0,	
0,0,	0,0,	2219,2219,	2229,2059,	
0,0,	0,0,	2236,1235,	2236,1236,	
2224,2287,	2229,2003,	2229,2062,	0,0,	
2229,2059,	2230,2230,	2229,2059,	0,0,	
2229,2059,	0,0,	0,0,	2230,2230,	
2230,2231,	0,0,	2230,2230,	0,0,	
2230,2230,	0,0,	2230,2230,	2229,2059,	
0,0,	2236,2300,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2230,2230,	2236,1235,	2236,1237,	
0,0,	2236,1235,	2224,2224,	2236,1235,	
2224,2224,	2236,1235,	2224,2224,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2236,1238,	0,0,	0,0,	2237,1101,	
0,0,	2229,2059,	0,0,	2229,2059,	
0,0,	2229,2059,	0,0,	2237,1101,	
2237,1102,	0,0,	0,0,	2230,2230,	
2224,2224,	2230,2230,	0,0,	2230,2230,	
0,0,	0,0,	2238,740,	0,0,	
0,0,	0,0,	0,0,	2229,2292,	
0,0,	0,0,	2238,740,	2238,741,	
2241,2241,	0,0,	2236,1235,	2229,2059,	
2236,1235,	0,0,	2236,1235,	0,0,	
2241,2241,	2241,2305,	0,0,	2237,1173,	
2237,1103,	2230,2230,	2237,1101,	0,0,	
2237,1101,	0,0,	2237,1101,	2242,2242,	
0,0,	2238,2302,	0,0,	0,0,	
0,0,	0,0,	0,0,	2242,2242,	
2242,2308,	2237,1104,	2238,740,	2238,743,	
2236,1299,	2238,740,	0,0,	2238,740,	
0,0,	2238,740,	0,0,	0,0,	
2241,2241,	2241,2306,	0,0,	2241,2241,	
0,0,	2241,2241,	0,0,	2241,2241,	
2238,810,	0,0,	0,0,	0,0,	
0,0,	2242,2242,	0,0,	0,0,	
0,0,	0,0,	2241,2307,	2242,2242,	
2242,2309,	2243,2243,	2242,2242,	2237,1101,	
2242,2242,	2237,1101,	2242,2242,	2237,1101,	
0,0,	2243,2243,	2243,2310,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2242,2242,	0,0,	0,0,	
2255,2255,	2237,2301,	2238,740,	0,0,	
2238,740,	0,0,	2238,740,	0,0,	
2255,2255,	2255,2323,	2258,2258,	0,0,	
2241,2241,	2237,1101,	2241,2241,	2243,2243,	
2241,2241,	0,0,	2258,2258,	2258,2328,	
0,0,	2243,2243,	2243,2244,	0,0,	
2243,2243,	0,0,	2243,2243,	0,0,	
2243,2243,	2260,2260,	0,0,	2242,2242,	
2238,740,	2242,2242,	2255,2255,	2242,2242,	
0,0,	2260,2260,	2260,2332,	2243,2243,	
2255,2255,	2255,2324,	2241,2241,	2255,2255,	
2258,2258,	2255,2255,	0,0,	2255,2255,	
0,0,	0,0,	2258,2258,	2258,2329,	
0,0,	2258,2258,	0,0,	2258,2258,	
0,0,	2258,2258,	2255,2325,	0,0,	
0,0,	2242,2242,	0,0,	2260,2260,	
0,0,	0,0,	0,0,	0,0,	
2258,2330,	2260,2260,	2260,2261,	2265,2265,	
2260,2260,	2243,2243,	2260,2260,	2243,2243,	
2260,2260,	2243,2243,	0,0,	2265,2265,	
2265,2337,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2260,2260,	
0,0,	0,0,	2271,2344,	0,0,	
2255,2255,	0,0,	2255,2255,	0,0,	
2255,2255,	0,0,	2271,2344,	2271,0,	
0,0,	0,0,	2258,2258,	2243,2243,	
2258,2258,	2265,2265,	2258,2258,	0,0,	
0,0,	0,0,	0,0,	2265,2265,	
2265,2338,	0,0,	2265,2265,	0,0,	
2265,2265,	0,0,	2265,2265,	0,0,	
0,0,	2260,2260,	2255,2255,	2260,2260,	
2271,2344,	2260,2260,	0,0,	0,0,	
0,0,	2265,2339,	2271,2344,	2271,2345,	
2258,2258,	2271,2344,	0,0,	2271,2344,	
0,0,	2271,2344,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2282,2353,	
2271,2344,	0,0,	0,0,	2260,2260,	
0,0,	0,0,	0,0,	2282,2353,	
0,0,	0,0,	2277,1001,	0,0,	
0,0,	0,0,	0,0,	2265,2265,	
0,0,	2265,2265,	0,0,	2265,2265,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2282,2353,	2271,2344,	0,0,	
2271,2344,	0,0,	2271,2344,	2282,2353,	
2282,2354,	0,0,	2282,2353,	0,0,	
2282,2353,	2265,2265,	2282,2353,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2282,2353,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2271,2344,	2277,2349,	2277,999,	2277,999,	
2277,999,	2277,999,	2277,999,	2277,999,	
2277,999,	2277,999,	2277,999,	2277,999,	
2277,999,	2277,999,	2277,999,	2277,999,	
2277,999,	2277,999,	2277,999,	2277,999,	
2277,999,	2277,999,	2277,999,	2277,999,	
2277,999,	2277,999,	2277,999,	2282,2353,	
2288,1012,	2282,2353,	0,0,	2282,2353,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2282,2353,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2288,2358,	
2288,1010,	2288,1010,	2288,1010,	2288,1010,	
2288,1010,	2288,1010,	2288,1010,	2288,1010,	
2288,1010,	2288,1010,	2288,1010,	2288,1010,	
2288,1010,	2288,1010,	2288,1010,	2288,1010,	
2288,1010,	2288,1010,	2288,1010,	2288,1010,	
2288,1010,	2288,1010,	2288,1010,	2288,1010,	
2288,1010,	2292,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2292,2059,	2292,2061,	2296,2364,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2296,2364,	
0,0,	2300,1235,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2300,1235,	2300,1236,	0,0,	
0,0,	0,0,	0,0,	2292,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2292,2003,	2292,2062,	0,0,	
2292,2059,	2296,2364,	2292,2059,	0,0,	
2292,2059,	0,0,	0,0,	2296,2364,	
2296,2365,	0,0,	2296,2364,	0,0,	
2296,2364,	0,0,	2296,2364,	2292,2059,	
0,0,	2300,1235,	2300,1237,	0,0,	
2300,1235,	0,0,	2300,1235,	0,0,	
2300,1235,	2296,2364,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2300,1238,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2301,1101,	
0,0,	2292,2059,	0,0,	2292,2059,	
0,0,	2292,2059,	0,0,	2301,1101,	
2301,1102,	2302,740,	0,0,	2296,2364,	
0,0,	2296,2364,	0,0,	2296,2364,	
0,0,	2302,740,	2302,741,	0,0,	
0,0,	2300,1235,	0,0,	2300,1235,	
2292,2362,	2300,1235,	0,0,	0,0,	
0,0,	0,0,	0,0,	2292,2059,	
0,0,	0,0,	0,0,	0,0,	
2300,2369,	0,0,	0,0,	2301,1173,	
2301,1103,	2296,2364,	2301,1101,	0,0,	
2301,1101,	0,0,	2301,1101,	0,0,	
0,0,	2302,740,	2302,2371,	2300,1299,	
2302,740,	0,0,	2302,740,	0,0,	
2302,740,	2301,1104,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2303,1027,	2302,810,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2303,1027,	2303,1028,	
0,0,	2321,1046,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2301,1101,	
0,0,	2301,1101,	0,0,	2301,1101,	
0,0,	2301,2370,	0,0,	0,0,	
0,0,	2302,740,	0,0,	2302,740,	
0,0,	2302,740,	2303,1027,	2303,1029,	
0,0,	2303,1027,	0,0,	2303,1027,	
0,0,	2303,1027,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2301,1101,	0,0,	0,0,	
2303,1030,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2302,740,	
2321,2386,	2321,1044,	2321,1044,	2321,1044,	
2321,1044,	2321,1044,	2321,1044,	2321,1044,	
2321,1044,	2321,1044,	2321,1044,	2321,1044,	
2321,1044,	2321,1044,	2321,1044,	2321,1044,	
2321,1044,	2321,1044,	2321,1044,	2321,1044,	
2321,1044,	2321,1044,	2321,1044,	2321,1044,	
2321,1044,	2321,1044,	2303,1027,	0,0,	
2303,1027,	0,0,	2303,2372,	2303,1027,	
2303,1027,	2303,1027,	2303,1027,	2303,1027,	
2303,1027,	2303,1027,	2303,1027,	2303,1027,	
2303,1027,	2303,1027,	2303,1027,	2303,1027,	
2303,1027,	2303,1027,	2303,1027,	2303,1027,	
2303,1027,	2303,1027,	2303,1027,	2303,1027,	
2303,1027,	2303,1027,	2303,1027,	2303,1027,	
2303,1106,	2306,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2306,2374,	2306,2305,	2313,2377,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2313,2377,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2306,2241,	2306,2306,	0,0,	
2306,2241,	2313,2377,	2306,2241,	0,0,	
2306,2241,	0,0,	0,0,	2313,2377,	
2313,2378,	0,0,	2313,2377,	0,0,	
2313,2377,	0,0,	2313,2377,	2306,2307,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2334,2394,	2313,2377,	0,0,	0,0,	
0,0,	0,0,	2675,1028,	0,0,	
2334,2394,	0,0,	0,0,	2326,1053,	
0,0,	0,0,	2675,1028,	2675,1028,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2306,2241,	0,0,	2306,2241,	
0,0,	2306,2241,	0,0,	0,0,	
0,0,	0,0,	2334,2394,	2313,2377,	
0,0,	2313,2377,	0,0,	2313,2377,	
2334,2394,	2334,2395,	0,0,	2334,2394,	
0,0,	2334,2394,	2675,1028,	2334,2394,	
0,0,	2675,1028,	0,0,	2675,1028,	
0,0,	2675,1028,	0,0,	2306,2241,	
0,0,	0,0,	2334,2394,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2675,1031,	2313,2377,	2326,2389,	2326,1051,	
2326,1051,	2326,1051,	2326,1051,	2326,1051,	
2326,1051,	2326,1051,	2326,1051,	2326,1051,	
2326,1051,	2326,1051,	2326,1051,	2326,1051,	
2326,1051,	2326,1051,	2326,1051,	2326,1051,	
2326,1051,	2326,1051,	2326,1051,	2326,1051,	
2326,1051,	2326,1051,	2326,1051,	2326,1051,	
2334,2394,	2340,1067,	2334,2394,	0,0,	
2334,2394,	0,0,	2675,1028,	0,0,	
2675,1028,	0,0,	2675,1028,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2334,2394,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2675,1107,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2340,2399,	2340,1065,	2340,1065,	2340,1065,	
2340,1065,	2340,1065,	2340,1065,	2340,1065,	
2340,1065,	2340,1065,	2340,1065,	2340,1065,	
2340,1065,	2340,1065,	2340,1065,	2340,1065,	
2340,1065,	2340,1065,	2340,1065,	2340,1065,	
2340,1065,	2340,1065,	2340,1065,	2340,1065,	
2340,1065,	2340,1065,	2353,2353,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2353,2353,	2353,2412,	
2362,2059,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2362,2059,	2362,2061,	2364,2364,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2364,2364,	2364,2423,	
0,0,	0,0,	0,0,	0,0,	
2353,2353,	0,0,	0,0,	0,0,	
0,0,	0,0,	2353,2353,	2353,2354,	
0,0,	2353,2353,	2362,2059,	2353,2353,	
0,0,	2353,2353,	0,0,	0,0,	
2362,2003,	2362,2062,	0,0,	2362,2059,	
2364,2364,	2362,2059,	0,0,	2362,2059,	
2353,2353,	0,0,	2364,2364,	2364,2365,	
0,0,	2364,2364,	0,0,	2364,2364,	
0,0,	2364,2364,	2362,2059,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2364,2364,	0,0,	2369,1235,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2369,1235,	2369,1236,	
2592,2659,	0,0,	2353,2353,	0,0,	
2353,2353,	0,0,	2353,2353,	0,0,	
2592,2659,	2592,2660,	0,0,	0,0,	
2362,2059,	0,0,	2362,2059,	0,0,	
2362,2059,	0,0,	0,0,	2370,1101,	
2362,2421,	0,0,	2364,2364,	0,0,	
2364,2364,	0,0,	2364,2364,	2370,1101,	
2370,1102,	0,0,	2369,1235,	2369,1237,	
2353,2353,	2369,1235,	2592,2659,	2369,1235,	
0,0,	2369,1235,	0,0,	0,0,	
2592,2659,	2592,2661,	2362,2059,	2592,2659,	
0,0,	2592,2659,	0,0,	2592,2659,	
2369,1238,	0,0,	0,0,	0,0,	
2364,2364,	0,0,	0,0,	0,0,	
0,0,	0,0,	2592,2659,	2370,1173,	
2370,1103,	0,0,	2370,1101,	0,0,	
2370,1101,	0,0,	2370,1101,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2370,1104,	0,0,	0,0,	
0,0,	0,0,	2369,1235,	0,0,	
2369,1235,	0,0,	2369,1235,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2592,2659,	0,0,	2592,2659,	0,0,	
2592,2659,	0,0,	0,0,	0,0,	
2369,2429,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2370,1101,	
2369,1299,	2370,1101,	0,0,	2370,2430,	
2370,1101,	2370,1101,	2370,1101,	2370,1101,	
2370,1101,	2370,1101,	2370,1101,	2370,1101,	
2370,1101,	2370,1101,	2370,1101,	2370,1101,	
2370,1101,	2370,1101,	2370,1101,	2370,1101,	
2370,1101,	2370,1101,	2370,1101,	2370,1101,	
2370,1101,	2370,1101,	2370,1101,	2370,1101,	
2370,1101,	2370,1101,	2371,740,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2371,813,	2371,741,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2374,2241,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2374,2374,	2374,2305,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2371,740,	2371,743,	
0,0,	2371,740,	0,0,	2371,740,	
2371,2431,	2371,740,	0,0,	0,0,	
2374,1798,	0,0,	0,0,	0,0,	
0,0,	0,0,	2374,2241,	2374,2306,	
2371,810,	2374,2241,	0,0,	2374,2241,	
0,0,	2374,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2377,2377,	
2374,2307,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2377,2377,	
2377,2437,	0,0,	2384,1121,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2371,740,	0,0,	
2371,740,	0,0,	2371,740,	0,0,	
2374,2434,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2377,2377,	2374,2241,	0,0,	
2374,2241,	0,0,	2374,2241,	2377,2377,	
2377,2378,	0,0,	2377,2377,	0,0,	
2377,2377,	0,0,	2377,2377,	0,0,	
2371,740,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2377,2377,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2374,2241,	2384,2445,	2384,1119,	2384,1119,	
2384,1119,	2384,1119,	2384,1119,	2384,1119,	
2384,1119,	2384,1119,	2384,1119,	2384,1119,	
2384,1119,	2384,1119,	2384,1119,	2384,1119,	
2384,1119,	2384,1119,	2384,1119,	2384,1119,	
2384,1119,	2384,1119,	2384,1119,	2384,1119,	
2384,1119,	2384,1119,	2384,1119,	2377,2377,	
2394,2394,	2377,2377,	0,0,	2377,2377,	
0,0,	0,0,	0,0,	0,0,	
2394,2394,	2394,2455,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2406,1611,	
0,0,	2377,2377,	0,0,	0,0,	
0,0,	0,0,	2394,2394,	2406,1611,	
2406,1612,	0,0,	0,0,	0,0,	
2394,2394,	2394,2395,	0,0,	2394,2394,	
0,0,	2394,2394,	0,0,	2394,2394,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2394,2394,	0,0,	
0,0,	2406,1611,	0,0,	0,0,	
0,0,	0,0,	0,0,	2406,1672,	
2406,1613,	0,0,	2406,1611,	0,0,	
2406,1611,	0,0,	2406,1611,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2406,1611,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2394,2394,	0,0,	2394,2394,	0,0,	
2394,2394,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2406,1611,	
0,0,	2406,1611,	2394,2394,	2406,2466,	
2406,1611,	2406,1611,	2406,1611,	2406,1611,	
2406,1611,	2406,1611,	2406,1611,	2406,1611,	
2406,1611,	2406,1611,	2406,1611,	2406,1611,	
2406,1611,	2406,1611,	2406,1611,	2406,1611,	
2406,1611,	2406,1611,	2406,1611,	2406,1611,	
2406,1611,	2406,1611,	2406,1611,	2406,1611,	
2406,1611,	2406,1611,	2409,854,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2409,854,	2409,855,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2415,1620,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2415,1620,	2415,1621,	0,0,	
0,0,	0,0,	2409,933,	2409,2469,	
0,0,	2409,854,	0,0,	2409,854,	
0,0,	2409,854,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2409,854,	0,0,	0,0,	2415,1620,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2415,1681,	2415,1622,	0,0,	
2415,1620,	0,0,	2415,1620,	0,0,	
2415,1620,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2415,1620,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2409,854,	0,0,	
2409,854,	0,0,	2409,854,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2415,1620,	0,0,	2415,1620,	
2409,854,	2415,2474,	2415,1620,	2415,1620,	
2415,1620,	2415,1620,	2415,1620,	2415,1620,	
2415,1620,	2415,1620,	2415,1620,	2415,1620,	
2415,1620,	2415,1620,	2415,1620,	2415,1620,	
2415,1620,	2415,1620,	2415,1620,	2415,1620,	
2415,1620,	2415,1620,	2415,1620,	2415,1620,	
2415,1620,	2415,1620,	2415,1620,	2415,1620,	
2421,2059,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2421,2059,	2421,2061,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2427,1632,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2421,2059,	2427,1632,	
2427,1633,	0,0,	0,0,	0,0,	
2421,2003,	2421,2062,	0,0,	2421,2059,	
0,0,	2421,2059,	0,0,	2421,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2421,2059,	0,0,	
0,0,	2427,1632,	0,0,	0,0,	
0,0,	0,0,	0,0,	2427,1692,	
2427,1634,	0,0,	2427,1632,	0,0,	
2427,1632,	0,0,	2427,1632,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2427,1632,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2421,2059,	0,0,	2421,2059,	0,0,	
2421,2059,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2421,2480,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2427,1632,	
0,0,	2427,1632,	2421,2059,	2427,2484,	
2427,1632,	2427,1632,	2427,1632,	2427,1632,	
2427,1632,	2427,1632,	2427,1632,	2427,1632,	
2427,1632,	2427,1632,	2427,1632,	2427,1632,	
2427,1632,	2427,1632,	2427,1632,	2427,1632,	
2427,1632,	2427,1632,	2427,1632,	2427,1632,	
2427,1632,	2427,1632,	2427,1632,	2427,1632,	
2427,1632,	2427,1632,	2429,1235,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2429,1235,	2429,1236,	
2430,1101,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2430,1101,	2430,1102,	2431,2431,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2431,2431,	2431,2488,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2429,1235,	2429,1237,	
0,0,	2429,1235,	0,0,	2429,1235,	
0,0,	2429,1235,	0,0,	0,0,	
2430,1173,	2430,1103,	0,0,	2430,1101,	
0,0,	2430,1101,	0,0,	2430,1101,	
2429,1238,	0,0,	2431,2431,	2431,2489,	
0,0,	2431,2431,	0,0,	2431,2431,	
0,0,	2431,2431,	2430,1104,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2431,2490,	0,0,	0,0,	2797,1102,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2797,1102,	
2797,1102,	0,0,	2429,1235,	0,0,	
2429,1235,	0,0,	2429,1235,	0,0,	
2429,2486,	0,0,	2434,2241,	0,0,	
2430,1101,	0,0,	2430,1101,	0,0,	
2430,1101,	0,0,	2434,2241,	2434,2305,	
0,0,	0,0,	2431,2431,	0,0,	
2431,2431,	0,0,	2431,2431,	2430,2487,	
0,0,	0,0,	0,0,	2797,1174,	
2429,1299,	0,0,	2797,1102,	0,0,	
2797,1102,	2441,1646,	2797,1102,	0,0,	
0,0,	0,0,	2430,1101,	0,0,	
2434,1798,	2441,1646,	2441,1647,	0,0,	
0,0,	2797,1175,	2434,2241,	2434,2306,	
2431,2431,	2434,2241,	0,0,	2434,2241,	
0,0,	2434,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2434,2307,	0,0,	0,0,	2441,1646,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2441,1707,	2441,1648,	0,0,	
2441,1646,	0,0,	2441,1646,	2797,1102,	
2441,1646,	2797,1102,	0,0,	2797,1102,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2441,1646,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2434,2241,	0,0,	
2434,2241,	0,0,	2434,2241,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2797,1102,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2441,1646,	2434,2493,	2441,1646,	
2434,2241,	2441,2498,	2441,1646,	2441,1646,	
2441,1646,	2441,1646,	2441,1646,	2441,1646,	
2441,1646,	2441,1646,	2441,1646,	2441,1646,	
2441,1646,	2441,1646,	2441,1646,	2441,1646,	
2441,1646,	2441,1646,	2441,1646,	2441,1646,	
2441,1646,	2441,1646,	2441,1646,	2441,1646,	
2441,1646,	2441,1646,	2441,1646,	2441,1646,	
2446,2446,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2446,2446,	2446,2503,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2458,1663,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2446,2446,	2458,1663,	
2458,1664,	0,0,	0,0,	0,0,	
2446,2446,	2446,2504,	0,0,	2446,2446,	
0,0,	2446,2446,	0,0,	2446,2446,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2446,2505,	0,0,	
0,0,	2458,1663,	0,0,	0,0,	
0,0,	0,0,	0,0,	2458,1725,	
2458,1665,	0,0,	2458,1663,	0,0,	
2458,1663,	0,0,	2458,1663,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2458,1663,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2446,2446,	0,0,	2446,2446,	0,0,	
2446,2446,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2458,1663,	
0,0,	2458,1663,	2446,2446,	2458,2516,	
2458,1663,	2458,1663,	2458,1663,	2458,1663,	
2458,1663,	2458,1663,	2458,1663,	2458,1663,	
2458,1663,	2458,1663,	2458,1663,	2458,1663,	
2458,1663,	2458,1663,	2458,1663,	2458,1663,	
2458,1663,	2458,1663,	2458,1663,	2458,1663,	
2458,1663,	2458,1663,	2458,1663,	2458,1663,	
2458,1663,	2458,1663,	2469,854,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2469,935,	2469,855,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2480,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2480,2059,	2480,2061,	2623,2690,	
0,0,	0,0,	0,0,	0,0,	
2469,854,	0,0,	0,0,	2623,2690,	
2623,2691,	0,0,	2469,933,	2469,856,	
0,0,	2469,854,	0,0,	2469,854,	
2469,2527,	2469,854,	2486,1235,	0,0,	
2480,2538,	0,0,	0,0,	2480,2059,	
0,0,	0,0,	2486,1235,	2486,1236,	
2469,854,	2480,2003,	2480,2062,	0,0,	
2480,2059,	2623,2690,	2480,2059,	0,0,	
2480,2059,	0,0,	0,0,	2623,2690,	
2623,2692,	0,0,	2623,2690,	0,0,	
2623,2690,	0,0,	2623,2690,	2480,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2623,2693,	2486,1235,	2486,1237,	
0,0,	2486,1235,	2469,854,	2486,1235,	
2469,854,	2486,1235,	2469,854,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2486,1238,	0,0,	0,0,	0,0,	
0,0,	2480,2059,	0,0,	2480,2059,	
0,0,	2480,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	2623,2690,	
2469,854,	2623,2690,	0,0,	2623,2690,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2486,1235,	2480,2059,	
2486,1235,	0,0,	2486,2544,	2486,1235,	
2486,1235,	2486,1235,	2486,1235,	2486,1235,	
2486,1235,	2486,1235,	2486,1235,	2486,1235,	
2486,1235,	2486,1235,	2486,1235,	2486,1235,	
2486,1235,	2486,1235,	2486,1235,	2486,1235,	
2486,1235,	2486,1235,	2486,1235,	2486,1235,	
2486,1235,	2486,1235,	2486,1235,	2486,1235,	
2486,1299,	2487,1101,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2487,1101,	2487,1102,	2489,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2489,2546,	
2489,2488,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2493,2241,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2493,2241,	2493,2305,	
0,0,	2487,1173,	2487,1103,	0,0,	
2487,1101,	0,0,	2487,1101,	0,0,	
2487,1101,	0,0,	0,0,	2489,2431,	
2489,2489,	0,0,	2489,2431,	0,0,	
2489,2431,	0,0,	2489,2431,	2487,1104,	
0,0,	0,0,	0,0,	0,0,	
2493,1798,	0,0,	0,0,	0,0,	
0,0,	2489,2490,	2493,2241,	2493,2306,	
0,0,	2493,2241,	0,0,	2493,2241,	
0,0,	2493,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2493,2307,	0,0,	0,0,	2523,1733,	
0,0,	2487,1101,	0,0,	2487,1101,	
0,0,	2487,1101,	2501,1254,	2523,1733,	
2523,1734,	0,0,	0,0,	2489,2431,	
0,0,	2489,2431,	0,0,	2489,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2487,2545,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2493,2241,	2487,1101,	
2493,2241,	2523,1733,	2493,2241,	0,0,	
0,0,	0,0,	0,0,	2523,1733,	
2523,1735,	2489,2431,	2523,1733,	0,0,	
2523,1733,	0,0,	2523,1733,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2493,2549,	0,0,	0,0,	0,0,	
0,0,	2523,1733,	0,0,	0,0,	
2493,2241,	2501,2557,	2501,1252,	2501,1252,	
2501,1252,	2501,1252,	2501,1252,	2501,1252,	
2501,1252,	2501,1252,	2501,1252,	2501,1252,	
2501,1252,	2501,1252,	2501,1252,	2501,1252,	
2501,1252,	2501,1252,	2501,1252,	2501,1252,	
2501,1252,	2501,1252,	2501,1252,	2501,1252,	
2501,1252,	2501,1252,	2501,1252,	0,0,	
0,0,	0,0,	0,0,	2523,1733,	
0,0,	2523,1733,	0,0,	2523,2577,	
2523,1733,	2523,1733,	2523,1733,	2523,1733,	
2523,1733,	2523,1733,	2523,1733,	2523,1733,	
2523,1733,	2523,1733,	2523,1733,	2523,1733,	
2523,1733,	2523,1733,	2523,1733,	2523,1733,	
2523,1733,	2523,1733,	2523,1733,	2523,1733,	
2523,1733,	2523,1733,	2523,1733,	2523,1733,	
2523,1733,	2523,1801,	2526,999,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2526,999,	2526,1000,	
2527,2527,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2527,2527,	2527,2581,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2526,999,	2526,2580,	
0,0,	2526,999,	2527,2527,	2526,999,	
0,0,	2526,999,	0,0,	0,0,	
2527,2582,	2527,2583,	0,0,	2527,2527,	
0,0,	2527,2527,	0,0,	2527,2527,	
2526,999,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2531,1743,	2527,2527,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2531,1743,	2531,1744,	0,0,	
2896,1613,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2526,999,	0,0,	
2526,999,	0,0,	2526,999,	0,0,	
0,0,	0,0,	0,0,	2531,1743,	
2527,2527,	0,0,	2527,2527,	0,0,	
2527,2527,	2531,1743,	2531,1745,	0,0,	
2531,1743,	0,0,	2531,1743,	0,0,	
2531,1743,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2526,1076,	0,0,	0,0,	2531,1743,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2527,2527,	2896,2952,	
2896,1611,	2896,1611,	2896,1611,	2896,1611,	
2896,1611,	2896,1611,	2896,1611,	2896,1611,	
2896,1611,	2896,1611,	2896,1611,	2896,1611,	
2896,1611,	2896,1611,	2896,1611,	2896,1611,	
2896,1611,	2896,1611,	2896,1611,	2896,1611,	
2896,1611,	2896,1611,	2896,1611,	2896,1611,	
2896,1611,	2531,1743,	0,0,	2531,1743,	
0,0,	2531,2587,	2531,1743,	2531,1743,	
2531,1743,	2531,1743,	2531,1743,	2531,1743,	
2531,1743,	2531,1743,	2531,1743,	2531,1743,	
2531,1743,	2531,1743,	2531,1743,	2531,1743,	
2531,1743,	2531,1743,	2531,1743,	2531,1743,	
2531,1743,	2531,1743,	2531,1743,	2531,1743,	
2531,1743,	2531,1743,	2531,1743,	2531,1811,	
2535,2535,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2535,2535,	2535,2591,	2538,2059,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2538,2059,	2538,2061,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2544,1235,	0,0,	0,0,	
0,0,	0,0,	2535,2535,	0,0,	
0,0,	2544,1235,	2544,1236,	0,0,	
2535,2592,	2535,2593,	0,0,	2535,2535,	
2538,2059,	2535,2535,	0,0,	2535,2535,	
0,0,	0,0,	2538,2003,	2538,2062,	
0,0,	2538,2059,	0,0,	2538,2059,	
0,0,	2538,2059,	2535,2535,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2538,2059,	2544,1235,	2544,1237,	0,0,	
2544,1235,	2541,1756,	2544,1235,	0,0,	
2544,1235,	0,0,	0,0,	0,0,	
0,0,	2541,1756,	2541,1757,	0,0,	
0,0,	0,0,	0,0,	2544,1238,	
0,0,	0,0,	0,0,	0,0,	
2535,2535,	0,0,	2535,2535,	0,0,	
2535,2535,	0,0,	0,0,	0,0,	
0,0,	0,0,	2538,2059,	0,0,	
2538,2059,	0,0,	2538,2059,	2541,1756,	
0,0,	0,0,	0,0,	0,0,	
2538,2596,	2541,1756,	2541,1758,	0,0,	
2541,1756,	0,0,	2541,1756,	0,0,	
2541,1756,	2544,1235,	2535,2535,	2544,1235,	
0,0,	2544,1235,	0,0,	0,0,	
0,0,	0,0,	0,0,	2541,1756,	
2538,2059,	0,0,	0,0,	0,0,	
2544,2602,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2544,1299,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2541,1756,	0,0,	2541,1756,	
0,0,	2541,2599,	2541,1756,	2541,1756,	
2541,1756,	2541,1756,	2541,1756,	2541,1756,	
2541,1756,	2541,1756,	2541,1756,	2541,1756,	
2541,1756,	2541,1756,	2541,1756,	2541,1756,	
2541,1756,	2541,1756,	2541,1756,	2541,1756,	
2541,1756,	2541,1756,	2541,1756,	2541,1756,	
2541,1756,	2541,1756,	2541,1756,	2541,1823,	
2545,1101,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2545,1101,	2545,1102,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2546,2431,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2546,2546,	2546,2488,	0,0,	0,0,	
0,0,	0,0,	0,0,	2545,2603,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2545,1173,	2545,1103,	0,0,	2545,1101,	
0,0,	2545,1101,	0,0,	2545,1101,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2546,2431,	2546,2489,	2545,1104,	2546,2431,	
2548,2548,	2546,2431,	0,0,	2546,2431,	
0,0,	0,0,	0,0,	0,0,	
2548,2548,	2548,2606,	0,0,	0,0,	
0,0,	0,0,	2546,2490,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2545,1101,	0,0,	2545,1101,	0,0,	
2545,1101,	0,0,	2546,2604,	0,0,	
2548,2607,	2548,2608,	0,0,	2548,2548,	
0,0,	2548,2548,	2549,2241,	2548,2548,	
2546,2431,	0,0,	2546,2431,	0,0,	
2546,2431,	0,0,	2549,2241,	2549,2305,	
0,0,	0,0,	2548,2609,	0,0,	
0,0,	0,0,	2545,1101,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2553,1772,	0,0,	0,0,	
0,0,	0,0,	2546,2431,	0,0,	
2549,1798,	2553,1772,	2553,1773,	0,0,	
0,0,	0,0,	2549,2241,	2549,2306,	
0,0,	2549,2241,	0,0,	2549,2241,	
2548,2548,	2549,2241,	2548,2548,	0,0,	
2548,2548,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2549,2307,	0,0,	0,0,	2553,1772,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2553,1772,	2553,1774,	0,0,	
2553,1772,	0,0,	2553,1772,	0,0,	
2553,1772,	0,0,	2548,2548,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2553,1772,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2549,2241,	0,0,	
2549,2241,	0,0,	2549,2241,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2549,2610,	0,0,	0,0,	
0,0,	2553,1772,	0,0,	2553,1772,	
2549,2241,	2553,2614,	2553,1772,	2553,1772,	
2553,1772,	2553,1772,	2553,1772,	2553,1772,	
2553,1772,	2553,1772,	2553,1772,	2553,1772,	
2553,1772,	2553,1772,	2553,1772,	2553,1772,	
2553,1772,	2553,1772,	2553,1772,	2553,1772,	
2553,1772,	2553,1772,	2553,1772,	2553,1772,	
2553,1772,	2553,1772,	2553,1772,	2553,1838,	
2561,2561,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2561,2561,	2561,2622,	2564,2564,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2564,2564,	2564,2628,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2561,2561,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2561,2623,	2561,2624,	0,0,	2561,2561,	
2564,2564,	2561,2561,	0,0,	2561,2561,	
0,0,	0,0,	2564,2629,	2564,2630,	
0,0,	2564,2564,	0,0,	2564,2564,	
0,0,	2564,2564,	2561,2625,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2569,1791,	
2564,2631,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2569,1791,	
2569,1792,	0,0,	2904,1622,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2561,2561,	0,0,	2561,2561,	0,0,	
2561,2561,	0,0,	0,0,	0,0,	
0,0,	2569,1791,	2564,2564,	0,0,	
2564,2564,	0,0,	2564,2564,	2569,1791,	
2569,1793,	0,0,	2569,1791,	0,0,	
2569,1791,	0,0,	2569,1791,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2561,2561,	0,0,	
0,0,	2569,1791,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2564,2564,	2904,2960,	2904,1620,	2904,1620,	
2904,1620,	2904,1620,	2904,1620,	2904,1620,	
2904,1620,	2904,1620,	2904,1620,	2904,1620,	
2904,1620,	2904,1620,	2904,1620,	2904,1620,	
2904,1620,	2904,1620,	2904,1620,	2904,1620,	
2904,1620,	2904,1620,	2904,1620,	2904,1620,	
2904,1620,	2904,1620,	2904,1620,	2569,1791,	
0,0,	2569,1791,	0,0,	2569,2636,	
2569,1791,	2569,1791,	2569,1791,	2569,1791,	
2569,1791,	2569,1791,	2569,1791,	2569,1791,	
2569,1791,	2569,1791,	2569,1791,	2569,1791,	
2569,1791,	2569,1791,	2569,1791,	2569,1791,	
2569,1791,	2569,1791,	2569,1791,	2569,1791,	
2569,1791,	2569,1791,	2569,1791,	2569,1791,	
2569,1791,	2569,1857,	2573,2573,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2573,2573,	2573,2640,	
2580,999,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2580,1078,	2580,1000,	2602,1235,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2602,1235,	2602,1236,	
0,0,	0,0,	0,0,	0,0,	
2573,2573,	0,0,	0,0,	0,0,	
0,0,	0,0,	2573,2641,	2573,2642,	
0,0,	2573,2573,	2580,999,	2573,2573,	
0,0,	2573,2573,	0,0,	0,0,	
2580,999,	2580,1001,	0,0,	2580,999,	
0,0,	2580,999,	2580,2649,	2580,999,	
2573,2573,	0,0,	2602,1235,	2602,1237,	
0,0,	2602,1235,	0,0,	2602,1235,	
0,0,	2602,1235,	2580,999,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2602,1238,	0,0,	2603,1101,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2603,1101,	2603,1102,	
2604,2431,	0,0,	2573,2573,	0,0,	
2573,2573,	0,0,	2573,2573,	0,0,	
2604,2431,	2604,2488,	0,0,	0,0,	
2580,999,	0,0,	2580,999,	0,0,	
2580,999,	0,0,	0,0,	2607,2674,	
0,0,	0,0,	2602,1235,	0,0,	
2602,1235,	0,0,	2602,1235,	2607,2674,	
2607,2675,	0,0,	2603,1173,	2603,2672,	
2573,2573,	2603,1101,	0,0,	2603,1101,	
0,0,	2603,1101,	0,0,	0,0,	
2604,2431,	2604,2489,	2580,1076,	2604,2431,	
2602,2671,	2604,2431,	0,0,	2604,2431,	
2603,1104,	0,0,	0,0,	0,0,	
2602,1299,	2607,2649,	0,0,	0,0,	
0,0,	0,0,	2604,2490,	2607,2674,	
2607,2676,	2608,2548,	2607,2674,	0,0,	
2607,2674,	0,0,	2607,2674,	0,0,	
0,0,	2608,2678,	2608,2606,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2607,2677,	0,0,	0,0,	
3530,2059,	0,0,	2603,1101,	0,0,	
2603,1101,	0,0,	2603,1101,	0,0,	
3530,2059,	3530,2061,	2610,2241,	0,0,	
2604,2431,	0,0,	2604,2431,	0,0,	
2604,2431,	0,0,	2610,2241,	2610,2305,	
0,0,	2608,2607,	2608,2608,	0,0,	
2608,2548,	0,0,	2608,2548,	0,0,	
2608,2548,	2629,2696,	0,0,	2607,2674,	
2603,1101,	2607,2674,	3530,2059,	2607,2674,	
0,0,	2629,2696,	2629,2697,	2608,2609,	
2604,2673,	3530,3577,	2604,2431,	3530,2059,	
2610,1798,	3530,2059,	0,0,	3530,2059,	
0,0,	0,0,	2610,2241,	2610,2306,	
0,0,	2610,2241,	0,0,	2610,2241,	
0,0,	2610,2241,	3530,2059,	0,0,	
0,0,	2607,2241,	0,0,	2629,2696,	
0,0,	0,0,	0,0,	0,0,	
2610,2307,	2629,2696,	2629,2698,	2641,2708,	
2629,2696,	2608,2548,	2629,2696,	2608,2548,	
2629,2696,	2608,2548,	0,0,	2641,2708,	
2641,2709,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2629,2699,	
0,0,	0,0,	2643,1798,	0,0,	
3530,2059,	0,0,	3530,2059,	0,0,	
3530,2059,	0,0,	2643,1798,	2643,1863,	
0,0,	0,0,	2610,2241,	2608,2548,	
2610,2241,	2641,2708,	2610,2241,	0,0,	
0,0,	0,0,	2610,2679,	2641,2708,	
2641,2710,	0,0,	2641,2708,	0,0,	
2641,2708,	0,0,	2641,2708,	0,0,	
0,0,	2629,2696,	3530,2059,	2629,2696,	
2643,1798,	2629,2696,	0,0,	0,0,	
0,0,	2641,2708,	2643,1798,	2643,1864,	
2610,2241,	2643,1798,	0,0,	2643,1798,	
0,0,	2643,1798,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2643,1798,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2641,2708,	
0,0,	2641,2708,	0,0,	2641,2708,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2643,1798,	0,0,	
2643,1798,	0,0,	2643,2712,	2643,1798,	
2643,1798,	2643,1798,	2643,1798,	2643,1798,	
2643,1798,	2643,1798,	2643,1798,	2643,1798,	
2643,1798,	2643,1798,	2643,1798,	2643,1798,	
2643,1798,	2643,1798,	2643,1798,	2643,1798,	
2643,1798,	2643,1798,	2643,1798,	2643,1798,	
2643,1798,	2643,1798,	2643,1798,	2643,1798,	
2643,1798,	2649,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2649,2649,	2649,2650,	2651,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2651,2719,	
2651,2650,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2649,2649,	2649,2651,	0,0,	
2649,2649,	0,0,	2649,2649,	0,0,	
2649,2649,	0,0,	0,0,	2651,2649,	
2651,2651,	0,0,	2651,2649,	0,0,	
2651,2649,	0,0,	2651,2649,	2649,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2653,1808,	2651,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2653,1808,	2653,1872,	0,0,	2914,1634,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2649,2649,	0,0,	2649,2649,	
0,0,	2649,2649,	0,0,	0,0,	
0,0,	0,0,	2653,1808,	2651,2649,	
0,0,	2651,2649,	0,0,	2651,2649,	
2653,1808,	2653,1873,	0,0,	2653,1808,	
0,0,	2653,1808,	0,0,	2653,1808,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2649,2718,	
0,0,	0,0,	2653,1808,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2651,2718,	2914,2970,	2914,1632,	
2914,1632,	2914,1632,	2914,1632,	2914,1632,	
2914,1632,	2914,1632,	2914,1632,	2914,1632,	
2914,1632,	2914,1632,	2914,1632,	2914,1632,	
2914,1632,	2914,1632,	2914,1632,	2914,1632,	
2914,1632,	2914,1632,	2914,1632,	2914,1632,	
2914,1632,	2914,1632,	2914,1632,	2914,1632,	
2653,1808,	0,0,	2653,1808,	0,0,	
2653,2721,	2653,1808,	2653,1808,	2653,1808,	
2653,1808,	2653,1808,	2653,1808,	2653,1808,	
2653,1808,	2653,1808,	2653,1808,	2653,1808,	
2653,1808,	2653,1808,	2653,1808,	2653,1808,	
2653,1808,	2653,1808,	2653,1808,	2653,1808,	
2653,1808,	2653,1808,	2653,1808,	2653,1808,	
2653,1808,	2653,1808,	2653,1808,	2659,2659,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2659,2659,	
2659,2660,	2665,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2665,2059,	2665,2061,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2671,1235,	0,0,	0,0,	0,0,	
0,0,	2659,2659,	0,0,	0,0,	
2671,1235,	2671,1236,	0,0,	2659,2659,	
2659,2661,	0,0,	2659,2659,	2665,2059,	
2659,2659,	0,0,	2659,2659,	0,0,	
0,0,	2665,2003,	2665,2062,	0,0,	
2665,2059,	0,0,	2665,2059,	0,0,	
2665,2059,	2659,2659,	0,0,	2671,2738,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2665,2059,	
2671,1235,	2671,1237,	2672,1101,	2671,1235,	
0,0,	2671,1235,	0,0,	2671,1235,	
0,0,	0,0,	2672,1176,	2672,1102,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2671,1238,	0,0,	
0,0,	2673,2431,	0,0,	2659,2659,	
0,0,	2659,2659,	0,0,	2659,2659,	
0,0,	2673,2431,	2673,2488,	2677,2649,	
0,0,	2665,2059,	0,0,	2665,2059,	
0,0,	2665,2059,	0,0,	2677,2649,	
2677,2650,	0,0,	2672,1173,	2672,1103,	
0,0,	2672,1101,	0,0,	2672,1101,	
2672,2739,	2672,1101,	2665,2732,	0,0,	
2671,1235,	2659,2727,	2671,1235,	0,0,	
2671,1235,	0,0,	0,0,	0,0,	
2672,1104,	2673,2431,	2673,2489,	2665,2059,	
2673,2431,	0,0,	2673,2431,	0,0,	
2673,2431,	0,0,	0,0,	2677,2649,	
2677,2651,	0,0,	2677,2649,	0,0,	
2677,2649,	0,0,	2677,2649,	2673,2490,	
0,0,	0,0,	2671,1299,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2677,2649,	0,0,	0,0,	
0,0,	0,0,	2672,1101,	0,0,	
2672,1101,	2678,2548,	2672,1101,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2678,2678,	2678,2606,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2673,2431,	0,0,	2673,2431,	
0,0,	2673,2431,	0,0,	0,0,	
2679,2241,	0,0,	0,0,	2677,2649,	
2672,1101,	2677,2649,	0,0,	2677,2649,	
2679,2241,	2679,2305,	0,0,	2678,2527,	
0,0,	0,0,	0,0,	2673,2740,	
0,0,	2678,2607,	2678,2608,	0,0,	
2678,2548,	2690,2690,	2678,2548,	2673,2431,	
2678,2548,	0,0,	0,0,	0,0,	
0,0,	2690,2690,	2690,2691,	0,0,	
0,0,	2677,2718,	2679,1798,	2678,2609,	
0,0,	0,0,	0,0,	0,0,	
2679,2241,	2679,2306,	2693,2649,	2679,2241,	
0,0,	2679,2241,	0,0,	2679,2241,	
0,0,	0,0,	2693,2649,	2693,2650,	
0,0,	0,0,	0,0,	2690,2690,	
0,0,	0,0,	2679,2307,	2678,2743,	
0,0,	2690,2690,	2690,2692,	0,0,	
2690,2690,	0,0,	2690,2690,	0,0,	
2690,2690,	2678,2548,	0,0,	2678,2548,	
0,0,	2678,2548,	0,0,	0,0,	
0,0,	0,0,	0,0,	2690,2693,	
0,0,	0,0,	2693,2649,	2693,2651,	
0,0,	2693,2649,	0,0,	2693,2649,	
0,0,	2693,2649,	0,0,	0,0,	
2679,2241,	0,0,	2679,2241,	0,0,	
2679,2241,	0,0,	0,0,	2678,2548,	
2693,2649,	2696,2696,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2679,2744,	2696,2696,	2696,2697,	2699,2649,	
0,0,	2690,2690,	0,0,	2690,2690,	
0,0,	2690,2690,	0,0,	2699,2649,	
2699,2650,	0,0,	2679,2241,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2693,2649,	2696,2696,	
2693,2649,	0,0,	2693,2649,	0,0,	
0,0,	2696,2696,	2696,2698,	2690,2755,	
2696,2696,	0,0,	2696,2696,	0,0,	
2696,2696,	0,0,	0,0,	2699,2649,	
2699,2651,	0,0,	2699,2649,	0,0,	
2699,2649,	0,0,	2699,2649,	2696,2699,	
0,0,	0,0,	0,0,	0,0,	
2693,2718,	0,0,	0,0,	0,0,	
2702,1854,	2699,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2702,1854,	2702,1914,	0,0,	2927,1648,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2696,2696,	0,0,	2696,2696,	
0,0,	2696,2696,	0,0,	0,0,	
0,0,	0,0,	2702,1854,	2699,2649,	
0,0,	2699,2649,	0,0,	2699,2649,	
2702,1854,	2702,1915,	0,0,	2702,1854,	
0,0,	2702,1854,	0,0,	2702,1854,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2696,2759,	
0,0,	0,0,	2702,1854,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2699,2718,	2927,2982,	2927,1646,	
2927,1646,	2927,1646,	2927,1646,	2927,1646,	
2927,1646,	2927,1646,	2927,1646,	2927,1646,	
2927,1646,	2927,1646,	2927,1646,	2927,1646,	
2927,1646,	2927,1646,	2927,1646,	2927,1646,	
2927,1646,	2927,1646,	2927,1646,	2927,1646,	
2927,1646,	2927,1646,	2927,1646,	2927,1646,	
2702,1854,	0,0,	2702,1854,	0,0,	
2702,2763,	2702,1854,	2702,1854,	2702,1854,	
2702,1854,	2702,1854,	2702,1854,	2702,1854,	
2702,1854,	2702,1854,	2702,1854,	2702,1854,	
2702,1854,	2702,1854,	2702,1854,	2702,1854,	
2702,1854,	2702,1854,	2702,1854,	2702,1854,	
2702,1854,	2702,1854,	2702,1854,	2702,1854,	
2702,1854,	2702,1854,	2702,1854,	2708,2708,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2708,2708,	
2708,2709,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2719,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2719,2719,	
2719,2650,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2708,2708,	0,0,	0,0,	
0,0,	0,0,	0,0,	2708,2708,	
2708,2710,	0,0,	2708,2708,	0,0,	
2708,2708,	0,0,	2708,2708,	0,0,	
0,0,	2719,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	2719,2649,	
2719,2651,	2708,2708,	2719,2649,	0,0,	
2719,2649,	0,0,	2719,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2737,1947,	2719,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2737,1947,	2737,1948,	0,0,	2944,1665,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2708,2708,	
0,0,	2708,2708,	0,0,	2708,2708,	
0,0,	2719,2778,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2737,1947,	2719,2649,	
0,0,	2719,2649,	0,0,	2719,2649,	
2737,1947,	2737,1949,	0,0,	2737,1947,	
0,0,	2737,1947,	0,0,	2737,1947,	
0,0,	2708,2769,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2737,1947,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2719,2718,	2944,2998,	2944,1663,	
2944,1663,	2944,1663,	2944,1663,	2944,1663,	
2944,1663,	2944,1663,	2944,1663,	2944,1663,	
2944,1663,	2944,1663,	2944,1663,	2944,1663,	
2944,1663,	2944,1663,	2944,1663,	2944,1663,	
2944,1663,	2944,1663,	2944,1663,	2944,1663,	
2944,1663,	2944,1663,	2944,1663,	2944,1663,	
2737,1947,	0,0,	2737,1947,	0,0,	
2737,2795,	2737,1947,	2737,1947,	2737,1947,	
2737,1947,	2737,1947,	2737,1947,	2737,1947,	
2737,1947,	2737,1947,	2737,1947,	2737,1947,	
2737,1947,	2737,1947,	2737,1947,	2737,1947,	
2737,1947,	2737,1947,	2737,1947,	2737,1947,	
2737,1947,	2737,1947,	2737,1947,	2737,1947,	
2737,1947,	2737,1947,	2737,1947,	2738,1235,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2738,1235,	
2738,1236,	2739,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2739,2739,	2739,2797,	2740,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2740,2431,	
2740,2488,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2738,1235,	
2738,2796,	0,0,	2738,1235,	0,0,	
2738,1235,	0,0,	2738,1235,	0,0,	
0,0,	2739,2798,	2739,2799,	0,0,	
2739,2739,	0,0,	2739,2739,	0,0,	
2739,2739,	2738,1238,	0,0,	2740,2431,	
2740,2489,	0,0,	2740,2431,	0,0,	
2740,2431,	0,0,	2740,2431,	2739,2800,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2740,2490,	0,0,	2741,2241,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2741,2241,	
2741,2305,	0,0,	0,0,	2738,1235,	
0,0,	2738,1235,	0,0,	2738,1235,	
0,0,	0,0,	0,0,	2743,2548,	
0,0,	2739,2739,	0,0,	2739,2739,	
0,0,	2739,2739,	0,0,	2743,2548,	
2743,2606,	0,0,	0,0,	2740,2431,	
0,0,	2740,2431,	0,0,	2740,2431,	
0,0,	0,0,	0,0,	2741,2241,	
2741,2306,	2738,1299,	2741,2241,	0,0,	
2741,2241,	0,0,	2741,2241,	0,0,	
0,0,	0,0,	0,0,	2739,2739,	
0,0,	2743,2527,	2740,2801,	0,0,	
0,0,	2741,2307,	0,0,	2743,2607,	
2743,2608,	2740,2431,	2743,2548,	0,0,	
2743,2548,	2744,2241,	2743,2548,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2744,2241,	2744,2305,	0,0,	
0,0,	2743,2609,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2741,2241,	
0,0,	2741,2241,	0,0,	2741,2241,	
2744,2804,	0,0,	0,0,	2744,1798,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2744,2241,	2744,2306,	0,0,	
2744,2241,	2750,1961,	2744,2241,	2743,2548,	
2744,2241,	2743,2548,	0,0,	2743,2548,	
0,0,	2750,1961,	2750,1962,	0,0,	
0,0,	2741,2241,	0,0,	2744,2307,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2743,2803,	
0,0,	2743,2548,	0,0,	2750,1961,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2750,1961,	2750,1963,	0,0,	
2750,1961,	0,0,	2750,1961,	0,0,	
2750,1961,	2744,2241,	0,0,	2744,2241,	
0,0,	2744,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	2750,1961,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2744,2241,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2750,1961,	0,0,	2750,1961,	
0,0,	2750,2810,	2750,1961,	2750,1961,	
2750,1961,	2750,1961,	2750,1961,	2750,1961,	
2750,1961,	2750,1961,	2750,1961,	2750,1961,	
2750,1961,	2750,1961,	2750,1961,	2750,1961,	
2750,1961,	2750,1961,	2750,1961,	2750,1961,	
2750,1961,	2750,1961,	2750,1961,	2750,1961,	
2750,1961,	2750,1961,	2750,1961,	2750,1961,	
2753,2753,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2753,2753,	2753,2813,	2778,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2778,2649,	2778,2650,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2753,2753,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2753,2814,	2753,2815,	0,0,	2753,2753,	
2778,2649,	2753,2753,	0,0,	2753,2753,	
0,0,	0,0,	2778,2649,	2778,2651,	
0,0,	2778,2649,	0,0,	2778,2649,	
0,0,	2778,2649,	2753,2816,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2788,1939,	
2778,2649,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2788,1939,	
2788,1998,	0,0,	3005,1735,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2753,2753,	0,0,	2753,2753,	0,0,	
2753,2753,	0,0,	0,0,	0,0,	
0,0,	2788,1939,	2778,2649,	0,0,	
2778,2649,	0,0,	2778,2649,	2788,1939,	
2788,1999,	0,0,	2788,1939,	0,0,	
2788,1939,	0,0,	2788,1939,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2753,2753,	0,0,	
0,0,	2788,1939,	0,0,	0,0,	
0,0,	0,0,	2778,2838,	0,0,	
2778,2718,	3005,3059,	3005,1733,	3005,1733,	
3005,1733,	3005,1733,	3005,1733,	3005,1733,	
3005,1733,	3005,1733,	3005,1733,	3005,1733,	
3005,1733,	3005,1733,	3005,1733,	3005,1733,	
3005,1733,	3005,1733,	3005,1733,	3005,1733,	
3005,1733,	3005,1733,	3005,1733,	3005,1733,	
3005,1733,	3005,1733,	3005,1733,	2788,2000,	
0,0,	2788,1939,	0,0,	2788,2848,	
2788,1939,	2788,1939,	2788,1939,	2788,1939,	
2788,1939,	2788,1939,	2788,1939,	2788,1939,	
2788,1939,	2788,1939,	2788,1939,	2788,1939,	
2788,1939,	2788,1939,	2788,1939,	2788,1939,	
2788,1939,	2788,1939,	2788,1939,	2788,1939,	
2788,1939,	2788,1939,	2788,1939,	2788,1939,	
2788,1939,	2788,1939,	2789,1941,	0,0,	
0,0,	0,0,	3013,1745,	0,0,	
0,0,	0,0,	2789,1941,	2789,2002,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2789,1941,	0,0,	0,0,	0,0,	
0,0,	0,0,	2789,2003,	2789,2004,	
0,0,	2789,2005,	0,0,	2789,1941,	
0,0,	2789,1941,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2789,1941,	3013,3067,	3013,1743,	3013,1743,	
3013,1743,	3013,1743,	3013,1743,	3013,1743,	
3013,1743,	3013,1743,	3013,1743,	3013,1743,	
3013,1743,	3013,1743,	3013,1743,	3013,1743,	
3013,1743,	3013,1743,	3013,1743,	3013,1743,	
3013,1743,	3013,1743,	3013,1743,	3013,1743,	
3013,1743,	3013,1743,	3013,1743,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2789,1941,	0,0,	
2789,1941,	0,0,	2789,2849,	2789,1941,	
2789,1941,	2789,1941,	2789,1941,	2789,1941,	
2789,1941,	2789,1941,	2789,1941,	2789,1941,	
2789,1941,	2789,1941,	2789,1941,	2789,1941,	
2789,1941,	2789,1941,	2789,1941,	2789,1941,	
2789,1941,	2789,1941,	2789,1941,	2789,1941,	
2789,1941,	2789,1941,	2789,1941,	2789,1941,	
2789,1941,	2790,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2790,2059,	2790,2061,	2796,1235,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2796,1301,	
2796,1236,	2798,2856,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2798,2856,	2798,2857,	0,0,	
0,0,	0,0,	0,0,	2790,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2790,2003,	2790,2062,	0,0,	
2790,2059,	0,0,	2790,2059,	0,0,	
2790,2059,	0,0,	0,0,	2796,1235,	
2796,1237,	0,0,	2796,1235,	0,0,	
2796,1235,	2796,2856,	2796,1235,	2790,2059,	
0,0,	2798,2856,	2798,2858,	0,0,	
2798,2856,	0,0,	2798,2856,	0,0,	
2798,2856,	2796,1238,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2798,2859,	
0,0,	2799,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2799,2860,	2799,2797,	2801,2431,	
0,0,	2790,2059,	0,0,	2790,2059,	
0,0,	2790,2059,	0,0,	2801,2431,	
2801,2488,	2803,2548,	0,0,	2796,1235,	
0,0,	2796,1235,	0,0,	2796,1235,	
0,0,	2803,2548,	2803,2606,	0,0,	
0,0,	2798,2856,	2790,2850,	2798,2856,	
0,0,	2798,2856,	0,0,	0,0,	
0,0,	2799,2798,	2799,2799,	2790,2059,	
2799,2739,	0,0,	2799,2739,	0,0,	
2799,2739,	0,0,	0,0,	2801,2431,	
2801,2489,	2796,1299,	2801,2431,	2803,2527,	
2801,2431,	0,0,	2801,2431,	2799,2800,	
0,0,	2803,2607,	2803,2608,	2798,2431,	
2803,2548,	0,0,	2803,2548,	0,0,	
2803,2548,	2801,2490,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2803,2609,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2804,2241,	
0,0,	2799,2739,	0,0,	2799,2739,	
0,0,	2799,2739,	0,0,	2804,2241,	
2804,2305,	0,0,	0,0,	2801,2431,	
0,0,	2801,2431,	0,0,	2801,2431,	
0,0,	0,0,	2814,2872,	2801,2861,	
0,0,	2803,2548,	0,0,	2803,2548,	
0,0,	2803,2548,	2814,2872,	2814,2873,	
2838,2649,	0,0,	0,0,	2799,2739,	
0,0,	2804,1798,	0,0,	0,0,	
2838,2649,	2838,2650,	0,0,	2804,2241,	
2804,2306,	2801,2431,	2804,2241,	2803,2863,	
2804,2241,	0,0,	2804,2241,	3277,3341,	
0,0,	0,0,	0,0,	2803,2548,	
2814,2872,	0,0,	0,0,	3277,3341,	
3277,3342,	2804,2307,	2814,2872,	2814,2874,	
0,0,	2814,2872,	2838,2649,	2814,2872,	
0,0,	2814,2872,	0,0,	0,0,	
2838,2649,	2838,2651,	2850,2059,	2838,2649,	
0,0,	2838,2649,	0,0,	2838,2649,	
2814,2875,	0,0,	2850,2059,	2850,2061,	
0,0,	3277,3341,	0,0,	0,0,	
0,0,	0,0,	2838,2649,	3277,3341,	
3277,3343,	0,0,	3277,3341,	2804,2241,	
3277,3341,	2804,2241,	3277,3341,	2804,2241,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2804,2864,	0,0,	0,0,	
2850,2059,	3277,3341,	0,0,	0,0,	
0,0,	0,0,	2814,2872,	2850,2062,	
2814,2872,	2850,2059,	2814,2872,	2850,2059,	
0,0,	2850,2059,	0,0,	0,0,	
2838,2649,	2804,2241,	2838,2649,	0,0,	
2838,2649,	0,0,	0,0,	0,0,	
2850,2059,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3277,3341,	
0,0,	3277,3341,	2838,2898,	3277,3341,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2838,2718,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2850,2059,	0,0,	
2850,2059,	0,0,	2850,2910,	2850,2059,	
2850,2059,	2850,2059,	2850,2059,	2850,2059,	
2850,2059,	2850,2059,	2850,2059,	2850,2059,	
2850,2059,	2850,2059,	2850,2059,	2850,2059,	
2850,2059,	2850,2059,	2850,2059,	2850,2059,	
2850,2059,	2850,2059,	2850,2059,	2850,2059,	
2850,2059,	2850,2059,	2850,2059,	2850,2059,	
2850,2059,	2856,2856,	0,0,	0,0,	
0,0,	0,0,	0,0,	2857,1236,	
0,0,	2856,2856,	2856,2857,	0,0,	
0,0,	0,0,	0,0,	2857,1236,	
2857,1236,	2858,2856,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2858,2917,	2858,2857,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2856,2856,	2856,2858,	0,0,	
2856,2856,	0,0,	2856,2856,	2857,1236,	
2856,2856,	0,0,	2857,1236,	0,0,	
2857,1236,	0,0,	2857,1236,	0,0,	
0,0,	2858,2856,	2858,2858,	2856,2859,	
2858,2856,	0,0,	2858,2856,	0,0,	
2858,2856,	2857,1239,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2859,2649,	2858,2859,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2859,2649,	2859,2650,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2856,2856,	0,0,	2856,2856,	
0,0,	2856,2856,	0,0,	2857,1236,	
0,0,	2857,1236,	0,0,	2857,1236,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2858,2856,	0,0,	2858,2856,	
0,0,	2858,2856,	2859,2649,	2859,2651,	
2860,2739,	2859,2649,	0,0,	2859,2649,	
0,0,	2859,2649,	0,0,	2856,2916,	
2860,2860,	2860,2797,	0,0,	0,0,	
0,0,	2857,1300,	0,0,	0,0,	
2859,2649,	0,0,	0,0,	2861,2431,	
0,0,	0,0,	0,0,	2858,2916,	
0,0,	0,0,	0,0,	2861,2431,	
2861,2488,	2863,2548,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2863,2548,	2863,2606,	0,0,	
2860,2798,	2860,2799,	0,0,	2860,2739,	
0,0,	2860,2739,	0,0,	2860,2739,	
0,0,	0,0,	2859,2649,	0,0,	
2859,2649,	0,0,	2859,2649,	0,0,	
0,0,	0,0,	2860,2800,	2861,2431,	
2861,2489,	0,0,	2861,2431,	2863,2527,	
2861,2431,	0,0,	2861,2431,	0,0,	
0,0,	2863,2607,	2863,2608,	0,0,	
2863,2548,	0,0,	2863,2548,	0,0,	
2863,2548,	2861,2490,	0,0,	0,0,	
2859,2718,	0,0,	2860,2918,	0,0,	
0,0,	0,0,	0,0,	2863,2609,	
0,0,	0,0,	2872,2872,	0,0,	
2860,2739,	0,0,	2860,2739,	0,0,	
2860,2739,	0,0,	2872,2872,	2872,2873,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2875,2649,	0,0,	2861,2431,	
0,0,	2861,2431,	0,0,	2861,2431,	
0,0,	2875,2649,	2875,2650,	0,0,	
0,0,	2863,2548,	2860,2739,	2863,2548,	
2872,2872,	2863,2548,	0,0,	2861,2919,	
0,0,	0,0,	2872,2872,	2872,2874,	
0,0,	2872,2872,	2898,2649,	2872,2872,	
0,0,	2872,2872,	0,0,	0,0,	
0,0,	2861,2431,	2898,2649,	2898,2650,	
2863,2921,	0,0,	0,0,	0,0,	
2872,2875,	2875,2649,	2875,2651,	2863,2548,	
2875,2649,	0,0,	2875,2649,	0,0,	
2875,2649,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2875,2649,	
2898,2649,	0,0,	0,0,	0,0,	
0,0,	0,0,	2898,2649,	2898,2651,	
0,0,	2898,2649,	0,0,	2898,2649,	
2916,2431,	2898,2649,	2872,2872,	0,0,	
2872,2872,	0,0,	2872,2872,	0,0,	
2916,2431,	2916,2488,	0,0,	0,0,	
2898,2649,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2917,2856,	
0,0,	2875,2649,	0,0,	2875,2649,	
0,0,	2875,2649,	0,0,	2917,2917,	
2917,2857,	0,0,	0,0,	0,0,	
2872,2930,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2916,2431,	2916,2489,	0,0,	2916,2431,	
2918,2739,	2916,2431,	2898,2649,	2916,2431,	
2898,2649,	0,0,	2898,2649,	2875,2718,	
2918,2739,	2918,2797,	0,0,	0,0,	
0,0,	0,0,	2916,2490,	2917,2856,	
2917,2858,	0,0,	2917,2856,	0,0,	
2917,2856,	0,0,	2917,2856,	0,0,	
0,0,	2898,2954,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2898,2718,	2917,2859,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2918,2798,	2918,2799,	0,0,	2918,2739,	
0,0,	2918,2739,	2919,2431,	2918,2739,	
2916,2431,	0,0,	2916,2431,	0,0,	
2916,2431,	0,0,	2919,2431,	2919,2488,	
0,0,	2917,2972,	2918,2800,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2921,2548,	0,0,	2917,2856,	
0,0,	2917,2856,	0,0,	2917,2856,	
0,0,	2921,2548,	2921,2606,	0,0,	
0,0,	2919,2974,	2916,2431,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2919,2431,	2919,2489,	
0,0,	2919,2431,	0,0,	2919,2431,	
2918,2739,	2919,2431,	2918,2739,	0,0,	
2918,2739,	2917,2916,	0,0,	2921,2527,	
0,0,	0,0,	0,0,	0,0,	
2919,2490,	2921,2607,	2921,2608,	0,0,	
2921,2548,	2922,2241,	2921,2548,	0,0,	
2921,2548,	0,0,	0,0,	0,0,	
0,0,	2922,2241,	2922,2305,	0,0,	
2918,2973,	0,0,	2918,2739,	2921,2609,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2929,2081,	0,0,	2919,2431,	0,0,	
2919,2431,	0,0,	2919,2431,	2922,1798,	
2929,2081,	2929,2135,	0,0,	0,0,	
0,0,	2922,2241,	2922,2306,	0,0,	
2922,2241,	0,0,	2922,2241,	0,0,	
2922,2241,	2921,2548,	0,0,	2921,2548,	
0,0,	2921,2548,	0,0,	0,0,	
0,0,	2921,2976,	0,0,	2922,2307,	
2919,2431,	0,0,	2929,2081,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2929,2081,	2929,2136,	0,0,	2929,2081,	
0,0,	2929,2081,	0,0,	2929,2081,	
0,0,	0,0,	0,0,	2921,2548,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2929,2137,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2922,2241,	0,0,	2922,2241,	
0,0,	2922,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2922,2977,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2929,2081,	0,0,	2929,2081,	2922,2241,	
2929,2984,	2929,2081,	2929,2081,	2929,2081,	
2929,2081,	2929,2081,	2929,2081,	2929,2081,	
2929,2081,	2929,2081,	2929,2081,	2929,2081,	
2929,2081,	2929,2081,	2929,2081,	2929,2081,	
2929,2081,	2929,2081,	2929,2081,	2929,2081,	
2929,2081,	2929,2081,	2929,2081,	2929,2081,	
2929,2081,	2929,2081,	2929,2081,	2954,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2954,2649,	
2954,2650,	2972,2856,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2972,2856,	2972,2857,	2973,2739,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2973,2739,	
2973,2797,	0,0,	0,0,	0,0,	
0,0,	2954,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	2954,2649,	
2954,2651,	0,0,	2954,2649,	0,0,	
2954,2649,	0,0,	2954,2649,	0,0,	
0,0,	2972,2856,	2972,2858,	0,0,	
2972,2856,	0,0,	2972,2856,	0,0,	
2972,2856,	2954,2649,	0,0,	2973,2798,	
2973,2799,	0,0,	2973,2739,	0,0,	
2973,2739,	0,0,	2973,2739,	2972,2859,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2973,2800,	0,0,	2974,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	2974,2431,	
2974,2488,	0,0,	0,0,	2954,2649,	
0,0,	2954,2649,	0,0,	2954,2649,	
0,0,	0,0,	0,0,	2954,3008,	
0,0,	2972,2856,	0,0,	2972,2856,	
0,0,	2972,2856,	0,0,	0,0,	
2976,2548,	0,0,	0,0,	2973,2739,	
0,0,	2973,2739,	0,0,	2973,2739,	
2976,2548,	2976,2606,	0,0,	2974,2431,	
2974,2489,	2954,2718,	2974,2431,	0,0,	
2974,2431,	0,0,	2974,2431,	3287,3351,	
0,0,	2972,3026,	0,0,	2972,2916,	
0,0,	2973,3027,	0,0,	3287,3351,	
3287,3352,	2974,2490,	0,0,	0,0,	
0,0,	2973,2739,	2976,2527,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2976,2607,	2976,2608,	3003,2210,	2976,2548,	
0,0,	2976,2548,	0,0,	2976,2548,	
0,0,	0,0,	3003,2210,	3003,2269,	
0,0,	3287,3351,	0,0,	0,0,	
0,0,	0,0,	2976,2609,	3287,3351,	
3287,3353,	0,0,	3287,3351,	2974,2431,	
3287,3351,	2974,2431,	3287,3351,	2974,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2974,3028,	0,0,	0,0,	
3003,2210,	3287,3351,	0,0,	0,0,	
0,0,	0,0,	3003,2210,	3003,2211,	
0,0,	3003,2210,	0,0,	3003,2210,	
0,0,	3003,2210,	0,0,	0,0,	
2976,2548,	2974,2431,	2976,2548,	0,0,	
2976,2548,	0,0,	0,0,	0,0,	
3003,2210,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
2976,3030,	0,0,	0,0,	3287,3351,	
0,0,	3287,3351,	0,0,	3287,3351,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	2976,2548,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3003,2210,	0,0,	
3003,2210,	0,0,	3003,3057,	3003,2210,	
3003,2210,	3003,2210,	3003,2210,	3003,2210,	
3003,2210,	3003,2210,	3003,2210,	3003,2210,	
3003,2210,	3003,2210,	3003,2210,	3003,2210,	
3003,2210,	3003,2210,	3003,2210,	3003,2210,	
3003,2210,	3003,2210,	3003,2210,	3003,2210,	
3003,2210,	3003,2210,	3003,2210,	3003,2210,	
3003,2210,	3008,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3008,2649,	3008,2650,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3011,2219,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3008,2649,	
3011,2219,	3011,2280,	0,0,	0,0,	
0,0,	3008,2649,	3008,2651,	0,0,	
3008,2649,	0,0,	3008,2649,	0,0,	
3008,2649,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3008,2649,	
0,0,	0,0,	3011,2219,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3011,2219,	3011,2220,	0,0,	3011,2219,	
0,0,	3011,2219,	0,0,	3011,2219,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3011,2219,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3008,2649,	0,0,	3008,2649,	
0,0,	3008,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3008,3062,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3011,2219,	0,0,	3011,2219,	3008,2718,	
3011,3065,	3011,2219,	3011,2219,	3011,2219,	
3011,2219,	3011,2219,	3011,2219,	3011,2219,	
3011,2219,	3011,2219,	3011,2219,	3011,2219,	
3011,2219,	3011,2219,	3011,2219,	3011,2219,	
3011,2219,	3011,2219,	3011,2219,	3011,2219,	
3011,2219,	3011,2219,	3011,2219,	3011,2219,	
3011,2219,	3011,2219,	3011,2219,	3020,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3020,2059,	
3020,2061,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3021,2230,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3020,2059,	3021,2230,	3021,2293,	
0,0,	0,0,	0,0,	3020,2003,	
3020,2062,	0,0,	3020,2059,	0,0,	
3020,2059,	0,0,	3020,2059,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3020,2059,	0,0,	0,0,	
3021,2230,	0,0,	0,0,	0,0,	
0,0,	0,0,	3021,2230,	3021,2231,	
0,0,	3021,2230,	0,0,	3021,2230,	
0,0,	3021,2230,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3021,2230,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3020,2059,	
0,0,	3020,2059,	3023,1758,	3020,2059,	
0,0,	0,0,	3020,3074,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3021,2230,	0,0,	
3021,2230,	3020,2059,	3021,3075,	3021,2230,	
3021,2230,	3021,2230,	3021,2230,	3021,2230,	
3021,2230,	3021,2230,	3021,2230,	3021,2230,	
3021,2230,	3021,2230,	3021,2230,	3021,2230,	
3021,2230,	3021,2230,	3021,2230,	3021,2230,	
3021,2230,	3021,2230,	3021,2230,	3021,2230,	
3021,2230,	3021,2230,	3021,2230,	3021,2230,	
3021,2230,	3023,3077,	3023,1756,	3023,1756,	
3023,1756,	3023,1756,	3023,1756,	3023,1756,	
3023,1756,	3023,1756,	3023,1756,	3023,1756,	
3023,1756,	3023,1756,	3023,1756,	3023,1756,	
3023,1756,	3023,1756,	3023,1756,	3023,1756,	
3023,1756,	3023,1756,	3023,1756,	3023,1756,	
3023,1756,	3023,1756,	3023,1756,	3026,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3026,2856,	
3026,2857,	3027,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3027,2739,	3027,2797,	0,0,	
0,0,	0,0,	0,0,	3028,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3028,2431,	
3028,2488,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3026,2856,	
3026,2858,	0,0,	3026,2856,	0,0,	
3026,2856,	0,0,	3026,2856,	0,0,	
0,0,	3027,2798,	3027,2799,	0,0,	
3027,2739,	0,0,	3027,2739,	0,0,	
3027,2739,	3026,2859,	0,0,	0,0,	
0,0,	0,0,	0,0,	3028,2431,	
3028,2489,	0,0,	3028,2431,	3027,2800,	
3028,2431,	0,0,	3028,2431,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3028,2490,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3026,2856,	
0,0,	3026,2856,	0,0,	3026,2856,	
0,0,	0,0,	0,0,	3030,2548,	
0,0,	3027,2739,	0,0,	3027,2739,	
0,0,	3027,2739,	0,0,	3030,2548,	
3030,2606,	0,0,	0,0,	0,0,	
0,0,	3026,3080,	0,0,	3028,2431,	
0,0,	3028,2431,	3031,2241,	3028,2431,	
0,0,	3026,2916,	0,0,	3028,3082,	
3027,3081,	0,0,	3031,2241,	3031,2305,	
3300,3364,	0,0,	3030,3084,	3027,2739,	
0,0,	3030,2527,	0,0,	0,0,	
3300,3364,	3300,3365,	0,0,	3030,2607,	
3030,2608,	0,0,	3030,2548,	0,0,	
3030,2548,	3028,2431,	3030,2548,	3033,2243,	
0,0,	0,0,	0,0,	0,0,	
3031,1798,	0,0,	0,0,	3033,2243,	
3033,2310,	3030,2609,	3031,2241,	3031,2306,	
0,0,	3031,2241,	3300,3364,	3031,2241,	
0,0,	3031,2241,	0,0,	0,0,	
3300,3364,	3300,3366,	0,0,	3300,3364,	
0,0,	3300,3364,	0,0,	3300,3364,	
3031,2307,	0,0,	0,0,	0,0,	
0,0,	3033,2243,	0,0,	0,0,	
0,0,	0,0,	3300,3364,	3033,2243,	
3033,2244,	0,0,	3033,2243,	3030,2548,	
3033,2243,	3030,2548,	3033,2243,	3030,2548,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3033,2243,	0,0,	0,0,	
0,0,	0,0,	3031,2241,	0,0,	
3031,2241,	0,0,	3031,2241,	3035,1774,	
0,0,	0,0,	0,0,	0,0,	
3300,3364,	3030,2548,	3300,3364,	0,0,	
3300,3364,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3031,3085,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3033,2243,	
3031,2241,	3033,2243,	0,0,	3033,3087,	
3033,2243,	3033,2243,	3033,2243,	3033,2243,	
3033,2243,	3033,2243,	3033,2243,	3033,2243,	
3033,2243,	3033,2243,	3033,2243,	3033,2243,	
3033,2243,	3033,2243,	3033,2243,	3033,2243,	
3033,2243,	3033,2243,	3033,2243,	3033,2243,	
3033,2243,	3033,2243,	3033,2243,	3033,2243,	
3033,2243,	3033,2243,	3035,3089,	3035,1772,	
3035,1772,	3035,1772,	3035,1772,	3035,1772,	
3035,1772,	3035,1772,	3035,1772,	3035,1772,	
3035,1772,	3035,1772,	3035,1772,	3035,1772,	
3035,1772,	3035,1772,	3035,1772,	3035,1772,	
3035,1772,	3035,1772,	3035,1772,	3035,1772,	
3035,1772,	3035,1772,	3035,1772,	3035,1772,	
3049,2260,	0,0,	0,0,	0,0,	
3051,1793,	0,0,	0,0,	0,0,	
3049,2260,	3049,2332,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3049,2260,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3049,2260,	3049,2261,	0,0,	3049,2260,	
0,0,	3049,2260,	0,0,	3049,2260,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3049,2260,	3051,3105,	
3051,1791,	3051,1791,	3051,1791,	3051,1791,	
3051,1791,	3051,1791,	3051,1791,	3051,1791,	
3051,1791,	3051,1791,	3051,1791,	3051,1791,	
3051,1791,	3051,1791,	3051,1791,	3051,1791,	
3051,1791,	3051,1791,	3051,1791,	3051,1791,	
3051,1791,	3051,1791,	3051,1791,	3051,1791,	
3051,1791,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3049,2260,	0,0,	3049,2260,	0,0,	
3049,3103,	3049,2260,	3049,2260,	3049,2260,	
3049,2260,	3049,2260,	3049,2260,	3049,2260,	
3049,2260,	3049,2260,	3049,2260,	3049,2260,	
3049,2260,	3049,2260,	3049,2260,	3049,2260,	
3049,2260,	3049,2260,	3049,2260,	3049,2260,	
3049,2260,	3049,2260,	3049,2260,	3049,2260,	
3049,2260,	3049,2260,	3049,2260,	3061,2215,	
0,0,	0,0,	0,0,	3110,1864,	
0,0,	0,0,	0,0,	3061,2215,	
3061,2274,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3061,2215,	0,0,	0,0,	
0,0,	0,0,	0,0,	3061,2215,	
3061,2275,	0,0,	3061,2215,	0,0,	
3061,2215,	0,0,	3061,2215,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3061,2276,	3110,3164,	3110,1798,	
3110,1798,	3110,1798,	3110,1798,	3110,1798,	
3110,1798,	3110,1798,	3110,1798,	3110,1798,	
3110,1798,	3110,1798,	3110,1798,	3110,1798,	
3110,1798,	3110,1798,	3110,1798,	3110,1798,	
3110,1798,	3110,1798,	3110,1798,	3110,1798,	
3110,1798,	3110,1798,	3110,1798,	3110,1798,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3061,2215,	
0,0,	3061,2215,	0,0,	3061,3115,	
3061,2215,	3061,2215,	3061,2215,	3061,2215,	
3061,2215,	3061,2215,	3061,2215,	3061,2215,	
3061,2215,	3061,2215,	3061,2215,	3061,2215,	
3061,2215,	3061,2215,	3061,2215,	3061,2215,	
3061,2215,	3061,2215,	3061,2215,	3061,2215,	
3061,2215,	3061,2215,	3061,2215,	3061,2215,	
3061,2215,	3061,2215,	3062,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3062,2649,	3062,2650,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3069,2224,	0,0,	0,0,	
0,0,	3062,3116,	0,0,	0,0,	
3062,2649,	3069,2224,	3069,2285,	0,0,	
0,0,	0,0,	3062,2649,	3062,2651,	
0,0,	3062,2649,	0,0,	3062,2649,	
0,0,	3062,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3062,2649,	0,0,	0,0,	3069,2224,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3069,2224,	3069,2286,	0,0,	
3069,2224,	0,0,	3069,2224,	0,0,	
3069,2224,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3069,2287,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3062,2649,	0,0,	
3062,2649,	0,0,	3062,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3069,2224,	0,0,	3069,2224,	
3062,2718,	3069,3123,	3069,2224,	3069,2224,	
3069,2224,	3069,2224,	3069,2224,	3069,2224,	
3069,2224,	3069,2224,	3069,2224,	3069,2224,	
3069,2224,	3069,2224,	3069,2224,	3069,2224,	
3069,2224,	3069,2224,	3069,2224,	3069,2224,	
3069,2224,	3069,2224,	3069,2224,	3069,2224,	
3069,2224,	3069,2224,	3069,2224,	3069,2224,	
3080,2856,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3080,2856,	3080,2857,	3081,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3081,2739,	3081,2797,	
3082,2431,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3082,2431,	3082,2488,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3080,2856,	3080,2858,	0,0,	3080,2856,	
0,0,	3080,2856,	0,0,	3080,2856,	
0,0,	0,0,	3081,2798,	3081,2799,	
0,0,	3081,2739,	0,0,	3081,2739,	
0,0,	3081,2739,	3080,2859,	0,0,	
3082,2431,	3082,2489,	0,0,	3082,2431,	
0,0,	3082,2431,	0,0,	3082,2431,	
3081,2800,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3082,2490,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3084,2548,	0,0,	
3080,2856,	0,0,	3080,2856,	0,0,	
3080,2856,	0,0,	3084,2548,	3084,2606,	
0,0,	0,0,	3081,2739,	0,0,	
3081,2739,	0,0,	3081,2739,	0,0,	
0,0,	0,0,	3081,3135,	0,0,	
3082,2431,	0,0,	3082,2431,	3080,3134,	
3082,2431,	3085,2241,	0,0,	0,0,	
0,0,	0,0,	3080,2916,	0,0,	
3084,2527,	3085,2241,	3085,2305,	0,0,	
0,0,	3082,3136,	3084,2607,	3084,2608,	
3081,2739,	3084,2548,	0,0,	3084,2548,	
0,0,	3084,2548,	0,0,	0,0,	
0,0,	0,0,	3082,2431,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3084,2609,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3085,2241,	3085,2306,	0,0,	
3085,2241,	0,0,	3085,2241,	0,0,	
3085,2241,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3085,2307,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3084,2548,	0,0,	
3084,2548,	0,0,	3084,2548,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3084,3138,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3085,2241,	0,0,	3085,2241,	
3084,2548,	3085,3139,	3085,2241,	3085,2241,	
3085,2241,	3085,2241,	3085,2241,	3085,2241,	
3085,2241,	3085,2241,	3085,2241,	3085,2241,	
3085,2241,	3085,2241,	3085,2241,	3085,2241,	
3085,2241,	3085,2241,	3085,2241,	3085,2241,	
3085,2241,	3085,2241,	3085,2241,	3085,2241,	
3085,2241,	3085,2241,	3085,2241,	3085,2241,	
3086,2242,	0,0,	0,0,	0,0,	
3118,1873,	0,0,	0,0,	0,0,	
3086,2242,	3086,2308,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3086,2242,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3086,2242,	3086,2309,	0,0,	3086,2242,	
0,0,	3086,2242,	0,0,	3086,2242,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3086,2242,	3118,3172,	
3118,1808,	3118,1808,	3118,1808,	3118,1808,	
3118,1808,	3118,1808,	3118,1808,	3118,1808,	
3118,1808,	3118,1808,	3118,1808,	3118,1808,	
3118,1808,	3118,1808,	3118,1808,	3118,1808,	
3118,1808,	3118,1808,	3118,1808,	3118,1808,	
3118,1808,	3118,1808,	3118,1808,	3118,1808,	
3118,1808,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3086,2242,	0,0,	3086,2242,	0,0,	
3086,3140,	3086,2242,	3086,2242,	3086,2242,	
3086,2242,	3086,2242,	3086,2242,	3086,2242,	
3086,2242,	3086,2242,	3086,2242,	3086,2242,	
3086,2242,	3086,2242,	3086,2242,	3086,2242,	
3086,2242,	3086,2242,	3086,2242,	3086,2242,	
3086,2242,	3086,2242,	3086,2242,	3086,2242,	
3086,2242,	3086,2242,	3086,2242,	3098,2255,	
0,0,	0,0,	0,0,	3156,1915,	
0,0,	0,0,	0,0,	3098,2255,	
3098,2323,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3098,2255,	0,0,	0,0,	
0,0,	0,0,	0,0,	3098,2255,	
3098,2324,	0,0,	3098,2255,	0,0,	
3098,2255,	0,0,	3098,2255,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3098,2325,	3156,3210,	3156,1854,	
3156,1854,	3156,1854,	3156,1854,	3156,1854,	
3156,1854,	3156,1854,	3156,1854,	3156,1854,	
3156,1854,	3156,1854,	3156,1854,	3156,1854,	
3156,1854,	3156,1854,	3156,1854,	3156,1854,	
3156,1854,	3156,1854,	3156,1854,	3156,1854,	
3156,1854,	3156,1854,	3156,1854,	3156,1854,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3098,2255,	
0,0,	3098,2255,	0,0,	3098,3152,	
3098,2255,	3098,2255,	3098,2255,	3098,2255,	
3098,2255,	3098,2255,	3098,2255,	3098,2255,	
3098,2255,	3098,2255,	3098,2255,	3098,2255,	
3098,2255,	3098,2255,	3098,2255,	3098,2255,	
3098,2255,	3098,2255,	3098,2255,	3098,2255,	
3098,2255,	3098,2255,	3098,2255,	3098,2255,	
3098,2255,	3098,2255,	3101,2258,	0,0,	
0,0,	0,0,	3187,1949,	0,0,	
0,0,	0,0,	3101,2258,	3101,2328,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3101,2258,	0,0,	0,0,	0,0,	
0,0,	0,0,	3101,2258,	3101,2329,	
0,0,	3101,2258,	0,0,	3101,2258,	
0,0,	3101,2258,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3101,2330,	3187,3241,	3187,1947,	3187,1947,	
3187,1947,	3187,1947,	3187,1947,	3187,1947,	
3187,1947,	3187,1947,	3187,1947,	3187,1947,	
3187,1947,	3187,1947,	3187,1947,	3187,1947,	
3187,1947,	3187,1947,	3187,1947,	3187,1947,	
3187,1947,	3187,1947,	3187,1947,	3187,1947,	
3187,1947,	3187,1947,	3187,1947,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3101,2258,	0,0,	
3101,2258,	0,0,	3101,3155,	3101,2258,	
3101,2258,	3101,2258,	3101,2258,	3101,2258,	
3101,2258,	3101,2258,	3101,2258,	3101,2258,	
3101,2258,	3101,2258,	3101,2258,	3101,2258,	
3101,2258,	3101,2258,	3101,2258,	3101,2258,	
3101,2258,	3101,2258,	3101,2258,	3101,2258,	
3101,2258,	3101,2258,	3101,2258,	3101,2258,	
3101,2258,	3107,2265,	0,0,	0,0,	
0,0,	3199,1963,	0,0,	0,0,	
0,0,	3107,2265,	3107,2337,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3107,2265,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3107,2265,	3107,2338,	0,0,	
3107,2265,	0,0,	3107,2265,	0,0,	
3107,2265,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3107,2339,	
3199,3253,	3199,1961,	3199,1961,	3199,1961,	
3199,1961,	3199,1961,	3199,1961,	3199,1961,	
3199,1961,	3199,1961,	3199,1961,	3199,1961,	
3199,1961,	3199,1961,	3199,1961,	3199,1961,	
3199,1961,	3199,1961,	3199,1961,	3199,1961,	
3199,1961,	3199,1961,	3199,1961,	3199,1961,	
3199,1961,	3199,1961,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3107,2265,	0,0,	3107,2265,	
0,0,	3107,3161,	3107,2265,	3107,2265,	
3107,2265,	3107,2265,	3107,2265,	3107,2265,	
3107,2265,	3107,2265,	3107,2265,	3107,2265,	
3107,2265,	3107,2265,	3107,2265,	3107,2265,	
3107,2265,	3107,2265,	3107,2265,	3107,2265,	
3107,2265,	3107,2265,	3107,2265,	3107,2265,	
3107,2265,	3107,2265,	3107,2265,	3107,2265,	
3112,2344,	0,0,	0,0,	0,0,	
3234,1999,	0,0,	0,0,	0,0,	
3112,2344,	3112,2403,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3112,2344,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3112,2344,	3112,2345,	0,0,	3112,2344,	
0,0,	3112,2344,	0,0,	3112,2344,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3112,2344,	3234,3292,	
3234,1939,	3234,1939,	3234,1939,	3234,1939,	
3234,1939,	3234,1939,	3234,1939,	3234,1939,	
3234,1939,	3234,1939,	3234,1939,	3234,1939,	
3234,1939,	3234,1939,	3234,1939,	3234,1939,	
3234,1939,	3234,1939,	3234,1939,	3234,1939,	
3234,1939,	3234,1939,	3234,1939,	3234,1939,	
3234,1939,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3112,2344,	0,0,	3112,2344,	0,0,	
3112,3166,	3112,2344,	3112,2344,	3112,2344,	
3112,2344,	3112,2344,	3112,2344,	3112,2344,	
3112,2344,	3112,2344,	3112,2344,	3112,2344,	
3112,2344,	3112,2344,	3112,2344,	3112,2344,	
3112,2344,	3112,2344,	3112,2344,	3112,2344,	
3112,2344,	3112,2344,	3112,2344,	3112,2344,	
3112,2344,	3112,2344,	3112,2344,	3116,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3116,2649,	
3116,2650,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3120,2353,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3116,2649,	3120,2353,	3120,2412,	
0,0,	0,0,	0,0,	3116,2649,	
3116,2651,	0,0,	3116,2649,	0,0,	
3116,2649,	0,0,	3116,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3116,2649,	0,0,	0,0,	
3120,2353,	0,0,	0,0,	0,0,	
0,0,	0,0,	3120,2353,	3120,2354,	
0,0,	3120,2353,	0,0,	3120,2353,	
0,0,	3120,2353,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3120,2353,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3116,2649,	
0,0,	3116,2649,	0,0,	3116,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3116,3170,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3120,2353,	0,0,	
3120,2353,	3116,2718,	3120,3174,	3120,2353,	
3120,2353,	3120,2353,	3120,2353,	3120,2353,	
3120,2353,	3120,2353,	3120,2353,	3120,2353,	
3120,2353,	3120,2353,	3120,2353,	3120,2353,	
3120,2353,	3120,2353,	3120,2353,	3120,2353,	
3120,2353,	3120,2353,	3120,2353,	3120,2353,	
3120,2353,	3120,2353,	3120,2353,	3120,2353,	
3120,2353,	3128,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3128,2059,	3128,2061,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3130,2364,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3128,2059,	
3130,2364,	3130,2423,	0,0,	0,0,	
0,0,	3128,2003,	3128,2062,	0,0,	
3128,2059,	0,0,	3128,2059,	0,0,	
3128,2059,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3128,2059,	
0,0,	0,0,	3130,2364,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3130,2364,	3130,2365,	0,0,	3130,2364,	
0,0,	3130,2364,	0,0,	3130,2364,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3130,2364,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3128,2059,	0,0,	3128,2059,	
0,0,	3128,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3128,3182,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3130,2364,	0,0,	3130,2364,	3128,2059,	
3130,3184,	3130,2364,	3130,2364,	3130,2364,	
3130,2364,	3130,2364,	3130,2364,	3130,2364,	
3130,2364,	3130,2364,	3130,2364,	3130,2364,	
3130,2364,	3130,2364,	3130,2364,	3130,2364,	
3130,2364,	3130,2364,	3130,2364,	3130,2364,	
3130,2364,	3130,2364,	3130,2364,	3130,2364,	
3130,2364,	3130,2364,	3130,2364,	3134,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3134,2856,	
3134,2857,	3135,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3135,2739,	3135,2797,	3136,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3136,2431,	
3136,2488,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3134,2856,	
3134,2858,	0,0,	3134,2856,	0,0,	
3134,2856,	0,0,	3134,2856,	0,0,	
0,0,	3135,2798,	3135,2799,	0,0,	
3135,2739,	0,0,	3135,2739,	0,0,	
3135,2739,	3134,2859,	0,0,	3136,2431,	
3136,2489,	0,0,	3136,2431,	0,0,	
3136,2431,	0,0,	3136,2431,	3135,2800,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3136,2490,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3142,2377,	0,0,	3134,2856,	
0,0,	3134,2856,	3235,2004,	3134,2856,	
0,0,	3142,2377,	3142,2437,	3134,3188,	
0,0,	3135,2739,	0,0,	3135,2739,	
0,0,	3135,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	3136,2431,	
0,0,	3136,2431,	0,0,	3136,2431,	
0,0,	3135,3189,	0,0,	3136,3190,	
0,0,	3134,2916,	0,0,	3142,2377,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3142,2377,	3142,2378,	3135,2739,	
3142,2377,	0,0,	3142,2377,	0,0,	
3142,2377,	0,0,	0,0,	0,0,	
0,0,	3136,2431,	0,0,	0,0,	
0,0,	0,0,	0,0,	3142,2377,	
0,0,	3235,3293,	3235,1941,	3235,1941,	
3235,1941,	3235,1941,	3235,1941,	3235,1941,	
3235,1941,	3235,1941,	3235,1941,	3235,1941,	
3235,1941,	3235,1941,	3235,1941,	3235,1941,	
3235,1941,	3235,1941,	3235,1941,	3235,1941,	
3235,1941,	3235,1941,	3235,1941,	3235,1941,	
3235,1941,	3235,1941,	3235,1941,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3142,2377,	0,0,	3142,2377,	
0,0,	3142,3196,	3142,2377,	3142,2377,	
3142,2377,	3142,2377,	3142,2377,	3142,2377,	
3142,2377,	3142,2377,	3142,2377,	3142,2377,	
3142,2377,	3142,2377,	3142,2377,	3142,2377,	
3142,2377,	3142,2377,	3142,2377,	3142,2377,	
3142,2377,	3142,2377,	3142,2377,	3142,2377,	
3142,2377,	3142,2377,	3142,2377,	3142,2377,	
3158,2394,	0,0,	0,0,	0,0,	
3384,2136,	0,0,	0,0,	0,0,	
3158,2394,	3158,2455,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3158,2394,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3158,2394,	3158,2395,	0,0,	3158,2394,	
0,0,	3158,2394,	0,0,	3158,2394,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3158,2394,	3384,3444,	
3384,2081,	3384,2081,	3384,2081,	3384,2081,	
3384,2081,	3384,2081,	3384,2081,	3384,2081,	
3384,2081,	3384,2081,	3384,2081,	3384,2081,	
3384,2081,	3384,2081,	3384,2081,	3384,2081,	
3384,2081,	3384,2081,	3384,2081,	3384,2081,	
3384,2081,	3384,2081,	3384,2081,	3384,2081,	
3384,2081,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3158,2394,	0,0,	3158,2394,	0,0,	
3158,3212,	3158,2394,	3158,2394,	3158,2394,	
3158,2394,	3158,2394,	3158,2394,	3158,2394,	
3158,2394,	3158,2394,	3158,2394,	3158,2394,	
3158,2394,	3158,2394,	3158,2394,	3158,2394,	
3158,2394,	3158,2394,	3158,2394,	3158,2394,	
3158,2394,	3158,2394,	3158,2394,	3158,2394,	
3158,2394,	3158,2394,	3158,2394,	3182,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3182,2059,	
3182,2061,	3188,2856,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3188,2856,	3188,2857,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3189,2739,	0,0,	0,0,	0,0,	
0,0,	3182,2059,	0,0,	0,0,	
3189,2739,	3189,2797,	0,0,	3182,2003,	
3182,2062,	0,0,	3182,2059,	0,0,	
3182,2059,	0,0,	3182,2059,	0,0,	
0,0,	3188,2856,	3188,2858,	0,0,	
3188,2856,	0,0,	3188,2856,	0,0,	
3188,2856,	3182,2059,	0,0,	3189,3243,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3188,2859,	
3189,2798,	3189,2799,	0,0,	3189,2739,	
0,0,	3189,2739,	0,0,	3189,2739,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3189,2800,	0,0,	
0,0,	3190,2431,	0,0,	3182,2059,	
0,0,	3182,2059,	0,0,	3182,2059,	
0,0,	3190,2431,	3190,2488,	3192,2548,	
0,0,	3188,2856,	0,0,	3188,2856,	
0,0,	3188,2856,	0,0,	3192,2548,	
3192,2606,	3182,3236,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3188,3242,	3222,3222,	0,0,	
3189,2739,	3182,2059,	3189,2739,	0,0,	
3189,2739,	0,0,	3222,3222,	3222,3276,	
0,0,	3190,2431,	3190,2489,	3188,2916,	
3190,2431,	3192,2527,	3190,2431,	0,0,	
3190,2431,	0,0,	0,0,	3192,2607,	
3192,2608,	0,0,	3192,2548,	0,0,	
3192,2548,	0,0,	3192,2548,	3190,2490,	
0,0,	0,0,	3189,2739,	0,0,	
3222,3222,	0,0,	0,0,	0,0,	
0,0,	3192,2609,	3222,3277,	3222,3278,	
3224,2649,	3222,3222,	0,0,	3222,3222,	
0,0,	3222,3222,	0,0,	0,0,	
3224,2649,	3224,2650,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3222,3222,	0,0,	0,0,	3230,3230,	
0,0,	3190,2431,	0,0,	3190,2431,	
0,0,	3190,2431,	0,0,	3230,3230,	
3230,3286,	3236,2059,	0,0,	3192,2548,	
0,0,	3192,2548,	3224,2649,	3192,2548,	
0,0,	3236,2059,	3236,2061,	0,0,	
3224,2649,	3224,2651,	3190,3244,	3224,2649,	
0,0,	3224,2649,	0,0,	3224,2649,	
3192,3246,	0,0,	3222,3222,	3190,2431,	
3222,3222,	3230,3230,	3222,3222,	0,0,	
0,0,	0,0,	3224,2649,	3230,3287,	
3230,3288,	3192,2548,	3230,3230,	3236,2059,	
3230,3230,	0,0,	3230,3230,	0,0,	
0,0,	3236,2003,	3236,2062,	0,0,	
3236,2059,	0,0,	3236,2059,	0,0,	
3236,2059,	3230,3230,	0,0,	0,0,	
3222,3222,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3236,2059,	
0,0,	0,0,	3240,3298,	0,0,	
3224,2649,	0,0,	3224,2649,	0,0,	
3224,2649,	0,0,	3240,3298,	3240,3299,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3224,3280,	0,0,	3230,3230,	
0,0,	3230,3230,	0,0,	3230,3230,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3236,2059,	3224,2718,	3236,2059,	
3240,3298,	3236,2059,	0,0,	3236,3294,	
0,0,	0,0,	3240,3300,	3240,3301,	
0,0,	3240,3298,	3242,2856,	3240,3298,	
0,0,	3240,3298,	0,0,	0,0,	
0,0,	3230,3230,	3242,2856,	3242,2857,	
0,0,	0,0,	0,0,	0,0,	
3240,3298,	0,0,	3243,2739,	3236,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3243,2739,	3243,2797,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3242,3303,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3242,2856,	3242,2858,	
0,0,	3242,2856,	0,0,	3242,2856,	
0,0,	3242,2856,	3240,3298,	0,0,	
3240,3298,	0,0,	3240,3298,	0,0,	
0,0,	0,0,	3243,2798,	3243,2799,	
3242,2859,	3243,2739,	0,0,	3243,2739,	
3244,2431,	3243,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3244,2431,	3244,2488,	0,0,	0,0,	
3243,2800,	0,0,	0,0,	0,0,	
3240,3298,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3242,2856,	0,0,	
3242,2856,	0,0,	3242,2856,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3244,2431,	3244,2489,	0,0,	3244,2431,	
0,0,	3244,2431,	3243,2739,	3244,2431,	
3243,2739,	0,0,	3243,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3243,3304,	0,0,	3244,2490,	0,0,	
3242,2916,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3243,2739,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3244,2431,	0,0,	3244,2431,	0,0,	
3244,3305,	3244,2431,	3244,2431,	3244,2431,	
3244,2431,	3244,2431,	3244,2431,	3244,2431,	
3244,2431,	3244,2431,	3244,2431,	3244,2431,	
3244,2431,	3244,2431,	3244,2431,	3244,2431,	
3244,2431,	3244,2431,	3244,2431,	3244,2431,	
3244,2431,	3244,2431,	3244,2431,	3244,2431,	
3244,2431,	3244,2431,	3244,2431,	3247,2241,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3247,2241,	
3247,2305,	3252,3313,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3252,3313,	3252,3314,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3247,1798,	0,0,	0,0,	
0,0,	0,0,	0,0,	3247,2241,	
3247,2306,	0,0,	3247,2241,	3252,3313,	
3247,2241,	0,0,	3247,2241,	0,0,	
0,0,	3252,3315,	3252,3316,	0,0,	
3252,3313,	0,0,	3252,3313,	0,0,	
3252,3313,	3247,2307,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3257,2446,	3252,3313,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3257,2446,	3257,2503,	
0,0,	3463,2211,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3247,2241,	
0,0,	3247,2241,	0,0,	3247,2241,	
0,0,	0,0,	3247,3308,	0,0,	
3257,2446,	3252,3313,	0,0,	3252,3313,	
0,0,	3252,3313,	3257,2446,	3257,2504,	
0,0,	3257,2446,	0,0,	3257,2446,	
0,0,	3257,2446,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3247,2241,	0,0,	0,0,	
3257,2505,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3252,3313,	
3463,3514,	3463,2210,	3463,2210,	3463,2210,	
3463,2210,	3463,2210,	3463,2210,	3463,2210,	
3463,2210,	3463,2210,	3463,2210,	3463,2210,	
3463,2210,	3463,2210,	3463,2210,	3463,2210,	
3463,2210,	3463,2210,	3463,2210,	3463,2210,	
3463,2210,	3463,2210,	3463,2210,	3463,2210,	
3463,2210,	3463,2210,	3257,2446,	0,0,	
3257,2446,	0,0,	3257,3321,	3257,2446,	
3257,2446,	3257,2446,	3257,2446,	3257,2446,	
3257,2446,	3257,2446,	3257,2446,	3257,2446,	
3257,2446,	3257,2446,	3257,2446,	3257,2446,	
3257,2446,	3257,2446,	3257,2446,	3257,2446,	
3257,2446,	3257,2446,	3257,2446,	3257,2446,	
3257,2446,	3257,2446,	3257,2446,	3257,2446,	
3257,2446,	3268,3268,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3268,3268,	3268,3332,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3315,3379,	
0,0,	0,0,	0,0,	0,0,	
3294,2059,	0,0,	0,0,	3315,3379,	
3315,3380,	0,0,	0,0,	3268,3268,	
3294,2059,	3294,2061,	0,0,	0,0,	
0,0,	3268,3333,	3268,3334,	0,0,	
3268,3268,	0,0,	3268,3268,	0,0,	
3268,3268,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3315,3379,	0,0,	3268,3268,	
0,0,	0,0,	3294,2059,	3315,3379,	
3315,3381,	0,0,	3315,3379,	0,0,	
3315,3379,	3294,2062,	3315,3379,	3294,2059,	
0,0,	3294,2059,	0,0,	3294,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3315,3379,	0,0,	0,0,	
0,0,	0,0,	3294,2059,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3268,3268,	0,0,	3268,3268,	
0,0,	3268,3268,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3315,3379,	
0,0,	3315,3379,	0,0,	3315,3379,	
3294,2059,	0,0,	3294,2059,	3268,3268,	
3294,3360,	3294,2059,	3294,2059,	3294,2059,	
3294,2059,	3294,2059,	3294,2059,	3294,2059,	
3294,2059,	3294,2059,	3294,2059,	3294,2059,	
3294,2059,	3294,2059,	3294,2059,	3294,2059,	
3294,2059,	3294,2059,	3294,2059,	3294,2059,	
3294,2059,	3294,2059,	3294,2059,	3294,2059,	
3294,2059,	3294,2059,	3294,2059,	3303,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3303,2856,	
3303,2857,	0,0,	0,0,	3304,2739,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3304,2739,	
3304,2797,	3305,2431,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3305,2431,	3305,2488,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3303,2856,	
3303,2858,	0,0,	3303,2856,	0,0,	
3303,2856,	0,0,	3303,2856,	0,0,	
0,0,	0,0,	0,0,	3304,2798,	
3304,2799,	0,0,	3304,2739,	0,0,	
3304,2739,	3303,2859,	3304,2739,	0,0,	
0,0,	3305,2431,	3305,2489,	0,0,	
3305,2431,	0,0,	3305,2431,	0,0,	
3305,2431,	3304,2800,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3305,2490,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3303,2856,	
0,0,	3303,2856,	0,0,	3303,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3303,3369,	0,0,	3304,2739,	
0,0,	3304,2739,	0,0,	3304,2739,	
0,0,	0,0,	3307,2548,	3304,3370,	
0,0,	3305,2431,	0,0,	3305,2431,	
0,0,	3305,2431,	3307,2548,	3307,2606,	
3333,3397,	3303,2916,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3333,3397,	3333,3398,	3341,3341,	0,0,	
0,0,	3304,2739,	0,0,	0,0,	
3305,3371,	0,0,	3341,3341,	3341,3342,	
0,0,	0,0,	0,0,	3305,2431,	
3307,2527,	0,0,	0,0,	0,0,	
0,0,	0,0,	3307,2607,	3307,2608,	
0,0,	3307,2548,	3333,3397,	3307,2548,	
0,0,	3307,2548,	0,0,	0,0,	
3333,3397,	3333,3399,	0,0,	3333,3397,	
3341,3341,	3333,3397,	0,0,	3333,3397,	
3307,2609,	0,0,	3341,3341,	3341,3343,	
0,0,	3341,3341,	0,0,	3341,3341,	
0,0,	3341,3341,	3333,3397,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3341,3341,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3346,2649,	
0,0,	0,0,	3307,2548,	0,0,	
3307,2548,	0,0,	3307,2548,	3346,2649,	
3346,2650,	0,0,	0,0,	0,0,	
3333,3397,	0,0,	3333,3397,	0,0,	
3333,3397,	0,0,	0,0,	0,0,	
0,0,	0,0,	3341,3341,	3307,3373,	
3341,3341,	0,0,	3341,3341,	0,0,	
3347,2527,	0,0,	0,0,	0,0,	
3307,2548,	3346,2649,	0,0,	0,0,	
3347,2527,	3347,2581,	0,0,	3346,2649,	
3346,2651,	0,0,	3346,2649,	0,0,	
3346,2649,	0,0,	3346,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3341,3407,	0,0,	0,0,	0,0,	
0,0,	3346,2649,	0,0,	0,0,	
0,0,	0,0,	3347,2527,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3347,2582,	3347,2583,	0,0,	3347,2527,	
0,0,	3347,2527,	0,0,	3347,2527,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3347,2527,	0,0,	
0,0,	0,0,	0,0,	3346,2649,	
0,0,	3346,2649,	0,0,	3346,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3346,3411,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3347,2527,	3346,2718,	3347,2527,	0,0,	
3347,3412,	3347,2527,	3347,2527,	3347,2527,	
3347,2527,	3347,2527,	3347,2527,	3347,2527,	
3347,2527,	3347,2527,	3347,2527,	3347,2527,	
3347,2527,	3347,2527,	3347,2527,	3347,2527,	
3347,2527,	3347,2527,	3347,2527,	3347,2527,	
3347,2527,	3347,2527,	3347,2527,	3347,2527,	
3347,2527,	3347,2527,	3347,2527,	3351,3351,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3351,3351,	
3351,3352,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3357,2535,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3351,3351,	3357,2535,	3357,2591,	
0,0,	0,0,	0,0,	3351,3351,	
3351,3353,	0,0,	3351,3351,	0,0,	
3351,3351,	0,0,	3351,3351,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3351,3351,	0,0,	0,0,	
3357,2535,	0,0,	0,0,	0,0,	
0,0,	0,0,	3357,2592,	3357,2593,	
0,0,	3357,2535,	0,0,	3357,2535,	
0,0,	3357,2535,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3357,2535,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3351,3351,	
0,0,	3351,3351,	0,0,	3351,3351,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3357,2535,	0,0,	
3357,2535,	3351,3416,	3357,3421,	3357,2535,	
3357,2535,	3357,2535,	3357,2535,	3357,2535,	
3357,2535,	3357,2535,	3357,2535,	3357,2535,	
3357,2535,	3357,2535,	3357,2535,	3357,2535,	
3357,2535,	3357,2535,	3357,2535,	3357,2535,	
3357,2535,	3357,2535,	3357,2535,	3357,2535,	
3357,2535,	3357,2535,	3357,2535,	3357,2535,	
3357,2535,	3363,3364,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3363,3364,	3363,3365,	3369,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3369,2856,	
3369,2857,	3370,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3370,2739,	3370,2797,	0,0,	
0,0,	0,0,	0,0,	3363,3364,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3363,3364,	3363,3366,	0,0,	
3363,3364,	0,0,	3363,3364,	0,0,	
3363,3364,	0,0,	0,0,	3369,2856,	
3369,2858,	0,0,	3369,2856,	0,0,	
3369,2856,	0,0,	3369,2856,	3363,3364,	
0,0,	3370,2798,	3370,2799,	0,0,	
3370,2739,	0,0,	3370,2739,	0,0,	
3370,2739,	3369,2859,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3370,2800,	
0,0,	3371,2431,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3371,2431,	3371,2488,	0,0,	
0,0,	3363,3364,	0,0,	3363,3364,	
0,0,	3363,3364,	0,0,	0,0,	
0,0,	0,0,	0,0,	3369,2856,	
0,0,	3369,2856,	0,0,	3369,2856,	
0,0,	0,0,	3373,2548,	3369,3431,	
0,0,	3370,2739,	0,0,	3370,2739,	
0,0,	3370,2739,	3373,2548,	3373,2606,	
0,0,	3371,2431,	3371,2489,	3363,3427,	
3371,2431,	0,0,	3371,2431,	0,0,	
3371,2431,	0,0,	3370,3432,	0,0,	
0,0,	3369,2916,	0,0,	0,0,	
0,0,	0,0,	0,0,	3371,2490,	
0,0,	0,0,	0,0,	3370,2739,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3373,2607,	3373,2608,	
0,0,	3373,2548,	0,0,	3373,2548,	
0,0,	3373,2548,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3373,2609,	0,0,	0,0,	0,0,	
0,0,	3371,2431,	0,0,	3371,2431,	
0,0,	3371,2431,	0,0,	0,0,	
0,0,	3371,3433,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3373,2548,	3371,2431,	
3373,2548,	0,0,	3373,3435,	3373,2548,	
3373,2548,	3373,2548,	3373,2548,	3373,2548,	
3373,2548,	3373,2548,	3373,2548,	3373,2548,	
3373,2548,	3373,2548,	3373,2548,	3373,2548,	
3373,2548,	3373,2548,	3373,2548,	3373,2548,	
3373,2548,	3373,2548,	3373,2548,	3373,2548,	
3373,2548,	3373,2548,	3373,2548,	3373,2548,	
3373,2548,	3374,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3374,2241,	3374,2305,	3378,3379,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3378,3379,	
3378,3380,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3374,1798,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3374,2241,	3374,2306,	0,0,	
3374,2241,	3378,3379,	3374,2241,	0,0,	
3374,2241,	0,0,	0,0,	3378,3379,	
3378,3381,	0,0,	3378,3379,	0,0,	
3378,3379,	0,0,	3378,3379,	3374,2307,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3378,3379,	3389,2561,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3389,2561,	3389,2622,	
3470,2220,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3374,2241,	0,0,	3374,2241,	
0,0,	3374,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	3378,3379,	
3389,2561,	3378,3379,	0,0,	3378,3379,	
3374,3436,	0,0,	3389,2623,	3389,2624,	
0,0,	3389,2561,	0,0,	3389,2561,	
0,0,	3389,2561,	0,0,	0,0,	
0,0,	0,0,	0,0,	3374,2241,	
0,0,	0,0,	0,0,	0,0,	
3389,2625,	0,0,	0,0,	0,0,	
0,0,	3378,3440,	0,0,	3470,3521,	
3470,2219,	3470,2219,	3470,2219,	3470,2219,	
3470,2219,	3470,2219,	3470,2219,	3470,2219,	
3470,2219,	3470,2219,	3470,2219,	3470,2219,	
3470,2219,	3470,2219,	3470,2219,	3470,2219,	
3470,2219,	3470,2219,	3470,2219,	3470,2219,	
3470,2219,	3470,2219,	3470,2219,	3470,2219,	
3470,2219,	0,0,	3389,2561,	0,0,	
3389,2561,	0,0,	3389,3449,	3389,2561,	
3389,2561,	3389,2561,	3389,2561,	3389,2561,	
3389,2561,	3389,2561,	3389,2561,	3389,2561,	
3389,2561,	3389,2561,	3389,2561,	3389,2561,	
3389,2561,	3389,2561,	3389,2561,	3389,2561,	
3389,2561,	3389,2561,	3389,2561,	3389,2561,	
3389,2561,	3389,2561,	3389,2561,	3389,2561,	
3389,2561,	3392,2564,	0,0,	0,0,	
0,0,	3480,2231,	0,0,	0,0,	
0,0,	3392,2564,	3392,2628,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3392,2564,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3392,2629,	3392,2630,	0,0,	
3392,2564,	0,0,	3392,2564,	0,0,	
3392,2564,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3392,2631,	
3480,3531,	3480,2230,	3480,2230,	3480,2230,	
3480,2230,	3480,2230,	3480,2230,	3480,2230,	
3480,2230,	3480,2230,	3480,2230,	3480,2230,	
3480,2230,	3480,2230,	3480,2230,	3480,2230,	
3480,2230,	3480,2230,	3480,2230,	3480,2230,	
3480,2230,	3480,2230,	3480,2230,	3480,2230,	
3480,2230,	3480,2230,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3392,2564,	0,0,	3392,2564,	
0,0,	3392,3452,	3392,2564,	3392,2564,	
3392,2564,	3392,2564,	3392,2564,	3392,2564,	
3392,2564,	3392,2564,	3392,2564,	3392,2564,	
3392,2564,	3392,2564,	3392,2564,	3392,2564,	
3392,2564,	3392,2564,	3392,2564,	3392,2564,	
3392,2564,	3392,2564,	3392,2564,	3392,2564,	
3392,2564,	3392,2564,	3392,2564,	3392,2564,	
3397,3397,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3397,3397,	3397,3398,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3403,2573,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3397,3397,	3403,2573,	
3403,2640,	0,0,	0,0,	0,0,	
3397,3397,	3397,3399,	0,0,	3397,3397,	
0,0,	3397,3397,	0,0,	3397,3397,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3397,3397,	0,0,	
0,0,	3403,2573,	0,0,	0,0,	
0,0,	0,0,	0,0,	3403,2641,	
3403,2642,	0,0,	3403,2573,	0,0,	
3403,2573,	0,0,	3403,2573,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3403,2573,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3397,3397,	0,0,	3397,3397,	0,0,	
3397,3397,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3403,2573,	
0,0,	3403,2573,	3397,3457,	3403,3462,	
3403,2573,	3403,2573,	3403,2573,	3403,2573,	
3403,2573,	3403,2573,	3403,2573,	3403,2573,	
3403,2573,	3403,2573,	3403,2573,	3403,2573,	
3403,2573,	3403,2573,	3403,2573,	3403,2573,	
3403,2573,	3403,2573,	3403,2573,	3403,2573,	
3403,2573,	3403,2573,	3403,2573,	3403,2573,	
3403,2573,	3403,2573,	3411,2649,	0,0,	
0,0,	0,0,	3492,2244,	0,0,	
0,0,	0,0,	3411,2649,	3411,2650,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3411,2649,	0,0,	0,0,	0,0,	
0,0,	0,0,	3411,2649,	3411,2651,	
0,0,	3411,2649,	0,0,	3411,2649,	
0,0,	3411,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3411,2649,	3492,3542,	3492,2243,	3492,2243,	
3492,2243,	3492,2243,	3492,2243,	3492,2243,	
3492,2243,	3492,2243,	3492,2243,	3492,2243,	
3492,2243,	3492,2243,	3492,2243,	3492,2243,	
3492,2243,	3492,2243,	3492,2243,	3492,2243,	
3492,2243,	3492,2243,	3492,2243,	3492,2243,	
3492,2243,	3492,2243,	3492,2243,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3411,2649,	0,0,	
3411,2649,	0,0,	3411,3468,	3411,2649,	
3411,2649,	3411,2649,	3411,2649,	3411,2649,	
3411,2649,	3411,2649,	3411,2649,	3411,2649,	
3411,2649,	3411,2649,	3411,2649,	3411,2649,	
3411,2649,	3411,2649,	3411,2649,	3411,2649,	
3411,2649,	3411,2649,	3411,2649,	3411,2649,	
3411,2649,	3411,2649,	3411,2649,	3411,2649,	
3411,2718,	3420,2659,	0,0,	0,0,	
0,0,	3507,2261,	0,0,	0,0,	
0,0,	3420,2659,	3420,2660,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3420,2659,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3420,2659,	3420,2661,	0,0,	
3420,2659,	0,0,	3420,2659,	0,0,	
3420,2659,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3420,2659,	
3507,3556,	3507,2260,	3507,2260,	3507,2260,	
3507,2260,	3507,2260,	3507,2260,	3507,2260,	
3507,2260,	3507,2260,	3507,2260,	3507,2260,	
3507,2260,	3507,2260,	3507,2260,	3507,2260,	
3507,2260,	3507,2260,	3507,2260,	3507,2260,	
3507,2260,	3507,2260,	3507,2260,	3507,2260,	
3507,2260,	3507,2260,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3420,2659,	0,0,	3420,2659,	
0,0,	3420,3475,	3420,2659,	3420,2659,	
3420,2659,	3420,2659,	3420,2659,	3420,2659,	
3420,2659,	3420,2659,	3420,2659,	3420,2659,	
3420,2659,	3420,2659,	3420,2659,	3420,2659,	
3420,2659,	3420,2659,	3420,2659,	3420,2659,	
3420,2659,	3420,2659,	3420,2659,	3420,2659,	
3420,2659,	3420,2659,	3420,2659,	3420,2727,	
3431,2856,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3431,2856,	3431,2857,	3432,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3432,2739,	3432,2797,	
3433,2431,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3433,2431,	3433,2488,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3431,2856,	3431,2858,	0,0,	3431,2856,	
0,0,	3431,2856,	0,0,	3431,2856,	
0,0,	0,0,	3432,2798,	3432,2799,	
0,0,	3432,2739,	0,0,	3432,2739,	
0,0,	3432,2739,	3431,2859,	0,0,	
3433,2431,	3433,2489,	0,0,	3433,2431,	
0,0,	3433,2431,	0,0,	3433,2431,	
3432,2800,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3433,2490,	0,0,	
3434,2674,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3434,2674,	3434,2675,	3518,2275,	0,0,	
3431,2856,	0,0,	3431,2856,	0,0,	
3431,2856,	0,0,	0,0,	0,0,	
0,0,	0,0,	3432,2739,	0,0,	
3432,2739,	0,0,	3432,2739,	0,0,	
0,0,	3431,3485,	3432,3486,	0,0,	
3433,2431,	0,0,	3433,2431,	0,0,	
3433,2431,	0,0,	0,0,	3433,3487,	
3434,2674,	3434,2676,	3431,2916,	3434,2674,	
0,0,	3434,2674,	0,0,	3434,2674,	
0,0,	0,0,	0,0,	0,0,	
3432,2739,	0,0,	0,0,	0,0,	
0,0,	0,0,	3434,2677,	0,0,	
0,0,	0,0,	3433,2431,	0,0,	
0,0,	3518,3567,	3518,2215,	3518,2215,	
3518,2215,	3518,2215,	3518,2215,	3518,2215,	
3518,2215,	3518,2215,	3518,2215,	3518,2215,	
3518,2215,	3518,2215,	3518,2215,	3518,2215,	
3518,2215,	3518,2215,	3518,2215,	3518,2215,	
3518,2215,	3518,2215,	3518,2215,	3518,2215,	
3518,2215,	3518,2215,	3518,2215,	0,0,	
3434,2674,	0,0,	3434,2674,	0,0,	
3434,3488,	3434,2674,	3434,2674,	3434,2674,	
3434,2674,	3434,2674,	3434,2674,	3434,2674,	
3434,2674,	3434,2674,	3434,2674,	3434,2674,	
3434,2674,	3434,2674,	3434,2674,	3434,2674,	
3434,2674,	3434,2674,	3434,2674,	3434,2674,	
3434,2674,	3434,2674,	3434,2674,	3434,2674,	
3434,2674,	3434,2674,	3434,2741,	3436,2241,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3436,2241,	
3436,2305,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3448,2690,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3436,1798,	3448,2690,	3448,2691,	
0,0,	0,0,	0,0,	3436,2241,	
3436,2306,	0,0,	3436,2241,	0,0,	
3436,2241,	0,0,	3436,2241,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3436,2307,	0,0,	0,0,	
3448,2690,	0,0,	0,0,	0,0,	
0,0,	0,0,	3448,2690,	3448,2692,	
0,0,	3448,2690,	0,0,	3448,2690,	
0,0,	3448,2690,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3448,2693,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3436,2241,	
0,0,	3436,2241,	0,0,	3436,2241,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3436,3490,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3448,2690,	0,0,	
3448,2690,	3436,2241,	3448,3501,	3448,2690,	
3448,2690,	3448,2690,	3448,2690,	3448,2690,	
3448,2690,	3448,2690,	3448,2690,	3448,2690,	
3448,2690,	3448,2690,	3448,2690,	3448,2690,	
3448,2690,	3448,2690,	3448,2690,	3448,2690,	
3448,2690,	3448,2690,	3448,2690,	3448,2690,	
3448,2690,	3448,2690,	3448,2690,	3448,2690,	
3448,2755,	3451,2696,	0,0,	0,0,	
0,0,	3525,2286,	0,0,	0,0,	
0,0,	3451,2696,	3451,2697,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3451,2696,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3451,2696,	3451,2698,	0,0,	
3451,2696,	0,0,	3451,2696,	0,0,	
3451,2696,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3451,2699,	
3525,3574,	3525,2224,	3525,2224,	3525,2224,	
3525,2224,	3525,2224,	3525,2224,	3525,2224,	
3525,2224,	3525,2224,	3525,2224,	3525,2224,	
3525,2224,	3525,2224,	3525,2224,	3525,2224,	
3525,2224,	3525,2224,	3525,2224,	3525,2224,	
3525,2224,	3525,2224,	3525,2224,	3525,2224,	
3525,2224,	3525,2224,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3451,2696,	0,0,	3451,2696,	
0,0,	3451,3504,	3451,2696,	3451,2696,	
3451,2696,	3451,2696,	3451,2696,	3451,2696,	
3451,2696,	3451,2696,	3451,2696,	3451,2696,	
3451,2696,	3451,2696,	3451,2696,	3451,2696,	
3451,2696,	3451,2696,	3451,2696,	3451,2696,	
3451,2696,	3451,2696,	3451,2696,	3451,2696,	
3451,2696,	3451,2696,	3451,2696,	3451,2759,	
3461,2708,	0,0,	0,0,	0,0,	
3541,2309,	0,0,	0,0,	0,0,	
3461,2708,	3461,2709,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3461,2708,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3461,2708,	3461,2710,	0,0,	3461,2708,	
0,0,	3461,2708,	0,0,	3461,2708,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3461,2708,	3541,3588,	
3541,2242,	3541,2242,	3541,2242,	3541,2242,	
3541,2242,	3541,2242,	3541,2242,	3541,2242,	
3541,2242,	3541,2242,	3541,2242,	3541,2242,	
3541,2242,	3541,2242,	3541,2242,	3541,2242,	
3541,2242,	3541,2242,	3541,2242,	3541,2242,	
3541,2242,	3541,2242,	3541,2242,	3541,2242,	
3541,2242,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3461,2708,	0,0,	3461,2708,	0,0,	
3461,3512,	3461,2708,	3461,2708,	3461,2708,	
3461,2708,	3461,2708,	3461,2708,	3461,2708,	
3461,2708,	3461,2708,	3461,2708,	3461,2708,	
3461,2708,	3461,2708,	3461,2708,	3461,2708,	
3461,2708,	3461,2708,	3461,2708,	3461,2708,	
3461,2708,	3461,2708,	3461,2708,	3461,2708,	
3461,2708,	3461,2708,	3461,2769,	3485,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3485,2856,	
3485,2857,	3486,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3486,2739,	3486,2797,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3485,2856,	
3485,2858,	0,0,	3485,2856,	0,0,	
3485,2856,	0,0,	3485,2856,	0,0,	
0,0,	3486,2798,	3486,2799,	0,0,	
3486,2739,	0,0,	3486,2739,	0,0,	
3486,2739,	3485,2859,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3487,2431,	3486,2800,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3487,2431,	3487,2488,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3485,2856,	
0,0,	3485,2856,	0,0,	3485,2856,	
0,0,	3487,3537,	0,0,	3485,3535,	
0,0,	3486,2739,	0,0,	3486,2739,	
0,0,	3486,2739,	3487,2431,	3487,2489,	
3490,2241,	3487,2431,	0,0,	3487,2431,	
0,0,	3487,2431,	0,0,	0,0,	
3490,2241,	3490,2305,	0,0,	0,0,	
0,0,	3485,2916,	3486,3536,	0,0,	
3487,2490,	0,0,	0,0,	3535,2856,	
0,0,	0,0,	0,0,	3486,2739,	
0,0,	0,0,	0,0,	3535,2856,	
3535,2857,	0,0,	0,0,	0,0,	
0,0,	0,0,	3490,1798,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3490,2241,	3490,2306,	0,0,	3490,2241,	
0,0,	3490,2241,	0,0,	3490,2241,	
3536,2739,	0,0,	3487,2431,	0,0,	
3487,2431,	0,0,	3487,2431,	0,0,	
3536,2739,	3536,2797,	3490,2307,	3535,2856,	
3535,2858,	0,0,	3535,2856,	0,0,	
3535,2856,	0,0,	3535,2856,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3535,2859,	0,0,	0,0,	
3487,2431,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3536,2798,	3536,2799,	0,0,	3536,2739,	
3490,2241,	3536,2739,	3490,2241,	3536,2739,	
3490,2241,	0,0,	3490,3540,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3536,2800,	0,0,	
0,0,	0,0,	0,0,	3535,2856,	
0,0,	3535,2856,	0,0,	3535,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3490,2241,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3535,3582,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3536,2739,	3535,2916,	3536,2739,	0,0,	
3536,3583,	3536,2739,	3536,2739,	3536,2739,	
3536,2739,	3536,2739,	3536,2739,	3536,2739,	
3536,2739,	3536,2739,	3536,2739,	3536,2739,	
3536,2739,	3536,2739,	3536,2739,	3536,2739,	
3536,2739,	3536,2739,	3536,2739,	3536,2739,	
3536,2739,	3536,2739,	3536,2739,	3536,2739,	
3536,2739,	3536,2739,	3536,2739,	3537,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3537,2431,	
3537,2488,	3539,2548,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3539,2548,	3539,2606,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3537,2431,	
3537,2489,	0,0,	3537,2431,	3539,2527,	
3537,2431,	0,0,	3537,2431,	0,0,	
0,0,	3539,2607,	3539,2608,	0,0,	
3539,2548,	0,0,	3539,2548,	0,0,	
3539,2548,	3537,2490,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3539,2609,	
0,0,	3540,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3540,2241,	3540,2305,	3552,2324,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3537,2431,	
0,0,	3537,2431,	0,0,	3537,2431,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3539,2548,	0,0,	3539,2548,	
0,0,	3539,2548,	3537,3584,	0,0,	
3539,3586,	3540,2241,	3540,2306,	0,0,	
3540,2241,	0,0,	3540,2241,	0,0,	
3540,2241,	0,0,	0,0,	0,0,	
0,0,	3537,2431,	0,0,	0,0,	
0,0,	0,0,	0,0,	3540,2307,	
0,0,	0,0,	0,0,	3539,2548,	
0,0,	0,0,	3552,3599,	3552,2255,	
3552,2255,	3552,2255,	3552,2255,	3552,2255,	
3552,2255,	3552,2255,	3552,2255,	3552,2255,	
3552,2255,	3552,2255,	3552,2255,	3552,2255,	
3552,2255,	3552,2255,	3552,2255,	3552,2255,	
3552,2255,	3552,2255,	3552,2255,	3552,2255,	
3552,2255,	3552,2255,	3552,2255,	3552,2255,	
0,0,	3540,2241,	0,0,	3540,2241,	
0,0,	3540,3587,	3540,2241,	3540,2241,	
3540,2241,	3540,2241,	3540,2241,	3540,2241,	
3540,2241,	3540,2241,	3540,2241,	3540,2241,	
3540,2241,	3540,2241,	3540,2241,	3540,2241,	
3540,2241,	3540,2241,	3540,2241,	3540,2241,	
3540,2241,	3540,2241,	3540,2241,	3540,2241,	
3540,2241,	3540,2241,	3540,2241,	3540,2241,	
3548,2753,	0,0,	0,0,	0,0,	
3555,2329,	0,0,	0,0,	0,0,	
3548,2753,	3548,2813,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3548,2753,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3548,2814,	3548,2815,	0,0,	3548,2753,	
0,0,	3548,2753,	0,0,	3548,2753,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3548,2816,	3555,3602,	
3555,2258,	3555,2258,	3555,2258,	3555,2258,	
3555,2258,	3555,2258,	3555,2258,	3555,2258,	
3555,2258,	3555,2258,	3555,2258,	3555,2258,	
3555,2258,	3555,2258,	3555,2258,	3555,2258,	
3555,2258,	3555,2258,	3555,2258,	3555,2258,	
3555,2258,	3555,2258,	3555,2258,	3555,2258,	
3555,2258,	3560,2338,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3548,2753,	0,0,	3548,2753,	0,0,	
3548,3595,	3548,2753,	3548,2753,	3548,2753,	
3548,2753,	3548,2753,	3548,2753,	3548,2753,	
3548,2753,	3548,2753,	3548,2753,	3548,2753,	
3548,2753,	3548,2753,	3548,2753,	3548,2753,	
3548,2753,	3548,2753,	3548,2753,	3548,2753,	
3548,2753,	3548,2753,	3548,2753,	3548,2753,	
3548,2753,	3548,2753,	3548,2753,	3564,2345,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3560,3607,	3560,2265,	3560,2265,	3560,2265,	
3560,2265,	3560,2265,	3560,2265,	3560,2265,	
3560,2265,	3560,2265,	3560,2265,	3560,2265,	
3560,2265,	3560,2265,	3560,2265,	3560,2265,	
3560,2265,	3560,2265,	3560,2265,	3560,2265,	
3560,2265,	3560,2265,	3560,2265,	3560,2265,	
3560,2265,	3560,2265,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3564,3611,	3564,2344,	
3564,2344,	3564,2344,	3564,2344,	3564,2344,	
3564,2344,	3564,2344,	3564,2344,	3564,2344,	
3564,2344,	3564,2344,	3564,2344,	3564,2344,	
3564,2344,	3564,2344,	3564,2344,	3564,2344,	
3564,2344,	3564,2344,	3564,2344,	3564,2344,	
3564,2344,	3564,2344,	3564,2344,	3564,2344,	
3568,2649,	0,0,	0,0,	0,0,	
3571,2354,	0,0,	0,0,	0,0,	
3568,2649,	3568,2650,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3568,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3568,2649,	3568,2651,	0,0,	3568,2649,	
0,0,	3568,2649,	0,0,	3568,2649,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3568,2649,	3571,3618,	
3571,2353,	3571,2353,	3571,2353,	3571,2353,	
3571,2353,	3571,2353,	3571,2353,	3571,2353,	
3571,2353,	3571,2353,	3571,2353,	3571,2353,	
3571,2353,	3571,2353,	3571,2353,	3571,2353,	
3571,2353,	3571,2353,	3571,2353,	3571,2353,	
3571,2353,	3571,2353,	3571,2353,	3571,2353,	
3571,2353,	0,0,	0,0,	0,0,	
0,0,	3577,2059,	0,0,	0,0,	
3568,2649,	3579,2365,	3568,2649,	0,0,	
3568,2649,	3577,2117,	3577,2061,	3568,3615,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3568,2718,	3577,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3577,2062,	0,0,	
3577,2059,	0,0,	3577,2059,	3582,2856,	
3577,2059,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3582,2856,	
3582,2857,	0,0,	0,0,	3577,2059,	
3579,3625,	3579,2364,	3579,2364,	3579,2364,	
3579,2364,	3579,2364,	3579,2364,	3579,2364,	
3579,2364,	3579,2364,	3579,2364,	3579,2364,	
3579,2364,	3579,2364,	3579,2364,	3579,2364,	
3579,2364,	3579,2364,	3579,2364,	3579,2364,	
3579,2364,	3579,2364,	3579,2364,	3579,2364,	
3579,2364,	3579,2364,	0,0,	3582,2856,	
3582,2858,	0,0,	3582,2856,	0,0,	
3582,2856,	3577,2059,	3582,2856,	3577,2059,	
0,0,	3577,2059,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3582,2859,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3577,2059,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3582,2856,	
0,0,	3582,2856,	0,0,	3582,3628,	
3582,2856,	3582,2856,	3582,2856,	3582,2856,	
3582,2856,	3582,2856,	3582,2856,	3582,2856,	
3582,2856,	3582,2856,	3582,2856,	3582,2856,	
3582,2856,	3582,2856,	3582,2856,	3582,2856,	
3582,2856,	3582,2856,	3582,2856,	3582,2856,	
3582,2856,	3582,2856,	3582,2856,	3582,2856,	
3582,2856,	3582,2916,	3583,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3583,2739,	3583,2797,	
3584,2431,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3584,2431,	3584,2488,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3583,2798,	3583,2799,	
0,0,	3583,2739,	0,0,	3583,2739,	
0,0,	3583,2739,	0,0,	0,0,	
3584,2431,	3584,2489,	0,0,	3584,2431,	
0,0,	3584,2431,	0,0,	3584,2431,	
3583,2800,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3594,2872,	3584,2490,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3594,2872,	3594,2873,	0,0,	
3590,2378,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3583,2739,	0,0,	
3583,2739,	0,0,	3583,2739,	0,0,	
0,0,	0,0,	0,0,	3594,2872,	
3584,2431,	0,0,	3584,2431,	0,0,	
3584,2431,	3594,2872,	3594,2874,	0,0,	
3594,2872,	0,0,	3594,2872,	0,0,	
3594,2872,	3583,3629,	0,0,	0,0,	
0,0,	0,0,	3584,3630,	0,0,	
3583,2739,	0,0,	0,0,	3594,2875,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3584,2431,	3590,3636,	
3590,2377,	3590,2377,	3590,2377,	3590,2377,	
3590,2377,	3590,2377,	3590,2377,	3590,2377,	
3590,2377,	3590,2377,	3590,2377,	3590,2377,	
3590,2377,	3590,2377,	3590,2377,	3590,2377,	
3590,2377,	3590,2377,	3590,2377,	3590,2377,	
3590,2377,	3590,2377,	3590,2377,	3590,2377,	
3590,2377,	3594,2872,	3604,2395,	3594,2872,	
0,0,	3594,3640,	3594,2872,	3594,2872,	
3594,2872,	3594,2872,	3594,2872,	3594,2872,	
3594,2872,	3594,2872,	3594,2872,	3594,2872,	
3594,2872,	3594,2872,	3594,2872,	3594,2872,	
3594,2872,	3594,2872,	3594,2872,	3594,2872,	
3594,2872,	3594,2872,	3594,2872,	3594,2872,	
3594,2872,	3594,2872,	3594,2872,	3594,2930,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3628,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3628,2856,	
3628,2857,	0,0,	0,0,	0,0,	
0,0,	3604,3650,	3604,2394,	3604,2394,	
3604,2394,	3604,2394,	3604,2394,	3604,2394,	
3604,2394,	3604,2394,	3604,2394,	3604,2394,	
3604,2394,	3604,2394,	3604,2394,	3604,2394,	
3604,2394,	3604,2394,	3604,2394,	3604,2394,	
3604,2394,	3604,2394,	3604,2394,	3604,2394,	
3604,2394,	3604,2394,	3604,2394,	3628,2856,	
3628,2858,	3629,2739,	3628,2856,	0,0,	
3628,2856,	0,0,	3628,2856,	0,0,	
0,0,	3629,2739,	3629,2797,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3628,2859,	0,0,	0,0,	
3630,2431,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3630,2431,	3630,2488,	3632,2548,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3632,2548,	3632,2606,	
0,0,	3629,2798,	3629,2799,	0,0,	
3629,2739,	0,0,	3629,2739,	0,0,	
3629,2739,	3661,2649,	0,0,	3628,2856,	
0,0,	3628,2856,	0,0,	3628,2856,	
0,0,	3661,2649,	3661,2650,	3629,2800,	
3630,2431,	3630,2489,	0,0,	3630,2431,	
3632,2527,	3630,2431,	0,0,	3630,2431,	
0,0,	0,0,	3632,2607,	3632,2608,	
0,0,	3632,2548,	3628,3674,	3632,2548,	
0,0,	3632,2548,	3630,2490,	0,0,	
0,0,	3628,2916,	0,0,	3661,2649,	
0,0,	0,0,	0,0,	0,0,	
3632,2609,	3661,2649,	3661,2651,	3674,2856,	
3661,2649,	3629,2739,	3661,2649,	3629,2739,	
3661,2649,	3629,2739,	0,0,	3674,2856,	
3674,2857,	3629,3675,	0,0,	0,0,	
0,0,	0,0,	0,0,	3661,2649,	
0,0,	0,0,	0,0,	0,0,	
3630,2431,	0,0,	3630,2431,	0,0,	
3630,2431,	0,0,	3630,3676,	0,0,	
3675,2739,	0,0,	3632,2548,	3629,2739,	
3632,2548,	0,0,	3632,2548,	0,0,	
3675,2739,	3675,2797,	0,0,	3674,2856,	
3674,2858,	0,0,	3674,2856,	0,0,	
3674,2856,	3632,3678,	3674,2856,	0,0,	
0,0,	3661,2649,	3630,2431,	3661,2649,	
0,0,	3661,2649,	0,0,	0,0,	
0,0,	3674,2859,	0,0,	0,0,	
3632,2548,	0,0,	0,0,	0,0,	
3661,3706,	0,0,	0,0,	0,0,	
3675,2798,	3675,2799,	0,0,	3675,2739,	
3676,2431,	3675,2739,	0,0,	3675,2739,	
0,0,	0,0,	0,0,	3661,2718,	
3676,2431,	3676,2488,	0,0,	0,0,	
0,0,	0,0,	3675,2800,	0,0,	
0,0,	0,0,	0,0,	3674,2856,	
0,0,	3674,2856,	0,0,	3674,2856,	
0,0,	0,0,	0,0,	3674,3719,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3676,2431,	3676,2489,	0,0,	3676,2431,	
0,0,	3676,2431,	0,0,	3676,2431,	
3675,2739,	3674,2916,	3675,2739,	0,0,	
3675,2739,	0,0,	0,0,	3675,3720,	
0,0,	0,0,	3676,2490,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3675,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3676,2431,	0,0,	3676,2431,	0,0,	
3676,3721,	3676,2431,	3676,2431,	3676,2431,	
3676,2431,	3676,2431,	3676,2431,	3676,2431,	
3676,2431,	3676,2431,	3676,2431,	3676,2431,	
3676,2431,	3676,2431,	3676,2431,	3676,2431,	
3676,2431,	3676,2431,	3676,2431,	3676,2431,	
3676,2431,	3676,2431,	3676,2431,	3676,2431,	
3676,2431,	3676,2431,	3676,2431,	3678,2548,	
0,0,	0,0,	0,0,	3687,2504,	
0,0,	0,0,	0,0,	3678,2548,	
3678,2606,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3678,2527,	0,0,	0,0,	
0,0,	0,0,	0,0,	3678,2607,	
3678,2608,	0,0,	3678,2548,	0,0,	
3678,2548,	0,0,	3678,2548,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3678,2609,	3687,3732,	3687,2446,	
3687,2446,	3687,2446,	3687,2446,	3687,2446,	
3687,2446,	3687,2446,	3687,2446,	3687,2446,	
3687,2446,	3687,2446,	3687,2446,	3687,2446,	
3687,2446,	3687,2446,	3687,2446,	3687,2446,	
3687,2446,	3687,2446,	3687,2446,	3687,2446,	
3687,2446,	3687,2446,	3687,2446,	3687,2446,	
0,0,	0,0,	0,0,	0,0,	
3706,2649,	0,0,	0,0,	3678,2548,	
0,0,	3678,2548,	0,0,	3678,2548,	
3706,2649,	3706,2650,	3719,2856,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3719,2856,	3719,2857,	
0,0,	3678,3723,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3720,2739,	0,0,	0,0,	
0,0,	3678,2548,	3706,2649,	0,0,	
0,0,	3720,2739,	3720,2797,	0,0,	
3706,2649,	3706,2651,	0,0,	3706,2649,	
0,0,	3706,2649,	0,0,	3706,2649,	
0,0,	0,0,	3719,2856,	3719,2858,	
0,0,	3719,2856,	0,0,	3719,2856,	
0,0,	3719,2856,	3706,2649,	0,0,	
3720,3765,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3719,2859,	3720,2798,	3720,2799,	3721,2431,	
3720,2739,	0,0,	3720,2739,	0,0,	
3720,2739,	0,0,	0,0,	3721,2431,	
3721,2488,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3720,2800,	
0,0,	0,0,	3723,2548,	0,0,	
3706,2649,	0,0,	3706,2649,	0,0,	
3706,2649,	0,0,	3723,2548,	3723,2606,	
0,0,	0,0,	3719,2856,	0,0,	
3719,2856,	0,0,	3719,2856,	0,0,	
0,0,	3719,3764,	3706,3751,	3721,2431,	
3721,2489,	0,0,	3721,2431,	0,0,	
3721,2431,	0,0,	3721,2431,	3724,2241,	
0,0,	3720,2739,	3706,2718,	3720,2739,	
3723,2527,	3720,2739,	0,0,	3724,2241,	
3724,2305,	3721,2490,	3723,2607,	3723,2608,	
3719,2916,	3723,2548,	0,0,	3723,2548,	
0,0,	3723,2548,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3723,2609,	0,0,	0,0,	3720,2739,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3724,2241,	
3724,3769,	3746,3746,	3724,2241,	3721,2431,	
3724,2241,	3721,2431,	3724,2241,	3721,2431,	
0,0,	3746,3746,	3746,3791,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3724,2307,	3721,3766,	0,0,	
0,0,	0,0,	3723,2548,	0,0,	
3723,2548,	0,0,	3723,2548,	0,0,	
3723,3768,	0,0,	3751,2649,	0,0,	
0,0,	3721,2431,	0,0,	3746,3746,	
0,0,	0,0,	3751,2649,	3751,2650,	
0,0,	3746,3746,	3746,3792,	0,0,	
3746,3746,	0,0,	3746,3746,	0,0,	
3746,3746,	0,0,	0,0,	3724,2241,	
3723,2548,	3724,2241,	0,0,	3724,2241,	
0,0,	0,0,	0,0,	3746,3746,	
0,0,	0,0,	0,0,	0,0,	
3751,2649,	0,0,	0,0,	0,0,	
0,0,	0,0,	3751,2649,	3751,2651,	
0,0,	3751,2649,	0,0,	3751,2649,	
0,0,	3751,2649,	0,0,	0,0,	
0,0,	3724,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3751,2649,	0,0,	0,0,	3753,3753,	
0,0,	3746,3746,	0,0,	3746,3746,	
0,0,	3746,3746,	3752,2583,	3753,3753,	
3753,3798,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3751,2649,	3746,3746,	
3751,2649,	3753,3753,	3751,2649,	0,0,	
3751,3796,	0,0,	0,0,	3753,3753,	
3753,3799,	0,0,	3753,3753,	0,0,	
3753,3753,	0,0,	3753,3753,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3753,3753,	0,0,	0,0,	
3751,2718,	3752,3797,	3752,2527,	3752,2527,	
3752,2527,	3752,2527,	3752,2527,	3752,2527,	
3752,2527,	3752,2527,	3752,2527,	3752,2527,	
3752,2527,	3752,2527,	3752,2527,	3752,2527,	
3752,2527,	3752,2527,	3752,2527,	3752,2527,	
3752,2527,	3752,2527,	3752,2527,	3752,2527,	
3752,2527,	3752,2527,	3752,2527,	3759,2593,	
0,0,	0,0,	0,0,	3753,3753,	
0,0,	3753,3753,	0,0,	3753,3753,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3753,3753,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3759,3804,	3759,2535,	
3759,2535,	3759,2535,	3759,2535,	3759,2535,	
3759,2535,	3759,2535,	3759,2535,	3759,2535,	
3759,2535,	3759,2535,	3759,2535,	3759,2535,	
3759,2535,	3759,2535,	3759,2535,	3759,2535,	
3759,2535,	3759,2535,	3759,2535,	3759,2535,	
3759,2535,	3759,2535,	3759,2535,	3759,2535,	
3760,3805,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3760,3805,	3760,3806,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3764,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3764,2856,	
3764,2857,	3765,2739,	0,0,	0,0,	
0,0,	0,0,	3760,3805,	0,0,	
0,0,	3765,2739,	3765,2797,	0,0,	
3760,3805,	3760,3807,	0,0,	3760,3805,	
0,0,	3760,3805,	0,0,	3760,3805,	
3766,2431,	0,0,	3764,3811,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3766,2431,	3766,2488,	3760,3805,	3764,2856,	
3764,2858,	0,0,	3764,2856,	0,0,	
3764,2856,	0,0,	3764,2856,	0,0,	
0,0,	3765,2798,	3765,2799,	0,0,	
3765,2739,	0,0,	3765,2739,	0,0,	
3765,2739,	3764,2859,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3765,2800,	
3766,2431,	3766,2489,	3768,2548,	3766,2431,	
3760,3805,	3766,2431,	3760,3805,	3766,2431,	
3760,3805,	0,0,	3768,2548,	3768,2606,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3766,2490,	0,0,	
0,0,	0,0,	0,0,	3764,2856,	
0,0,	3764,2856,	0,0,	3764,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3765,2739,	3760,3805,	3765,2739,	
0,0,	3765,2739,	0,0,	0,0,	
0,0,	0,0,	3768,2607,	3768,2608,	
0,0,	3768,2548,	0,0,	3768,2548,	
3765,3812,	3768,2548,	0,0,	0,0,	
3766,2431,	3764,2916,	3766,2431,	0,0,	
3766,2431,	0,0,	0,0,	0,0,	
3768,2609,	0,0,	0,0,	3765,2739,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3766,3813,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3766,2431,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3768,2548,	0,0,	
3768,2548,	0,0,	3768,3815,	3768,2548,	
3768,2548,	3768,2548,	3768,2548,	3768,2548,	
3768,2548,	3768,2548,	3768,2548,	3768,2548,	
3768,2548,	3768,2548,	3768,2548,	3768,2548,	
3768,2548,	3768,2548,	3768,2548,	3768,2548,	
3768,2548,	3768,2548,	3768,2548,	3768,2548,	
3768,2548,	3768,2548,	3768,2548,	3768,2548,	
3768,2548,	3769,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3769,2374,	3769,2305,	3771,3816,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3771,3816,	
3771,3817,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3769,2241,	3769,2306,	0,0,	
3769,2241,	3771,3816,	3769,2241,	0,0,	
3769,2241,	0,0,	0,0,	3771,3816,	
3771,3818,	0,0,	3771,3816,	0,0,	
3771,3816,	0,0,	3771,3816,	3769,2307,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3771,3816,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3779,2624,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3769,2241,	0,0,	3769,2241,	
0,0,	3769,2241,	0,0,	0,0,	
0,0,	0,0,	0,0,	3771,3816,	
0,0,	3771,3816,	3782,2630,	3771,3816,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3769,2241,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3771,3816,	3779,3826,	3779,2561,	
3779,2561,	3779,2561,	3779,2561,	3779,2561,	
3779,2561,	3779,2561,	3779,2561,	3779,2561,	
3779,2561,	3779,2561,	3779,2561,	3779,2561,	
3779,2561,	3779,2561,	3779,2561,	3779,2561,	
3779,2561,	3779,2561,	3779,2561,	3779,2561,	
3779,2561,	3779,2561,	3779,2561,	3779,2561,	
0,0,	3782,3828,	3782,2564,	3782,2564,	
3782,2564,	3782,2564,	3782,2564,	3782,2564,	
3782,2564,	3782,2564,	3782,2564,	3782,2564,	
3782,2564,	3782,2564,	3782,2564,	3782,2564,	
3782,2564,	3782,2564,	3782,2564,	3782,2564,	
3782,2564,	3782,2564,	3782,2564,	3782,2564,	
3782,2564,	3782,2564,	3782,2564,	3784,3784,	
0,0,	0,0,	0,0,	3790,2642,	
0,0,	0,0,	0,0,	3784,3784,	
3784,3829,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3784,3784,	0,0,	0,0,	
0,0,	0,0,	0,0,	3784,3784,	
3784,3830,	0,0,	3784,3784,	0,0,	
3784,3784,	0,0,	3784,3784,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3784,3784,	3790,3835,	3790,2573,	
3790,2573,	3790,2573,	3790,2573,	3790,2573,	
3790,2573,	3790,2573,	3790,2573,	3790,2573,	
3790,2573,	3790,2573,	3790,2573,	3790,2573,	
3790,2573,	3790,2573,	3790,2573,	3790,2573,	
3790,2573,	3790,2573,	3790,2573,	3790,2573,	
3790,2573,	3790,2573,	3790,2573,	3790,2573,	
3796,2651,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3784,3784,	
0,0,	3784,3784,	0,0,	3784,3784,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3803,2661,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3784,3784,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3796,3840,	
3796,2649,	3796,2649,	3796,2649,	3796,2649,	
3796,2649,	3796,2649,	3796,2649,	3796,2649,	
3796,2649,	3796,2649,	3796,2649,	3796,2649,	
3796,2649,	3796,2649,	3796,2649,	3796,2649,	
3796,2649,	3796,2649,	3796,2649,	3796,2649,	
3796,2649,	3796,2649,	3796,2649,	3796,2649,	
3796,2649,	3803,3846,	3803,2659,	3803,2659,	
3803,2659,	3803,2659,	3803,2659,	3803,2659,	
3803,2659,	3803,2659,	3803,2659,	3803,2659,	
3803,2659,	3803,2659,	3803,2659,	3803,2659,	
3803,2659,	3803,2659,	3803,2659,	3803,2659,	
3803,2659,	3803,2659,	3803,2659,	3803,2659,	
3803,2659,	3803,2659,	3803,2659,	3811,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3811,2856,	
3811,2857,	3812,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3812,2739,	3812,2797,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3813,2431,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3813,2431,	3813,2488,	0,0,	3811,2856,	
3811,2858,	0,0,	3811,2856,	0,0,	
3811,2856,	0,0,	3811,2856,	0,0,	
0,0,	3812,2798,	3812,2799,	0,0,	
3812,2739,	0,0,	3812,2739,	0,0,	
3812,2739,	3811,2859,	0,0,	3813,3854,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3812,2800,	
3813,2431,	3813,2489,	3814,2674,	3813,2431,	
0,0,	3813,2431,	0,0,	3813,2431,	
0,0,	0,0,	3814,2674,	3814,2675,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3813,2490,	0,0,	
0,0,	0,0,	0,0,	3811,2856,	
0,0,	3811,2856,	0,0,	3811,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3812,2739,	0,0,	3812,2739,	
0,0,	3812,2739,	3811,3852,	0,0,	
0,0,	0,0,	3814,2674,	3814,2676,	
0,0,	3814,2674,	0,0,	3814,2674,	
0,0,	3814,2674,	0,0,	3812,3853,	
3813,2431,	3811,2916,	3813,2431,	0,0,	
3813,2431,	0,0,	0,0,	0,0,	
3814,2677,	0,0,	0,0,	3812,2739,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3825,2692,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3813,2431,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3814,2674,	0,0,	
3814,2674,	3827,2698,	3814,3855,	3814,2674,	
3814,2674,	3814,2674,	3814,2674,	3814,2674,	
3814,2674,	3814,2674,	3814,2674,	3814,2674,	
3814,2674,	3814,2674,	3814,2674,	3814,2674,	
3814,2674,	3814,2674,	3814,2674,	3814,2674,	
3814,2674,	3814,2674,	3814,2674,	3814,2674,	
3814,2674,	3814,2674,	3814,2674,	3814,2674,	
3814,2741,	3825,3864,	3825,2690,	3825,2690,	
3825,2690,	3825,2690,	3825,2690,	3825,2690,	
3825,2690,	3825,2690,	3825,2690,	3825,2690,	
3825,2690,	3825,2690,	3825,2690,	3825,2690,	
3825,2690,	3825,2690,	3825,2690,	3825,2690,	
3825,2690,	3825,2690,	3825,2690,	3825,2690,	
3825,2690,	3825,2690,	3825,2690,	3834,2710,	
3827,3866,	3827,2696,	3827,2696,	3827,2696,	
3827,2696,	3827,2696,	3827,2696,	3827,2696,	
3827,2696,	3827,2696,	3827,2696,	3827,2696,	
3827,2696,	3827,2696,	3827,2696,	3827,2696,	
3827,2696,	3827,2696,	3827,2696,	3827,2696,	
3827,2696,	3827,2696,	3827,2696,	3827,2696,	
3827,2696,	3827,2696,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3834,3872,	3834,2708,	
3834,2708,	3834,2708,	3834,2708,	3834,2708,	
3834,2708,	3834,2708,	3834,2708,	3834,2708,	
3834,2708,	3834,2708,	3834,2708,	3834,2708,	
3834,2708,	3834,2708,	3834,2708,	3834,2708,	
3834,2708,	3834,2708,	3834,2708,	3834,2708,	
3834,2708,	3834,2708,	3834,2708,	3834,2708,	
3837,3837,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3837,3837,	3837,3875,	3843,3843,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3843,3843,	3843,3882,	
3849,3889,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3849,3889,	3849,3890,	0,0,	0,0,	
0,0,	0,0,	3837,3837,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3837,3837,	3837,3876,	0,0,	3837,3837,	
3843,3843,	3837,3837,	0,0,	3837,3837,	
0,0,	0,0,	3843,3843,	3843,3883,	
0,0,	3843,3843,	3849,3889,	3843,3843,	
0,0,	3843,3843,	3837,3837,	0,0,	
3849,3889,	3849,3891,	0,0,	3849,3889,	
0,0,	3849,3889,	0,0,	3849,3889,	
3843,3843,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3849,3889,	0,0,	
3852,2856,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3852,2856,	3852,2857,	3853,2739,	0,0,	
3837,3837,	0,0,	3837,3837,	0,0,	
3837,3837,	0,0,	3853,2739,	3853,2797,	
3854,2431,	0,0,	3843,3843,	0,0,	
3843,3843,	0,0,	3843,3843,	0,0,	
3854,2431,	3854,2488,	0,0,	0,0,	
3849,3889,	0,0,	3849,3889,	0,0,	
3849,3889,	0,0,	0,0,	0,0,	
3852,2856,	3852,2858,	3837,3837,	3852,2856,	
0,0,	3852,2856,	0,0,	3852,2856,	
0,0,	0,0,	3853,2798,	3853,2799,	
3843,3843,	3853,2739,	0,0,	3853,2739,	
0,0,	3853,2739,	3852,2859,	0,0,	
3854,2431,	3854,3896,	3849,3889,	3854,2431,	
0,0,	3854,2431,	0,0,	3854,2431,	
3853,2800,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3854,2490,	0,0,	
3894,2856,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3894,2856,	3894,2857,	3858,3900,	0,0,	
3852,2856,	0,0,	3852,2856,	0,0,	
3852,2856,	0,0,	3858,3900,	3858,3901,	
0,0,	0,0,	3853,2739,	0,0,	
3853,2739,	0,0,	3853,2739,	0,0,	
3853,3895,	3869,3869,	3852,3894,	0,0,	
3854,2431,	0,0,	3854,2431,	0,0,	
3854,2431,	3869,3869,	3869,3913,	0,0,	
3894,2856,	3894,2858,	3852,2916,	3894,2856,	
3858,3900,	3894,2856,	0,0,	3894,2856,	
0,0,	0,0,	3858,3900,	3858,3902,	
3853,2739,	3858,3900,	0,0,	3858,3900,	
0,0,	3858,3900,	3894,2859,	0,0,	
0,0,	0,0,	3854,2431,	3869,3869,	
0,0,	0,0,	0,0,	0,0,	
3858,3900,	3869,3869,	3869,3914,	3895,2739,	
3869,3869,	0,0,	3869,3869,	0,0,	
3869,3869,	0,0,	0,0,	3895,2739,	
3895,2797,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3869,3869,	
0,0,	0,0,	0,0,	0,0,	
3894,2856,	0,0,	3894,2856,	0,0,	
3894,2856,	0,0,	3894,3935,	0,0,	
0,0,	0,0,	3858,3900,	0,0,	
3858,3900,	0,0,	3858,3900,	0,0,	
0,0,	0,0,	0,0,	3895,2798,	
3895,2799,	0,0,	3895,2739,	0,0,	
3895,2739,	0,0,	3895,2739,	0,0,	
0,0,	3869,3869,	3894,2916,	3869,3869,	
0,0,	3869,3869,	0,0,	0,0,	
0,0,	3895,2800,	0,0,	0,0,	
3858,3900,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3906,2815,	0,0,	3869,3869,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3895,2739,	
0,0,	3895,2739,	0,0,	3895,3936,	
3895,2739,	3895,2739,	3895,2739,	3895,2739,	
3895,2739,	3895,2739,	3895,2739,	3895,2739,	
3895,2739,	3895,2739,	3895,2739,	3895,2739,	
3895,2739,	3895,2739,	3895,2739,	3895,2739,	
3895,2739,	3895,2739,	3895,2739,	3895,2739,	
3895,2739,	3895,2739,	3895,2739,	3895,2739,	
3895,2739,	3895,2739,	3896,2431,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3896,2546,	3896,2488,	
3906,3944,	3906,2753,	3906,2753,	3906,2753,	
3906,2753,	3906,2753,	3906,2753,	3906,2753,	
3906,2753,	3906,2753,	3906,2753,	3906,2753,	
3906,2753,	3906,2753,	3906,2753,	3906,2753,	
3906,2753,	3906,2753,	3906,2753,	3906,2753,	
3906,2753,	3906,2753,	3906,2753,	3906,2753,	
3906,2753,	3906,2753,	0,0,	0,0,	
0,0,	0,0,	3896,2431,	3896,2489,	
3922,3222,	3896,2431,	0,0,	3896,2431,	
0,0,	3896,2431,	0,0,	0,0,	
3922,3222,	3922,3276,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3896,2490,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3922,3222,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3922,3277,	3922,3278,	0,0,	3922,3222,	
0,0,	3922,3222,	0,0,	3922,3222,	
0,0,	0,0,	3896,2431,	0,0,	
3896,2431,	0,0,	3896,2431,	0,0,	
0,0,	0,0,	3922,3222,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3896,2431,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3922,3222,	0,0,	3922,3222,	0,0,	
3922,3958,	3922,3222,	3922,3222,	3922,3222,	
3922,3222,	3922,3222,	3922,3222,	3922,3222,	
3922,3222,	3922,3222,	3922,3222,	3922,3222,	
3922,3222,	3922,3222,	3922,3222,	3922,3222,	
3922,3222,	3922,3222,	3922,3222,	3922,3222,	
3922,3222,	3922,3222,	3922,3222,	3922,3222,	
3922,3222,	3922,3222,	3922,3222,	3928,3230,	
0,0,	0,0,	0,0,	3943,2874,	
0,0,	0,0,	0,0,	3928,3230,	
3928,3286,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3928,3230,	0,0,	0,0,	
0,0,	0,0,	0,0,	3928,3287,	
3928,3288,	0,0,	3928,3230,	0,0,	
3928,3230,	0,0,	3928,3230,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3928,3230,	3943,3979,	3943,2872,	
3943,2872,	3943,2872,	3943,2872,	3943,2872,	
3943,2872,	3943,2872,	3943,2872,	3943,2872,	
3943,2872,	3943,2872,	3943,2872,	3943,2872,	
3943,2872,	3943,2872,	3943,2872,	3943,2872,	
3943,2872,	3943,2872,	3943,2872,	3943,2872,	
3943,2872,	3943,2872,	3943,2872,	3943,2872,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3928,3230,	
0,0,	3928,3230,	0,0,	3928,3964,	
3928,3230,	3928,3230,	3928,3230,	3928,3230,	
3928,3230,	3928,3230,	3928,3230,	3928,3230,	
3928,3230,	3928,3230,	3928,3230,	3928,3230,	
3928,3230,	3928,3230,	3928,3230,	3928,3230,	
3928,3230,	3928,3230,	3928,3230,	3928,3230,	
3928,3230,	3928,3230,	3928,3230,	3928,3230,	
3928,3230,	3928,3230,	3934,3298,	0,0,	
0,0,	0,0,	4134,3278,	0,0,	
0,0,	0,0,	3934,3298,	3934,3299,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3934,3298,	0,0,	0,0,	0,0,	
0,0,	0,0,	3934,3300,	3934,3301,	
0,0,	3934,3298,	0,0,	3934,3298,	
0,0,	3934,3298,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3934,3298,	4134,4154,	4134,3222,	4134,3222,	
4134,3222,	4134,3222,	4134,3222,	4134,3222,	
4134,3222,	4134,3222,	4134,3222,	4134,3222,	
4134,3222,	4134,3222,	4134,3222,	4134,3222,	
4134,3222,	4134,3222,	4134,3222,	4134,3222,	
4134,3222,	4134,3222,	4134,3222,	4134,3222,	
4134,3222,	4134,3222,	4134,3222,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3934,3298,	0,0,	
3934,3298,	0,0,	3934,3970,	3934,3298,	
3934,3298,	3934,3298,	3934,3298,	3934,3298,	
3934,3298,	3934,3298,	3934,3298,	3934,3298,	
3934,3298,	3934,3298,	3934,3298,	3934,3298,	
3934,3298,	3934,3298,	3934,3298,	3934,3298,	
3934,3298,	3934,3298,	3934,3298,	3934,3298,	
3934,3298,	3934,3298,	3934,3298,	3934,3298,	
3934,3298,	3935,2856,	0,0,	0,0,	
0,0,	4138,3288,	0,0,	0,0,	
0,0,	3935,2856,	3935,2857,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3935,2856,	3935,2858,	0,0,	
3935,2856,	0,0,	3935,2856,	0,0,	
3935,2856,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3935,2859,	
4138,4158,	4138,3230,	4138,3230,	4138,3230,	
4138,3230,	4138,3230,	4138,3230,	4138,3230,	
4138,3230,	4138,3230,	4138,3230,	4138,3230,	
4138,3230,	4138,3230,	4138,3230,	4138,3230,	
4138,3230,	4138,3230,	4138,3230,	4138,3230,	
4138,3230,	4138,3230,	4138,3230,	4138,3230,	
4138,3230,	4138,3230,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3935,2856,	0,0,	3935,2856,	
0,0,	3935,3971,	3935,2856,	3935,2856,	
3935,2856,	3935,2856,	3935,2856,	3935,2856,	
3935,2856,	3935,2856,	3935,2856,	3935,2856,	
3935,2856,	3935,2856,	3935,2856,	3935,2856,	
3935,2856,	3935,2856,	3935,2856,	3935,2856,	
3935,2856,	3935,2856,	3935,2856,	3935,2856,	
3935,2856,	3935,2856,	3935,2856,	3935,2916,	
3936,2739,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3936,2739,	3936,2797,	3938,2548,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3938,2548,	3938,2606,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3936,2798,	3936,2799,	0,0,	3936,2739,	
0,0,	3936,2739,	0,0,	3936,2739,	
0,0,	0,0,	3938,2607,	3938,3974,	
0,0,	3938,2548,	0,0,	3938,2548,	
0,0,	3938,2548,	3936,2800,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3938,2609,	3942,3313,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3942,3313,	3942,3314,	4142,3301,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3936,2739,	0,0,	3936,2739,	0,0,	
3936,2739,	0,0,	0,0,	0,0,	
0,0,	0,0,	3938,2548,	3942,3313,	
3938,2548,	0,0,	3938,2548,	3936,3972,	
0,0,	3942,3315,	3942,3316,	0,0,	
3942,3313,	0,0,	3942,3313,	0,0,	
3942,3313,	0,0,	0,0,	0,0,	
0,0,	0,0,	3936,2739,	0,0,	
0,0,	0,0,	0,0,	3942,3313,	
0,0,	0,0,	0,0,	0,0,	
3938,2548,	0,0,	4142,4162,	4142,3298,	
4142,3298,	4142,3298,	4142,3298,	4142,3298,	
4142,3298,	4142,3298,	4142,3298,	4142,3298,	
4142,3298,	4142,3298,	4142,3298,	4142,3298,	
4142,3298,	4142,3298,	4142,3298,	4142,3298,	
4142,3298,	4142,3298,	4142,3298,	4142,3298,	
4142,3298,	4142,3298,	4142,3298,	4142,3298,	
0,0,	3942,3313,	0,0,	3942,3313,	
0,0,	3942,3978,	3942,3313,	3942,3313,	
3942,3313,	3942,3313,	3942,3313,	3942,3313,	
3942,3313,	3942,3313,	3942,3313,	3942,3313,	
3942,3313,	3942,3313,	3942,3313,	3942,3313,	
3942,3313,	3942,3313,	3942,3313,	3942,3313,	
3942,3313,	3942,3313,	3942,3313,	3942,3313,	
3942,3313,	3942,3313,	3942,3313,	3942,3313,	
3952,3268,	0,0,	0,0,	0,0,	
4146,3316,	0,0,	0,0,	0,0,	
3952,3268,	3952,3332,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3952,3268,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3952,3333,	3952,3334,	0,0,	3952,3268,	
0,0,	3952,3268,	0,0,	3952,3268,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3952,3268,	4146,4166,	
4146,3313,	4146,3313,	4146,3313,	4146,3313,	
4146,3313,	4146,3313,	4146,3313,	4146,3313,	
4146,3313,	4146,3313,	4146,3313,	4146,3313,	
4146,3313,	4146,3313,	4146,3313,	4146,3313,	
4146,3313,	4146,3313,	4146,3313,	4146,3313,	
4146,3313,	4146,3313,	4146,3313,	4146,3313,	
4146,3313,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3952,3268,	0,0,	3952,3268,	0,0,	
3952,3988,	3952,3268,	3952,3268,	3952,3268,	
3952,3268,	3952,3268,	3952,3268,	3952,3268,	
3952,3268,	3952,3268,	3952,3268,	3952,3268,	
3952,3268,	3952,3268,	3952,3268,	3952,3268,	
3952,3268,	3952,3268,	3952,3268,	3952,3268,	
3952,3268,	3952,3268,	3952,3268,	3952,3268,	
3952,3268,	3952,3268,	3952,3268,	3957,3341,	
0,0,	0,0,	0,0,	4150,3334,	
0,0,	0,0,	0,0,	3957,3341,	
3957,3342,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3957,3341,	0,0,	0,0,	
0,0,	0,0,	0,0,	3957,3341,	
3957,3343,	0,0,	3957,3341,	0,0,	
3957,3341,	0,0,	3957,3341,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3957,3341,	4150,4170,	4150,3268,	
4150,3268,	4150,3268,	4150,3268,	4150,3268,	
4150,3268,	4150,3268,	4150,3268,	4150,3268,	
4150,3268,	4150,3268,	4150,3268,	4150,3268,	
4150,3268,	4150,3268,	4150,3268,	4150,3268,	
4150,3268,	4150,3268,	4150,3268,	4150,3268,	
4150,3268,	4150,3268,	4150,3268,	4150,3268,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3957,3341,	
0,0,	3957,3341,	0,0,	3957,3993,	
3957,3341,	3957,3341,	3957,3341,	3957,3341,	
3957,3341,	3957,3341,	3957,3341,	3957,3341,	
3957,3341,	3957,3341,	3957,3341,	3957,3341,	
3957,3341,	3957,3341,	3957,3341,	3957,3341,	
3957,3341,	3957,3341,	3957,3341,	3957,3341,	
3957,3341,	3957,3341,	3957,3341,	3957,3341,	
3957,3341,	3957,3407,	3959,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3959,2649,	3959,2650,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3963,3351,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3963,3351,	3963,3352,	0,0,	
0,0,	0,0,	3959,2649,	3959,3995,	
0,0,	3959,2649,	0,0,	3959,2649,	
0,0,	3959,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3959,2649,	0,0,	0,0,	3963,3351,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3963,3351,	3963,3353,	0,0,	
3963,3351,	0,0,	3963,3351,	0,0,	
3963,3351,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3963,3351,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3959,2649,	0,0,	
3959,2649,	0,0,	3959,2649,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3963,3351,	0,0,	3963,3351,	
3959,2718,	3963,3998,	3963,3351,	3963,3351,	
3963,3351,	3963,3351,	3963,3351,	3963,3351,	
3963,3351,	3963,3351,	3963,3351,	3963,3351,	
3963,3351,	3963,3351,	3963,3351,	3963,3351,	
3963,3351,	3963,3351,	3963,3351,	3963,3351,	
3963,3351,	3963,3351,	3963,3351,	3963,3351,	
3963,3351,	3963,3351,	3963,3351,	3963,3416,	
3969,3364,	0,0,	0,0,	0,0,	
4153,3343,	0,0,	0,0,	0,0,	
3969,3364,	3969,3365,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3969,3364,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3969,3364,	3969,3366,	0,0,	3969,3364,	
0,0,	3969,3364,	0,0,	3969,3364,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3969,3364,	4153,4173,	
4153,3341,	4153,3341,	4153,3341,	4153,3341,	
4153,3341,	4153,3341,	4153,3341,	4153,3341,	
4153,3341,	4153,3341,	4153,3341,	4153,3341,	
4153,3341,	4153,3341,	4153,3341,	4153,3341,	
4153,3341,	4153,3341,	4153,3341,	4153,3341,	
4153,3341,	4153,3341,	4153,3341,	4153,3341,	
4153,3341,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3969,3364,	0,0,	3969,3364,	0,0,	
3969,4003,	3969,3364,	3969,3364,	3969,3364,	
3969,3364,	3969,3364,	3969,3364,	3969,3364,	
3969,3364,	3969,3364,	3969,3364,	3969,3364,	
3969,3364,	3969,3364,	3969,3364,	3969,3364,	
3969,3364,	3969,3364,	3969,3364,	3969,3364,	
3969,3364,	3969,3364,	3969,3364,	3969,3364,	
3969,3364,	3969,3364,	3969,3427,	3971,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3971,2856,	
3971,2857,	3972,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3972,2739,	3972,2797,	3974,2548,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3974,2678,	
3974,2606,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3971,2856,	
3971,2858,	0,0,	3971,2856,	0,0,	
3971,2856,	0,0,	3971,2856,	0,0,	
0,0,	3972,2798,	3972,2799,	0,0,	
3972,2739,	0,0,	3972,2739,	0,0,	
3972,2739,	3971,2859,	0,0,	3974,2607,	
3974,2608,	0,0,	3974,2548,	0,0,	
3974,2548,	0,0,	3974,2548,	3972,2800,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3974,2609,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3971,2856,	
0,0,	3971,2856,	0,0,	3971,2856,	
0,0,	0,0,	0,0,	3977,3379,	
0,0,	3972,2739,	0,0,	3972,2739,	
4157,3353,	3972,2739,	3971,4005,	3977,3379,	
3977,3380,	0,0,	0,0,	3974,2548,	
0,0,	3974,2548,	0,0,	3974,2548,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3971,2916,	0,0,	3972,4006,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3972,2739,	
0,0,	3977,3379,	0,0,	0,0,	
0,0,	0,0,	0,0,	3977,3379,	
3977,3381,	3974,2548,	3977,3379,	0,0,	
3977,3379,	0,0,	3977,3379,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3977,3379,	0,0,	4157,4177,	
4157,3351,	4157,3351,	4157,3351,	4157,3351,	
4157,3351,	4157,3351,	4157,3351,	4157,3351,	
4157,3351,	4157,3351,	4157,3351,	4157,3351,	
4157,3351,	4157,3351,	4157,3351,	4157,3351,	
4157,3351,	4157,3351,	4157,3351,	4157,3351,	
4157,3351,	4157,3351,	4157,3351,	4157,3351,	
4157,3351,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	3977,3379,	
0,0,	3977,3379,	0,0,	3977,4010,	
3977,3379,	3977,3379,	3977,3379,	3977,3379,	
3977,3379,	3977,3379,	3977,3379,	3977,3379,	
3977,3379,	3977,3379,	3977,3379,	3977,3379,	
3977,3379,	3977,3379,	3977,3379,	3977,3379,	
3977,3379,	3977,3379,	3977,3379,	3977,3379,	
3977,3379,	3977,3379,	3977,3379,	3977,3379,	
3977,3379,	3977,3440,	3987,3397,	0,0,	
0,0,	0,0,	4161,3366,	0,0,	
0,0,	0,0,	3987,3397,	3987,3398,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3987,3397,	0,0,	0,0,	0,0,	
0,0,	0,0,	3987,3397,	3987,3399,	
0,0,	3987,3397,	0,0,	3987,3397,	
0,0,	3987,3397,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
3987,3397,	4161,4181,	4161,3364,	4161,3364,	
4161,3364,	4161,3364,	4161,3364,	4161,3364,	
4161,3364,	4161,3364,	4161,3364,	4161,3364,	
4161,3364,	4161,3364,	4161,3364,	4161,3364,	
4161,3364,	4161,3364,	4161,3364,	4161,3364,	
4161,3364,	4161,3364,	4161,3364,	4161,3364,	
4161,3364,	4161,3364,	4161,3364,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	3987,3397,	0,0,	
3987,3397,	0,0,	3987,4018,	3987,3397,	
3987,3397,	3987,3397,	3987,3397,	3987,3397,	
3987,3397,	3987,3397,	3987,3397,	3987,3397,	
3987,3397,	3987,3397,	3987,3397,	3987,3397,	
3987,3397,	3987,3397,	3987,3397,	3987,3397,	
3987,3397,	3987,3397,	3987,3397,	3987,3397,	
3987,3397,	3987,3397,	3987,3397,	3987,3397,	
3987,3457,	3995,2649,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	3995,2719,	3995,2650,	4005,2856,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4005,2856,	
4005,2857,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4006,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4006,2739,	4006,2797,	
0,0,	3995,2649,	3995,2651,	0,0,	
3995,2649,	0,0,	3995,2649,	0,0,	
3995,2649,	0,0,	0,0,	4005,2856,	
4005,2858,	0,0,	4005,2856,	0,0,	
4005,2856,	0,0,	4005,2856,	3995,2649,	
0,0,	4006,4034,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4005,2859,	4006,2798,	4006,2799,	
0,0,	4006,2739,	0,0,	4006,2739,	
0,0,	4006,2739,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4006,2800,	0,0,	0,0,	0,0,	
0,0,	3995,2649,	0,0,	3995,2649,	
0,0,	3995,2649,	0,0,	0,0,	
4033,2856,	0,0,	0,0,	4005,2856,	
0,0,	4005,2856,	0,0,	4005,2856,	
4033,2856,	4033,2857,	4034,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4034,2739,	4034,2797,	
4057,2856,	0,0,	4006,2739,	3995,2718,	
4006,2739,	4005,4033,	4006,2739,	0,0,	
4057,2856,	4057,2857,	0,0,	4033,4057,	
0,0,	4005,2916,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4033,2856,	4033,2858,	0,0,	4033,2856,	
0,0,	4033,2856,	0,0,	4033,2856,	
0,0,	0,0,	4034,2798,	4034,4058,	
4006,2739,	4034,2739,	0,0,	4034,2739,	
0,0,	4034,2739,	4033,2859,	0,0,	
4057,2856,	4057,4081,	0,0,	4057,2856,	
0,0,	4057,2856,	0,0,	4057,2856,	
4034,2800,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4057,2859,	0,0,	
4058,2739,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4058,2860,	4058,2797,	4081,2856,	0,0,	
4033,2856,	0,0,	4033,2856,	0,0,	
4033,2856,	0,0,	4081,2917,	4081,2857,	
0,0,	0,0,	4034,2739,	0,0,	
4034,2739,	0,0,	4034,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4057,2856,	0,0,	4057,2856,	0,0,	
4057,2856,	0,0,	0,0,	0,0,	
4058,2798,	4058,2799,	4033,2916,	4058,2739,	
0,0,	4058,2739,	0,0,	4058,2739,	
0,0,	0,0,	4081,2856,	4081,2858,	
4034,2739,	4081,2856,	0,0,	4081,2856,	
0,0,	4081,2856,	4058,2800,	0,0,	
0,0,	0,0,	4057,2916,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4081,2859,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4165,3381,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4058,2739,	0,0,	4058,2739,	0,0,	
4058,2739,	0,0,	0,0,	0,0,	
0,0,	0,0,	4081,2856,	0,0,	
4081,2856,	4169,3399,	4081,2856,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4058,2739,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4081,2916,	4165,4185,	4165,3379,	4165,3379,	
4165,3379,	4165,3379,	4165,3379,	4165,3379,	
4165,3379,	4165,3379,	4165,3379,	4165,3379,	
4165,3379,	4165,3379,	4165,3379,	4165,3379,	
4165,3379,	4165,3379,	4165,3379,	4165,3379,	
4165,3379,	4165,3379,	4165,3379,	4165,3379,	
4165,3379,	4165,3379,	4165,3379,	0,0,	
4169,4189,	4169,3397,	4169,3397,	4169,3397,	
4169,3397,	4169,3397,	4169,3397,	4169,3397,	
4169,3397,	4169,3397,	4169,3397,	4169,3397,	
4169,3397,	4169,3397,	4169,3397,	4169,3397,	
4169,3397,	4169,3397,	4169,3397,	4169,3397,	
4169,3397,	4169,3397,	4169,3397,	4169,3397,	
4169,3397,	4169,3397,	4171,3746,	0,0,	
0,0,	0,0,	4296,3792,	0,0,	
0,0,	0,0,	4171,3746,	4171,3791,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4171,3746,	0,0,	0,0,	0,0,	
0,0,	0,0,	4171,3746,	4171,3792,	
0,0,	4171,3746,	0,0,	4171,3746,	
0,0,	4171,3746,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4171,3746,	4296,4306,	4296,3746,	4296,3746,	
4296,3746,	4296,3746,	4296,3746,	4296,3746,	
4296,3746,	4296,3746,	4296,3746,	4296,3746,	
4296,3746,	4296,3746,	4296,3746,	4296,3746,	
4296,3746,	4296,3746,	4296,3746,	4296,3746,	
4296,3746,	4296,3746,	4296,3746,	4296,3746,	
4296,3746,	4296,3746,	4296,3746,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4171,3746,	0,0,	
4171,3746,	0,0,	4171,4191,	4171,3746,	
4171,3746,	4171,3746,	4171,3746,	4171,3746,	
4171,3746,	4171,3746,	4171,3746,	4171,3746,	
4171,3746,	4171,3746,	4171,3746,	4171,3746,	
4171,3746,	4171,3746,	4171,3746,	4171,3746,	
4171,3746,	4171,3746,	4171,3746,	4171,3746,	
4171,3746,	4171,3746,	4171,3746,	4171,3746,	
4171,3746,	4175,3753,	0,0,	0,0,	
0,0,	4298,3799,	0,0,	0,0,	
0,0,	4175,3753,	4175,3798,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4175,3753,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4175,3753,	4175,3799,	0,0,	
4175,3753,	0,0,	4175,3753,	0,0,	
4175,3753,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4175,3753,	
4298,4308,	4298,3753,	4298,3753,	4298,3753,	
4298,3753,	4298,3753,	4298,3753,	4298,3753,	
4298,3753,	4298,3753,	4298,3753,	4298,3753,	
4298,3753,	4298,3753,	4298,3753,	4298,3753,	
4298,3753,	4298,3753,	4298,3753,	4298,3753,	
4298,3753,	4298,3753,	4298,3753,	4298,3753,	
4298,3753,	4298,3753,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4175,3753,	0,0,	4175,3753,	
0,0,	4175,4195,	4175,3753,	4175,3753,	
4175,3753,	4175,3753,	4175,3753,	4175,3753,	
4175,3753,	4175,3753,	4175,3753,	4175,3753,	
4175,3753,	4175,3753,	4175,3753,	4175,3753,	
4175,3753,	4175,3753,	4175,3753,	4175,3753,	
4175,3753,	4175,3753,	4175,3753,	4175,3753,	
4175,3753,	4175,3753,	4175,3753,	4175,3753,	
4179,3805,	0,0,	0,0,	0,0,	
4300,3807,	0,0,	0,0,	0,0,	
4179,3805,	4179,3806,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4179,3805,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4179,3805,	4179,3807,	0,0,	4179,3805,	
0,0,	4179,3805,	0,0,	4179,3805,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4179,3805,	4300,4310,	
4300,3805,	4300,3805,	4300,3805,	4300,3805,	
4300,3805,	4300,3805,	4300,3805,	4300,3805,	
4300,3805,	4300,3805,	4300,3805,	4300,3805,	
4300,3805,	4300,3805,	4300,3805,	4300,3805,	
4300,3805,	4300,3805,	4300,3805,	4300,3805,	
4300,3805,	4300,3805,	4300,3805,	4300,3805,	
4300,3805,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4179,3805,	0,0,	4179,3805,	0,0,	
4179,4199,	4179,3805,	4179,3805,	4179,3805,	
4179,3805,	4179,3805,	4179,3805,	4179,3805,	
4179,3805,	4179,3805,	4179,3805,	4179,3805,	
4179,3805,	4179,3805,	4179,3805,	4179,3805,	
4179,3805,	4179,3805,	4179,3805,	4179,3805,	
4179,3805,	4179,3805,	4179,3805,	4179,3805,	
4179,3805,	4179,3805,	4179,3805,	4183,3816,	
0,0,	0,0,	0,0,	4302,3818,	
0,0,	0,0,	0,0,	4183,3816,	
4183,3817,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4183,3816,	0,0,	0,0,	
0,0,	0,0,	0,0,	4183,3816,	
4183,3818,	0,0,	4183,3816,	0,0,	
4183,3816,	0,0,	4183,3816,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4183,3816,	4302,4312,	4302,3816,	
4302,3816,	4302,3816,	4302,3816,	4302,3816,	
4302,3816,	4302,3816,	4302,3816,	4302,3816,	
4302,3816,	4302,3816,	4302,3816,	4302,3816,	
4302,3816,	4302,3816,	4302,3816,	4302,3816,	
4302,3816,	4302,3816,	4302,3816,	4302,3816,	
4302,3816,	4302,3816,	4302,3816,	4302,3816,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4183,3816,	
0,0,	4183,3816,	0,0,	4183,4203,	
4183,3816,	4183,3816,	4183,3816,	4183,3816,	
4183,3816,	4183,3816,	4183,3816,	4183,3816,	
4183,3816,	4183,3816,	4183,3816,	4183,3816,	
4183,3816,	4183,3816,	4183,3816,	4183,3816,	
4183,3816,	4183,3816,	4183,3816,	4183,3816,	
4183,3816,	4183,3816,	4183,3816,	4183,3816,	
4183,3816,	4183,3816,	4187,3784,	0,0,	
0,0,	0,0,	4304,3830,	0,0,	
0,0,	0,0,	4187,3784,	4187,3829,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4187,3784,	0,0,	0,0,	0,0,	
0,0,	0,0,	4187,3784,	4187,3830,	
0,0,	4187,3784,	0,0,	4187,3784,	
0,0,	4187,3784,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4187,3784,	4304,4314,	4304,3784,	4304,3784,	
4304,3784,	4304,3784,	4304,3784,	4304,3784,	
4304,3784,	4304,3784,	4304,3784,	4304,3784,	
4304,3784,	4304,3784,	4304,3784,	4304,3784,	
4304,3784,	4304,3784,	4304,3784,	4304,3784,	
4304,3784,	4304,3784,	4304,3784,	4304,3784,	
4304,3784,	4304,3784,	4304,3784,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4187,3784,	0,0,	
4187,3784,	0,0,	4187,4207,	4187,3784,	
4187,3784,	4187,3784,	4187,3784,	4187,3784,	
4187,3784,	4187,3784,	4187,3784,	4187,3784,	
4187,3784,	4187,3784,	4187,3784,	4187,3784,	
4187,3784,	4187,3784,	4187,3784,	4187,3784,	
4187,3784,	4187,3784,	4187,3784,	4187,3784,	
4187,3784,	4187,3784,	4187,3784,	4187,3784,	
4187,3784,	4212,3837,	0,0,	0,0,	
0,0,	4317,3876,	0,0,	0,0,	
0,0,	4212,3837,	4212,3875,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4212,3837,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4212,3837,	4212,3876,	0,0,	
4212,3837,	0,0,	4212,3837,	0,0,	
4212,3837,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4212,3837,	
4317,4327,	4317,3837,	4317,3837,	4317,3837,	
4317,3837,	4317,3837,	4317,3837,	4317,3837,	
4317,3837,	4317,3837,	4317,3837,	4317,3837,	
4317,3837,	4317,3837,	4317,3837,	4317,3837,	
4317,3837,	4317,3837,	4317,3837,	4317,3837,	
4317,3837,	4317,3837,	4317,3837,	4317,3837,	
4317,3837,	4317,3837,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4212,3837,	0,0,	4212,3837,	
0,0,	4212,4232,	4212,3837,	4212,3837,	
4212,3837,	4212,3837,	4212,3837,	4212,3837,	
4212,3837,	4212,3837,	4212,3837,	4212,3837,	
4212,3837,	4212,3837,	4212,3837,	4212,3837,	
4212,3837,	4212,3837,	4212,3837,	4212,3837,	
4212,3837,	4212,3837,	4212,3837,	4212,3837,	
4212,3837,	4212,3837,	4212,3837,	4212,3837,	
4216,3843,	0,0,	0,0,	0,0,	
4319,3883,	0,0,	0,0,	0,0,	
4216,3843,	4216,3882,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4216,3843,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4216,3843,	4216,3883,	0,0,	4216,3843,	
0,0,	4216,3843,	0,0,	4216,3843,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4216,3843,	4319,4329,	
4319,3843,	4319,3843,	4319,3843,	4319,3843,	
4319,3843,	4319,3843,	4319,3843,	4319,3843,	
4319,3843,	4319,3843,	4319,3843,	4319,3843,	
4319,3843,	4319,3843,	4319,3843,	4319,3843,	
4319,3843,	4319,3843,	4319,3843,	4319,3843,	
4319,3843,	4319,3843,	4319,3843,	4319,3843,	
4319,3843,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4216,3843,	0,0,	4216,3843,	0,0,	
4216,4236,	4216,3843,	4216,3843,	4216,3843,	
4216,3843,	4216,3843,	4216,3843,	4216,3843,	
4216,3843,	4216,3843,	4216,3843,	4216,3843,	
4216,3843,	4216,3843,	4216,3843,	4216,3843,	
4216,3843,	4216,3843,	4216,3843,	4216,3843,	
4216,3843,	4216,3843,	4216,3843,	4216,3843,	
4216,3843,	4216,3843,	4216,3843,	4220,3889,	
0,0,	0,0,	0,0,	4321,3891,	
0,0,	0,0,	0,0,	4220,3889,	
4220,3890,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4220,3889,	0,0,	0,0,	
0,0,	0,0,	0,0,	4220,3889,	
4220,3891,	0,0,	4220,3889,	0,0,	
4220,3889,	0,0,	4220,3889,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4220,3889,	4321,4331,	4321,3889,	
4321,3889,	4321,3889,	4321,3889,	4321,3889,	
4321,3889,	4321,3889,	4321,3889,	4321,3889,	
4321,3889,	4321,3889,	4321,3889,	4321,3889,	
4321,3889,	4321,3889,	4321,3889,	4321,3889,	
4321,3889,	4321,3889,	4321,3889,	4321,3889,	
4321,3889,	4321,3889,	4321,3889,	4321,3889,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4220,3889,	
0,0,	4220,3889,	0,0,	4220,4240,	
4220,3889,	4220,3889,	4220,3889,	4220,3889,	
4220,3889,	4220,3889,	4220,3889,	4220,3889,	
4220,3889,	4220,3889,	4220,3889,	4220,3889,	
4220,3889,	4220,3889,	4220,3889,	4220,3889,	
4220,3889,	4220,3889,	4220,3889,	4220,3889,	
4220,3889,	4220,3889,	4220,3889,	4220,3889,	
4220,3889,	4220,3889,	4224,3900,	0,0,	
0,0,	0,0,	4323,3902,	0,0,	
0,0,	0,0,	4224,3900,	4224,3901,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4224,3900,	0,0,	0,0,	0,0,	
0,0,	0,0,	4224,3900,	4224,3902,	
0,0,	4224,3900,	0,0,	4224,3900,	
0,0,	4224,3900,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
4224,3900,	4323,4333,	4323,3900,	4323,3900,	
4323,3900,	4323,3900,	4323,3900,	4323,3900,	
4323,3900,	4323,3900,	4323,3900,	4323,3900,	
4323,3900,	4323,3900,	4323,3900,	4323,3900,	
4323,3900,	4323,3900,	4323,3900,	4323,3900,	
4323,3900,	4323,3900,	4323,3900,	4323,3900,	
4323,3900,	4323,3900,	4323,3900,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	4224,3900,	0,0,	
4224,3900,	0,0,	4224,4244,	4224,3900,	
4224,3900,	4224,3900,	4224,3900,	4224,3900,	
4224,3900,	4224,3900,	4224,3900,	4224,3900,	
4224,3900,	4224,3900,	4224,3900,	4224,3900,	
4224,3900,	4224,3900,	4224,3900,	4224,3900,	
4224,3900,	4224,3900,	4224,3900,	4224,3900,	
4224,3900,	4224,3900,	4224,3900,	4224,3900,	
4224,3900,	4228,3869,	0,0,	0,0,	
0,0,	4325,3914,	0,0,	0,0,	
0,0,	4228,3869,	4228,3913,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4228,3869,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4228,3869,	4228,3914,	0,0,	
4228,3869,	0,0,	4228,3869,	0,0,	
4228,3869,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	4228,3869,	
4325,4335,	4325,3869,	4325,3869,	4325,3869,	
4325,3869,	4325,3869,	4325,3869,	4325,3869,	
4325,3869,	4325,3869,	4325,3869,	4325,3869,	
4325,3869,	4325,3869,	4325,3869,	4325,3869,	
4325,3869,	4325,3869,	4325,3869,	4325,3869,	
4325,3869,	4325,3869,	4325,3869,	4325,3869,	
4325,3869,	4325,3869,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	4228,3869,	0,0,	4228,3869,	
0,0,	4228,4248,	4228,3869,	4228,3869,	
4228,3869,	4228,3869,	4228,3869,	4228,3869,	
4228,3869,	4228,3869,	4228,3869,	4228,3869,	
4228,3869,	4228,3869,	4228,3869,	4228,3869,	
4228,3869,	4228,3869,	4228,3869,	4228,3869,	
4228,3869,	4228,3869,	4228,3869,	4228,3869,	
4228,3869,	4228,3869,	4228,3869,	4228,3869,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		yyvstop+1,
yycrank+-10,	yysvec+1,	yyvstop+3,
yycrank+-28,	0,		yyvstop+5,
yycrank+-12,	yysvec+3,	yyvstop+8,
yycrank+-96,	yysvec+1,	yyvstop+11,
yycrank+-121,	yysvec+1,	yyvstop+13,
yycrank+-165,	yysvec+1,	yyvstop+15,
yycrank+-190,	yysvec+1,	yyvstop+17,
yycrank+-53,	yysvec+1,	yyvstop+19,
yycrank+-141,	yysvec+1,	yyvstop+21,
yycrank+-205,	yysvec+1,	yyvstop+23,
yycrank+-221,	yysvec+1,	yyvstop+25,
yycrank+-156,	yysvec+1,	yyvstop+27,
yycrank+-181,	yysvec+1,	yyvstop+29,
yycrank+-292,	yysvec+1,	yyvstop+31,
yycrank+-306,	yysvec+1,	yyvstop+33,
yycrank+-395,	0,		yyvstop+35,
yycrank+0,	0,		yyvstop+37,
yycrank+-8,	yysvec+17,	yyvstop+39,
yycrank+-9,	yysvec+17,	yyvstop+41,
yycrank+-16,	yysvec+17,	yyvstop+43,
yycrank+-14,	yysvec+17,	yyvstop+45,
yycrank+-22,	yysvec+17,	yyvstop+47,
yycrank+-24,	yysvec+17,	yyvstop+49,
yycrank+-407,	0,		yyvstop+51,
yycrank+0,	0,		yyvstop+54,
yycrank+-13,	yysvec+25,	yyvstop+57,
yycrank+-19,	yysvec+25,	yyvstop+60,
yycrank+-35,	yysvec+25,	yyvstop+63,
yycrank+-25,	yysvec+25,	yyvstop+66,
yycrank+-29,	yysvec+25,	yyvstop+69,
yycrank+-36,	yysvec+25,	yyvstop+72,
yycrank+-20,	yysvec+17,	yyvstop+75,
yycrank+-31,	yysvec+17,	yyvstop+78,
yycrank+-266,	yysvec+17,	yyvstop+81,
yycrank+-23,	yysvec+17,	yyvstop+84,
yycrank+-327,	yysvec+17,	yyvstop+87,
yycrank+-336,	yysvec+17,	yyvstop+90,
yycrank+-415,	yysvec+17,	yyvstop+93,
yycrank+-416,	yysvec+17,	yyvstop+96,
yycrank+-72,	yysvec+17,	yyvstop+99,
yycrank+75,	0,		yyvstop+102,
yycrank+-106,	yysvec+17,	yyvstop+105,
yycrank+-131,	yysvec+17,	yyvstop+108,
yycrank+-140,	yysvec+17,	yyvstop+111,
yycrank+-142,	yysvec+17,	yyvstop+114,
yycrank+-150,	yysvec+17,	yyvstop+117,
yycrank+-425,	yysvec+17,	yyvstop+120,
yycrank+-160,	yysvec+17,	yyvstop+123,
yycrank+-437,	yysvec+17,	yyvstop+126,
yycrank+-167,	yysvec+17,	yyvstop+129,
yycrank+-175,	yysvec+17,	yyvstop+131,
yycrank+-449,	yysvec+17,	yyvstop+134,
yycrank+-489,	yysvec+17,	yyvstop+137,
yycrank+-505,	yysvec+17,	yyvstop+140,
yycrank+-516,	yysvec+17,	yyvstop+143,
yycrank+-230,	yysvec+17,	yyvstop+146,
yycrank+-233,	yysvec+17,	yyvstop+148,
yycrank+-257,	yysvec+17,	yyvstop+150,
yycrank+-235,	yysvec+17,	yyvstop+152,
yycrank+-286,	yysvec+17,	yyvstop+154,
yycrank+-261,	yysvec+17,	yyvstop+156,
yycrank+-466,	yysvec+17,	yyvstop+158,
yycrank+-523,	yysvec+17,	yyvstop+160,
yycrank+-526,	yysvec+17,	yyvstop+162,
yycrank+-531,	yysvec+17,	yyvstop+164,
yycrank+-540,	yysvec+17,	yyvstop+166,
yycrank+-346,	yysvec+17,	yyvstop+168,
yycrank+-301,	yysvec+17,	yyvstop+170,
yycrank+-313,	yysvec+17,	yyvstop+172,
yycrank+-334,	yysvec+17,	yyvstop+174,
yycrank+-278,	yysvec+17,	yyvstop+176,
yycrank+-615,	0,		yyvstop+179,
yycrank+-37,	yysvec+73,	yyvstop+181,
yycrank+-38,	yysvec+73,	yyvstop+183,
yycrank+-46,	yysvec+73,	yyvstop+185,
yycrank+-44,	yysvec+73,	yyvstop+187,
yycrank+-49,	yysvec+73,	yyvstop+189,
yycrank+-61,	yysvec+73,	yyvstop+191,
yycrank+-282,	yysvec+17,	0,	
yycrank+-322,	yysvec+17,	0,	
yycrank+-349,	yysvec+17,	0,	
yycrank+-477,	yysvec+17,	0,	
yycrank+-352,	yysvec+17,	0,	
yycrank+-356,	yysvec+17,	0,	
yycrank+-436,	yysvec+17,	0,	
yycrank+-307,	yysvec+17,	0,	
yycrank+-41,	yysvec+25,	yyvstop+193,
yycrank+0,	0,		yyvstop+195,
yycrank+-84,	yysvec+25,	yyvstop+197,
yycrank+-242,	yysvec+25,	yyvstop+199,
yycrank+-461,	yysvec+25,	yyvstop+201,
yycrank+-77,	yysvec+25,	yyvstop+203,
yycrank+-50,	yysvec+25,	yyvstop+205,
yycrank+-62,	yysvec+25,	yyvstop+207,
yycrank+-145,	yysvec+25,	yyvstop+209,
yycrank+-545,	yysvec+17,	0,	
yycrank+-325,	yysvec+17,	yyvstop+211,
yycrank+-620,	yysvec+17,	0,	
yycrank+-557,	yysvec+17,	0,	
yycrank+-623,	yysvec+17,	0,	
yycrank+-633,	yysvec+17,	0,	
yycrank+-371,	yysvec+17,	yyvstop+213,
yycrank+0,	yysvec+42,	yyvstop+215,
yycrank+-634,	yysvec+17,	yyvstop+217,
yycrank+-712,	yysvec+17,	0,	
yycrank+-731,	yysvec+17,	0,	
yycrank+-654,	yysvec+17,	yyvstop+219,
yycrank+-332,	yysvec+17,	yyvstop+221,
yycrank+-717,	yysvec+17,	yyvstop+223,
yycrank+-732,	yysvec+17,	yyvstop+225,
yycrank+-745,	yysvec+17,	yyvstop+227,
yycrank+-752,	yysvec+17,	yyvstop+229,
yycrank+-566,	yysvec+17,	0,	
yycrank+-821,	0,		0,	
yycrank+-367,	yysvec+17,	0,	
yycrank+-539,	yysvec+17,	0,	
yycrank+-528,	yysvec+17,	0,	
yycrank+-850,	0,		0,	
yycrank+-773,	yysvec+17,	0,	
yycrank+-360,	yysvec+17,	yyvstop+231,
yycrank+-810,	yysvec+17,	0,	
yycrank+-835,	yysvec+17,	0,	
yycrank+-862,	yysvec+17,	0,	
yycrank+-869,	yysvec+17,	0,	
yycrank+-939,	0,		0,	
yycrank+-568,	yysvec+17,	0,	
yycrank+-556,	yysvec+17,	0,	
yycrank+-418,	yysvec+17,	0,	
yycrank+-47,	yysvec+73,	0,	
yycrank+0,	0,		yyvstop+233,
yycrank+-288,	yysvec+73,	0,	
yycrank+-456,	yysvec+73,	0,	
yycrank+-651,	yysvec+73,	0,	
yycrank+-192,	yysvec+73,	0,	
yycrank+-178,	yysvec+73,	0,	
yycrank+-318,	yysvec+73,	0,	
yycrank+-337,	yysvec+73,	0,	
yycrank+-648,	yysvec+17,	0,	
yycrank+-734,	yysvec+17,	0,	
yycrank+-927,	yysvec+17,	0,	
yycrank+-628,	yysvec+17,	0,	
yycrank+-667,	yysvec+17,	0,	
yycrank+-674,	yysvec+17,	0,	
yycrank+-562,	yysvec+17,	0,	
yycrank+-153,	yysvec+25,	yyvstop+235,
yycrank+-636,	yysvec+25,	yyvstop+237,
yycrank+-929,	yysvec+25,	yyvstop+239,
yycrank+-377,	yysvec+25,	yyvstop+241,
yycrank+-379,	yysvec+25,	yyvstop+243,
yycrank+-482,	yysvec+25,	yyvstop+245,
yycrank+-66,	yysvec+25,	yyvstop+247,
yycrank+-910,	yysvec+17,	0,	
yycrank+-976,	yysvec+17,	0,	
yycrank+-983,	yysvec+17,	0,	
yycrank+-1053,	yysvec+17,	0,	
yycrank+-1078,	0,		0,	
yycrank+-1088,	0,		0,	
yycrank+-459,	yysvec+157,	0,	
yycrank+-1145,	0,		0,	
yycrank+-1159,	0,		0,	
yycrank+-550,	yysvec+160,	0,	
yycrank+-1054,	yysvec+17,	yyvstop+249,
yycrank+-1066,	yysvec+17,	yyvstop+251,
yycrank+-1130,	yysvec+17,	yyvstop+253,
yycrank+-1093,	yysvec+17,	yyvstop+255,
yycrank+-740,	yysvec+17,	0,	
yycrank+-1225,	0,		0,	
yycrank+-832,	yysvec+168,	0,	
yycrank+410,	0,		0,	
yycrank+-1208,	yysvec+168,	0,	
yycrank+-790,	yysvec+168,	0,	
yycrank+-808,	yysvec+17,	0,	
yycrank+-774,	yysvec+17,	0,	
yycrank+-771,	yysvec+17,	0,	
yycrank+-1248,	0,		0,	
yycrank+-1219,	yysvec+176,	0,	
yycrank+559,	0,		0,	
yycrank+-1238,	yysvec+176,	0,	
yycrank+-797,	yysvec+176,	0,	
yycrank+-1111,	yysvec+17,	0,	
yycrank+-1255,	yysvec+17,	0,	
yycrank+-1262,	yysvec+17,	0,	
yycrank+-1267,	yysvec+17,	0,	
yycrank+-691,	yysvec+17,	0,	
yycrank+-815,	yysvec+17,	0,	
yycrank+-861,	yysvec+17,	0,	
yycrank+-836,	yysvec+17,	0,	
yycrank+-353,	yysvec+73,	0,	
yycrank+-1272,	yysvec+73,	0,	
yycrank+-1319,	yysvec+73,	0,	
yycrank+-555,	yysvec+73,	0,	
yycrank+-597,	yysvec+73,	0,	
yycrank+-605,	yysvec+73,	0,	
yycrank+-173,	yysvec+73,	0,	
yycrank+-887,	yysvec+17,	0,	
yycrank+-866,	yysvec+17,	0,	
yycrank+-912,	yysvec+17,	0,	
yycrank+-892,	yysvec+17,	0,	
yycrank+-883,	yysvec+17,	0,	
yycrank+-913,	yysvec+17,	0,	
yycrank+-725,	yysvec+17,	0,	
yycrank+-921,	yysvec+17,	0,	
yycrank+-923,	yysvec+17,	0,	
yycrank+-967,	yysvec+17,	0,	
yycrank+-139,	yysvec+25,	yyvstop+257,
yycrank+-439,	yysvec+25,	yyvstop+259,
yycrank+-481,	yysvec+25,	yyvstop+261,
yycrank+-148,	yysvec+25,	yyvstop+263,
yycrank+-769,	yysvec+25,	yyvstop+265,
yycrank+-645,	yysvec+25,	yyvstop+267,
yycrank+-440,	yysvec+25,	yyvstop+269,
yycrank+-330,	yysvec+25,	yyvstop+271,
yycrank+-692,	yysvec+25,	yyvstop+273,
yycrank+-590,	yysvec+25,	yyvstop+275,
yycrank+-1288,	yysvec+17,	0,	
yycrank+-1327,	yysvec+17,	0,	
yycrank+-1334,	yysvec+17,	0,	
yycrank+-1355,	yysvec+17,	0,	
yycrank+-754,	yysvec+17,	yyvstop+277,
yycrank+0,	0,		yyvstop+279,
yycrank+-937,	yysvec+157,	0,	
yycrank+-925,	yysvec+17,	yyvstop+281,
yycrank+-1397,	yysvec+160,	0,	
yycrank+0,	0,		yyvstop+283,
yycrank+-1403,	yysvec+161,	0,	
yycrank+-1073,	yysvec+160,	0,	
yycrank+-1368,	yysvec+17,	yyvstop+285,
yycrank+-1418,	yysvec+17,	yyvstop+287,
yycrank+-1432,	yysvec+17,	yyvstop+289,
yycrank+-1443,	yysvec+17,	yyvstop+291,
yycrank+-1075,	yysvec+17,	0,	
yycrank+-535,	yysvec+168,	0,	
yycrank+-644,	yysvec+168,	0,	
yycrank+-577,	yysvec+168,	0,	
yycrank+-1460,	0,		0,	
yycrank+-900,	yysvec+168,	0,	
yycrank+139,	0,		0,	
yycrank+-877,	yysvec+168,	0,	
yycrank+-1083,	yysvec+168,	0,	
yycrank+-182,	yysvec+168,	yyvstop+293,
yycrank+-1023,	yysvec+17,	0,	
yycrank+-1062,	yysvec+17,	0,	
yycrank+-1132,	yysvec+17,	0,	
yycrank+-650,	yysvec+176,	0,	
yycrank+-657,	yysvec+176,	0,	
yycrank+-755,	yysvec+176,	0,	
yycrank+-969,	yysvec+176,	0,	
yycrank+272,	0,		0,	
yycrank+-908,	yysvec+176,	0,	
yycrank+-1096,	yysvec+176,	0,	
yycrank+-329,	yysvec+176,	yyvstop+295,
yycrank+-1495,	yysvec+17,	0,	
yycrank+-1502,	yysvec+17,	0,	
yycrank+-1546,	yysvec+17,	0,	
yycrank+-1575,	yysvec+17,	0,	
yycrank+-1586,	yysvec+17,	0,	
yycrank+-1154,	yysvec+17,	0,	
yycrank+-1120,	yysvec+17,	0,	
yycrank+-1202,	yysvec+17,	0,	
yycrank+-655,	yysvec+73,	0,	
yycrank+-964,	yysvec+73,	0,	
yycrank+-777,	yysvec+73,	0,	
yycrank+-919,	yysvec+73,	0,	
yycrank+-1178,	yysvec+73,	0,	
yycrank+-926,	yysvec+73,	0,	
yycrank+-882,	yysvec+73,	0,	
yycrank+-475,	yysvec+73,	0,	
yycrank+-972,	yysvec+73,	0,	
yycrank+-653,	yysvec+73,	0,	
yycrank+-1203,	yysvec+17,	0,	
yycrank+-1182,	yysvec+17,	0,	
yycrank+-1614,	yysvec+126,	0,	
yycrank+-1206,	yysvec+17,	0,	
yycrank+-1101,	yysvec+17,	0,	
yycrank+-1172,	yysvec+17,	0,	
yycrank+-1269,	yysvec+17,	0,	
yycrank+-1222,	yysvec+17,	0,	
yycrank+-1325,	yysvec+17,	0,	
yycrank+-1640,	yysvec+126,	0,	
yycrank+-768,	yysvec+25,	yyvstop+297,
yycrank+-454,	yysvec+25,	yyvstop+299,
yycrank+-1762,	0,		yyvstop+301,
yycrank+-1168,	yysvec+25,	yyvstop+303,
yycrank+-971,	yysvec+25,	yyvstop+305,
yycrank+-512,	yysvec+25,	yyvstop+307,
yycrank+-1026,	yysvec+25,	yyvstop+309,
yycrank+-973,	yysvec+25,	yyvstop+311,
yycrank+-1076,	yysvec+25,	yyvstop+313,
yycrank+-1725,	yysvec+283,	yyvstop+315,
yycrank+-1594,	yysvec+17,	0,	
yycrank+-1806,	yysvec+17,	0,	
yycrank+-1605,	yysvec+17,	0,	
yycrank+-1846,	yysvec+126,	0,	
yycrank+-1074,	yysvec+157,	0,	
yycrank+-1968,	yysvec+160,	0,	
yycrank+-1971,	yysvec+161,	0,	
yycrank+-1978,	yysvec+160,	0,	
yycrank+-1187,	yysvec+160,	0,	
yycrank+-1894,	yysvec+17,	yyvstop+317,
yycrank+-1983,	yysvec+17,	yyvstop+319,
yycrank+-2001,	yysvec+17,	yyvstop+321,
yycrank+-2008,	yysvec+126,	yyvstop+323,
yycrank+-1209,	yysvec+17,	0,	
yycrank+-1188,	yysvec+168,	0,	
yycrank+-2034,	yysvec+236,	0,	
yycrank+-1199,	yysvec+168,	0,	
yycrank+-1211,	yysvec+168,	0,	
yycrank+-1270,	yysvec+168,	0,	
yycrank+-1275,	yysvec+168,	0,	
yycrank+0,	0,		yyvstop+325,
yycrank+-1271,	yysvec+168,	0,	
yycrank+-1217,	yysvec+168,	0,	
yycrank+-1367,	yysvec+17,	0,	
yycrank+-1378,	yysvec+17,	0,	
yycrank+-1474,	yysvec+17,	0,	
yycrank+-1282,	yysvec+176,	0,	
yycrank+-2156,	0,		0,	
yycrank+-1300,	yysvec+176,	0,	
yycrank+-1307,	yysvec+176,	0,	
yycrank+-1284,	yysvec+176,	0,	
yycrank+0,	0,		yyvstop+327,
yycrank+-1309,	yysvec+176,	0,	
yycrank+-1352,	yysvec+176,	0,	
yycrank+-1597,	yysvec+17,	0,	
yycrank+-1960,	yysvec+17,	0,	
yycrank+-1986,	yysvec+17,	0,	
yycrank+-2189,	yysvec+126,	0,	
yycrank+-2311,	0,		0,	
yycrank+-2321,	0,		0,	
yycrank+-886,	yysvec+329,	0,	
yycrank+-1381,	yysvec+17,	0,	
yycrank+-1385,	yysvec+17,	0,	
yycrank+-2348,	yysvec+126,	0,	
yycrank+-1305,	yysvec+73,	0,	
yycrank+-1342,	yysvec+73,	0,	
yycrank+-2378,	0,		0,	
yycrank+-1318,	yysvec+73,	0,	
yycrank+-1369,	yysvec+73,	0,	
yycrank+-1347,	yysvec+73,	0,	
yycrank+-1392,	yysvec+73,	0,	
yycrank+-981,	yysvec+73,	0,	
yycrank+-1398,	yysvec+73,	0,	
yycrank+-2430,	yysvec+337,	0,	
yycrank+-1445,	yysvec+17,	0,	
yycrank+-1497,	yysvec+17,	0,	
yycrank+-1512,	yysvec+17,	0,	
yycrank+-1405,	yysvec+17,	0,	
yycrank+-1591,	yysvec+17,	0,	
yycrank+-1648,	yysvec+17,	0,	
yycrank+-1666,	yysvec+17,	0,	
yycrank+-1596,	yysvec+17,	0,	
yycrank+-1655,	yysvec+17,	0,	
yycrank+-1602,	yysvec+17,	0,	
yycrank+-1429,	yysvec+25,	yyvstop+329,
yycrank+-552,	yysvec+25,	yyvstop+331,
yycrank+-1433,	yysvec+25,	yyvstop+333,
yycrank+-1435,	yysvec+25,	yyvstop+335,
yycrank+-1475,	yysvec+25,	yyvstop+337,
yycrank+-1394,	yysvec+25,	yyvstop+339,
yycrank+-1499,	yysvec+25,	yyvstop+341,
yycrank+-1391,	yysvec+25,	yyvstop+343,
yycrank+-1486,	yysvec+25,	yyvstop+345,
yycrank+-985,	yysvec+25,	yyvstop+347,
yycrank+-2303,	yysvec+17,	0,	
yycrank+-2330,	yysvec+17,	0,	
yycrank+-2464,	yysvec+17,	0,	
yycrank+-2512,	yysvec+17,	0,	
yycrank+-1406,	yysvec+157,	0,	
yycrank+-2556,	0,		0,	
yycrank+-1476,	yysvec+160,	0,	
yycrank+-2546,	yysvec+17,	yyvstop+349,
yycrank+-2553,	yysvec+17,	yyvstop+351,
yycrank+-2566,	yysvec+17,	yyvstop+353,
yycrank+-2577,	yysvec+17,	yyvstop+355,
yycrank+-1657,	yysvec+17,	0,	
yycrank+-1482,	yysvec+168,	0,	
yycrank+-1506,	yysvec+168,	0,	
yycrank+-1510,	yysvec+168,	0,	
yycrank+-2589,	yysvec+236,	0,	
yycrank+-1572,	yysvec+168,	0,	
yycrank+-1415,	yysvec+168,	0,	
yycrank+-1503,	yysvec+168,	0,	
yycrank+-1807,	yysvec+17,	0,	
yycrank+-1659,	yysvec+17,	0,	
yycrank+-1665,	yysvec+17,	0,	
yycrank+-1568,	yysvec+176,	0,	
yycrank+-1589,	yysvec+176,	0,	
yycrank+-1606,	yysvec+176,	0,	
yycrank+-1736,	yysvec+176,	0,	
yycrank+-1737,	yysvec+176,	0,	
yycrank+-1742,	yysvec+176,	0,	
yycrank+-2622,	yysvec+17,	0,	
yycrank+-1991,	yysvec+17,	0,	
yycrank+-2623,	yysvec+17,	0,	
yycrank+-2636,	yysvec+17,	0,	
yycrank+-1615,	yysvec+17,	yyvstop+357,
yycrank+0,	0,		yyvstop+359,
yycrank+-1890,	yysvec+329,	0,	
yycrank+-1809,	yysvec+17,	0,	
yycrank+-1772,	yysvec+17,	0,	
yycrank+-1886,	yysvec+17,	0,	
yycrank+-1560,	yysvec+73,	0,	
yycrank+-1610,	yysvec+73,	0,	
yycrank+-1773,	yysvec+73,	0,	
yycrank+-1873,	yysvec+73,	0,	
yycrank+-1776,	yysvec+73,	0,	
yycrank+-1858,	yysvec+73,	0,	
yycrank+-1876,	yysvec+73,	0,	
yycrank+-1472,	yysvec+73,	0,	
yycrank+-1868,	yysvec+73,	0,	
yycrank+-1569,	yysvec+73,	0,	
yycrank+-1883,	yysvec+17,	0,	
yycrank+-1758,	yysvec+17,	0,	
yycrank+-2673,	yysvec+126,	0,	
yycrank+-1897,	yysvec+17,	0,	
yycrank+-1778,	yysvec+17,	0,	
yycrank+-2706,	yysvec+126,	0,	
yycrank+-1888,	yysvec+17,	0,	
yycrank+-1885,	yysvec+17,	0,	
yycrank+-2828,	yysvec+17,	0,	
yycrank+-1636,	yysvec+17,	0,	
yycrank+-1760,	yysvec+17,	0,	
yycrank+-1402,	yysvec+25,	yyvstop+361,
yycrank+-1618,	yysvec+25,	yyvstop+363,
yycrank+-2788,	yysvec+283,	yyvstop+365,
yycrank+-1576,	yysvec+25,	yyvstop+367,
yycrank+-1086,	yysvec+25,	yyvstop+369,
yycrank+-2869,	yysvec+283,	yyvstop+371,
yycrank+-1377,	yysvec+25,	yyvstop+373,
yycrank+-1875,	yysvec+25,	yyvstop+375,
yycrank+-2917,	yysvec+25,	yyvstop+377,
yycrank+-1204,	yysvec+25,	yyvstop+379,
yycrank+-1743,	yysvec+25,	yyvstop+381,
yycrank+-2754,	yysvec+17,	0,	
yycrank+-2833,	yysvec+17,	0,	
yycrank+-2148,	yysvec+17,	0,	
yycrank+-2825,	yysvec+17,	0,	
yycrank+-1867,	yysvec+157,	0,	
yycrank+-2991,	0,		0,	
yycrank+-1882,	yysvec+160,	0,	
yycrank+-2902,	yysvec+17,	yyvstop+383,
yycrank+-2907,	yysvec+17,	yyvstop+385,
yycrank+-2996,	yysvec+17,	yyvstop+387,
yycrank+-3009,	yysvec+17,	yyvstop+389,
yycrank+-1994,	yysvec+17,	0,	
yycrank+-1638,	yysvec+168,	0,	
yycrank+-2961,	yysvec+236,	0,	
yycrank+-1889,	yysvec+168,	0,	
yycrank+-2055,	yysvec+168,	0,	
yycrank+-1896,	yysvec+168,	0,	
yycrank+-2003,	yysvec+168,	0,	
yycrank+-3043,	yysvec+236,	0,	
yycrank+-2048,	yysvec+17,	0,	
yycrank+-2151,	yysvec+17,	0,	
yycrank+-3088,	yysvec+17,	0,	
yycrank+-3166,	0,		yyvstop+391,
yycrank+-1732,	yysvec+176,	0,	
yycrank+-3129,	yysvec+318,	0,	
yycrank+-2118,	yysvec+176,	0,	
yycrank+-1942,	yysvec+176,	0,	
yycrank+-2120,	yysvec+176,	0,	
yycrank+-3210,	yysvec+318,	0,	
yycrank+-3089,	yysvec+17,	0,	
yycrank+-2306,	yysvec+17,	0,	
yycrank+-2153,	yysvec+17,	0,	
yycrank+-3167,	yysvec+17,	0,	
yycrank+-1770,	yysvec+329,	0,	
yycrank+-2171,	yysvec+17,	0,	
yycrank+-2182,	yysvec+17,	0,	
yycrank+-3332,	0,		0,	
yycrank+-3256,	yysvec+471,	0,	
yycrank+-2058,	yysvec+73,	0,	
yycrank+-1734,	yysvec+73,	0,	
yycrank+-3295,	yysvec+337,	0,	
yycrank+-2126,	yysvec+73,	0,	
yycrank+-2127,	yysvec+73,	0,	
yycrank+-3376,	yysvec+337,	0,	
yycrank+-2129,	yysvec+73,	0,	
yycrank+-2128,	yysvec+73,	0,	
yycrank+-3421,	yysvec+73,	0,	
yycrank+-1749,	yysvec+73,	0,	
yycrank+-1751,	yysvec+73,	0,	
yycrank+-2030,	yysvec+17,	0,	
yycrank+-2163,	yysvec+17,	0,	
yycrank+-2275,	yysvec+17,	0,	
yycrank+-2308,	yysvec+17,	0,	
yycrank+-2164,	yysvec+17,	0,	
yycrank+-2200,	yysvec+17,	0,	
yycrank+-2319,	yysvec+17,	0,	
yycrank+-3458,	yysvec+126,	0,	
yycrank+-3580,	0,		0,	
yycrank+-1620,	yysvec+492,	0,	
yycrank+-3590,	0,		0,	
yycrank+-1645,	yysvec+492,	0,	
yycrank+-2318,	yysvec+17,	0,	
yycrank+-1754,	yysvec+25,	yyvstop+393,
yycrank+-1753,	yysvec+25,	yyvstop+395,
yycrank+-704,	yysvec+25,	yyvstop+397,
yycrank+-2134,	yysvec+25,	yyvstop+399,
yycrank+-1967,	yysvec+25,	yyvstop+401,
yycrank+-2133,	yysvec+25,	yyvstop+403,
yycrank+-2137,	yysvec+25,	yyvstop+405,
yycrank+-3617,	yysvec+283,	yyvstop+407,
yycrank+-3647,	0,		yyvstop+409,
yycrank+-1893,	yysvec+505,	yyvstop+411,
yycrank+0,	yysvec+494,	yyvstop+413,
yycrank+-2037,	yysvec+505,	yyvstop+415,
yycrank+-2130,	yysvec+25,	yyvstop+417,
yycrank+-3257,	yysvec+17,	0,	
yycrank+-3699,	yysvec+126,	0,	
yycrank+-2135,	yysvec+157,	0,	
yycrank+-3821,	0,		0,	
yycrank+-2140,	yysvec+160,	0,	
yycrank+-3329,	yysvec+17,	yyvstop+419,
yycrank+-3848,	yysvec+126,	yyvstop+421,
yycrank+-2324,	yysvec+17,	0,	
yycrank+-1863,	yysvec+168,	0,	
yycrank+-1990,	yysvec+168,	0,	
yycrank+-2281,	yysvec+168,	0,	
yycrank+-2282,	yysvec+168,	0,	
yycrank+-2293,	yysvec+168,	0,	
yycrank+-2277,	yysvec+168,	0,	
yycrank+-2285,	yysvec+168,	0,	
yycrank+-2322,	yysvec+17,	0,	
yycrank+-3875,	yysvec+126,	0,	
yycrank+-3997,	yysvec+17,	0,	
yycrank+-4009,	0,		0,	
yycrank+-4019,	yysvec+17,	0,	
yycrank+-4087,	yysvec+17,	0,	
yycrank+0,	0,		yyvstop+423,
yycrank+-2043,	yysvec+457,	yyvstop+425,
yycrank+-1870,	yysvec+176,	0,	
yycrank+-2294,	yysvec+176,	0,	
yycrank+-2283,	yysvec+176,	0,	
yycrank+-2295,	yysvec+176,	0,	
yycrank+-2296,	yysvec+176,	0,	
yycrank+-2321,	yysvec+176,	0,	
yycrank+-3411,	yysvec+17,	0,	
yycrank+-4114,	yysvec+126,	0,	
yycrank+-2326,	yysvec+329,	0,	
yycrank+-2331,	yysvec+17,	0,	
yycrank+-4141,	yysvec+126,	0,	
yycrank+-4263,	0,		0,	
yycrank+-4273,	0,		0,	
yycrank+-2136,	yysvec+544,	0,	
yycrank+-2174,	yysvec+544,	0,	
yycrank+-4283,	0,		0,	
yycrank+-4344,	0,		0,	
yycrank+-2284,	yysvec+548,	0,	
yycrank+-2175,	yysvec+548,	0,	
yycrank+-1769,	yysvec+73,	0,	
yycrank+-1979,	yysvec+73,	0,	
yycrank+-2333,	yysvec+73,	0,	
yycrank+-2291,	yysvec+73,	0,	
yycrank+-2387,	yysvec+73,	0,	
yycrank+-2329,	yysvec+73,	0,	
yycrank+-2302,	yysvec+73,	0,	
yycrank+-4310,	yysvec+337,	0,	
yycrank+-4433,	0,		0,	
yycrank+-2178,	yysvec+560,	0,	
yycrank+0,	yysvec+494,	yyvstop+427,
yycrank+-2180,	yysvec+560,	0,	
yycrank+-2467,	yysvec+73,	0,	
yycrank+-2563,	yysvec+17,	0,	
yycrank+-2176,	yysvec+17,	0,	
yycrank+-2511,	yysvec+17,	0,	
yycrank+-2579,	yysvec+17,	0,	
yycrank+-2612,	yysvec+17,	0,	
yycrank+-2614,	yysvec+17,	0,	
yycrank+-2600,	yysvec+17,	0,	
yycrank+-2574,	yysvec+17,	0,	
yycrank+-2305,	yysvec+17,	yyvstop+429,
yycrank+0,	0,		yyvstop+431,
yycrank+-2576,	yysvec+492,	0,	
yycrank+-2625,	yysvec+17,	0,	
yycrank+-2335,	yysvec+25,	yyvstop+433,
yycrank+-2027,	yysvec+25,	yyvstop+435,
yycrank+-2391,	yysvec+25,	yyvstop+437,
yycrank+-2353,	yysvec+25,	yyvstop+439,
yycrank+-2397,	yysvec+25,	yyvstop+441,
yycrank+-2400,	yysvec+25,	yyvstop+443,
yycrank+-2460,	yysvec+25,	yyvstop+445,
yycrank+-2461,	yysvec+25,	yyvstop+447,
yycrank+-341,	yysvec+25,	yyvstop+449,
yycrank+-2714,	yysvec+505,	yyvstop+452,
yycrank+-2477,	yysvec+25,	yyvstop+454,
yycrank+-3418,	yysvec+17,	0,	
yycrank+-3497,	yysvec+17,	0,	
yycrank+-2466,	yysvec+157,	0,	
yycrank+-4443,	0,		0,	
yycrank+-2472,	yysvec+160,	0,	
yycrank+-3572,	yysvec+17,	yyvstop+456,
yycrank+-3738,	yysvec+17,	yyvstop+458,
yycrank+-2715,	yysvec+17,	0,	
yycrank+-2473,	yysvec+168,	0,	
yycrank+-2610,	yysvec+168,	0,	
yycrank+-2535,	yysvec+168,	0,	
yycrank+-2613,	yysvec+168,	0,	
yycrank+-2616,	yysvec+168,	0,	
yycrank+-2538,	yysvec+168,	0,	
yycrank+-2627,	yysvec+168,	0,	
yycrank+-2724,	yysvec+17,	0,	
yycrank+-2725,	yysvec+17,	0,	
yycrank+-2586,	yysvec+17,	yyvstop+460,
yycrank+0,	0,		yyvstop+462,
yycrank+-4453,	yysvec+17,	0,	
yycrank+-4523,	0,		0,	
yycrank+-2756,	yysvec+457,	yyvstop+464,
yycrank+-2594,	yysvec+176,	0,	
yycrank+-2633,	yysvec+176,	0,	
yycrank+-2598,	yysvec+176,	0,	
yycrank+-2634,	yysvec+176,	0,	
yycrank+-2709,	yysvec+176,	0,	
yycrank+-2639,	yysvec+176,	0,	
yycrank+-3599,	yysvec+17,	0,	
yycrank+-3660,	yysvec+17,	0,	
yycrank+-2718,	yysvec+329,	0,	
yycrank+-2842,	yysvec+17,	0,	
yycrank+-2838,	yysvec+17,	0,	
yycrank+-2759,	yysvec+17,	yyvstop+466,
yycrank+0,	0,		yyvstop+468,
yycrank+-2816,	yysvec+544,	0,	
yycrank+-2873,	yysvec+544,	0,	
yycrank+-2789,	yysvec+17,	yyvstop+470,
yycrank+0,	0,		yyvstop+472,
yycrank+-2835,	yysvec+548,	0,	
yycrank+-2922,	yysvec+548,	0,	
yycrank+-2476,	yysvec+73,	0,	
yycrank+-2710,	yysvec+73,	0,	
yycrank+-2726,	yysvec+73,	0,	
yycrank+-2721,	yysvec+73,	0,	
yycrank+-2798,	yysvec+73,	0,	
yycrank+-2813,	yysvec+73,	0,	
yycrank+-2478,	yysvec+73,	0,	
yycrank+-2475,	yysvec+73,	0,	
yycrank+-348,	yysvec+73,	yyvstop+474,
yycrank+-3011,	yysvec+560,	0,	
yycrank+-2897,	yysvec+73,	0,	
yycrank+-2836,	yysvec+17,	0,	
yycrank+-3211,	yysvec+17,	0,	
yycrank+-3001,	yysvec+17,	0,	
yycrank+-2985,	yysvec+17,	0,	
yycrank+-3005,	yysvec+17,	0,	
yycrank+-3014,	yysvec+17,	0,	
yycrank+-3080,	yysvec+17,	0,	
yycrank+-3085,	yysvec+17,	0,	
yycrank+-2526,	yysvec+492,	0,	
yycrank+-3006,	yysvec+17,	0,	
yycrank+-2481,	yysvec+25,	yyvstop+476,
yycrank+-3050,	yysvec+25,	yyvstop+478,
yycrank+-2818,	yysvec+25,	yyvstop+480,
yycrank+-2000,	yysvec+25,	yyvstop+482,
yycrank+-2529,	yysvec+25,	yyvstop+484,
yycrank+-2812,	yysvec+25,	yyvstop+486,
yycrank+-2899,	yysvec+25,	yyvstop+488,
yycrank+-2824,	yysvec+25,	yyvstop+490,
yycrank+-2720,	yysvec+505,	yyvstop+492,
yycrank+-3073,	yysvec+25,	yyvstop+494,
yycrank+-3743,	yysvec+17,	0,	
yycrank+-3813,	yysvec+17,	0,	
yycrank+-2901,	yysvec+157,	0,	
yycrank+-4533,	0,		0,	
yycrank+-2989,	yysvec+160,	0,	
yycrank+-3833,	yysvec+17,	yyvstop+496,
yycrank+-3994,	yysvec+17,	yyvstop+498,
yycrank+-3086,	yysvec+17,	0,	
yycrank+-3136,	yysvec+168,	0,	
yycrank+-3065,	yysvec+168,	0,	
yycrank+-2161,	yysvec+168,	0,	
yycrank+-3071,	yysvec+168,	0,	
yycrank+-2635,	yysvec+168,	0,	
yycrank+-2893,	yysvec+168,	0,	
yycrank+-3076,	yysvec+168,	0,	
yycrank+-3164,	yysvec+17,	0,	
yycrank+-4552,	yysvec+17,	0,	
yycrank+-4594,	yysvec+17,	0,	
yycrank+-4613,	0,		0,	
yycrank+-2817,	yysvec+457,	yyvstop+500,
yycrank+-3212,	yysvec+176,	0,	
yycrank+-3081,	yysvec+176,	0,	
yycrank+-2165,	yysvec+176,	0,	
yycrank+-2918,	yysvec+176,	0,	
yycrank+-2915,	yysvec+176,	0,	
yycrank+-3084,	yysvec+176,	0,	
yycrank+-3818,	yysvec+17,	0,	
yycrank+-3989,	yysvec+17,	0,	
yycrank+-3093,	yysvec+329,	0,	
yycrank+-3182,	yysvec+17,	0,	
yycrank+-4642,	yysvec+471,	0,	
yycrank+-3174,	yysvec+544,	0,	
yycrank+-2819,	yysvec+544,	0,	
yycrank+-3292,	yysvec+548,	0,	
yycrank+-2988,	yysvec+548,	0,	
yycrank+-3096,	yysvec+73,	0,	
yycrank+-3213,	yysvec+73,	0,	
yycrank+-3097,	yysvec+73,	0,	
yycrank+-2571,	yysvec+73,	0,	
yycrank+-2920,	yysvec+73,	0,	
yycrank+-3137,	yysvec+73,	0,	
yycrank+-3003,	yysvec+73,	0,	
yycrank+-3161,	yysvec+73,	0,	
yycrank+-3083,	yysvec+560,	0,	
yycrank+-3340,	yysvec+73,	0,	
yycrank+-3250,	yysvec+17,	0,	
yycrank+-3326,	yysvec+17,	0,	
yycrank+-3328,	yysvec+17,	0,	
yycrank+-3409,	yysvec+17,	0,	
yycrank+-3429,	yysvec+17,	0,	
yycrank+-3348,	yysvec+17,	0,	
yycrank+-3430,	yysvec+17,	0,	
yycrank+-3264,	yysvec+17,	0,	
yycrank+-2894,	yysvec+492,	0,	
yycrank+-3489,	yysvec+17,	0,	
yycrank+-3063,	yysvec+25,	yyvstop+502,
yycrank+-3175,	yysvec+25,	yyvstop+504,
yycrank+-3154,	yysvec+25,	yyvstop+506,
yycrank+-3231,	yysvec+25,	yyvstop+508,
yycrank+-3145,	yysvec+25,	yyvstop+510,
yycrank+-3176,	yysvec+25,	yyvstop+512,
yycrank+-3233,	yysvec+25,	yyvstop+514,
yycrank+-3178,	yysvec+25,	yyvstop+516,
yycrank+-3153,	yysvec+505,	yyvstop+518,
yycrank+-1289,	yysvec+25,	yyvstop+520,
yycrank+-4063,	yysvec+17,	0,	
yycrank+-3181,	yysvec+157,	0,	
yycrank+-4623,	0,		0,	
yycrank+-3259,	yysvec+160,	0,	
yycrank+-4077,	yysvec+17,	yyvstop+522,
yycrank+-4669,	yysvec+126,	0,	
yycrank+-3236,	yysvec+168,	0,	
yycrank+-3171,	yysvec+168,	0,	
yycrank+-3241,	yysvec+168,	0,	
yycrank+-3321,	yysvec+168,	0,	
yycrank+-3319,	yysvec+168,	0,	
yycrank+-3339,	yysvec+168,	0,	
yycrank+-3234,	yysvec+168,	0,	
yycrank+-3330,	yysvec+168,	0,	
yycrank+-3494,	yysvec+17,	0,	
yycrank+-4703,	yysvec+17,	0,	
yycrank+-4792,	0,		0,	
yycrank+-4802,	yysvec+17,	0,	
yycrank+-4812,	yysvec+17,	0,	
yycrank+-4882,	0,		0,	
yycrank+-4892,	0,		0,	
yycrank+-3235,	yysvec+457,	yyvstop+524,
yycrank+-3342,	yysvec+176,	0,	
yycrank+-3341,	yysvec+176,	0,	
yycrank+-3403,	yysvec+176,	0,	
yycrank+-3343,	yysvec+176,	0,	
yycrank+-3400,	yysvec+176,	0,	
yycrank+-3404,	yysvec+176,	0,	
yycrank+-3392,	yysvec+176,	0,	
yycrank+-3834,	yysvec+17,	0,	
yycrank+-3082,	yysvec+329,	0,	
yycrank+-3509,	yysvec+17,	0,	
yycrank+-4902,	0,		0,	
yycrank+-4973,	0,		0,	
yycrank+-3428,	yysvec+757,	0,	
yycrank+-2620,	yysvec+757,	0,	
yycrank+-1765,	yysvec+544,	0,	
yycrank+-3406,	yysvec+544,	0,	
yycrank+-1871,	yysvec+548,	0,	
yycrank+-3419,	yysvec+548,	0,	
yycrank+-3401,	yysvec+73,	0,	
yycrank+-3486,	yysvec+73,	0,	
yycrank+-3408,	yysvec+73,	0,	
yycrank+-3470,	yysvec+73,	0,	
yycrank+-3490,	yysvec+73,	0,	
yycrank+-3493,	yysvec+73,	0,	
yycrank+-3491,	yysvec+73,	0,	
yycrank+-3484,	yysvec+73,	0,	
yycrank+-3496,	yysvec+560,	0,	
yycrank+-1880,	yysvec+73,	0,	
yycrank+-3512,	yysvec+17,	0,	
yycrank+-3598,	yysvec+17,	0,	
yycrank+-4939,	yysvec+126,	0,	
yycrank+-3587,	yysvec+17,	0,	
yycrank+-3588,	yysvec+17,	0,	
yycrank+-3658,	yysvec+17,	0,	
yycrank+-3644,	yysvec+17,	0,	
yycrank+-3623,	yysvec+17,	0,	
yycrank+-3500,	yysvec+492,	0,	
yycrank+-5062,	yysvec+17,	0,	
yycrank+-3485,	yysvec+25,	yyvstop+526,
yycrank+-3504,	yysvec+25,	yyvstop+528,
yycrank+-5025,	yysvec+283,	yyvstop+530,
yycrank+-3315,	yysvec+25,	yyvstop+532,
yycrank+-3314,	yysvec+25,	yyvstop+534,
yycrank+-3505,	yysvec+25,	yyvstop+536,
yycrank+-1507,	yysvec+25,	yyvstop+538,
yycrank+-950,	yysvec+25,	yyvstop+540,
yycrank+-3507,	yysvec+505,	yyvstop+542,
yycrank+-5151,	yysvec+25,	yyvstop+544,
yycrank+-4440,	yysvec+17,	0,	
yycrank+-3506,	yysvec+157,	0,	
yycrank+-5170,	0,		0,	
yycrank+-3541,	yysvec+160,	0,	
yycrank+-4799,	yysvec+17,	yyvstop+546,
yycrank+-3662,	yysvec+17,	0,	
yycrank+-3545,	yysvec+168,	0,	
yycrank+-5197,	yysvec+236,	0,	
yycrank+-3585,	yysvec+168,	0,	
yycrank+-3551,	yysvec+168,	0,	
yycrank+-3611,	yysvec+168,	0,	
yycrank+-3604,	yysvec+168,	0,	
yycrank+-3602,	yysvec+168,	0,	
yycrank+-3590,	yysvec+168,	0,	
yycrank+-3668,	yysvec+17,	0,	
yycrank+-3739,	yysvec+17,	yyvstop+548,
yycrank+0,	0,		yyvstop+550,
yycrank+-5227,	yysvec+17,	0,	
yycrank+-5320,	yysvec+608,	0,	
yycrank+-5330,	0,		0,	
yycrank+-5342,	0,		0,	
yycrank+-3634,	yysvec+457,	yyvstop+552,
yycrank+-3665,	yysvec+176,	0,	
yycrank+-5369,	yysvec+318,	0,	
yycrank+-3619,	yysvec+176,	0,	
yycrank+-3657,	yysvec+176,	0,	
yycrank+-3725,	yysvec+176,	0,	
yycrank+-3659,	yysvec+176,	0,	
yycrank+-3722,	yysvec+176,	0,	
yycrank+-4278,	yysvec+17,	0,	
yycrank+-3620,	yysvec+329,	0,	
yycrank+-3751,	yysvec+17,	0,	
yycrank+-3753,	yysvec+17,	yyvstop+554,
yycrank+0,	0,		yyvstop+556,
yycrank+-3735,	yysvec+757,	0,	
yycrank+-3828,	yysvec+757,	0,	
yycrank+-5491,	yysvec+544,	0,	
yycrank+-3638,	yysvec+544,	0,	
yycrank+-5494,	yysvec+548,	0,	
yycrank+-3720,	yysvec+548,	0,	
yycrank+-3740,	yysvec+73,	0,	
yycrank+-3750,	yysvec+73,	0,	
yycrank+-5457,	yysvec+337,	0,	
yycrank+-3632,	yysvec+73,	0,	
yycrank+-3716,	yysvec+73,	0,	
yycrank+-3785,	yysvec+73,	0,	
yycrank+-3737,	yysvec+73,	0,	
yycrank+-3729,	yysvec+73,	0,	
yycrank+-3731,	yysvec+560,	0,	
yycrank+-5584,	yysvec+73,	0,	
yycrank+-3891,	yysvec+17,	0,	
yycrank+-3832,	yysvec+17,	0,	
yycrank+-3895,	yysvec+17,	0,	
yycrank+-3842,	yysvec+17,	0,	
yycrank+-3890,	yysvec+17,	0,	
yycrank+-3990,	yysvec+17,	0,	
yycrank+-3991,	yysvec+17,	0,	
yycrank+-3993,	yysvec+17,	0,	
yycrank+-3806,	yysvec+492,	0,	
yycrank+-5594,	yysvec+814,	0,	
yycrank+-5606,	0,		0,	
yycrank+-5654,	yysvec+814,	0,	
yycrank+-3826,	yysvec+25,	yyvstop+558,
yycrank+-3639,	yysvec+25,	yyvstop+560,
yycrank+-3857,	yysvec+25,	yyvstop+562,
yycrank+-500,	yysvec+25,	yyvstop+564,
yycrank+-3745,	yysvec+25,	yyvstop+566,
yycrank+-3845,	yysvec+25,	yyvstop+568,
yycrank+-3851,	yysvec+25,	yyvstop+570,
yycrank+-3860,	yysvec+25,	yyvstop+572,
yycrank+-3811,	yysvec+505,	yyvstop+574,
yycrank+-5674,	0,		yyvstop+576,
yycrank+0,	yysvec+855,	yyvstop+578,
yycrank+-3880,	yysvec+866,	yyvstop+580,
yycrank+-4111,	yysvec+17,	0,	
yycrank+-3966,	yysvec+157,	0,	
yycrank+-5696,	0,		0,	
yycrank+-3969,	yysvec+160,	0,	
yycrank+-4868,	yysvec+17,	yyvstop+582,
yycrank+-4007,	yysvec+17,	0,	
yycrank+-3982,	yysvec+168,	0,	
yycrank+-3985,	yysvec+168,	0,	
yycrank+-501,	yysvec+168,	0,	
yycrank+-3830,	yysvec+168,	0,	
yycrank+-5723,	yysvec+236,	0,	
yycrank+-4016,	yysvec+168,	0,	
yycrank+-3970,	yysvec+168,	0,	
yycrank+-4020,	yysvec+168,	0,	
yycrank+-5763,	yysvec+17,	0,	
yycrank+-5805,	yysvec+17,	0,	
yycrank+-5853,	yysvec+678,	0,	
yycrank+-847,	yysvec+814,	0,	
yycrank+-5865,	yysvec+855,	0,	
yycrank+-4066,	yysvec+814,	0,	
yycrank+-5875,	yysvec+814,	yyvstop+584,
yycrank+-5943,	0,		0,	
yycrank+-3971,	yysvec+457,	yyvstop+586,
yycrank+-4022,	yysvec+176,	0,	
yycrank+-4004,	yysvec+176,	0,	
yycrank+-681,	yysvec+176,	0,	
yycrank+-3988,	yysvec+176,	0,	
yycrank+-4027,	yysvec+176,	0,	
yycrank+-3973,	yysvec+176,	0,	
yycrank+-4051,	yysvec+176,	0,	
yycrank+-4268,	yysvec+17,	0,	
yycrank+-3344,	yysvec+329,	0,	
yycrank+-4071,	yysvec+757,	0,	
yycrank+-4053,	yysvec+757,	0,	
yycrank+-3733,	yysvec+757,	0,	
yycrank+-5955,	0,		0,	
yycrank+-5972,	0,		0,	
yycrank+-4068,	yysvec+904,	0,	
yycrank+-6014,	yysvec+814,	yyvstop+588,
yycrank+-4039,	yysvec+544,	0,	
yycrank+-6033,	0,		0,	
yycrank+-6062,	0,		0,	
yycrank+-4113,	yysvec+909,	0,	
yycrank+-6081,	yysvec+814,	yyvstop+590,
yycrank+-4040,	yysvec+548,	0,	
yycrank+-4024,	yysvec+73,	0,	
yycrank+-4094,	yysvec+73,	0,	
yycrank+-4056,	yysvec+73,	0,	
yycrank+-746,	yysvec+73,	0,	
yycrank+-4085,	yysvec+73,	0,	
yycrank+-4102,	yysvec+73,	0,	
yycrank+-4105,	yysvec+73,	0,	
yycrank+-4107,	yysvec+73,	0,	
yycrank+-4103,	yysvec+560,	0,	
yycrank+-6103,	0,		0,	
yycrank+0,	yysvec+855,	yyvstop+592,
yycrank+-4143,	yysvec+923,	0,	
yycrank+-6131,	yysvec+126,	0,	
yycrank+-4156,	yysvec+17,	0,	
yycrank+-4153,	yysvec+17,	0,	
yycrank+-4281,	yysvec+17,	0,	
yycrank+-4157,	yysvec+17,	0,	
yycrank+-4260,	yysvec+17,	0,	
yycrank+-4159,	yysvec+492,	0,	
yycrank+-6123,	yysvec+17,	yyvstop+594,
yycrank+-6253,	0,		yyvstop+596,
yycrank+-6269,	0,		0,	
yycrank+-6296,	yysvec+283,	yyvstop+598,
yycrank+-4165,	yysvec+25,	yyvstop+600,
yycrank+-4150,	yysvec+25,	yyvstop+602,
yycrank+-4292,	yysvec+25,	yyvstop+604,
yycrank+-3251,	yysvec+25,	yyvstop+606,
yycrank+-1039,	yysvec+25,	yyvstop+608,
yycrank+-4229,	yysvec+505,	yyvstop+610,
yycrank+-6326,	yysvec+25,	yyvstop+612,
yycrank+-4294,	yysvec+866,	yyvstop+615,
yycrank+-4195,	yysvec+157,	0,	
yycrank+-4239,	yysvec+663,	0,	
yycrank+-4243,	yysvec+160,	0,	
yycrank+-4270,	yysvec+17,	0,	
yycrank+-4235,	yysvec+168,	0,	
yycrank+-4233,	yysvec+168,	0,	
yycrank+-4342,	yysvec+168,	0,	
yycrank+-4247,	yysvec+168,	0,	
yycrank+-4237,	yysvec+168,	0,	
yycrank+-4253,	yysvec+168,	0,	
yycrank+-1173,	yysvec+168,	0,	
yycrank+-6419,	yysvec+744,	0,	
yycrank+-6429,	yysvec+745,	0,	
yycrank+-6439,	0,		yyvstop+617,
yycrank+-6499,	yysvec+934,	yyvstop+619,
yycrank+0,	yysvec+855,	yyvstop+621,
yycrank+-4352,	yysvec+814,	0,	
yycrank+-6519,	0,		0,	
yycrank+-4255,	yysvec+457,	yyvstop+623,
yycrank+-4271,	yysvec+176,	0,	
yycrank+-4320,	yysvec+176,	0,	
yycrank+-4391,	yysvec+176,	0,	
yycrank+-4264,	yysvec+176,	0,	
yycrank+-4273,	yysvec+176,	0,	
yycrank+-1455,	yysvec+176,	0,	
yycrank+-4301,	yysvec+329,	0,	
yycrank+-2169,	yysvec+757,	0,	
yycrank+-3637,	yysvec+757,	0,	
yycrank+-6540,	yysvec+544,	yyvstop+625,
yycrank+-6567,	yysvec+545,	yyvstop+627,
yycrank+0,	yysvec+855,	yyvstop+629,
yycrank+-4431,	yysvec+904,	0,	
yycrank+-4339,	yysvec+544,	0,	
yycrank+-6588,	yysvec+548,	yyvstop+631,
yycrank+-6608,	yysvec+549,	yyvstop+633,
yycrank+0,	yysvec+855,	yyvstop+635,
yycrank+-4438,	yysvec+909,	0,	
yycrank+-4349,	yysvec+548,	0,	
yycrank+-6609,	yysvec+337,	0,	
yycrank+-4293,	yysvec+73,	0,	
yycrank+-4341,	yysvec+73,	0,	
yycrank+-4451,	yysvec+73,	0,	
yycrank+-4291,	yysvec+73,	0,	
yycrank+-1593,	yysvec+73,	0,	
yycrank+-4355,	yysvec+560,	0,	
yycrank+-6731,	yysvec+73,	yyvstop+637,
yycrank+-4461,	yysvec+923,	0,	
yycrank+-4441,	yysvec+17,	0,	
yycrank+-4497,	yysvec+17,	0,	
yycrank+-4161,	yysvec+17,	0,	
yycrank+-4509,	yysvec+17,	0,	
yycrank+-4462,	yysvec+17,	0,	
yycrank+-4480,	yysvec+17,	0,	
yycrank+-4133,	yysvec+492,	0,	
yycrank+-6741,	yysvec+958,	0,	
yycrank+-681,	yysvec+934,	0,	
yycrank+-6751,	yysvec+958,	0,	
yycrank+-6761,	0,		0,	
yycrank+-4353,	yysvec+25,	yyvstop+639,
yycrank+-3836,	yysvec+25,	yyvstop+641,
yycrank+-4137,	yysvec+25,	yyvstop+643,
yycrank+-4144,	yysvec+25,	yyvstop+645,
yycrank+-4404,	yysvec+25,	yyvstop+647,
yycrank+-4245,	yysvec+25,	yyvstop+649,
yycrank+-4145,	yysvec+505,	yyvstop+651,
yycrank+-6831,	0,		yyvstop+653,
yycrank+-715,	yysvec+934,	yyvstop+655,
yycrank+-4152,	yysvec+1010,	yyvstop+657,
yycrank+-4424,	yysvec+866,	yyvstop+659,
yycrank+-4403,	yysvec+157,	0,	
yycrank+-6850,	0,		0,	
yycrank+-4413,	yysvec+160,	0,	
yycrank+-4570,	yysvec+17,	0,	
yycrank+-4299,	yysvec+168,	0,	
yycrank+-4149,	yysvec+168,	0,	
yycrank+-4158,	yysvec+168,	yyvstop+661,
yycrank+-4407,	yysvec+168,	0,	
yycrank+-4414,	yysvec+168,	0,	
yycrank+-6877,	yysvec+236,	0,	
yycrank+-4252,	yysvec+168,	0,	
yycrank+-6821,	yysvec+814,	0,	
yycrank+-6911,	yysvec+815,	0,	
yycrank+-2388,	yysvec+958,	0,	
yycrank+-7000,	yysvec+934,	0,	
yycrank+-4467,	yysvec+958,	0,	
yycrank+-7010,	yysvec+958,	yyvstop+663,
yycrank+-853,	yysvec+934,	yyvstop+665,
yycrank+-4545,	yysvec+814,	0,	
yycrank+-7029,	0,		0,	
yycrank+-4429,	yysvec+457,	yyvstop+667,
yycrank+-4363,	yysvec+176,	0,	
yycrank+-4464,	yysvec+176,	0,	
yycrank+-4468,	yysvec+176,	yyvstop+669,
yycrank+-4417,	yysvec+176,	0,	
yycrank+-7056,	yysvec+318,	0,	
yycrank+-4473,	yysvec+176,	0,	
yycrank+-4481,	yysvec+329,	0,	
yycrank+-7090,	yysvec+757,	0,	
yycrank+-4505,	yysvec+757,	0,	
yycrank+-7179,	0,		0,	
yycrank+-7189,	0,		0,	
yycrank+-4507,	yysvec+1044,	0,	
yycrank+-7199,	yysvec+958,	yyvstop+671,
yycrank+-876,	yysvec+934,	yyvstop+673,
yycrank+-4487,	yysvec+904,	0,	
yycrank+-4541,	yysvec+544,	0,	
yycrank+-7269,	0,		0,	
yycrank+-7279,	0,		0,	
yycrank+-4546,	yysvec+1051,	0,	
yycrank+-7259,	yysvec+958,	yyvstop+675,
yycrank+-905,	yysvec+934,	yyvstop+677,
yycrank+-4510,	yysvec+909,	0,	
yycrank+-4565,	yysvec+548,	0,	
yycrank+-4528,	yysvec+73,	0,	
yycrank+-4568,	yysvec+73,	0,	
yycrank+-4569,	yysvec+73,	0,	
yycrank+-4573,	yysvec+73,	0,	
yycrank+-4471,	yysvec+73,	0,	
yycrank+-4512,	yysvec+73,	0,	
yycrank+-4577,	yysvec+560,	0,	
yycrank+-7349,	0,		0,	
yycrank+-987,	yysvec+934,	yyvstop+679,
yycrank+-4618,	yysvec+1065,	0,	
yycrank+-4547,	yysvec+923,	0,	
yycrank+-4652,	yysvec+17,	0,	
yycrank+-4631,	yysvec+17,	0,	
yycrank+-4683,	yysvec+17,	0,	
yycrank+-4687,	yysvec+17,	0,	
yycrank+-4685,	yysvec+17,	0,	
yycrank+-4689,	yysvec+17,	0,	
yycrank+-4244,	yysvec+492,	0,	
yycrank+-3881,	yysvec+17,	yyvstop+681,
yycrank+0,	0,		yyvstop+683,
yycrank+-7368,	0,		0,	
yycrank+-7378,	0,		0,	
yycrank+-4595,	yysvec+25,	yyvstop+685,
yycrank+-4597,	yysvec+25,	yyvstop+687,
yycrank+-4608,	yysvec+25,	yyvstop+689,
yycrank+-4571,	yysvec+25,	yyvstop+691,
yycrank+-4583,	yysvec+25,	yyvstop+693,
yycrank+-4650,	yysvec+25,	yyvstop+695,
yycrank+-4638,	yysvec+505,	yyvstop+697,
yycrank+-1180,	yysvec+25,	yyvstop+699,
yycrank+-4672,	yysvec+1010,	yyvstop+702,
yycrank+-4680,	yysvec+866,	yyvstop+704,
yycrank+-7439,	0,		0,	
yycrank+-4656,	yysvec+663,	0,	
yycrank+-7562,	0,		0,	
yycrank+-4789,	yysvec+17,	0,	
yycrank+-4673,	yysvec+168,	0,	
yycrank+-4643,	yysvec+168,	0,	
yycrank+-4658,	yysvec+168,	0,	
yycrank+-4636,	yysvec+168,	0,	
yycrank+-4257,	yysvec+168,	0,	
yycrank+-4688,	yysvec+168,	0,	
yycrank+-4698,	yysvec+168,	0,	
yycrank+-7397,	yysvec+814,	0,	
yycrank+-7685,	yysvec+855,	0,	
yycrank+-7695,	yysvec+814,	0,	
yycrank+-7705,	yysvec+814,	yyvstop+706,
yycrank+-7765,	yysvec+890,	0,	
yycrank+-7775,	yysvec+17,	yyvstop+708,
yycrank+-2723,	yysvec+528,	yyvstop+710,
yycrank+-4846,	yysvec+958,	0,	
yycrank+-4701,	yysvec+814,	0,	
yycrank+-7794,	0,		0,	
yycrank+-4717,	yysvec+457,	yyvstop+712,
yycrank+-4691,	yysvec+176,	0,	
yycrank+-4696,	yysvec+176,	0,	
yycrank+-4659,	yysvec+176,	0,	
yycrank+-4708,	yysvec+176,	0,	
yycrank+-4718,	yysvec+176,	0,	
yycrank+-4706,	yysvec+176,	0,	
yycrank+-4660,	yysvec+329,	0,	
yycrank+-7836,	0,		0,	
yycrank+-7855,	0,		0,	
yycrank+-4810,	yysvec+1119,	0,	
yycrank+-7884,	yysvec+814,	yyvstop+714,
yycrank+-4766,	yysvec+757,	0,	
yycrank+-1324,	yysvec+544,	yyvstop+716,
yycrank+0,	yysvec+545,	yyvstop+718,
yycrank+-4815,	yysvec+1044,	0,	
yycrank+-4710,	yysvec+904,	0,	
yycrank+-4773,	yysvec+544,	0,	
yycrank+-1613,	yysvec+548,	yyvstop+720,
yycrank+0,	yysvec+549,	yyvstop+722,
yycrank+-4823,	yysvec+1051,	0,	
yycrank+-4817,	yysvec+909,	0,	
yycrank+-4776,	yysvec+548,	0,	
yycrank+-4768,	yysvec+73,	0,	
yycrank+-4831,	yysvec+73,	0,	
yycrank+-4775,	yysvec+73,	0,	
yycrank+-4826,	yysvec+73,	0,	
yycrank+-4793,	yysvec+73,	0,	
yycrank+-4839,	yysvec+73,	0,	
yycrank+-4781,	yysvec+560,	0,	
yycrank+-1617,	yysvec+73,	yyvstop+724,
yycrank+-4911,	yysvec+1065,	0,	
yycrank+-4824,	yysvec+923,	0,	
yycrank+-4962,	yysvec+17,	0,	
yycrank+-4942,	yysvec+17,	0,	
yycrank+-4976,	yysvec+17,	0,	
yycrank+-4832,	yysvec+17,	0,	
yycrank+-4946,	yysvec+17,	0,	
yycrank+-4980,	yysvec+17,	0,	
yycrank+-4820,	yysvec+492,	0,	
yycrank+-7903,	0,		0,	
yycrank+-7926,	0,		0,	
yycrank+-4862,	yysvec+25,	yyvstop+726,
yycrank+-3853,	yysvec+25,	yyvstop+728,
yycrank+-4918,	yysvec+25,	yyvstop+730,
yycrank+-4835,	yysvec+25,	yyvstop+732,
yycrank+-4838,	yysvec+25,	yyvstop+734,
yycrank+-4912,	yysvec+25,	yyvstop+736,
yycrank+-4915,	yysvec+505,	yyvstop+738,
yycrank+-4913,	yysvec+1010,	yyvstop+740,
yycrank+-4876,	yysvec+866,	yyvstop+742,
yycrank+-4949,	yysvec+157,	0,	
yycrank+-7974,	0,		0,	
yycrank+-4958,	yysvec+160,	0,	
yycrank+-4960,	yysvec+17,	0,	
yycrank+-4926,	yysvec+168,	0,	
yycrank+-4922,	yysvec+168,	0,	
yycrank+-4916,	yysvec+168,	0,	
yycrank+-4934,	yysvec+168,	0,	
yycrank+-4954,	yysvec+168,	0,	
yycrank+-4929,	yysvec+168,	0,	
yycrank+-4981,	yysvec+168,	0,	
yycrank+-8031,	yysvec+958,	yyvstop+744,
yycrank+-8037,	yysvec+934,	yyvstop+746,
yycrank+0,	yysvec+855,	yyvstop+748,
yycrank+-8094,	yysvec+935,	0,	
yycrank+-8104,	yysvec+962,	0,	
yycrank+-4956,	yysvec+958,	0,	
yycrank+-4969,	yysvec+814,	0,	
yycrank+-4985,	yysvec+890,	0,	
yycrank+-4986,	yysvec+457,	yyvstop+750,
yycrank+-4964,	yysvec+176,	0,	
yycrank+-4931,	yysvec+176,	0,	
yycrank+-4925,	yysvec+176,	0,	
yycrank+-5041,	yysvec+176,	0,	
yycrank+-4987,	yysvec+176,	0,	
yycrank+-5047,	yysvec+176,	0,	
yycrank+-4961,	yysvec+329,	0,	
yycrank+-8161,	yysvec+757,	yyvstop+752,
yycrank+-8175,	yysvec+758,	yyvstop+754,
yycrank+0,	yysvec+855,	yyvstop+756,
yycrank+-5071,	yysvec+1119,	0,	
yycrank+-5042,	yysvec+757,	0,	
yycrank+-4970,	yysvec+1044,	0,	
yycrank+-5048,	yysvec+904,	0,	
yycrank+-5052,	yysvec+544,	0,	
yycrank+-5051,	yysvec+1051,	0,	
yycrank+-5050,	yysvec+909,	0,	
yycrank+-5057,	yysvec+548,	0,	
yycrank+-5056,	yysvec+73,	0,	
yycrank+-5053,	yysvec+73,	0,	
yycrank+-5060,	yysvec+73,	0,	
yycrank+-5058,	yysvec+73,	0,	
yycrank+-5069,	yysvec+73,	0,	
yycrank+-5072,	yysvec+73,	0,	
yycrank+-5073,	yysvec+560,	0,	
yycrank+-5061,	yysvec+1065,	0,	
yycrank+-5065,	yysvec+923,	0,	
yycrank+-5159,	yysvec+17,	0,	
yycrank+-5166,	yysvec+17,	0,	
yycrank+-5177,	yysvec+17,	0,	
yycrank+-5107,	yysvec+17,	0,	
yycrank+-5165,	yysvec+17,	0,	
yycrank+-5067,	yysvec+492,	0,	
yycrank+-8205,	0,		0,	
yycrank+-8232,	0,		0,	
yycrank+-5146,	yysvec+25,	yyvstop+758,
yycrank+-5152,	yysvec+25,	yyvstop+760,
yycrank+-5158,	yysvec+25,	yyvstop+762,
yycrank+-5076,	yysvec+25,	yyvstop+764,
yycrank+-2170,	yysvec+25,	yyvstop+766,
yycrank+-5121,	yysvec+505,	yyvstop+768,
yycrank+-5074,	yysvec+1010,	yyvstop+770,
yycrank+-5123,	yysvec+866,	yyvstop+772,
yycrank+-5125,	yysvec+157,	0,	
yycrank+-8295,	yysvec+1092,	0,	
yycrank+-5141,	yysvec+160,	0,	
yycrank+-7525,	yysvec+126,	0,	
yycrank+-5164,	yysvec+168,	0,	
yycrank+-5171,	yysvec+168,	0,	
yycrank+-5162,	yysvec+168,	0,	
yycrank+-5173,	yysvec+168,	0,	
yycrank+-5070,	yysvec+168,	0,	
yycrank+-2808,	yysvec+168,	0,	
yycrank+-8251,	yysvec+958,	0,	
yycrank+-8418,	yysvec+934,	0,	
yycrank+-8428,	yysvec+958,	0,	
yycrank+-8438,	yysvec+958,	yyvstop+774,
yycrank+-1548,	yysvec+934,	yyvstop+776,
yycrank+-8498,	yysvec+1002,	0,	
yycrank+-8518,	yysvec+1033,	0,	
yycrank+-5210,	yysvec+958,	0,	
yycrank+-5179,	yysvec+814,	0,	
yycrank+-8564,	0,		0,	
yycrank+-5175,	yysvec+457,	yyvstop+778,
yycrank+-5190,	yysvec+176,	0,	
yycrank+-5198,	yysvec+176,	0,	
yycrank+-5207,	yysvec+176,	0,	
yycrank+-5191,	yysvec+176,	0,	
yycrank+-3595,	yysvec+176,	0,	
yycrank+-8591,	0,		0,	
yycrank+-8714,	0,		0,	
yycrank+-8724,	0,		0,	
yycrank+-4840,	yysvec+1252,	0,	
yycrank+-8734,	yysvec+958,	yyvstop+780,
yycrank+-1667,	yysvec+934,	yyvstop+782,
yycrank+-5205,	yysvec+1119,	0,	
yycrank+-5203,	yysvec+757,	0,	
yycrank+-5212,	yysvec+1044,	0,	
yycrank+-5234,	yysvec+904,	0,	
yycrank+-5218,	yysvec+544,	0,	
yycrank+-5217,	yysvec+1051,	0,	
yycrank+-5235,	yysvec+909,	0,	
yycrank+-5224,	yysvec+548,	0,	
yycrank+-5209,	yysvec+73,	0,	
yycrank+-5211,	yysvec+73,	0,	
yycrank+-5230,	yysvec+73,	0,	
yycrank+-5222,	yysvec+73,	0,	
yycrank+-3714,	yysvec+73,	0,	
yycrank+-5237,	yysvec+560,	0,	
yycrank+-5239,	yysvec+1065,	0,	
yycrank+-5240,	yysvec+923,	0,	
yycrank+-5245,	yysvec+17,	0,	
yycrank+-5228,	yysvec+17,	0,	
yycrank+-5327,	yysvec+17,	0,	
yycrank+-5338,	yysvec+17,	0,	
yycrank+-5339,	yysvec+17,	0,	
yycrank+-5241,	yysvec+492,	0,	
yycrank+-8804,	0,		0,	
yycrank+-8814,	0,		0,	
yycrank+-5248,	yysvec+25,	yyvstop+784,
yycrank+-5242,	yysvec+25,	yyvstop+786,
yycrank+-5315,	yysvec+25,	yyvstop+788,
yycrank+-5313,	yysvec+25,	yyvstop+790,
yycrank+-3861,	yysvec+25,	yyvstop+792,
yycrank+-5304,	yysvec+505,	yyvstop+794,
yycrank+-5317,	yysvec+1010,	yyvstop+796,
yycrank+-5321,	yysvec+866,	yyvstop+798,
yycrank+-5192,	yysvec+157,	0,	
yycrank+-5318,	yysvec+591,	0,	
yycrank+-5331,	yysvec+160,	0,	
yycrank+-5377,	yysvec+17,	0,	
yycrank+-5325,	yysvec+168,	0,	
yycrank+-5333,	yysvec+168,	0,	
yycrank+-5353,	yysvec+168,	0,	
yycrank+-5350,	yysvec+168,	0,	
yycrank+-5364,	yysvec+168,	0,	
yycrank+-5349,	yysvec+168,	0,	
yycrank+-8794,	yysvec+17,	yyvstop+800,
yycrank+-3515,	yysvec+741,	yyvstop+802,
yycrank+-8884,	yysvec+1078,	0,	
yycrank+-8894,	yysvec+1079,	0,	
yycrank+-8951,	yysvec+1110,	0,	
yycrank+-5382,	yysvec+958,	0,	
yycrank+-5387,	yysvec+814,	0,	
yycrank+-5351,	yysvec+890,	0,	
yycrank+-5355,	yysvec+457,	yyvstop+804,
yycrank+-5378,	yysvec+176,	0,	
yycrank+-5365,	yysvec+176,	0,	
yycrank+-5366,	yysvec+176,	0,	
yycrank+-5370,	yysvec+176,	0,	
yycrank+-5362,	yysvec+176,	0,	
yycrank+-5394,	yysvec+329,	0,	
yycrank+-1752,	yysvec+757,	yyvstop+806,
yycrank+0,	yysvec+758,	yyvstop+808,
yycrank+-5499,	yysvec+1252,	0,	
yycrank+-5396,	yysvec+1119,	0,	
yycrank+-5185,	yysvec+757,	0,	
yycrank+-5398,	yysvec+1044,	0,	
yycrank+-5400,	yysvec+904,	0,	
yycrank+-5405,	yysvec+544,	0,	
yycrank+-5402,	yysvec+1051,	0,	
yycrank+-5403,	yysvec+909,	0,	
yycrank+-5406,	yysvec+548,	0,	
yycrank+-5407,	yysvec+73,	0,	
yycrank+-5404,	yysvec+73,	0,	
yycrank+-5384,	yysvec+73,	0,	
yycrank+-5418,	yysvec+73,	0,	
yycrank+-5471,	yysvec+73,	0,	
yycrank+-5415,	yysvec+560,	0,	
yycrank+-5412,	yysvec+1065,	0,	
yycrank+-5413,	yysvec+923,	0,	
yycrank+-5507,	yysvec+17,	0,	
yycrank+-5509,	yysvec+17,	0,	
yycrank+-5492,	yysvec+17,	0,	
yycrank+-5570,	yysvec+17,	0,	
yycrank+-5589,	yysvec+17,	0,	
yycrank+-5483,	yysvec+492,	0,	
yycrank+-8993,	0,		0,	
yycrank+-9041,	0,		0,	
yycrank+-5419,	yysvec+25,	yyvstop+810,
yycrank+-5421,	yysvec+25,	yyvstop+812,
yycrank+-5558,	yysvec+25,	yyvstop+814,
yycrank+-5022,	yysvec+25,	yyvstop+816,
yycrank+-5560,	yysvec+25,	yyvstop+818,
yycrank+-5510,	yysvec+505,	yyvstop+820,
yycrank+-5420,	yysvec+1010,	yyvstop+822,
yycrank+-5564,	yysvec+866,	yyvstop+824,
yycrank+-5566,	yysvec+157,	0,	
yycrank+-5422,	yysvec+663,	0,	
yycrank+-5569,	yysvec+160,	0,	
yycrank+-5571,	yysvec+17,	0,	
yycrank+-5563,	yysvec+168,	0,	
yycrank+-5591,	yysvec+168,	0,	
yycrank+-5583,	yysvec+168,	0,	
yycrank+-5567,	yysvec+168,	0,	
yycrank+-5502,	yysvec+168,	0,	
yycrank+-5595,	yysvec+168,	0,	
yycrank+-8974,	yysvec+1151,	0,	
yycrank+-9083,	yysvec+1152,	0,	
yycrank+-9020,	yysvec+890,	0,	
yycrank+-5587,	yysvec+958,	0,	
yycrank+-5607,	yysvec+814,	0,	
yycrank+-9110,	0,		0,	
yycrank+-5580,	yysvec+457,	yyvstop+826,
yycrank+-5603,	yysvec+176,	0,	
yycrank+-5602,	yysvec+176,	0,	
yycrank+-5614,	yysvec+176,	0,	
yycrank+-5604,	yysvec+176,	0,	
yycrank+-5619,	yysvec+176,	0,	
yycrank+-5618,	yysvec+329,	0,	
yycrank+-5376,	yysvec+1252,	0,	
yycrank+-5541,	yysvec+1119,	0,	
yycrank+-5620,	yysvec+757,	0,	
yycrank+-5624,	yysvec+1044,	0,	
yycrank+-5627,	yysvec+904,	0,	
yycrank+-5616,	yysvec+544,	0,	
yycrank+-5631,	yysvec+1051,	0,	
yycrank+-5644,	yysvec+909,	0,	
yycrank+-5629,	yysvec+548,	0,	
yycrank+-5628,	yysvec+73,	0,	
yycrank+-5643,	yysvec+73,	0,	
yycrank+-5650,	yysvec+73,	0,	
yycrank+-5648,	yysvec+73,	0,	
yycrank+-5692,	yysvec+73,	0,	
yycrank+-5636,	yysvec+560,	0,	
yycrank+-5651,	yysvec+1065,	0,	
yycrank+-5694,	yysvec+923,	0,	
yycrank+-5717,	yysvec+17,	0,	
yycrank+-5746,	yysvec+17,	0,	
yycrank+-5736,	yysvec+17,	0,	
yycrank+-5770,	yysvec+17,	0,	
yycrank+-5718,	yysvec+17,	0,	
yycrank+-9152,	0,		0,	
yycrank+-9275,	0,		0,	
yycrank+-9285,	0,		0,	
yycrank+-5662,	yysvec+25,	yyvstop+828,
yycrank+-5681,	yysvec+25,	yyvstop+830,
yycrank+-5666,	yysvec+25,	yyvstop+832,
yycrank+-5693,	yysvec+25,	yyvstop+834,
yycrank+-1756,	yysvec+25,	yyvstop+836,
yycrank+-9348,	0,		yyvstop+838,
yycrank+-5739,	yysvec+1010,	yyvstop+840,
yycrank+-5752,	yysvec+866,	yyvstop+842,
yycrank+-5742,	yysvec+157,	0,	
yycrank+-9304,	0,		0,	
yycrank+-5760,	yysvec+160,	0,	
yycrank+-5756,	yysvec+17,	0,	
yycrank+-5706,	yysvec+168,	0,	
yycrank+-5743,	yysvec+168,	0,	
yycrank+-5829,	yysvec+168,	0,	
yycrank+-5759,	yysvec+168,	0,	
yycrank+-5761,	yysvec+168,	0,	
yycrank+-1757,	yysvec+168,	0,	
yycrank+-9471,	yysvec+1215,	0,	
yycrank+-9481,	yysvec+1216,	0,	
yycrank+-9495,	yysvec+1244,	0,	
yycrank+-5828,	yysvec+958,	0,	
yycrank+-5837,	yysvec+814,	0,	
yycrank+-9543,	yysvec+126,	0,	
yycrank+-9666,	0,		yyvstop+844,
yycrank+-5771,	yysvec+176,	0,	
yycrank+-5745,	yysvec+176,	0,	
yycrank+-5839,	yysvec+176,	0,	
yycrank+-5831,	yysvec+176,	0,	
yycrank+-1872,	yysvec+176,	0,	
yycrank+-5838,	yysvec+329,	0,	
yycrank+-5768,	yysvec+1252,	0,	
yycrank+-5846,	yysvec+1119,	0,	
yycrank+-5847,	yysvec+757,	0,	
yycrank+-5850,	yysvec+1044,	0,	
yycrank+-5851,	yysvec+904,	0,	
yycrank+-9789,	0,		0,	
yycrank+-5854,	yysvec+1051,	0,	
yycrank+-5863,	yysvec+909,	0,	
yycrank+-9912,	0,		0,	
yycrank+-5862,	yysvec+73,	0,	
yycrank+-5866,	yysvec+73,	0,	
yycrank+-5876,	yysvec+73,	0,	
yycrank+-5872,	yysvec+73,	0,	
yycrank+-1887,	yysvec+73,	0,	
yycrank+-10035,	0,		0,	
yycrank+-5885,	yysvec+1065,	0,	
yycrank+-5868,	yysvec+923,	0,	
yycrank+-9629,	yysvec+126,	0,	
yycrank+-5897,	yysvec+17,	0,	
yycrank+-5893,	yysvec+17,	0,	
yycrank+-5999,	yysvec+17,	0,	
yycrank+-5970,	yysvec+17,	0,	
yycrank+-5890,	yysvec+492,	0,	
yycrank+-10158,	0,		0,	
yycrank+-5848,	yysvec+1216,	0,	
yycrank+-9752,	yysvec+283,	yyvstop+846,
yycrank+-5887,	yysvec+25,	yyvstop+848,
yycrank+-5889,	yysvec+25,	yyvstop+850,
yycrank+-5991,	yysvec+25,	yyvstop+852,
yycrank+-6012,	yysvec+25,	yyvstop+854,
yycrank+-5903,	yysvec+505,	yyvstop+856,
yycrank+-5721,	yysvec+1010,	yyvstop+858,
yycrank+-5925,	yysvec+866,	yyvstop+860,
yycrank+-5899,	yysvec+157,	0,	
yycrank+-5726,	yysvec+797,	0,	
yycrank+-5969,	yysvec+160,	0,	
yycrank+-5983,	yysvec+17,	0,	
yycrank+-5941,	yysvec+168,	0,	
yycrank+-5987,	yysvec+168,	0,	
yycrank+-6022,	yysvec+168,	0,	
yycrank+-5985,	yysvec+168,	0,	
yycrank+-5933,	yysvec+168,	0,	
yycrank+-6106,	yysvec+168,	0,	
yycrank+-10168,	yysvec+1279,	0,	
yycrank+-10178,	yysvec+1280,	0,	
yycrank+-10248,	yysvec+890,	0,	
yycrank+-6019,	yysvec+958,	0,	
yycrank+-6004,	yysvec+814,	0,	
yycrank+-5986,	yysvec+815,	0,	
yycrank+-6015,	yysvec+457,	yyvstop+862,
yycrank+-6058,	yysvec+176,	0,	
yycrank+-5988,	yysvec+176,	0,	
yycrank+-6104,	yysvec+176,	0,	
yycrank+-6051,	yysvec+176,	0,	
yycrank+-6130,	yysvec+176,	0,	
yycrank+-5744,	yysvec+329,	0,	
yycrank+-6045,	yysvec+1252,	0,	
yycrank+-5913,	yysvec+1119,	0,	
yycrank+-6034,	yysvec+757,	0,	
yycrank+-5883,	yysvec+1044,	0,	
yycrank+-6074,	yysvec+904,	0,	
yycrank+-6047,	yysvec+544,	0,	
yycrank+-5901,	yysvec+1051,	0,	
yycrank+-6078,	yysvec+909,	0,	
yycrank+-6072,	yysvec+548,	0,	
yycrank+-9875,	yysvec+337,	0,	
yycrank+-6076,	yysvec+73,	0,	
yycrank+-6043,	yysvec+73,	0,	
yycrank+-6160,	yysvec+73,	0,	
yycrank+-6172,	yysvec+73,	0,	
yycrank+-6094,	yysvec+560,	0,	
yycrank+-6128,	yysvec+1065,	0,	
yycrank+-6092,	yysvec+923,	0,	
yycrank+-6173,	yysvec+17,	0,	
yycrank+-6179,	yysvec+17,	0,	
yycrank+-6180,	yysvec+17,	0,	
yycrank+-6185,	yysvec+17,	0,	
yycrank+-6170,	yysvec+17,	yyvstop+864,
yycrank+-6155,	yysvec+492,	0,	
yycrank+-10258,	0,		0,	
yycrank+-10321,	0,		0,	
yycrank+-6101,	yysvec+25,	yyvstop+866,
yycrank+-6171,	yysvec+25,	yyvstop+868,
yycrank+-6149,	yysvec+25,	yyvstop+870,
yycrank+-2183,	yysvec+25,	yyvstop+872,
yycrank+-1891,	yysvec+25,	yyvstop+874,
yycrank+-6163,	yysvec+505,	yyvstop+877,
yycrank+-6164,	yysvec+1010,	yyvstop+879,
yycrank+-6165,	yysvec+866,	yyvstop+881,
yycrank+-6175,	yysvec+157,	0,	
yycrank+-10363,	0,		0,	
yycrank+-6181,	yysvec+160,	0,	
yycrank+-6182,	yysvec+17,	0,	
yycrank+-6226,	yysvec+168,	0,	
yycrank+-6219,	yysvec+168,	0,	
yycrank+-2349,	yysvec+168,	0,	
yycrank+-6144,	yysvec+168,	0,	
yycrank+-9998,	yysvec+236,	0,	
yycrank+-1996,	yysvec+168,	yyvstop+883,
yycrank+-10382,	yysvec+1339,	0,	
yycrank+-10411,	yysvec+1340,	0,	
yycrank+-10453,	yysvec+1364,	0,	
yycrank+-6230,	yysvec+958,	0,	
yycrank+-6224,	yysvec+814,	0,	
yycrank+-6231,	yysvec+890,	0,	
yycrank+-6240,	yysvec+457,	yyvstop+886,
yycrank+-6244,	yysvec+176,	0,	
yycrank+-6229,	yysvec+176,	0,	
yycrank+-2484,	yysvec+176,	0,	
yycrank+-10480,	yysvec+318,	0,	
yycrank+-2002,	yysvec+176,	yyvstop+888,
yycrank+-6235,	yysvec+329,	0,	
yycrank+-6241,	yysvec+1252,	0,	
yycrank+-6253,	yysvec+1119,	0,	
yycrank+-6242,	yysvec+757,	0,	
yycrank+-6248,	yysvec+1044,	0,	
yycrank+-6227,	yysvec+904,	0,	
yycrank+-6254,	yysvec+544,	0,	
yycrank+-6251,	yysvec+1051,	0,	
yycrank+-6247,	yysvec+909,	0,	
yycrank+-6258,	yysvec+548,	0,	
yycrank+-6261,	yysvec+73,	0,	
yycrank+-6266,	yysvec+73,	0,	
yycrank+-6260,	yysvec+73,	0,	
yycrank+-2705,	yysvec+73,	0,	
yycrank+-2018,	yysvec+73,	yyvstop+891,
yycrank+-6264,	yysvec+560,	0,	
yycrank+-6272,	yysvec+1065,	0,	
yycrank+-6263,	yysvec+923,	0,	
yycrank+-6316,	yysvec+17,	0,	
yycrank+-6277,	yysvec+17,	0,	
yycrank+-6335,	yysvec+17,	0,	
yycrank+-10392,	yysvec+17,	0,	
yycrank+-6278,	yysvec+492,	0,	
yycrank+-6279,	yysvec+1339,	0,	
yycrank+-6280,	yysvec+1216,	0,	
yycrank+-6267,	yysvec+25,	yyvstop+893,
yycrank+-6274,	yysvec+25,	yyvstop+895,
yycrank+-6281,	yysvec+25,	yyvstop+897,
yycrank+-10510,	yysvec+25,	yyvstop+899,
yycrank+-6283,	yysvec+505,	yyvstop+901,
yycrank+-6287,	yysvec+1010,	yyvstop+903,
yycrank+-6289,	yysvec+866,	yyvstop+905,
yycrank+-10562,	yysvec+1090,	0,	
yycrank+-10684,	0,		0,	
yycrank+-10647,	yysvec+1092,	0,	
yycrank+-6337,	yysvec+17,	0,	
yycrank+-6276,	yysvec+168,	0,	
yycrank+-6318,	yysvec+168,	0,	
yycrank+-10773,	yysvec+168,	0,	
yycrank+-6307,	yysvec+168,	0,	
yycrank+-6349,	yysvec+168,	0,	
yycrank+-10783,	yysvec+1395,	0,	
yycrank+-10802,	yysvec+1396,	0,	
yycrank+-10872,	yysvec+126,	0,	
yycrank+-6321,	yysvec+958,	0,	
yycrank+-6383,	yysvec+814,	0,	
yycrank+-10995,	0,		0,	
yycrank+-6390,	yysvec+457,	yyvstop+907,
yycrank+-6385,	yysvec+176,	0,	
yycrank+-6391,	yysvec+176,	0,	
yycrank+-11005,	yysvec+176,	0,	
yycrank+-6393,	yysvec+176,	0,	
yycrank+-6392,	yysvec+329,	0,	
yycrank+-5944,	yysvec+1252,	0,	
yycrank+-6394,	yysvec+1119,	0,	
yycrank+-11062,	0,		0,	
yycrank+-6395,	yysvec+1044,	0,	
yycrank+-6403,	yysvec+904,	0,	
yycrank+-6405,	yysvec+544,	0,	
yycrank+-6409,	yysvec+1051,	0,	
yycrank+-6410,	yysvec+909,	0,	
yycrank+-6413,	yysvec+548,	0,	
yycrank+-6400,	yysvec+73,	0,	
yycrank+-6408,	yysvec+73,	0,	
yycrank+-6399,	yysvec+73,	0,	
yycrank+-11185,	yysvec+73,	0,	
yycrank+-6427,	yysvec+560,	0,	
yycrank+-6416,	yysvec+1065,	0,	
yycrank+-6420,	yysvec+923,	0,	
yycrank+-6444,	yysvec+17,	0,	
yycrank+-6496,	yysvec+17,	0,	
yycrank+-6527,	yysvec+17,	0,	
yycrank+-11195,	0,		0,	
yycrank+-10516,	0,		0,	
yycrank+-5766,	yysvec+1611,	0,	
yycrank+-6414,	yysvec+492,	0,	
yycrank+-11205,	0,		0,	
yycrank+-11275,	0,		0,	
yycrank+-6440,	yysvec+25,	yyvstop+909,
yycrank+-6422,	yysvec+25,	yyvstop+911,
yycrank+-6447,	yysvec+25,	yyvstop+913,
yycrank+-11285,	0,		yyvstop+915,
yycrank+0,	yysvec+1612,	yyvstop+917,
yycrank+-6483,	yysvec+1620,	yyvstop+919,
yycrank+-6514,	yysvec+505,	yyvstop+921,
yycrank+-6460,	yysvec+1010,	yyvstop+923,
yycrank+-6452,	yysvec+866,	yyvstop+925,
yycrank+-6449,	yysvec+157,	0,	
yycrank+-11295,	0,		0,	
yycrank+-6477,	yysvec+160,	0,	
yycrank+-6529,	yysvec+17,	0,	
yycrank+-6424,	yysvec+168,	0,	
yycrank+-6532,	yysvec+168,	0,	
yycrank+-11365,	0,		0,	
yycrank+-6513,	yysvec+1612,	0,	
yycrank+-6563,	yysvec+1632,	0,	
yycrank+-2146,	yysvec+168,	0,	
yycrank+-6488,	yysvec+168,	0,	
yycrank+-11355,	yysvec+1451,	0,	
yycrank+-11375,	yysvec+1216,	0,	
yycrank+-11445,	yysvec+815,	0,	
yycrank+-6538,	yysvec+958,	0,	
yycrank+-6549,	yysvec+814,	0,	
yycrank+-6541,	yysvec+1033,	0,	
yycrank+-6589,	yysvec+457,	yyvstop+927,
yycrank+-6489,	yysvec+176,	0,	
yycrank+-6608,	yysvec+176,	0,	
yycrank+-11455,	0,		0,	
yycrank+-6577,	yysvec+1612,	0,	
yycrank+-6611,	yysvec+1646,	0,	
yycrank+-6509,	yysvec+176,	0,	
yycrank+-6583,	yysvec+329,	0,	
yycrank+-6613,	yysvec+1252,	0,	
yycrank+-6537,	yysvec+1119,	0,	
yycrank+-6511,	yysvec+757,	0,	
yycrank+-6559,	yysvec+1044,	0,	
yycrank+-6551,	yysvec+904,	0,	
yycrank+-6634,	yysvec+544,	0,	
yycrank+-6562,	yysvec+1051,	0,	
yycrank+-6564,	yysvec+909,	0,	
yycrank+-6638,	yysvec+548,	0,	
yycrank+-6642,	yysvec+73,	0,	
yycrank+-6626,	yysvec+73,	0,	
yycrank+-6645,	yysvec+73,	0,	
yycrank+-11465,	0,		0,	
yycrank+0,	yysvec+1612,	yyvstop+929,
yycrank+-6637,	yysvec+1663,	0,	
yycrank+-6654,	yysvec+560,	0,	
yycrank+-6629,	yysvec+1065,	0,	
yycrank+-6631,	yysvec+923,	0,	
yycrank+-6647,	yysvec+17,	0,	
yycrank+-6649,	yysvec+17,	0,	
yycrank+-6694,	yysvec+17,	0,	
yycrank+-11535,	yysvec+17,	yyvstop+931,
yycrank+-11545,	0,		yyvstop+933,
yycrank+-6691,	yysvec+1611,	0,	
yycrank+-6646,	yysvec+492,	0,	
yycrank+-6597,	yysvec+1339,	0,	
yycrank+-11602,	0,		0,	
yycrank+-2172,	yysvec+25,	yyvstop+935,
yycrank+-2301,	yysvec+25,	yyvstop+937,
yycrank+-6633,	yysvec+25,	yyvstop+939,
yycrank+-11725,	yysvec+25,	yyvstop+941,
yycrank+-6693,	yysvec+1620,	yyvstop+944,
yycrank+-6648,	yysvec+505,	yyvstop+946,
yycrank+-6652,	yysvec+1010,	yyvstop+948,
yycrank+-11735,	0,		yyvstop+950,
yycrank+-6650,	yysvec+157,	0,	
yycrank+-11858,	yysvec+1092,	0,	
yycrank+-6653,	yysvec+160,	0,	
yycrank+-6749,	yysvec+17,	0,	
yycrank+-6651,	yysvec+168,	0,	
yycrank+-6657,	yysvec+168,	0,	
yycrank+-11889,	yysvec+168,	yyvstop+952,
yycrank+-2295,	yysvec+1612,	0,	
yycrank+-6738,	yysvec+1632,	0,	
yycrank+-2394,	yysvec+1632,	yyvstop+954,
yycrank+-6769,	yysvec+168,	0,	
yycrank+-6706,	yysvec+168,	0,	
yycrank+-11982,	yysvec+1507,	0,	
yycrank+-11994,	yysvec+1508,	0,	
yycrank+-12006,	yysvec+890,	0,	
yycrank+-6716,	yysvec+958,	0,	
yycrank+-12054,	yysvec+1677,	0,	
yycrank+-12177,	0,		0,	
yycrank+-6655,	yysvec+457,	yyvstop+956,
yycrank+-6713,	yysvec+176,	0,	
yycrank+-6715,	yysvec+176,	0,	
yycrank+-12187,	yysvec+176,	yyvstop+958,
yycrank+-2677,	yysvec+1612,	0,	
yycrank+-6785,	yysvec+1646,	0,	
yycrank+-2696,	yysvec+1646,	yyvstop+960,
yycrank+-6756,	yysvec+176,	0,	
yycrank+-10835,	yysvec+1251,	0,	
yycrank+-6742,	yysvec+1252,	0,	
yycrank+-6727,	yysvec+1119,	0,	
yycrank+-6722,	yysvec+757,	0,	
yycrank+-6770,	yysvec+1044,	0,	
yycrank+-12206,	0,		0,	
yycrank+-6707,	yysvec+544,	0,	
yycrank+-6777,	yysvec+1051,	0,	
yycrank+-12329,	0,		0,	
yycrank+-6744,	yysvec+548,	0,	
yycrank+-2697,	yysvec+73,	0,	
yycrank+-6791,	yysvec+73,	0,	
yycrank+-6771,	yysvec+73,	0,	
yycrank+-12452,	yysvec+73,	yyvstop+962,
yycrank+-6805,	yysvec+1663,	0,	
yycrank+-6787,	yysvec+560,	0,	
yycrank+-6800,	yysvec+1065,	0,	
yycrank+-12462,	0,		0,	
yycrank+-6890,	yysvec+17,	0,	
yycrank+-6851,	yysvec+17,	0,	
yycrank+-6845,	yysvec+17,	0,	
yycrank+-12585,	0,		0,	
yycrank+-2623,	yysvec+1673,	0,	
yycrank+-6834,	yysvec+1733,	0,	
yycrank+-6776,	yysvec+1611,	0,	
yycrank+-6759,	yysvec+492,	0,	
yycrank+-12595,	0,		0,	
yycrank+-6807,	yysvec+1152,	0,	
yycrank+-6880,	yysvec+25,	yyvstop+964,
yycrank+-6793,	yysvec+25,	yyvstop+966,
yycrank+-6860,	yysvec+25,	yyvstop+968,
yycrank+-12605,	0,		yyvstop+970,
yycrank+-2631,	yysvec+1673,	yyvstop+972,
yycrank+-6841,	yysvec+1743,	yyvstop+974,
yycrank+-6815,	yysvec+1620,	yyvstop+976,
yycrank+-6861,	yysvec+505,	yyvstop+978,
yycrank+-6692,	yysvec+1010,	yyvstop+980,
yycrank+-6887,	yysvec+866,	yyvstop+982,
yycrank+-6875,	yysvec+157,	0,	
yycrank+-6892,	yysvec+1518,	0,	
yycrank+-6883,	yysvec+160,	0,	
yycrank+-6896,	yysvec+17,	0,	
yycrank+-6893,	yysvec+168,	0,	
yycrank+-6891,	yysvec+168,	0,	
yycrank+-12675,	0,		0,	
yycrank+-6898,	yysvec+1673,	0,	
yycrank+-6904,	yysvec+1756,	0,	
yycrank+0,	yysvec+1612,	yyvstop+984,
yycrank+-6897,	yysvec+1632,	0,	
yycrank+-2717,	yysvec+168,	yyvstop+986,
yycrank+-2805,	yysvec+168,	0,	
yycrank+-12685,	yysvec+1339,	0,	
yycrank+-12695,	yysvec+1216,	0,	
yycrank+-12765,	yysvec+1585,	0,	
yycrank+-6899,	yysvec+958,	0,	
yycrank+-6907,	yysvec+814,	0,	
yycrank+-12775,	0,		0,	
yycrank+-6920,	yysvec+457,	yyvstop+989,
yycrank+-6916,	yysvec+176,	0,	
yycrank+-6922,	yysvec+176,	0,	
yycrank+-12794,	0,		0,	
yycrank+-7005,	yysvec+1673,	0,	
yycrank+-6998,	yysvec+1772,	0,	
yycrank+0,	yysvec+1612,	yyvstop+991,
yycrank+-6908,	yysvec+1646,	0,	
yycrank+-2811,	yysvec+176,	0,	
yycrank+-6924,	yysvec+329,	0,	
yycrank+-6868,	yysvec+1252,	0,	
yycrank+-6923,	yysvec+1119,	0,	
yycrank+-6811,	yysvec+757,	0,	
yycrank+-6970,	yysvec+1044,	0,	
yycrank+-6919,	yysvec+904,	0,	
yycrank+-6925,	yysvec+544,	0,	
yycrank+-6972,	yysvec+1051,	0,	
yycrank+-6926,	yysvec+909,	0,	
yycrank+-6974,	yysvec+548,	0,	
yycrank+-7008,	yysvec+73,	0,	
yycrank+-6984,	yysvec+73,	0,	
yycrank+-6983,	yysvec+73,	0,	
yycrank+-12836,	0,		0,	
yycrank+-2739,	yysvec+1673,	yyvstop+993,
yycrank+-7034,	yysvec+1791,	0,	
yycrank+-6995,	yysvec+1663,	0,	
yycrank+-7007,	yysvec+560,	0,	
yycrank+-7015,	yysvec+1065,	0,	
yycrank+-7011,	yysvec+923,	0,	
yycrank+-12865,	0,		0,	
yycrank+-7068,	yysvec+17,	0,	
yycrank+-7050,	yysvec+17,	0,	
yycrank+-7062,	yysvec+17,	yyvstop+995,
yycrank+0,	0,		yyvstop+997,
yycrank+-7059,	yysvec+1733,	0,	
yycrank+-7020,	yysvec+1611,	0,	
yycrank+-7021,	yysvec+492,	0,	
yycrank+-12909,	0,		0,	
yycrank+-7038,	yysvec+1216,	0,	
yycrank+-13032,	0,		yyvstop+999,
yycrank+-7023,	yysvec+25,	yyvstop+1001,
yycrank+-7024,	yysvec+25,	yyvstop+1003,
yycrank+-2975,	yysvec+25,	yyvstop+1005,
yycrank+-7108,	yysvec+1743,	yyvstop+1008,
yycrank+-7025,	yysvec+1620,	yyvstop+1010,
yycrank+-7032,	yysvec+505,	yyvstop+1012,
yycrank+-13059,	0,		yyvstop+1014,
yycrank+-7040,	yysvec+866,	yyvstop+1016,
yycrank+-2980,	yysvec+157,	0,	
yycrank+-7064,	yysvec+513,	0,	
yycrank+-2987,	yysvec+160,	0,	
yycrank+-7069,	yysvec+17,	0,	
yycrank+-7067,	yysvec+168,	0,	
yycrank+-7048,	yysvec+168,	0,	
yycrank+-2992,	yysvec+168,	yyvstop+1018,
yycrank+-7061,	yysvec+1673,	0,	
yycrank+-7184,	yysvec+1756,	0,	
yycrank+-3147,	yysvec+1756,	yyvstop+1020,
yycrank+-7071,	yysvec+1632,	0,	
yycrank+-7187,	yysvec+168,	0,	
yycrank+-13182,	yysvec+1615,	0,	
yycrank+-13192,	yysvec+1616,	0,	
yycrank+-13249,	yysvec+1033,	0,	
yycrank+-13293,	yysvec+1806,	0,	
yycrank+-7105,	yysvec+814,	0,	
yycrank+-13416,	0,		0,	
yycrank+-7045,	yysvec+457,	yyvstop+1022,
yycrank+-7088,	yysvec+176,	0,	
yycrank+-7106,	yysvec+176,	0,	
yycrank+-3148,	yysvec+176,	yyvstop+1024,
yycrank+-7074,	yysvec+1673,	0,	
yycrank+-7194,	yysvec+1772,	0,	
yycrank+-3301,	yysvec+1772,	yyvstop+1026,
yycrank+-7150,	yysvec+1646,	0,	
yycrank+-7202,	yysvec+176,	0,	
yycrank+-7168,	yysvec+329,	0,	
yycrank+-7041,	yysvec+1252,	0,	
yycrank+-7152,	yysvec+1119,	0,	
yycrank+-7070,	yysvec+757,	0,	
yycrank+-13443,	0,		0,	
yycrank+-7153,	yysvec+904,	0,	
yycrank+-7162,	yysvec+544,	0,	
yycrank+-13566,	0,		0,	
yycrank+-7163,	yysvec+909,	0,	
yycrank+-7174,	yysvec+548,	0,	
yycrank+-13689,	0,		0,	
yycrank+-7173,	yysvec+73,	0,	
yycrank+-7176,	yysvec+73,	0,	
yycrank+-3459,	yysvec+73,	yyvstop+1028,
yycrank+-7208,	yysvec+1791,	0,	
yycrank+-7170,	yysvec+1663,	0,	
yycrank+-7200,	yysvec+560,	0,	
yycrank+-13716,	0,		0,	
yycrank+-7180,	yysvec+923,	0,	
yycrank+0,	0,		yyvstop+1030,
yycrank+-7072,	yysvec+1798,	0,	
yycrank+-7197,	yysvec+17,	0,	
yycrank+-7209,	yysvec+17,	0,	
yycrank+-7210,	yysvec+1733,	0,	
yycrank+-7190,	yysvec+1611,	0,	
yycrank+-11032,	yysvec+1394,	0,	
yycrank+-7213,	yysvec+1279,	0,	
yycrank+-13839,	0,		0,	
yycrank+0,	0,		yyvstop+1032,
yycrank+-7248,	yysvec+1808,	yyvstop+1035,
yycrank+-7186,	yysvec+25,	yyvstop+1037,
yycrank+-7204,	yysvec+25,	yyvstop+1039,
yycrank+-7211,	yysvec+1743,	yyvstop+1041,
yycrank+-7214,	yysvec+1620,	yyvstop+1043,
yycrank+-11572,	yysvec+1402,	yyvstop+1045,
yycrank+-7217,	yysvec+1010,	yyvstop+1047,
yycrank+-7251,	yysvec+866,	yyvstop+1049,
yycrank+-7300,	yysvec+157,	0,	
yycrank+-7292,	yysvec+797,	0,	
yycrank+-7326,	yysvec+160,	0,	
yycrank+-7329,	yysvec+17,	0,	
yycrank+-7233,	yysvec+168,	0,	
yycrank+-7253,	yysvec+168,	0,	
yycrank+-3414,	yysvec+1673,	yyvstop+1051,
yycrank+-7220,	yysvec+1756,	0,	
yycrank+-7221,	yysvec+1632,	0,	
yycrank+-13849,	0,		yyvstop+1053,
yycrank+-13859,	yysvec+1339,	0,	
yycrank+-13939,	yysvec+1677,	0,	
yycrank+-14062,	yysvec+1703,	0,	
yycrank+-7307,	yysvec+958,	0,	
yycrank+-7304,	yysvec+814,	0,	
yycrank+-14089,	yysvec+126,	0,	
yycrank+-12292,	yysvec+1421,	yyvstop+1055,
yycrank+-7256,	yysvec+176,	0,	
yycrank+-7277,	yysvec+176,	0,	
yycrank+-3429,	yysvec+1673,	yyvstop+1057,
yycrank+-7284,	yysvec+1772,	0,	
yycrank+-7301,	yysvec+1646,	0,	
yycrank+-14212,	0,		yyvstop+1059,
yycrank+-7321,	yysvec+329,	0,	
yycrank+-7298,	yysvec+1252,	0,	
yycrank+-14239,	0,		0,	
yycrank+-7313,	yysvec+757,	0,	
yycrank+-7315,	yysvec+1044,	0,	
yycrank+-7294,	yysvec+904,	0,	
yycrank+-13529,	yysvec+1433,	0,	
yycrank+-7318,	yysvec+1051,	0,	
yycrank+-7328,	yysvec+909,	0,	
yycrank+-13903,	yysvec+1436,	0,	
yycrank+0,	0,		yyvstop+1061,
yycrank+-7339,	yysvec+1854,	0,	
yycrank+-7341,	yysvec+73,	0,	
yycrank+-7338,	yysvec+73,	0,	
yycrank+-7333,	yysvec+1791,	0,	
yycrank+-7343,	yysvec+1663,	0,	
yycrank+-14266,	yysvec+1442,	0,	
yycrank+-7344,	yysvec+1065,	0,	
yycrank+-7358,	yysvec+923,	0,	
yycrank+-7387,	yysvec+1798,	0,	
yycrank+-7405,	yysvec+17,	0,	
yycrank+-7391,	yysvec+17,	0,	
yycrank+-7369,	yysvec+1733,	0,	
yycrank+-7376,	yysvec+1611,	0,	
yycrank+-7394,	yysvec+492,	0,	
yycrank+-7411,	yysvec+1339,	0,	
yycrank+-7393,	yysvec+1340,	0,	
yycrank+-7446,	yysvec+1808,	yyvstop+1064,
yycrank+-7390,	yysvec+25,	yyvstop+1066,
yycrank+-7454,	yysvec+25,	yyvstop+1068,
yycrank+-7415,	yysvec+1743,	yyvstop+1070,
yycrank+-7420,	yysvec+1620,	yyvstop+1072,
yycrank+-7425,	yysvec+505,	yyvstop+1074,
yycrank+-7422,	yysvec+1010,	yyvstop+1076,
yycrank+-7434,	yysvec+866,	yyvstop+1078,
yycrank+-14388,	0,		0,	
yycrank+-14391,	yysvec+160,	0,	
yycrank+-14407,	0,		0,	
yycrank+-7458,	yysvec+17,	0,	
yycrank+-7427,	yysvec+168,	0,	
yycrank+-7455,	yysvec+168,	0,	
yycrank+-7461,	yysvec+1756,	0,	
yycrank+-7464,	yysvec+1632,	0,	
yycrank+-3593,	yysvec+1890,	0,	
yycrank+0,	yysvec+170,	yyvstop+1080,
yycrank+-7469,	yysvec+1890,	0,	
yycrank+-14451,	yysvec+1738,	0,	
yycrank+-14497,	yysvec+1152,	0,	
yycrank+-14511,	yysvec+1768,	0,	
yycrank+-7465,	yysvec+958,	0,	
yycrank+-7467,	yysvec+814,	0,	
yycrank+-7471,	yysvec+1703,	0,	
yycrank+-7472,	yysvec+457,	yyvstop+1082,
yycrank+-7475,	yysvec+176,	0,	
yycrank+-7468,	yysvec+176,	0,	
yycrank+-7476,	yysvec+1772,	0,	
yycrank+-7477,	yysvec+1646,	0,	
yycrank+-3608,	yysvec+1903,	0,	
yycrank+0,	yysvec+178,	yyvstop+1084,
yycrank+-7572,	yysvec+1903,	0,	
yycrank+-3616,	yysvec+329,	0,	
yycrank+-7473,	yysvec+1252,	0,	
yycrank+-7480,	yysvec+1119,	0,	
yycrank+-7453,	yysvec+757,	0,	
yycrank+-7482,	yysvec+1044,	0,	
yycrank+-7543,	yysvec+904,	0,	
yycrank+-7485,	yysvec+544,	0,	
yycrank+-7483,	yysvec+1051,	0,	
yycrank+-7557,	yysvec+909,	0,	
yycrank+-7486,	yysvec+548,	0,	
yycrank+-7606,	yysvec+1854,	0,	
yycrank+-7550,	yysvec+73,	0,	
yycrank+-7544,	yysvec+73,	0,	
yycrank+-7535,	yysvec+1791,	0,	
yycrank+-7489,	yysvec+1663,	0,	
yycrank+-7609,	yysvec+560,	0,	
yycrank+-7553,	yysvec+1065,	0,	
yycrank+-7569,	yysvec+923,	0,	
yycrank+-7531,	yysvec+1798,	0,	
yycrank+-7678,	yysvec+17,	0,	
yycrank+-7680,	yysvec+17,	0,	
yycrank+-7571,	yysvec+1733,	0,	
yycrank+-7614,	yysvec+1611,	0,	
yycrank+-7576,	yysvec+492,	0,	
yycrank+-14568,	0,		0,	
yycrank+-14614,	0,		0,	
yycrank+-7578,	yysvec+1808,	yyvstop+1086,
yycrank+-7611,	yysvec+25,	yyvstop+1088,
yycrank+-7650,	yysvec+25,	yyvstop+1090,
yycrank+-7651,	yysvec+1743,	yyvstop+1092,
yycrank+-7656,	yysvec+1620,	yyvstop+1094,
yycrank+-7655,	yysvec+505,	yyvstop+1096,
yycrank+-7658,	yysvec+1010,	yyvstop+1098,
yycrank+-7660,	yysvec+866,	yyvstop+1100,
yycrank+0,	yysvec+158,	yyvstop+1102,
yycrank+-7692,	yysvec+1939,	0,	
yycrank+-3624,	yysvec+1798,	yyvstop+1104,
yycrank+-14634,	0,		0,	
yycrank+0,	yysvec+161,	yyvstop+1106,
yycrank+-3730,	yysvec+1798,	yyvstop+1108,
yycrank+-7698,	yysvec+1941,	0,	
yycrank+-9500,	yysvec+1941,	0,	
yycrank+-7715,	yysvec+17,	0,	
yycrank+-7668,	yysvec+168,	0,	
yycrank+-7661,	yysvec+168,	0,	
yycrank+-7667,	yysvec+1756,	0,	
yycrank+-7677,	yysvec+1632,	0,	
yycrank+-7718,	yysvec+1890,	0,	
yycrank+-14694,	yysvec+1806,	0,	
yycrank+-14817,	yysvec+1216,	0,	
yycrank+-14827,	yysvec+1834,	0,	
yycrank+-7671,	yysvec+958,	0,	
yycrank+-7714,	yysvec+814,	0,	
yycrank+-7666,	yysvec+745,	0,	
yycrank+-7674,	yysvec+457,	yyvstop+1110,
yycrank+-7676,	yysvec+176,	0,	
yycrank+-7686,	yysvec+176,	0,	
yycrank+-7696,	yysvec+1772,	0,	
yycrank+-7690,	yysvec+1646,	0,	
yycrank+-7778,	yysvec+1903,	0,	
yycrank+-7784,	yysvec+329,	0,	
yycrank+-14886,	0,		0,	
yycrank+-7731,	yysvec+1119,	0,	
yycrank+-7706,	yysvec+757,	0,	
yycrank+-7710,	yysvec+1044,	0,	
yycrank+-7688,	yysvec+904,	0,	
yycrank+-7700,	yysvec+544,	0,	
yycrank+-7783,	yysvec+1051,	0,	
yycrank+-7797,	yysvec+909,	0,	
yycrank+-7785,	yysvec+548,	0,	
yycrank+-7693,	yysvec+1854,	0,	
yycrank+-7791,	yysvec+73,	0,	
yycrank+-7799,	yysvec+73,	0,	
yycrank+-7802,	yysvec+1791,	0,	
yycrank+-7721,	yysvec+1663,	0,	
yycrank+-7801,	yysvec+560,	0,	
yycrank+-7806,	yysvec+1065,	0,	
yycrank+-7807,	yysvec+923,	0,	
yycrank+-7805,	yysvec+1798,	0,	
yycrank+-7865,	yysvec+17,	0,	
yycrank+-7866,	yysvec+17,	0,	
yycrank+-7808,	yysvec+1733,	0,	
yycrank+-7570,	yysvec+1611,	0,	
yycrank+-7575,	yysvec+492,	0,	
yycrank+-7679,	yysvec+1451,	0,	
yycrank+-15009,	0,		0,	
yycrank+-7809,	yysvec+1808,	yyvstop+1112,
yycrank+-7825,	yysvec+25,	yyvstop+1114,
yycrank+-7812,	yysvec+25,	yyvstop+1116,
yycrank+-7821,	yysvec+1743,	yyvstop+1118,
yycrank+-7827,	yysvec+1620,	yyvstop+1120,
yycrank+-7914,	yysvec+505,	yyvstop+1122,
yycrank+-7921,	yysvec+1010,	yyvstop+1124,
yycrank+-7810,	yysvec+866,	yyvstop+1126,
yycrank+-7877,	yysvec+1939,	0,	
yycrank+-14846,	yysvec+1941,	0,	
yycrank+-7945,	yysvec+1941,	0,	
yycrank+-12846,	yysvec+161,	yyvstop+1128,
yycrank+-15012,	yysvec+1941,	0,	
yycrank+-7892,	yysvec+17,	yyvstop+1130,
yycrank+-7895,	yysvec+168,	0,	
yycrank+-7900,	yysvec+168,	0,	
yycrank+-7881,	yysvec+1756,	0,	
yycrank+-7934,	yysvec+1632,	0,	
yycrank+-7837,	yysvec+1890,	0,	
yycrank+-15028,	yysvec+1279,	0,	
yycrank+-15117,	yysvec+1871,	0,	
yycrank+-15144,	yysvec+126,	0,	
yycrank+-7959,	yysvec+958,	0,	
yycrank+-7947,	yysvec+814,	0,	
yycrank+-7960,	yysvec+1033,	0,	
yycrank+-7961,	yysvec+457,	yyvstop+1132,
yycrank+-7897,	yysvec+176,	0,	
yycrank+-7915,	yysvec+176,	0,	
yycrank+-7929,	yysvec+1772,	0,	
yycrank+-7962,	yysvec+1646,	0,	
yycrank+-7913,	yysvec+1903,	0,	
yycrank+-15267,	0,		0,	
yycrank+-7927,	yysvec+1252,	0,	
yycrank+-7931,	yysvec+1119,	0,	
yycrank+-14663,	yysvec+1594,	0,	
yycrank+-7963,	yysvec+1044,	0,	
yycrank+-7944,	yysvec+904,	0,	
yycrank+-7985,	yysvec+544,	0,	
yycrank+-7993,	yysvec+1051,	0,	
yycrank+-7948,	yysvec+909,	0,	
yycrank+-7997,	yysvec+548,	0,	
yycrank+-7922,	yysvec+1854,	0,	
yycrank+-7955,	yysvec+73,	0,	
yycrank+-7964,	yysvec+73,	0,	
yycrank+-8006,	yysvec+1791,	0,	
yycrank+-8012,	yysvec+1663,	0,	
yycrank+-8018,	yysvec+560,	0,	
yycrank+-8019,	yysvec+1065,	0,	
yycrank+-7969,	yysvec+923,	0,	
yycrank+-7971,	yysvec+1798,	0,	
yycrank+-8026,	yysvec+17,	0,	
yycrank+-8042,	yysvec+17,	0,	
yycrank+-7832,	yysvec+1733,	0,	
yycrank+-8003,	yysvec+1611,	0,	
yycrank+-3734,	yysvec+492,	0,	
yycrank+-15277,	0,		0,	
yycrank+-15287,	0,		0,	
yycrank+-8011,	yysvec+1808,	yyvstop+1134,
yycrank+-8014,	yysvec+25,	yyvstop+1136,
yycrank+-8015,	yysvec+25,	yyvstop+1138,
yycrank+-8022,	yysvec+1743,	yyvstop+1140,
yycrank+-8020,	yysvec+1620,	yyvstop+1142,
yycrank+-3855,	yysvec+505,	yyvstop+1144,
yycrank+-7966,	yysvec+1010,	yyvstop+1146,
yycrank+-8023,	yysvec+866,	yyvstop+1148,
yycrank+-8034,	yysvec+1939,	0,	
yycrank+-8044,	yysvec+1941,	0,	
yycrank+-15357,	0,		0,	
yycrank+-8024,	yysvec+168,	0,	
yycrank+-8050,	yysvec+168,	0,	
yycrank+-8047,	yysvec+1756,	0,	
yycrank+-8056,	yysvec+1632,	0,	
yycrank+-8049,	yysvec+1890,	0,	
yycrank+-15367,	yysvec+1339,	0,	
yycrank+-15386,	yysvec+1340,	0,	
yycrank+-15428,	yysvec+1703,	0,	
yycrank+-8058,	yysvec+958,	0,	
yycrank+-8068,	yysvec+814,	0,	
yycrank+-15447,	yysvec+17,	0,	
yycrank+-3856,	yysvec+457,	yyvstop+1150,
yycrank+-8057,	yysvec+176,	0,	
yycrank+-8060,	yysvec+176,	0,	
yycrank+-8059,	yysvec+1772,	0,	
yycrank+-8066,	yysvec+1646,	0,	
yycrank+-8073,	yysvec+1903,	0,	
yycrank+0,	yysvec+330,	yyvstop+1152,
yycrank+-8102,	yysvec+2081,	0,	
yycrank+-3864,	yysvec+1798,	yyvstop+1154,
yycrank+-8077,	yysvec+1252,	0,	
yycrank+-8105,	yysvec+1119,	0,	
yycrank+-8075,	yysvec+757,	0,	
yycrank+-8078,	yysvec+1044,	0,	
yycrank+-8076,	yysvec+904,	0,	
yycrank+-3877,	yysvec+544,	0,	
yycrank+-8116,	yysvec+1051,	0,	
yycrank+-8083,	yysvec+909,	0,	
yycrank+-3885,	yysvec+548,	0,	
yycrank+-8079,	yysvec+1854,	0,	
yycrank+-8107,	yysvec+73,	0,	
yycrank+-8091,	yysvec+73,	0,	
yycrank+-8070,	yysvec+1791,	0,	
yycrank+-8115,	yysvec+1663,	0,	
yycrank+-3892,	yysvec+560,	0,	
yycrank+-8131,	yysvec+1065,	0,	
yycrank+-8132,	yysvec+923,	0,	
yycrank+-8156,	yysvec+1798,	0,	
yycrank+-15457,	0,		0,	
yycrank+-8170,	yysvec+17,	0,	
yycrank+-8158,	yysvec+1733,	0,	
yycrank+-8162,	yysvec+1611,	0,	
yycrank+-8235,	yysvec+492,	0,	
yycrank+-15476,	0,		0,	
yycrank+-15503,	yysvec+1677,	0,	
yycrank+-8183,	yysvec+1808,	yyvstop+1156,
yycrank+-15537,	yysvec+25,	yyvstop+1158,
yycrank+-8151,	yysvec+25,	yyvstop+1160,
yycrank+-8194,	yysvec+1743,	yyvstop+1162,
yycrank+-8186,	yysvec+1620,	yyvstop+1164,
yycrank+-8239,	yysvec+505,	yyvstop+1166,
yycrank+-8190,	yysvec+1010,	yyvstop+1168,
yycrank+-15584,	yysvec+1685,	yyvstop+1170,
yycrank+-8188,	yysvec+1939,	0,	
yycrank+-8193,	yysvec+1941,	0,	
yycrank+-15706,	0,		0,	
yycrank+-15716,	yysvec+168,	0,	
yycrank+-8196,	yysvec+168,	0,	
yycrank+-8213,	yysvec+1756,	0,	
yycrank+-8187,	yysvec+1632,	0,	
yycrank+-8201,	yysvec+1890,	0,	
yycrank+-15725,	yysvec+1988,	0,	
yycrank+-15735,	yysvec+1989,	0,	
yycrank+-15796,	yysvec+745,	0,	
yycrank+-8195,	yysvec+958,	0,	
yycrank+-15825,	yysvec+1677,	0,	
yycrank+-15948,	0,		0,	
yycrank+-8274,	yysvec+457,	yyvstop+1172,
yycrank+-15958,	yysvec+176,	0,	
yycrank+-8208,	yysvec+176,	0,	
yycrank+-8227,	yysvec+1772,	0,	
yycrank+-8223,	yysvec+1646,	0,	
yycrank+-8220,	yysvec+1903,	0,	
yycrank+-8270,	yysvec+2081,	0,	
yycrank+-8247,	yysvec+1252,	0,	
yycrank+-8248,	yysvec+1119,	0,	
yycrank+-8252,	yysvec+757,	0,	
yycrank+-8229,	yysvec+1044,	0,	
yycrank+-15985,	yysvec+1717,	0,	
yycrank+-8310,	yysvec+544,	0,	
yycrank+-8265,	yysvec+1051,	0,	
yycrank+-16012,	yysvec+1720,	0,	
yycrank+-8317,	yysvec+548,	0,	
yycrank+-8233,	yysvec+1854,	0,	
yycrank+-16134,	yysvec+73,	0,	
yycrank+-8267,	yysvec+73,	0,	
yycrank+-8290,	yysvec+1791,	0,	
yycrank+-8271,	yysvec+1663,	0,	
yycrank+-8326,	yysvec+560,	0,	
yycrank+-8272,	yysvec+1065,	0,	
yycrank+-16097,	yysvec+1729,	0,	
yycrank+-8316,	yysvec+1798,	0,	
yycrank+-8321,	yysvec+2156,	0,	
yycrank+-8411,	yysvec+2156,	0,	
yycrank+-8328,	yysvec+17,	0,	
yycrank+-8319,	yysvec+1733,	0,	
yycrank+-8320,	yysvec+1611,	0,	
yycrank+-16223,	0,		0,	
yycrank+-16233,	0,		0,	
yycrank+-8273,	yysvec+1989,	0,	
yycrank+-8323,	yysvec+1808,	yyvstop+1174,
yycrank+-16243,	0,		yyvstop+1176,
yycrank+-8333,	yysvec+2219,	yyvstop+1178,
yycrank+-8308,	yysvec+25,	yyvstop+1180,
yycrank+-8337,	yysvec+1743,	yyvstop+1182,
yycrank+-8324,	yysvec+1620,	yyvstop+1184,
yycrank+-16313,	0,		yyvstop+1186,
yycrank+-8327,	yysvec+1010,	yyvstop+1188,
yycrank+-8336,	yysvec+866,	yyvstop+1190,
yycrank+-8329,	yysvec+1939,	0,	
yycrank+-8335,	yysvec+1941,	0,	
yycrank+-16332,	0,		0,	
yycrank+-16342,	0,		0,	
yycrank+-8342,	yysvec+2230,	0,	
yycrank+-8318,	yysvec+168,	0,	
yycrank+-8338,	yysvec+1756,	0,	
yycrank+-8344,	yysvec+1632,	0,	
yycrank+-8345,	yysvec+1890,	0,	
yycrank+-16361,	yysvec+1451,	0,	
yycrank+-16422,	yysvec+2049,	0,	
yycrank+-16441,	yysvec+1033,	0,	
yycrank+-8382,	yysvec+958,	0,	
yycrank+-8394,	yysvec+814,	0,	
yycrank+-16451,	yysvec+1798,	0,	
yycrank+-16470,	0,		yyvstop+1192,
yycrank+-16512,	0,		0,	
yycrank+-8441,	yysvec+2243,	0,	
yycrank+-8343,	yysvec+176,	0,	
yycrank+-8349,	yysvec+1772,	0,	
yycrank+-8400,	yysvec+1646,	0,	
yycrank+-8389,	yysvec+1903,	0,	
yycrank+-8413,	yysvec+2081,	0,	
yycrank+-8425,	yysvec+1252,	0,	
yycrank+-8407,	yysvec+1119,	0,	
yycrank+-8429,	yysvec+757,	0,	
yycrank+-8418,	yysvec+1044,	0,	
yycrank+-8414,	yysvec+904,	0,	
yycrank+-16531,	0,		0,	
yycrank+-8421,	yysvec+1051,	0,	
yycrank+-8447,	yysvec+909,	0,	
yycrank+-16541,	0,		0,	
yycrank+-8423,	yysvec+1854,	0,	
yycrank+-16560,	0,		0,	
yycrank+-8459,	yysvec+2260,	0,	
yycrank+-8433,	yysvec+73,	0,	
yycrank+-8449,	yysvec+1791,	0,	
yycrank+-8443,	yysvec+1663,	0,	
yycrank+-16602,	0,		0,	
yycrank+-8431,	yysvec+1065,	0,	
yycrank+-8450,	yysvec+923,	0,	
yycrank+-8461,	yysvec+1798,	0,	
yycrank+0,	0,		yyvstop+1194,
yycrank+-8560,	yysvec+2156,	0,	
yycrank+-16621,	0,		0,	
yycrank+-8436,	yysvec+1733,	0,	
yycrank+-8453,	yysvec+1611,	0,	
yycrank+0,	yysvec+494,	yyvstop+1196,
yycrank+-8487,	yysvec+2215,	0,	
yycrank+-3974,	yysvec+1798,	yyvstop+1198,
yycrank+-16648,	yysvec+1806,	0,	
yycrank+-8452,	yysvec+1079,	0,	
yycrank+-8472,	yysvec+1808,	yyvstop+1200,
yycrank+0,	0,		yyvstop+1202,
yycrank+-8503,	yysvec+2219,	yyvstop+1205,
yycrank+-16678,	yysvec+25,	yyvstop+1207,
yycrank+-8467,	yysvec+1743,	yyvstop+1209,
yycrank+-8474,	yysvec+1620,	yyvstop+1211,
yycrank+0,	yysvec+494,	yyvstop+1213,
yycrank+-8529,	yysvec+2224,	yyvstop+1216,
yycrank+-4009,	yysvec+1808,	yyvstop+1218,
yycrank+-16730,	yysvec+1815,	yyvstop+1221,
yycrank+-8464,	yysvec+866,	yyvstop+1223,
yycrank+-8482,	yysvec+1939,	0,	
yycrank+-8484,	yysvec+1941,	0,	
yycrank+-16852,	0,		0,	
yycrank+0,	yysvec+170,	yyvstop+1225,
yycrank+-8534,	yysvec+2230,	0,	
yycrank+-4028,	yysvec+2230,	yyvstop+1227,
yycrank+-16862,	yysvec+168,	0,	
yycrank+-8521,	yysvec+1756,	0,	
yycrank+-8530,	yysvec+1632,	0,	
yycrank+-8494,	yysvec+1890,	0,	
yycrank+-16872,	yysvec+2105,	0,	
yycrank+-16942,	yysvec+2106,	0,	
yycrank+-16952,	yysvec+17,	0,	
yycrank+-17009,	yysvec+1806,	0,	
yycrank+-8539,	yysvec+814,	0,	
yycrank+-4686,	yysvec+528,	yyvstop+1229,
yycrank+-17132,	yysvec+1798,	0,	
yycrank+-4131,	yysvec+1798,	yyvstop+1231,
yycrank+0,	0,		yyvstop+1233,
yycrank+-8540,	yysvec+2242,	yyvstop+1236,
yycrank+0,	yysvec+178,	yyvstop+1238,
yycrank+-8547,	yysvec+2243,	0,	
yycrank+-4146,	yysvec+2243,	yyvstop+1240,
yycrank+-17142,	yysvec+176,	0,	
yycrank+-8545,	yysvec+1772,	0,	
yycrank+-8546,	yysvec+1646,	0,	
yycrank+-8505,	yysvec+1903,	0,	
yycrank+-8536,	yysvec+2081,	0,	
yycrank+-8548,	yysvec+1252,	0,	
yycrank+-8554,	yysvec+1119,	0,	
yycrank+-4147,	yysvec+757,	0,	
yycrank+-16979,	yysvec+1848,	0,	
yycrank+-8552,	yysvec+904,	0,	
yycrank+0,	yysvec+545,	yyvstop+1242,
yycrank+-8598,	yysvec+2255,	0,	
yycrank+-4154,	yysvec+1798,	yyvstop+1244,
yycrank+-17169,	yysvec+1851,	0,	
yycrank+-8555,	yysvec+909,	0,	
yycrank+0,	yysvec+549,	yyvstop+1246,
yycrank+-8600,	yysvec+2258,	0,	
yycrank+-4306,	yysvec+1798,	yyvstop+1248,
yycrank+-8586,	yysvec+1854,	0,	
yycrank+0,	0,		yyvstop+1250,
yycrank+-8635,	yysvec+2260,	0,	
yycrank+-17199,	yysvec+73,	0,	
yycrank+-8562,	yysvec+1791,	0,	
yycrank+-8574,	yysvec+1663,	0,	
yycrank+0,	yysvec+494,	yyvstop+1253,
yycrank+-8616,	yysvec+2265,	0,	
yycrank+-4469,	yysvec+1854,	yyvstop+1256,
yycrank+-17251,	yysvec+1861,	0,	
yycrank+-8556,	yysvec+923,	0,	
yycrank+-8542,	yysvec+1798,	0,	
yycrank+-8610,	yysvec+2156,	0,	
yycrank+-8624,	yysvec+2271,	0,	
yycrank+-8639,	yysvec+2271,	0,	
yycrank+-8618,	yysvec+1733,	0,	
yycrank+-8613,	yysvec+1611,	0,	
yycrank+-8674,	yysvec+2215,	0,	
yycrank+-8622,	yysvec+2105,	0,	
yycrank+-8630,	yysvec+1340,	0,	
yycrank+-8582,	yysvec+1808,	yyvstop+1258,
yycrank+-8596,	yysvec+2219,	yyvstop+1260,
yycrank+-17373,	0,		yyvstop+1262,
yycrank+-8627,	yysvec+2353,	yyvstop+1264,
yycrank+-8626,	yysvec+1743,	yyvstop+1266,
yycrank+-8623,	yysvec+1620,	yyvstop+1268,
yycrank+-8711,	yysvec+2224,	yyvstop+1270,
yycrank+-8631,	yysvec+1010,	yyvstop+1272,
yycrank+-8687,	yysvec+866,	yyvstop+1274,
yycrank+-8636,	yysvec+1939,	0,	
yycrank+-8637,	yysvec+1941,	0,	
yycrank+-17383,	0,		0,	
yycrank+-8640,	yysvec+2230,	0,	
yycrank+-17393,	0,		0,	
yycrank+-8732,	yysvec+2364,	0,	
yycrank+-8638,	yysvec+1756,	0,	
yycrank+-8684,	yysvec+1632,	0,	
yycrank+-8690,	yysvec+1890,	0,	
yycrank+-17453,	yysvec+2161,	0,	
yycrank+-17482,	yysvec+1677,	0,	
yycrank+-17605,	yysvec+2184,	0,	
yycrank+-8679,	yysvec+958,	0,	
yycrank+-8710,	yysvec+814,	0,	
yycrank+-17621,	0,		0,	
yycrank+-8729,	yysvec+2242,	yyvstop+1276,
yycrank+-8705,	yysvec+2243,	0,	
yycrank+-17678,	0,		0,	
yycrank+-8754,	yysvec+2377,	0,	
yycrank+-8698,	yysvec+1772,	0,	
yycrank+-8708,	yysvec+1646,	0,	
yycrank+-8722,	yysvec+1903,	0,	
yycrank+-8725,	yysvec+2081,	0,	
yycrank+-8743,	yysvec+1252,	0,	
yycrank+-17648,	yysvec+1906,	0,	
yycrank+-8783,	yysvec+757,	0,	
yycrank+-8724,	yysvec+1044,	0,	
yycrank+-8749,	yysvec+904,	0,	
yycrank+-8768,	yysvec+2255,	0,	
yycrank+-8757,	yysvec+1051,	0,	
yycrank+-8758,	yysvec+909,	0,	
yycrank+-8819,	yysvec+2258,	0,	
yycrank+-8764,	yysvec+1854,	0,	
yycrank+-8747,	yysvec+2260,	0,	
yycrank+-17771,	0,		0,	
yycrank+-8824,	yysvec+2394,	0,	
yycrank+-8774,	yysvec+1791,	0,	
yycrank+-8755,	yysvec+1663,	0,	
yycrank+-8835,	yysvec+2265,	0,	
yycrank+-8778,	yysvec+1065,	0,	
yycrank+-8832,	yysvec+923,	0,	
yycrank+-8742,	yysvec+1798,	0,	
yycrank+-8870,	yysvec+2156,	0,	
yycrank+0,	0,		yyvstop+1278,
yycrank+-8866,	yysvec+2271,	0,	
yycrank+-8828,	yysvec+1733,	0,	
yycrank+-17798,	0,		0,	
yycrank+-8792,	yysvec+2215,	0,	
yycrank+-8744,	yysvec+1215,	0,	
yycrank+-17921,	yysvec+814,	0,	
yycrank+-8830,	yysvec+1808,	yyvstop+1280,
yycrank+-8829,	yysvec+2219,	yyvstop+1282,
yycrank+0,	0,		yyvstop+1284,
yycrank+-8872,	yysvec+2353,	yyvstop+1287,
yycrank+-8840,	yysvec+1743,	yyvstop+1289,
yycrank+-17948,	0,		yyvstop+1291,
yycrank+-8836,	yysvec+2224,	yyvstop+1293,
yycrank+-8841,	yysvec+1010,	yyvstop+1295,
yycrank+-4483,	yysvec+866,	yyvstop+1297,
yycrank+-8856,	yysvec+1939,	0,	
yycrank+-8858,	yysvec+1941,	0,	
yycrank+-18071,	0,		0,	
yycrank+-8850,	yysvec+2230,	0,	
yycrank+0,	yysvec+170,	yyvstop+1299,
yycrank+-8897,	yysvec+2364,	0,	
yycrank+-4665,	yysvec+2364,	yyvstop+1301,
yycrank+-8863,	yysvec+1756,	0,	
yycrank+-18098,	0,		0,	
yycrank+-8776,	yysvec+1890,	0,	
yycrank+-18221,	yysvec+2216,	0,	
yycrank+-18231,	yysvec+1989,	0,	
yycrank+-18241,	yysvec+1798,	0,	
yycrank+-8873,	yysvec+958,	0,	
yycrank+-5215,	yysvec+814,	0,	
yycrank+-18321,	0,		0,	
yycrank+-8877,	yysvec+2242,	yyvstop+1303,
yycrank+-8854,	yysvec+2243,	0,	
yycrank+0,	yysvec+178,	yyvstop+1305,
yycrank+-8936,	yysvec+2377,	0,	
yycrank+-4667,	yysvec+2377,	yyvstop+1307,
yycrank+-8904,	yysvec+1772,	0,	
yycrank+-18348,	0,		0,	
yycrank+-8868,	yysvec+1903,	0,	
yycrank+-8905,	yysvec+2081,	0,	
yycrank+-8874,	yysvec+1252,	0,	
yycrank+-8882,	yysvec+1119,	0,	
yycrank+-18471,	0,		0,	
yycrank+-8908,	yysvec+1044,	0,	
yycrank+-4684,	yysvec+904,	0,	
yycrank+-8879,	yysvec+2255,	0,	
yycrank+-8909,	yysvec+1051,	0,	
yycrank+-4686,	yysvec+909,	0,	
yycrank+-8880,	yysvec+2258,	0,	
yycrank+-8912,	yysvec+1854,	0,	
yycrank+-8916,	yysvec+2260,	0,	
yycrank+0,	0,		yyvstop+1309,
yycrank+-9016,	yysvec+2394,	0,	
yycrank+-8926,	yysvec+1791,	0,	
yycrank+-18498,	0,		0,	
yycrank+-8891,	yysvec+2265,	0,	
yycrank+-8917,	yysvec+1065,	0,	
yycrank+-4787,	yysvec+923,	0,	
yycrank+-8928,	yysvec+1798,	0,	
yycrank+-8924,	yysvec+2156,	0,	
yycrank+-9001,	yysvec+2271,	0,	
yycrank+-8966,	yysvec+1733,	0,	
yycrank+-8920,	yysvec+1611,	0,	
yycrank+-8930,	yysvec+2215,	0,	
yycrank+-8944,	yysvec+1451,	0,	
yycrank+-18621,	0,		0,	
yycrank+-8962,	yysvec+1808,	yyvstop+1312,
yycrank+-8940,	yysvec+2219,	yyvstop+1314,
yycrank+-8932,	yysvec+2353,	yyvstop+1316,
yycrank+-8984,	yysvec+1743,	yyvstop+1318,
yycrank+-9007,	yysvec+1620,	yyvstop+1320,
yycrank+-9013,	yysvec+2224,	yyvstop+1322,
yycrank+-9015,	yysvec+1010,	yyvstop+1324,
yycrank+-9054,	yysvec+866,	yyvstop+1326,
yycrank+-8972,	yysvec+1939,	0,	
yycrank+-9023,	yysvec+1941,	0,	
yycrank+-18640,	0,		0,	
yycrank+-9017,	yysvec+2230,	0,	
yycrank+-9018,	yysvec+2364,	0,	
yycrank+-9035,	yysvec+1756,	0,	
yycrank+-9028,	yysvec+1632,	0,	
yycrank+-9036,	yysvec+1890,	0,	
yycrank+-18669,	yysvec+1806,	0,	
yycrank+-18792,	yysvec+1079,	0,	
yycrank+-5223,	yysvec+741,	yyvstop+1328,
yycrank+-18802,	yysvec+1798,	0,	
yycrank+-4795,	yysvec+1798,	yyvstop+1330,
yycrank+-9049,	yysvec+958,	0,	
yycrank+-9099,	yysvec+814,	0,	
yycrank+-18821,	0,		0,	
yycrank+-9060,	yysvec+2242,	yyvstop+1332,
yycrank+-9061,	yysvec+2243,	0,	
yycrank+-9062,	yysvec+2377,	0,	
yycrank+-9065,	yysvec+1772,	0,	
yycrank+-9068,	yysvec+1646,	0,	
yycrank+-9064,	yysvec+1903,	0,	
yycrank+-9072,	yysvec+2081,	0,	
yycrank+-18848,	yysvec+2025,	0,	
yycrank+-9067,	yysvec+1119,	0,	
yycrank+0,	yysvec+758,	yyvstop+1334,
yycrank+-9121,	yysvec+2446,	0,	
yycrank+-4822,	yysvec+1798,	yyvstop+1336,
yycrank+-9115,	yysvec+1044,	0,	
yycrank+-9126,	yysvec+904,	0,	
yycrank+-9070,	yysvec+2255,	0,	
yycrank+-9118,	yysvec+1051,	0,	
yycrank+-9150,	yysvec+909,	0,	
yycrank+-9076,	yysvec+2258,	0,	
yycrank+-9106,	yysvec+1854,	0,	
yycrank+-9113,	yysvec+2260,	0,	
yycrank+-9125,	yysvec+2394,	0,	
yycrank+-9090,	yysvec+1791,	0,	
yycrank+-9124,	yysvec+1663,	0,	
yycrank+-9128,	yysvec+2265,	0,	
yycrank+-9170,	yysvec+1065,	0,	
yycrank+-9179,	yysvec+923,	0,	
yycrank+-9129,	yysvec+1798,	0,	
yycrank+-9176,	yysvec+2156,	0,	
yycrank+-9185,	yysvec+2271,	0,	
yycrank+-18882,	0,		0,	
yycrank+-9147,	yysvec+1611,	0,	
yycrank+-9166,	yysvec+2215,	0,	
yycrank+-19005,	yysvec+958,	0,	
yycrank+-19015,	0,		0,	
yycrank+-9177,	yysvec+1808,	yyvstop+1338,
yycrank+-9178,	yysvec+2219,	yyvstop+1340,
yycrank+-9168,	yysvec+2353,	yyvstop+1342,
yycrank+-19072,	0,		yyvstop+1344,
yycrank+-9180,	yysvec+1620,	yyvstop+1346,
yycrank+-9171,	yysvec+2224,	yyvstop+1348,
yycrank+-4833,	yysvec+1010,	yyvstop+1350,
yycrank+-19195,	0,		yyvstop+1352,
yycrank+-9189,	yysvec+1939,	0,	
yycrank+-9190,	yysvec+1941,	0,	
yycrank+-19205,	0,		0,	
yycrank+-9192,	yysvec+2230,	0,	
yycrank+-9173,	yysvec+2364,	0,	
yycrank+-19268,	0,		0,	
yycrank+-9195,	yysvec+1632,	0,	
yycrank+-9132,	yysvec+1890,	0,	
yycrank+-19224,	yysvec+2105,	0,	
yycrank+-19391,	yysvec+1340,	0,	
yycrank+-19407,	yysvec+2374,	0,	
yycrank+-9175,	yysvec+958,	0,	
yycrank+-19451,	yysvec+2527,	0,	
yycrank+-19497,	0,		0,	
yycrank+-9181,	yysvec+2242,	yyvstop+1354,
yycrank+-9202,	yysvec+2243,	0,	
yycrank+-9186,	yysvec+2377,	0,	
yycrank+-19524,	0,		0,	
yycrank+-9250,	yysvec+1646,	0,	
yycrank+-9194,	yysvec+1903,	0,	
yycrank+-9193,	yysvec+2081,	0,	
yycrank+-9172,	yysvec+1252,	0,	
yycrank+-9257,	yysvec+1119,	0,	
yycrank+-9293,	yysvec+2446,	0,	
yycrank+-4938,	yysvec+1044,	0,	
yycrank+-19647,	0,		0,	
yycrank+-9196,	yysvec+2255,	0,	
yycrank+-4959,	yysvec+1051,	0,	
yycrank+-19657,	0,		0,	
yycrank+-9199,	yysvec+2258,	0,	
yycrank+-9264,	yysvec+1854,	0,	
yycrank+-9265,	yysvec+2260,	0,	
yycrank+-9266,	yysvec+2394,	0,	
yycrank+-19714,	0,		0,	
yycrank+-9276,	yysvec+1663,	0,	
yycrank+-9269,	yysvec+2265,	0,	
yycrank+-5063,	yysvec+1065,	0,	
yycrank+-19837,	0,		0,	
yycrank+-9286,	yysvec+1798,	0,	
yycrank+-9312,	yysvec+2156,	0,	
yycrank+-9299,	yysvec+2271,	0,	
yycrank+-9290,	yysvec+1733,	0,	
yycrank+-9295,	yysvec+1611,	0,	
yycrank+-9301,	yysvec+2215,	0,	
yycrank+-19847,	0,		0,	
yycrank+0,	yysvec+855,	yyvstop+1356,
yycrank+-15970,	yysvec+1798,	yyvstop+1358,
yycrank+-9327,	yysvec+2527,	0,	
yycrank+-9296,	yysvec+1808,	yyvstop+1360,
yycrank+-9282,	yysvec+2219,	yyvstop+1362,
yycrank+-9298,	yysvec+2353,	yyvstop+1364,
yycrank+-9300,	yysvec+1743,	yyvstop+1366,
yycrank+-9305,	yysvec+1620,	yyvstop+1368,
yycrank+-9311,	yysvec+2224,	yyvstop+1370,
yycrank+-9377,	yysvec+1010,	yyvstop+1372,
yycrank+0,	yysvec+855,	yyvstop+1374,
yycrank+-17463,	yysvec+1808,	yyvstop+1377,
yycrank+-9351,	yysvec+2535,	yyvstop+1380,
yycrank+-9313,	yysvec+1939,	0,	
yycrank+-9319,	yysvec+1941,	0,	
yycrank+-9317,	yysvec+2362,	0,	
yycrank+-9322,	yysvec+2230,	0,	
yycrank+-9314,	yysvec+2364,	0,	
yycrank+-9320,	yysvec+1756,	0,	
yycrank+-9325,	yysvec+1632,	0,	
yycrank+-9331,	yysvec+1890,	0,	
yycrank+-19857,	yysvec+1215,	0,	
yycrank+-19917,	yysvec+814,	0,	
yycrank+-19927,	yysvec+2434,	0,	
yycrank+-9484,	yysvec+958,	0,	
yycrank+-14592,	yysvec+855,	yyvstop+1382,
yycrank+-19946,	0,		yyvstop+1384,
yycrank+-19988,	yysvec+2527,	0,	
yycrank+-5108,	yysvec+2527,	yyvstop+1386,
yycrank+-20017,	0,		0,	
yycrank+-9332,	yysvec+2242,	yyvstop+1388,
yycrank+-9329,	yysvec+2243,	0,	
yycrank+-9361,	yysvec+2377,	0,	
yycrank+-9367,	yysvec+1772,	0,	
yycrank+-9337,	yysvec+1646,	0,	
yycrank+-9333,	yysvec+1903,	0,	
yycrank+-9371,	yysvec+2081,	0,	
yycrank+-9369,	yysvec+1252,	0,	
yycrank+-5208,	yysvec+1119,	0,	
yycrank+-9378,	yysvec+2446,	0,	
yycrank+-9431,	yysvec+1044,	0,	
yycrank+0,	yysvec+905,	yyvstop+1390,
yycrank+-18650,	yysvec+2255,	yyvstop+1392,
yycrank+-9433,	yysvec+2561,	0,	
yycrank+-5368,	yysvec+2527,	yyvstop+1394,
yycrank+-9375,	yysvec+2255,	0,	
yycrank+-9486,	yysvec+1051,	0,	
yycrank+0,	yysvec+910,	yyvstop+1396,
yycrank+-20036,	yysvec+2258,	yyvstop+1398,
yycrank+-9476,	yysvec+2564,	0,	
yycrank+-5372,	yysvec+2527,	yyvstop+1400,
yycrank+-9386,	yysvec+2258,	0,	
yycrank+-9380,	yysvec+1854,	0,	
yycrank+-9393,	yysvec+2260,	0,	
yycrank+-9384,	yysvec+2394,	0,	
yycrank+-9444,	yysvec+1791,	0,	
yycrank+-9397,	yysvec+1663,	0,	
yycrank+-9402,	yysvec+2265,	0,	
yycrank+-9515,	yysvec+1065,	0,	
yycrank+0,	yysvec+855,	yyvstop+1402,
yycrank+-20078,	yysvec+1854,	yyvstop+1405,
yycrank+-9479,	yysvec+2573,	0,	
yycrank+-20097,	0,		0,	
yycrank+-9535,	yysvec+2156,	0,	
yycrank+-9469,	yysvec+2271,	0,	
yycrank+-9450,	yysvec+1733,	0,	
yycrank+-9466,	yysvec+1611,	0,	
yycrank+-9447,	yysvec+2215,	0,	
yycrank+-20220,	yysvec+2607,	0,	
yycrank+-5293,	yysvec+934,	yyvstop+1407,
yycrank+-20230,	yysvec+2607,	0,	
yycrank+-9523,	yysvec+2527,	0,	
yycrank+-20287,	0,		yyvstop+1409,
yycrank+-9474,	yysvec+2219,	yyvstop+1411,
yycrank+-9472,	yysvec+2353,	yyvstop+1413,
yycrank+-9478,	yysvec+1743,	yyvstop+1415,
yycrank+-9529,	yysvec+1620,	yyvstop+1417,
yycrank+-9492,	yysvec+2224,	yyvstop+1419,
yycrank+-20410,	0,		yyvstop+1421,
yycrank+-5298,	yysvec+934,	yyvstop+1423,
yycrank+-9538,	yysvec+2659,	yyvstop+1426,
yycrank+-9541,	yysvec+2535,	yyvstop+1428,
yycrank+-9507,	yysvec+1939,	0,	
yycrank+-9513,	yysvec+1941,	0,	
yycrank+-20420,	0,		0,	
yycrank+-9567,	yysvec+2230,	0,	
yycrank+-9516,	yysvec+2364,	0,	
yycrank+-9521,	yysvec+1756,	0,	
yycrank+-9568,	yysvec+1632,	0,	
yycrank+-9554,	yysvec+1890,	0,	
yycrank+-20439,	yysvec+1451,	0,	
yycrank+-20481,	yysvec+2469,	0,	
yycrank+-20500,	yysvec+2493,	0,	
yycrank+-9496,	yysvec+2607,	0,	
yycrank+-17205,	yysvec+934,	yyvstop+1430,
yycrank+-9669,	yysvec+2607,	0,	
yycrank+-20510,	yysvec+2607,	yyvstop+1432,
yycrank+-20576,	0,		0,	
yycrank+-20599,	0,		0,	
yycrank+-9561,	yysvec+2242,	yyvstop+1434,
yycrank+-9579,	yysvec+2243,	0,	
yycrank+-9527,	yysvec+2377,	0,	
yycrank+-9530,	yysvec+1772,	0,	
yycrank+-9583,	yysvec+1646,	0,	
yycrank+-9570,	yysvec+1903,	0,	
yycrank+-9533,	yysvec+2081,	0,	
yycrank+-9584,	yysvec+1252,	0,	
yycrank+-9671,	yysvec+1119,	0,	
yycrank+-9571,	yysvec+2446,	0,	
yycrank+-20620,	0,		0,	
yycrank+0,	yysvec+1045,	yyvstop+1436,
yycrank+-9660,	yysvec+2690,	0,	
yycrank+-20641,	yysvec+2607,	yyvstop+1438,
yycrank+-9673,	yysvec+2561,	0,	
yycrank+-9578,	yysvec+2255,	0,	
yycrank+-20700,	0,		0,	
yycrank+0,	yysvec+1052,	yyvstop+1440,
yycrank+-9663,	yysvec+2696,	0,	
yycrank+-20710,	yysvec+2607,	yyvstop+1442,
yycrank+-9674,	yysvec+2564,	0,	
yycrank+-9585,	yysvec+2258,	0,	
yycrank+-20767,	0,		0,	
yycrank+-9647,	yysvec+2260,	0,	
yycrank+-9587,	yysvec+2394,	0,	
yycrank+-9590,	yysvec+1791,	0,	
yycrank+-9653,	yysvec+1663,	0,	
yycrank+-9588,	yysvec+2265,	0,	
yycrank+-20890,	0,		0,	
yycrank+-5404,	yysvec+934,	yyvstop+1444,
yycrank+-9664,	yysvec+2708,	0,	
yycrank+-9710,	yysvec+2573,	0,	
yycrank+-9465,	yysvec+1798,	0,	
yycrank+-9711,	yysvec+2156,	0,	
yycrank+-9682,	yysvec+2271,	0,	
yycrank+-9593,	yysvec+1733,	0,	
yycrank+-9591,	yysvec+1611,	0,	
yycrank+-9658,	yysvec+2215,	0,	
yycrank+-5501,	yysvec+1798,	yyvstop+1447,
yycrank+-20906,	0,		0,	
yycrank+-9556,	yysvec+2527,	0,	
yycrank+-9639,	yysvec+1808,	yyvstop+1449,
yycrank+-9595,	yysvec+2219,	yyvstop+1451,
yycrank+-9712,	yysvec+2353,	yyvstop+1453,
yycrank+-9662,	yysvec+1743,	yyvstop+1455,
yycrank+-9718,	yysvec+1620,	yyvstop+1457,
yycrank+-9763,	yysvec+2224,	yyvstop+1459,
yycrank+-5503,	yysvec+1808,	yyvstop+1461,
yycrank+-9792,	yysvec+2659,	yyvstop+1464,
yycrank+-9675,	yysvec+2535,	yyvstop+1466,
yycrank+-9762,	yysvec+1939,	0,	
yycrank+-9764,	yysvec+1941,	0,	
yycrank+-9716,	yysvec+2362,	0,	
yycrank+-9774,	yysvec+2230,	0,	
yycrank+-9770,	yysvec+2364,	0,	
yycrank+-9780,	yysvec+1756,	0,	
yycrank+-9773,	yysvec+1632,	0,	
yycrank+-20963,	0,		0,	
yycrank+-21086,	yysvec+958,	0,	
yycrank+-21096,	yysvec+2527,	0,	
yycrank+-21106,	yysvec+2549,	0,	
yycrank+-21166,	yysvec+1798,	yyvstop+1468,
yycrank+-9800,	yysvec+2607,	0,	
yycrank+-21186,	0,		0,	
yycrank+-21232,	0,		0,	
yycrank+-9765,	yysvec+2242,	yyvstop+1470,
yycrank+-9843,	yysvec+2243,	0,	
yycrank+-9805,	yysvec+2377,	0,	
yycrank+-9898,	yysvec+1772,	0,	
yycrank+-9891,	yysvec+1646,	0,	
yycrank+-21276,	0,		0,	
yycrank+-9890,	yysvec+2081,	0,	
yycrank+-5504,	yysvec+1252,	0,	
yycrank+-21399,	0,		0,	
yycrank+-9799,	yysvec+2446,	0,	
yycrank+-5505,	yysvec+2255,	yyvstop+1472,
yycrank+-9919,	yysvec+2690,	0,	
yycrank+-9681,	yysvec+2561,	0,	
yycrank+-9768,	yysvec+2255,	0,	
yycrank+-5506,	yysvec+2258,	yyvstop+1474,
yycrank+-9920,	yysvec+2696,	0,	
yycrank+-9797,	yysvec+2564,	0,	
yycrank+-9771,	yysvec+2258,	0,	
yycrank+-9803,	yysvec+1854,	0,	
yycrank+-9901,	yysvec+2260,	0,	
yycrank+-9892,	yysvec+2394,	0,	
yycrank+-9906,	yysvec+1791,	0,	
yycrank+-9900,	yysvec+1663,	0,	
yycrank+-9776,	yysvec+2265,	0,	
yycrank+-5715,	yysvec+1854,	yyvstop+1476,
yycrank+-10038,	yysvec+2708,	0,	
yycrank+-9804,	yysvec+2573,	0,	
yycrank+-10021,	yysvec+1798,	0,	
yycrank+-10081,	yysvec+2156,	0,	
yycrank+-9917,	yysvec+2271,	0,	
yycrank+-9787,	yysvec+1733,	0,	
yycrank+-9926,	yysvec+1611,	0,	
yycrank+-10022,	yysvec+2215,	0,	
yycrank+-21409,	0,		0,	
yycrank+-9801,	yysvec+2527,	0,	
yycrank+-10023,	yysvec+1808,	yyvstop+1478,
yycrank+-10025,	yysvec+2219,	yyvstop+1480,
yycrank+-9796,	yysvec+2353,	yyvstop+1482,
yycrank+-9888,	yysvec+1743,	yyvstop+1484,
yycrank+-9927,	yysvec+1620,	yyvstop+1486,
yycrank+-10024,	yysvec+2224,	yyvstop+1488,
yycrank+-9921,	yysvec+2659,	yyvstop+1490,
yycrank+-9924,	yysvec+2535,	yyvstop+1492,
yycrank+-21466,	0,		0,	
yycrank+-21589,	0,		0,	
yycrank+-21712,	0,		0,	
yycrank+-10030,	yysvec+2230,	0,	
yycrank+-9894,	yysvec+2364,	0,	
yycrank+-9899,	yysvec+1756,	0,	
yycrank+-10018,	yysvec+1632,	0,	
yycrank+-9925,	yysvec+1890,	0,	
yycrank+-21722,	yysvec+2580,	0,	
yycrank+-18302,	yysvec+855,	yyvstop+1494,
yycrank+-21732,	yysvec+2607,	yyvstop+1496,
yycrank+-21792,	yysvec+2527,	0,	
yycrank+-5720,	yysvec+2527,	yyvstop+1498,
yycrank+-21802,	yysvec+2610,	0,	
yycrank+-9928,	yysvec+2607,	0,	
yycrank+-21812,	0,		0,	
yycrank+-21882,	0,		0,	
yycrank+-10118,	yysvec+2242,	yyvstop+1500,
yycrank+-10122,	yysvec+2243,	0,	
yycrank+-9903,	yysvec+2377,	0,	
yycrank+-9923,	yysvec+1772,	0,	
yycrank+-10050,	yysvec+1646,	0,	
yycrank+-10046,	yysvec+1903,	0,	
yycrank+-10124,	yysvec+2081,	0,	
yycrank+-10043,	yysvec+1252,	0,	
yycrank+0,	yysvec+1120,	yyvstop+1502,
yycrank+-21901,	yysvec+2446,	yyvstop+1504,
yycrank+-9802,	yysvec+2753,	0,	
yycrank+-5728,	yysvec+2527,	yyvstop+1506,
yycrank+-10128,	yysvec+2446,	0,	
yycrank+-9922,	yysvec+2690,	0,	
yycrank+-10121,	yysvec+2561,	0,	
yycrank+-10129,	yysvec+2255,	0,	
yycrank+-10044,	yysvec+2696,	0,	
yycrank+-10130,	yysvec+2564,	0,	
yycrank+-10131,	yysvec+2258,	0,	
yycrank+-10132,	yysvec+1854,	0,	
yycrank+-10134,	yysvec+2260,	0,	
yycrank+-10014,	yysvec+2394,	0,	
yycrank+-10016,	yysvec+1791,	0,	
yycrank+-10133,	yysvec+1663,	0,	
yycrank+-10138,	yysvec+2265,	0,	
yycrank+-10139,	yysvec+2708,	0,	
yycrank+-10141,	yysvec+2573,	0,	
yycrank+-10142,	yysvec+1798,	0,	
yycrank+-10176,	yysvec+2156,	0,	
yycrank+-10205,	yysvec+2271,	0,	
yycrank+-10154,	yysvec+1733,	0,	
yycrank+-9288,	yysvec+1611,	0,	
yycrank+-10147,	yysvec+2215,	0,	
yycrank+-21911,	0,		0,	
yycrank+-10150,	yysvec+2527,	0,	
yycrank+-10143,	yysvec+1808,	yyvstop+1508,
yycrank+-10159,	yysvec+2219,	yyvstop+1510,
yycrank+-10149,	yysvec+2353,	yyvstop+1512,
yycrank+-10156,	yysvec+1743,	yyvstop+1514,
yycrank+-10155,	yysvec+1620,	yyvstop+1516,
yycrank+-10169,	yysvec+2224,	yyvstop+1518,
yycrank+-10161,	yysvec+2659,	yyvstop+1520,
yycrank+-10163,	yysvec+2535,	yyvstop+1522,
yycrank+-10166,	yysvec+1939,	0,	
yycrank+-10189,	yysvec+1941,	0,	
yycrank+-21953,	yysvec+2789,	0,	
yycrank+-10188,	yysvec+2230,	0,	
yycrank+-10171,	yysvec+2364,	0,	
yycrank+-10204,	yysvec+1756,	0,	
yycrank+-10186,	yysvec+1632,	0,	
yycrank+-10196,	yysvec+1890,	0,	
yycrank+-22076,	yysvec+2607,	0,	
yycrank+-22082,	yysvec+934,	yyvstop+1524,
yycrank+-22092,	yysvec+2607,	0,	
yycrank+-22149,	yysvec+2607,	yyvstop+1526,
yycrank+-22191,	yysvec+2678,	0,	
yycrank+-22210,	yysvec+2679,	0,	
yycrank+-10165,	yysvec+2607,	0,	
yycrank+-22220,	0,		0,	
yycrank+-10208,	yysvec+2610,	0,	
yycrank+-10235,	yysvec+2242,	yyvstop+1528,
yycrank+-10230,	yysvec+2243,	0,	
yycrank+-10236,	yysvec+2377,	0,	
yycrank+-10268,	yysvec+1772,	0,	
yycrank+-10253,	yysvec+1646,	0,	
yycrank+-10241,	yysvec+1903,	0,	
yycrank+-10197,	yysvec+2081,	0,	
yycrank+-22281,	0,		0,	
yycrank+0,	yysvec+1253,	yyvstop+1530,
yycrank+-9915,	yysvec+2872,	0,	
yycrank+-22300,	yysvec+2607,	yyvstop+1532,
yycrank+-10304,	yysvec+2753,	0,	
yycrank+-10261,	yysvec+2446,	0,	
yycrank+-10273,	yysvec+2690,	0,	
yycrank+-10198,	yysvec+2561,	0,	
yycrank+-10274,	yysvec+2255,	0,	
yycrank+-10279,	yysvec+2696,	0,	
yycrank+-10281,	yysvec+2564,	0,	
yycrank+-10276,	yysvec+2258,	0,	
yycrank+-10278,	yysvec+1854,	0,	
yycrank+-10285,	yysvec+2260,	0,	
yycrank+-10282,	yysvec+2394,	0,	
yycrank+-10291,	yysvec+1791,	0,	
yycrank+-10283,	yysvec+1663,	0,	
yycrank+-10295,	yysvec+2265,	0,	
yycrank+-10293,	yysvec+2708,	0,	
yycrank+-10284,	yysvec+2573,	0,	
yycrank+-10027,	yysvec+1798,	0,	
yycrank+-10318,	yysvec+2156,	0,	
yycrank+-10324,	yysvec+2271,	0,	
yycrank+-10302,	yysvec+1733,	0,	
yycrank+-19042,	yysvec+2406,	0,	
yycrank+-10296,	yysvec+2215,	0,	
yycrank+-22325,	0,		0,	
yycrank+-10316,	yysvec+2527,	0,	
yycrank+-10029,	yysvec+1808,	yyvstop+1534,
yycrank+-10332,	yysvec+2219,	yyvstop+1536,
yycrank+-10344,	yysvec+2353,	yyvstop+1538,
yycrank+-10326,	yysvec+1743,	yyvstop+1540,
yycrank+-19684,	yysvec+2415,	yyvstop+1542,
yycrank+-10305,	yysvec+2224,	yyvstop+1544,
yycrank+-10287,	yysvec+2659,	yyvstop+1546,
yycrank+-10347,	yysvec+2535,	yyvstop+1548,
yycrank+-10348,	yysvec+1939,	0,	
yycrank+-10368,	yysvec+1941,	0,	
yycrank+-10387,	yysvec+2292,	0,	
yycrank+-10390,	yysvec+2230,	0,	
yycrank+-10397,	yysvec+2364,	0,	
yycrank+-10405,	yysvec+1756,	0,	
yycrank+-20257,	yysvec+2427,	0,	
yycrank+-10342,	yysvec+1890,	0,	
yycrank+-22371,	yysvec+1798,	yyvstop+1550,
yycrank+-22390,	yysvec+2719,	0,	
yycrank+-22415,	yysvec+2743,	0,	
yycrank+-22461,	yysvec+2744,	0,	
yycrank+-10408,	yysvec+2607,	0,	
yycrank+-22480,	0,		0,	
yycrank+-22524,	0,		0,	
yycrank+-10404,	yysvec+2242,	yyvstop+1552,
yycrank+-10422,	yysvec+2243,	0,	
yycrank+-10426,	yysvec+2377,	0,	
yycrank+-10419,	yysvec+1772,	0,	
yycrank+-20737,	yysvec+2441,	0,	
yycrank+-10393,	yysvec+1903,	0,	
yycrank+-22551,	0,		0,	
yycrank+-5732,	yysvec+2446,	yyvstop+1554,
yycrank+-10458,	yysvec+2872,	0,	
yycrank+-10423,	yysvec+2753,	0,	
yycrank+-10036,	yysvec+2446,	0,	
yycrank+-10424,	yysvec+2690,	0,	
yycrank+-10431,	yysvec+2561,	0,	
yycrank+-10432,	yysvec+2255,	0,	
yycrank+-10439,	yysvec+2696,	0,	
yycrank+-10434,	yysvec+2564,	0,	
yycrank+-10460,	yysvec+2258,	0,	
yycrank+-10042,	yysvec+1854,	0,	
yycrank+-10436,	yysvec+2260,	0,	
yycrank+-10438,	yysvec+2394,	0,	
yycrank+-10442,	yysvec+1791,	0,	
yycrank+-20933,	yysvec+2458,	0,	
yycrank+-10496,	yysvec+2265,	0,	
yycrank+-10450,	yysvec+2708,	0,	
yycrank+-10446,	yysvec+2573,	0,	
yycrank+-10465,	yysvec+1798,	0,	
yycrank+-10523,	yysvec+2156,	0,	
yycrank+-10519,	yysvec+2271,	0,	
yycrank+-10517,	yysvec+1733,	0,	
yycrank+-10507,	yysvec+1611,	0,	
yycrank+-10467,	yysvec+2215,	0,	
yycrank+-22674,	0,		0,	
yycrank+-10454,	yysvec+2527,	0,	
yycrank+-10530,	yysvec+1808,	yyvstop+1556,
yycrank+-10494,	yysvec+2219,	yyvstop+1558,
yycrank+-10532,	yysvec+2353,	yyvstop+1560,
yycrank+-10529,	yysvec+1743,	yyvstop+1562,
yycrank+-10578,	yysvec+1620,	yyvstop+1564,
yycrank+-10589,	yysvec+2224,	yyvstop+1566,
yycrank+-10590,	yysvec+2659,	yyvstop+1568,
yycrank+-10501,	yysvec+2535,	yyvstop+1570,
yycrank+-10588,	yysvec+1939,	0,	
yycrank+-10592,	yysvec+1941,	0,	
yycrank+-10594,	yysvec+2362,	0,	
yycrank+-10582,	yysvec+2230,	0,	
yycrank+-10577,	yysvec+2364,	0,	
yycrank+-10598,	yysvec+1756,	0,	
yycrank+-10593,	yysvec+1632,	0,	
yycrank+-10440,	yysvec+1890,	0,	
yycrank+-22684,	yysvec+2778,	0,	
yycrank+-22694,	yysvec+2803,	0,	
yycrank+-22754,	yysvec+2804,	0,	
yycrank+-10599,	yysvec+2607,	0,	
yycrank+-22783,	0,		0,	
yycrank+-10601,	yysvec+2610,	0,	
yycrank+-10602,	yysvec+2242,	yyvstop+1572,
yycrank+-10584,	yysvec+2243,	0,	
yycrank+-10603,	yysvec+2377,	0,	
yycrank+-10605,	yysvec+1772,	0,	
yycrank+-10604,	yysvec+1646,	0,	
yycrank+-10486,	yysvec+1903,	0,	
yycrank+-10583,	yysvec+2081,	0,	
yycrank+-10585,	yysvec+2872,	0,	
yycrank+-10606,	yysvec+2753,	0,	
yycrank+-10607,	yysvec+2446,	0,	
yycrank+-10608,	yysvec+2690,	0,	
yycrank+-10609,	yysvec+2561,	0,	
yycrank+-10610,	yysvec+2255,	0,	
yycrank+-10613,	yysvec+2696,	0,	
yycrank+-10611,	yysvec+2564,	0,	
yycrank+-10614,	yysvec+2258,	0,	
yycrank+-10615,	yysvec+1854,	0,	
yycrank+-10666,	yysvec+2260,	0,	
yycrank+-10663,	yysvec+2394,	0,	
yycrank+-10687,	yysvec+1791,	0,	
yycrank+-10616,	yysvec+1663,	0,	
yycrank+-10674,	yysvec+2265,	0,	
yycrank+-10675,	yysvec+2708,	0,	
yycrank+-10685,	yysvec+2573,	0,	
yycrank+-10689,	yysvec+1798,	0,	
yycrank+-22825,	0,		0,	
yycrank+-10697,	yysvec+2271,	0,	
yycrank+-21436,	yysvec+2523,	0,	
yycrank+-10691,	yysvec+1611,	0,	
yycrank+-10695,	yysvec+2215,	0,	
yycrank+-22948,	0,		0,	
yycrank+-10580,	yysvec+2527,	0,	
yycrank+-10693,	yysvec+1808,	yyvstop+1574,
yycrank+-22975,	0,		yyvstop+1576,
yycrank+-10696,	yysvec+2353,	yyvstop+1578,
yycrank+-21552,	yysvec+2531,	yyvstop+1580,
yycrank+-10698,	yysvec+1620,	yyvstop+1582,
yycrank+-10700,	yysvec+2224,	yyvstop+1584,
yycrank+-10692,	yysvec+2659,	yyvstop+1586,
yycrank+-10746,	yysvec+2535,	yyvstop+1588,
yycrank+-10757,	yysvec+1939,	0,	
yycrank+-10778,	yysvec+1941,	0,	
yycrank+-23098,	0,		0,	
yycrank+-23125,	0,		0,	
yycrank+-10729,	yysvec+2364,	0,	
yycrank+-23152,	yysvec+2541,	0,	
yycrank+-10730,	yysvec+1632,	0,	
yycrank+-10694,	yysvec+1890,	0,	
yycrank+-23274,	yysvec+2838,	0,	
yycrank+-23284,	yysvec+2863,	0,	
yycrank+-23298,	yysvec+2610,	0,	
yycrank+-10728,	yysvec+2607,	0,	
yycrank+-23374,	0,		0,	
yycrank+-23393,	0,		0,	
yycrank+-10743,	yysvec+2242,	yyvstop+1590,
yycrank+-23422,	0,		0,	
yycrank+-10748,	yysvec+2377,	0,	
yycrank+-23449,	yysvec+2553,	0,	
yycrank+-10745,	yysvec+1646,	0,	
yycrank+-10754,	yysvec+1903,	0,	
yycrank+-10763,	yysvec+2081,	0,	
yycrank+-10774,	yysvec+2872,	0,	
yycrank+-10749,	yysvec+2753,	0,	
yycrank+-10784,	yysvec+2446,	0,	
yycrank+-10781,	yysvec+2690,	0,	
yycrank+-10786,	yysvec+2561,	0,	
yycrank+-10780,	yysvec+2255,	0,	
yycrank+-10791,	yysvec+2696,	0,	
yycrank+-10821,	yysvec+2564,	0,	
yycrank+-10793,	yysvec+2258,	0,	
yycrank+-10792,	yysvec+1854,	0,	
yycrank+-23571,	0,		0,	
yycrank+-10797,	yysvec+2394,	0,	
yycrank+-23534,	yysvec+2569,	0,	
yycrank+-10794,	yysvec+1663,	0,	
yycrank+-10796,	yysvec+2265,	0,	
yycrank+-10799,	yysvec+2708,	0,	
yycrank+-10827,	yysvec+2573,	0,	
yycrank+-10805,	yysvec+1798,	0,	
yycrank+-10842,	yysvec+2156,	0,	
yycrank+-10845,	yysvec+2271,	0,	
yycrank+-10814,	yysvec+1733,	0,	
yycrank+-10851,	yysvec+1611,	0,	
yycrank+-23694,	0,		0,	
yycrank+-23817,	0,		0,	
yycrank+-10798,	yysvec+2527,	0,	
yycrank+-10812,	yysvec+1808,	yyvstop+1592,
yycrank+-10844,	yysvec+2219,	yyvstop+1594,
yycrank+-10816,	yysvec+2353,	yyvstop+1596,
yycrank+-10860,	yysvec+1743,	yyvstop+1598,
yycrank+-10885,	yysvec+1620,	yyvstop+1600,
yycrank+-23844,	0,		yyvstop+1602,
yycrank+-10887,	yysvec+2659,	yyvstop+1604,
yycrank+-10825,	yysvec+2535,	yyvstop+1606,
yycrank+-10919,	yysvec+1939,	0,	
yycrank+-10920,	yysvec+1941,	0,	
yycrank+-10965,	yysvec+2480,	0,	
yycrank+-10882,	yysvec+2230,	0,	
yycrank+-10849,	yysvec+2364,	0,	
yycrank+-10924,	yysvec+1756,	0,	
yycrank+-10967,	yysvec+1632,	0,	
yycrank+-10922,	yysvec+1890,	0,	
yycrank+-23967,	yysvec+2898,	0,	
yycrank+-23977,	yysvec+2921,	0,	
yycrank+-23987,	yysvec+2922,	0,	
yycrank+-10968,	yysvec+2607,	0,	
yycrank+-24057,	0,		0,	
yycrank+-24084,	yysvec+2643,	0,	
yycrank+-24207,	0,		yyvstop+1608,
yycrank+-10959,	yysvec+2243,	0,	
yycrank+-10966,	yysvec+2377,	0,	
yycrank+-10960,	yysvec+1772,	0,	
yycrank+-10971,	yysvec+1646,	0,	
yycrank+-10970,	yysvec+1903,	0,	
yycrank+-10969,	yysvec+2081,	0,	
yycrank+-10977,	yysvec+2872,	0,	
yycrank+-10975,	yysvec+2753,	0,	
yycrank+-10974,	yysvec+2446,	0,	
yycrank+-10989,	yysvec+2690,	0,	
yycrank+-10976,	yysvec+2561,	0,	
yycrank+-24330,	0,		0,	
yycrank+-10992,	yysvec+2696,	0,	
yycrank+-10980,	yysvec+2564,	0,	
yycrank+-24453,	0,		0,	
yycrank+-10978,	yysvec+1854,	0,	
yycrank+-10983,	yysvec+2260,	0,	
yycrank+-10987,	yysvec+2394,	0,	
yycrank+-10981,	yysvec+1791,	0,	
yycrank+-11003,	yysvec+1663,	0,	
yycrank+-24576,	0,		0,	
yycrank+-11006,	yysvec+2708,	0,	
yycrank+-10984,	yysvec+2573,	0,	
yycrank+-23657,	yysvec+2643,	0,	
yycrank+-11116,	yysvec+2156,	0,	
yycrank+-24699,	0,		0,	
yycrank+-11000,	yysvec+1733,	0,	
yycrank+-5737,	yysvec+1611,	0,	
yycrank+-11004,	yysvec+2215,	0,	
yycrank+-24822,	0,		0,	
yycrank+-11008,	yysvec+2527,	0,	
yycrank+-24170,	yysvec+2653,	yyvstop+1610,
yycrank+-11010,	yysvec+2219,	yyvstop+1612,
yycrank+-24849,	0,		yyvstop+1614,
yycrank+-11002,	yysvec+1743,	yyvstop+1616,
yycrank+-5741,	yysvec+1620,	yyvstop+1618,
yycrank+-11040,	yysvec+2224,	yyvstop+1620,
yycrank+-11013,	yysvec+2659,	yyvstop+1622,
yycrank+-11018,	yysvec+2535,	yyvstop+1624,
yycrank+-11014,	yysvec+1939,	0,	
yycrank+-11016,	yysvec+1941,	0,	
yycrank+-24972,	0,		0,	
yycrank+-11023,	yysvec+2230,	0,	
yycrank+-24999,	0,		0,	
yycrank+-11072,	yysvec+1756,	0,	
yycrank+-5754,	yysvec+1632,	0,	
yycrank+-11024,	yysvec+1890,	0,	
yycrank+-25122,	yysvec+2954,	0,	
yycrank+-25132,	yysvec+2976,	0,	
yycrank+-25142,	yysvec+2610,	0,	
yycrank+-11147,	yysvec+2607,	0,	
yycrank+-11151,	yysvec+2921,	0,	
yycrank+-11146,	yysvec+2549,	0,	
yycrank+-11149,	yysvec+2242,	yyvstop+1626,
yycrank+-11155,	yysvec+2243,	0,	
yycrank+-25212,	0,		0,	
yycrank+-11148,	yysvec+1772,	0,	
yycrank+-5758,	yysvec+1646,	0,	
yycrank+-11156,	yysvec+1903,	0,	
yycrank+-11025,	yysvec+2081,	0,	
yycrank+-11157,	yysvec+2872,	0,	
yycrank+-11150,	yysvec+2753,	0,	
yycrank+-11159,	yysvec+2446,	0,	
yycrank+-11019,	yysvec+2690,	0,	
yycrank+-11160,	yysvec+2561,	0,	
yycrank+-11158,	yysvec+2255,	0,	
yycrank+-11165,	yysvec+2696,	0,	
yycrank+-11166,	yysvec+2564,	0,	
yycrank+-11161,	yysvec+2258,	0,	
yycrank+-24293,	yysvec+2702,	0,	
yycrank+-11168,	yysvec+2260,	0,	
yycrank+-25335,	0,		0,	
yycrank+-11174,	yysvec+1791,	0,	
yycrank+-5849,	yysvec+1663,	0,	
yycrank+-11167,	yysvec+2265,	0,	
yycrank+-11169,	yysvec+2708,	0,	
yycrank+-11170,	yysvec+2573,	0,	
yycrank+-11171,	yysvec+1798,	0,	
yycrank+-11224,	yysvec+2156,	0,	
yycrank+-11265,	yysvec+2271,	0,	
yycrank+-11054,	yysvec+1733,	0,	
yycrank+-10879,	yysvec+1611,	0,	
yycrank+-11180,	yysvec+2215,	0,	
yycrank+-11186,	yysvec+2954,	0,	
yycrank+-11181,	yysvec+2527,	0,	
yycrank+-11193,	yysvec+1808,	yyvstop+1628,
yycrank+-11203,	yysvec+2219,	yyvstop+1630,
yycrank+-11177,	yysvec+2353,	yyvstop+1632,
yycrank+-11200,	yysvec+1743,	yyvstop+1634,
yycrank+-11264,	yysvec+1620,	yyvstop+1636,
yycrank+-11196,	yysvec+2224,	yyvstop+1638,
yycrank+-11257,	yysvec+2659,	yyvstop+1640,
yycrank+-11215,	yysvec+2535,	yyvstop+1642,
yycrank+-11270,	yysvec+1939,	0,	
yycrank+-11272,	yysvec+1941,	0,	
yycrank+-25458,	0,		0,	
yycrank+-11267,	yysvec+2230,	0,	
yycrank+-11206,	yysvec+2364,	0,	
yycrank+-11300,	yysvec+1756,	0,	
yycrank+-11304,	yysvec+1632,	0,	
yycrank+-24416,	yysvec+2737,	0,	
yycrank+-25468,	yysvec+3008,	0,	
yycrank+-25487,	yysvec+3030,	0,	
yycrank+-25548,	yysvec+3031,	0,	
yycrank+-11303,	yysvec+2607,	0,	
yycrank+-25558,	0,		0,	
yycrank+-11311,	yysvec+2610,	0,	
yycrank+-11319,	yysvec+2242,	yyvstop+1644,
yycrank+-11293,	yysvec+2243,	0,	
yycrank+-11306,	yysvec+2377,	0,	
yycrank+-11308,	yysvec+1772,	0,	
yycrank+-11368,	yysvec+1646,	0,	
yycrank+-24539,	yysvec+2750,	0,	
yycrank+-11317,	yysvec+2081,	0,	
yycrank+-11296,	yysvec+2872,	0,	
yycrank+-11315,	yysvec+2753,	0,	
yycrank+-11313,	yysvec+2446,	0,	
yycrank+-11331,	yysvec+2690,	0,	
yycrank+-11318,	yysvec+2561,	0,	
yycrank+-11337,	yysvec+2255,	0,	
yycrank+-11341,	yysvec+2696,	0,	
yycrank+-11320,	yysvec+2564,	0,	
yycrank+-11344,	yysvec+2258,	0,	
yycrank+-11321,	yysvec+1854,	0,	
yycrank+-11349,	yysvec+2260,	0,	
yycrank+-11353,	yysvec+2394,	0,	
yycrank+-11399,	yysvec+1791,	0,	
yycrank+-11393,	yysvec+1663,	0,	
yycrank+-11391,	yysvec+2265,	0,	
yycrank+-11394,	yysvec+2708,	0,	
yycrank+-11395,	yysvec+2573,	0,	
yycrank+-11397,	yysvec+1798,	0,	
yycrank+-11441,	yysvec+2156,	0,	
yycrank+-11474,	yysvec+2271,	0,	
yycrank+-5880,	yysvec+1733,	0,	
yycrank+-25577,	0,		0,	
yycrank+-11402,	yysvec+2215,	0,	
yycrank+-25619,	0,		0,	
yycrank+-11417,	yysvec+2527,	0,	
yycrank+-11405,	yysvec+1808,	yyvstop+1646,
yycrank+-11411,	yysvec+2219,	yyvstop+1648,
yycrank+-11421,	yysvec+2353,	yyvstop+1650,
yycrank+-5888,	yysvec+1743,	yyvstop+1652,
yycrank+-25638,	0,		yyvstop+1654,
yycrank+-11415,	yysvec+2224,	yyvstop+1656,
yycrank+-11419,	yysvec+2659,	yyvstop+1658,
yycrank+-11425,	yysvec+2535,	yyvstop+1660,
yycrank+-24662,	yysvec+2788,	0,	
yycrank+-25176,	yysvec+2789,	0,	
yycrank+-25648,	0,		0,	
yycrank+-11439,	yysvec+2230,	0,	
yycrank+-11438,	yysvec+2364,	0,	
yycrank+-5966,	yysvec+1756,	0,	
yycrank+-25709,	0,		yyvstop+1662,
yycrank+-11435,	yysvec+1890,	0,	
yycrank+-25753,	yysvec+3062,	0,	
yycrank+-25769,	yysvec+3084,	0,	
yycrank+-25815,	yysvec+2643,	0,	
yycrank+-11443,	yysvec+2607,	0,	
yycrank+-11440,	yysvec+2921,	0,	
yycrank+-25938,	0,		0,	
yycrank+-11437,	yysvec+2242,	yyvstop+1664,
yycrank+-11485,	yysvec+2243,	0,	
yycrank+-11466,	yysvec+2377,	0,	
yycrank+-5993,	yysvec+1772,	0,	
yycrank+-25948,	0,		yyvstop+1666,
yycrank+-11477,	yysvec+1903,	0,	
yycrank+-11452,	yysvec+2081,	0,	
yycrank+-11489,	yysvec+2872,	0,	
yycrank+-11468,	yysvec+2753,	0,	
yycrank+-26005,	0,		0,	
yycrank+-11486,	yysvec+2690,	0,	
yycrank+-11481,	yysvec+2561,	0,	
yycrank+-11490,	yysvec+2255,	0,	
yycrank+-11488,	yysvec+2696,	0,	
yycrank+-11483,	yysvec+2564,	0,	
yycrank+-11492,	yysvec+2258,	0,	
yycrank+-11491,	yysvec+1854,	0,	
yycrank+-11515,	yysvec+2260,	0,	
yycrank+-11507,	yysvec+2394,	0,	
yycrank+-5995,	yysvec+1791,	0,	
yycrank+-26128,	0,		0,	
yycrank+-11509,	yysvec+2265,	0,	
yycrank+-11514,	yysvec+2708,	0,	
yycrank+-11517,	yysvec+2573,	0,	
yycrank+-11532,	yysvec+1798,	0,	
yycrank+-11555,	yysvec+2156,	0,	
yycrank+-11559,	yysvec+2271,	0,	
yycrank+-11563,	yysvec+1733,	0,	
yycrank+0,	yysvec+1612,	yyvstop+1668,
yycrank+-21930,	yysvec+1798,	yyvstop+1670,
yycrank+-10045,	yysvec+3222,	0,	
yycrank+-11575,	yysvec+2215,	0,	
yycrank+-11553,	yysvec+2954,	0,	
yycrank+-11531,	yysvec+2527,	0,	
yycrank+-11581,	yysvec+1808,	yyvstop+1672,
yycrank+-11545,	yysvec+2219,	yyvstop+1674,
yycrank+-11557,	yysvec+2353,	yyvstop+1676,
yycrank+-11613,	yysvec+1743,	yyvstop+1678,
yycrank+0,	yysvec+1612,	yyvstop+1680,
yycrank+-22802,	yysvec+1808,	yyvstop+1683,
yycrank+-10612,	yysvec+3230,	yyvstop+1686,
yycrank+-11583,	yysvec+2224,	yyvstop+1688,
yycrank+-11597,	yysvec+2659,	yyvstop+1690,
yycrank+-11614,	yysvec+2535,	yyvstop+1692,
yycrank+-11558,	yysvec+1939,	0,	
yycrank+-11622,	yysvec+1941,	0,	
yycrank+-26155,	yysvec+2789,	0,	
yycrank+-11623,	yysvec+2230,	0,	
yycrank+-11654,	yysvec+2364,	0,	
yycrank+-11620,	yysvec+1756,	0,	
yycrank+-6041,	yysvec+3240,	0,	
yycrank+-10040,	yysvec+1612,	yyvstop+1694,
yycrank+-23403,	yysvec+1890,	yyvstop+1696,
yycrank+-11733,	yysvec+3240,	0,	
yycrank+-11685,	yysvec+1890,	0,	
yycrank+-26278,	yysvec+3116,	0,	
yycrank+-26290,	yysvec+2921,	0,	
yycrank+-26300,	yysvec+2549,	0,	
yycrank+-11687,	yysvec+2607,	0,	
yycrank+-26389,	0,		0,	
yycrank+-11584,	yysvec+2744,	0,	
yycrank+-11589,	yysvec+2242,	yyvstop+1698,
yycrank+-11690,	yysvec+2243,	0,	
yycrank+-11691,	yysvec+2377,	0,	
yycrank+-11740,	yysvec+1772,	0,	
yycrank+-6126,	yysvec+3252,	0,	
yycrank+-10047,	yysvec+1612,	yyvstop+1700,
yycrank+-26150,	yysvec+1903,	yyvstop+1702,
yycrank+-11743,	yysvec+3252,	0,	
yycrank+-11696,	yysvec+1903,	0,	
yycrank+-11697,	yysvec+2081,	0,	
yycrank+-11698,	yysvec+2872,	0,	
yycrank+-11701,	yysvec+2753,	0,	
yycrank+-11699,	yysvec+2446,	0,	
yycrank+-11704,	yysvec+2690,	0,	
yycrank+-11695,	yysvec+2561,	0,	
yycrank+-11609,	yysvec+2255,	0,	
yycrank+-11705,	yysvec+2696,	0,	
yycrank+-11709,	yysvec+2564,	0,	
yycrank+-11716,	yysvec+2258,	0,	
yycrank+-11721,	yysvec+1854,	0,	
yycrank+-11708,	yysvec+2260,	0,	
yycrank+-11713,	yysvec+2394,	0,	
yycrank+-11750,	yysvec+1791,	0,	
yycrank+0,	yysvec+1612,	yyvstop+1704,
yycrank+-26399,	yysvec+1854,	yyvstop+1707,
yycrank+-10870,	yysvec+3268,	0,	
yycrank+-11730,	yysvec+2265,	0,	
yycrank+-11723,	yysvec+2708,	0,	
yycrank+-11715,	yysvec+2573,	0,	
yycrank+-6145,	yysvec+1798,	0,	
yycrank+-11751,	yysvec+2156,	0,	
yycrank+-11785,	yysvec+2271,	0,	
yycrank+-26409,	0,		0,	
yycrank+-6071,	yysvec+1673,	yyvstop+1709,
yycrank+-11593,	yysvec+3341,	0,	
yycrank+-11777,	yysvec+3222,	0,	
yycrank+-11757,	yysvec+2215,	0,	
yycrank+-26478,	0,		0,	
yycrank+-26507,	0,		0,	
yycrank+-6265,	yysvec+1808,	yyvstop+1711,
yycrank+-11714,	yysvec+2219,	yyvstop+1713,
yycrank+-11732,	yysvec+2353,	yyvstop+1715,
yycrank+-26630,	0,		yyvstop+1717,
yycrank+-6201,	yysvec+1673,	yyvstop+1719,
yycrank+-11610,	yysvec+3351,	yyvstop+1722,
yycrank+-11822,	yysvec+3230,	yyvstop+1724,
yycrank+-11761,	yysvec+2224,	yyvstop+1726,
yycrank+-11747,	yysvec+2659,	yyvstop+1728,
yycrank+-26657,	0,		yyvstop+1730,
yycrank+-11762,	yysvec+1939,	0,	
yycrank+-11765,	yysvec+1941,	0,	
yycrank+-11766,	yysvec+3128,	0,	
yycrank+-11770,	yysvec+2230,	0,	
yycrank+-11736,	yysvec+2364,	0,	
yycrank+-26780,	0,		yyvstop+1732,
yycrank+-6302,	yysvec+3363,	0,	
yycrank+-11865,	yysvec+1673,	yyvstop+1734,
yycrank+-11854,	yysvec+3363,	0,	
yycrank+-11861,	yysvec+3240,	0,	
yycrank+-11834,	yysvec+1890,	0,	
yycrank+-26790,	yysvec+2954,	0,	
yycrank+-26800,	yysvec+3192,	0,	
yycrank+-26860,	yysvec+2610,	0,	
yycrank+-11772,	yysvec+2607,	0,	
yycrank+-26889,	yysvec+3347,	0,	
yycrank+-27012,	0,		0,	
yycrank+-11779,	yysvec+2242,	yyvstop+1736,
yycrank+-11829,	yysvec+2243,	0,	
yycrank+-11840,	yysvec+2377,	0,	
yycrank+-27022,	0,		yyvstop+1738,
yycrank+-6426,	yysvec+3378,	0,	
yycrank+-11873,	yysvec+1673,	yyvstop+1740,
yycrank+-11869,	yysvec+3378,	0,	
yycrank+-11904,	yysvec+3252,	0,	
yycrank+-11847,	yysvec+1903,	0,	
yycrank+-25298,	yysvec+2929,	0,	
yycrank+-11784,	yysvec+2872,	0,	
yycrank+-11831,	yysvec+2753,	0,	
yycrank+-11842,	yysvec+2446,	0,	
yycrank+-11876,	yysvec+2690,	0,	
yycrank+-27081,	0,		0,	
yycrank+-11846,	yysvec+2255,	0,	
yycrank+-11879,	yysvec+2696,	0,	
yycrank+-27204,	0,		0,	
yycrank+-11877,	yysvec+2258,	0,	
yycrank+-6451,	yysvec+1854,	0,	
yycrank+-11878,	yysvec+2260,	0,	
yycrank+-11880,	yysvec+2394,	0,	
yycrank+-27327,	0,		0,	
yycrank+-6425,	yysvec+1673,	yyvstop+1742,
yycrank+-11883,	yysvec+3397,	0,	
yycrank+-11985,	yysvec+3268,	0,	
yycrank+-11890,	yysvec+2265,	0,	
yycrank+-11885,	yysvec+2708,	0,	
yycrank+-27354,	0,		0,	
yycrank+-11900,	yysvec+1798,	0,	
yycrank+-11987,	yysvec+2156,	0,	
yycrank+-12001,	yysvec+2271,	0,	
yycrank+-6553,	yysvec+1798,	yyvstop+1745,
yycrank+-11991,	yysvec+3341,	0,	
yycrank+-11881,	yysvec+3222,	0,	
yycrank+-11894,	yysvec+2215,	0,	
yycrank+-27477,	0,		0,	
yycrank+-11892,	yysvec+2527,	0,	
yycrank+-11905,	yysvec+1808,	yyvstop+1747,
yycrank+-11907,	yysvec+2219,	yyvstop+1749,
yycrank+-11910,	yysvec+2353,	yyvstop+1751,
yycrank+-6599,	yysvec+1808,	yyvstop+1753,
yycrank+-12025,	yysvec+3351,	yyvstop+1756,
yycrank+-11896,	yysvec+3230,	yyvstop+1758,
yycrank+-11903,	yysvec+2224,	yyvstop+1760,
yycrank+-27600,	0,		yyvstop+1762,
yycrank+-11897,	yysvec+2535,	yyvstop+1764,
yycrank+-11977,	yysvec+1939,	0,	
yycrank+-11978,	yysvec+1941,	0,	
yycrank+-11886,	yysvec+2229,	0,	
yycrank+-11970,	yysvec+2230,	0,	
yycrank+-11980,	yysvec+2364,	0,	
yycrank+-6862,	yysvec+1890,	yyvstop+1766,
yycrank+-12028,	yysvec+3363,	0,	
yycrank+-11989,	yysvec+3240,	0,	
yycrank+-6888,	yysvec+1890,	0,	
yycrank+-27723,	yysvec+3224,	0,	
yycrank+-27733,	yysvec+2921,	0,	
yycrank+-27743,	yysvec+3247,	0,	
yycrank+-27803,	yysvec+3411,	0,	
yycrank+-11990,	yysvec+2863,	0,	
yycrank+-27926,	0,		0,	
yycrank+-11979,	yysvec+2242,	yyvstop+1768,
yycrank+-11983,	yysvec+2243,	0,	
yycrank+-12004,	yysvec+2377,	0,	
yycrank+-6889,	yysvec+1903,	yyvstop+1770,
yycrank+-12036,	yysvec+3378,	0,	
yycrank+-11997,	yysvec+3252,	0,	
yycrank+-7047,	yysvec+1903,	0,	
yycrank+-12007,	yysvec+2081,	0,	
yycrank+-12014,	yysvec+2872,	0,	
yycrank+-11849,	yysvec+2753,	0,	
yycrank+-12016,	yysvec+2446,	0,	
yycrank+-27953,	0,		0,	
yycrank+-12009,	yysvec+2561,	0,	
yycrank+-12015,	yysvec+2255,	0,	
yycrank+-28076,	0,		0,	
yycrank+-12017,	yysvec+2564,	0,	
yycrank+-12019,	yysvec+2258,	0,	
yycrank+-12051,	yysvec+1854,	0,	
yycrank+-12024,	yysvec+2260,	0,	
yycrank+-12020,	yysvec+2394,	0,	
yycrank+-7189,	yysvec+1854,	yyvstop+1772,
yycrank+-12137,	yysvec+3397,	0,	
yycrank+-12029,	yysvec+3268,	0,	
yycrank+-12030,	yysvec+2265,	0,	
yycrank+-28199,	0,		0,	
yycrank+-12078,	yysvec+2573,	0,	
yycrank+-25975,	yysvec+3003,	0,	
yycrank+-12034,	yysvec+2271,	0,	
yycrank+-12072,	yysvec+3341,	0,	
yycrank+-12080,	yysvec+3222,	0,	
yycrank+-12038,	yysvec+2215,	0,	
yycrank+-12085,	yysvec+2898,	0,	
yycrank+-12031,	yysvec+2527,	0,	
yycrank+-27050,	yysvec+3011,	yyvstop+1774,
yycrank+-12079,	yysvec+2353,	yyvstop+1776,
yycrank+-12089,	yysvec+3351,	yyvstop+1778,
yycrank+-12093,	yysvec+3230,	yyvstop+1780,
yycrank+-12039,	yysvec+2224,	yyvstop+1782,
yycrank+-12097,	yysvec+2659,	yyvstop+1784,
yycrank+-12041,	yysvec+2535,	yyvstop+1786,
yycrank+-7437,	yysvec+1939,	0,	
yycrank+-7440,	yysvec+1941,	0,	
yycrank+-12052,	yysvec+2480,	0,	
yycrank+-27167,	yysvec+3021,	0,	
yycrank+-12092,	yysvec+2364,	0,	
yycrank+-12106,	yysvec+3363,	0,	
yycrank+-12094,	yysvec+3240,	0,	
yycrank+-12190,	yysvec+1890,	0,	
yycrank+-28322,	yysvec+2954,	0,	
yycrank+-28332,	yysvec+3307,	0,	
yycrank+-28389,	yysvec+2744,	0,	
yycrank+-12101,	yysvec+2607,	0,	
yycrank+-12138,	yysvec+2921,	0,	
yycrank+-28431,	0,		0,	
yycrank+-12139,	yysvec+2242,	yyvstop+1788,
yycrank+-27440,	yysvec+3033,	0,	
yycrank+-12140,	yysvec+2377,	0,	
yycrank+-12141,	yysvec+3378,	0,	
yycrank+-12142,	yysvec+3252,	0,	
yycrank+-12202,	yysvec+1903,	0,	
yycrank+-12143,	yysvec+2081,	0,	
yycrank+-12158,	yysvec+2872,	0,	
yycrank+-12147,	yysvec+2753,	0,	
yycrank+-12160,	yysvec+2446,	0,	
yycrank+-12098,	yysvec+2690,	0,	
yycrank+-12162,	yysvec+2561,	0,	
yycrank+-12156,	yysvec+2255,	0,	
yycrank+-12163,	yysvec+2696,	0,	
yycrank+-12188,	yysvec+2564,	0,	
yycrank+-12184,	yysvec+2258,	0,	
yycrank+-27563,	yysvec+3049,	0,	
yycrank+-12149,	yysvec+2394,	0,	
yycrank+-12211,	yysvec+3397,	0,	
yycrank+-12222,	yysvec+3268,	0,	
yycrank+-12192,	yysvec+2265,	0,	
yycrank+-12224,	yysvec+2708,	0,	
yycrank+-12201,	yysvec+2573,	0,	
yycrank+-12235,	yysvec+2156,	0,	
yycrank+-12246,	yysvec+2271,	0,	
yycrank+-12226,	yysvec+3341,	0,	
yycrank+-12231,	yysvec+3222,	0,	
yycrank+-27772,	yysvec+3061,	0,	
yycrank+-12234,	yysvec+2954,	0,	
yycrank+-12198,	yysvec+2527,	0,	
yycrank+-12225,	yysvec+2219,	yyvstop+1790,
yycrank+-12245,	yysvec+2353,	yyvstop+1792,
yycrank+-12227,	yysvec+3351,	yyvstop+1794,
yycrank+-12233,	yysvec+3230,	yyvstop+1796,
yycrank+-28039,	yysvec+3069,	yyvstop+1798,
yycrank+-12250,	yysvec+2659,	yyvstop+1800,
yycrank+-12236,	yysvec+2535,	yyvstop+1802,
yycrank+-12337,	yysvec+1939,	0,	
yycrank+-12339,	yysvec+1941,	0,	
yycrank+-20007,	yysvec+1941,	0,	
yycrank+-12244,	yysvec+2230,	0,	
yycrank+-12251,	yysvec+2364,	0,	
yycrank+-12239,	yysvec+3363,	0,	
yycrank+-12252,	yysvec+3240,	0,	
yycrank+-28450,	yysvec+3346,	0,	
yycrank+-28479,	yysvec+3347,	0,	
yycrank+-28602,	yysvec+3374,	0,	
yycrank+-12255,	yysvec+2607,	0,	
yycrank+-28612,	0,		0,	
yycrank+-28672,	yysvec+2643,	0,	
yycrank+-28162,	yysvec+3086,	yyvstop+1804,
yycrank+-12253,	yysvec+2243,	0,	
yycrank+-12254,	yysvec+2377,	0,	
yycrank+-12248,	yysvec+3378,	0,	
yycrank+-12338,	yysvec+3252,	0,	
yycrank+-12323,	yysvec+2081,	0,	
yycrank+-12341,	yysvec+2872,	0,	
yycrank+-28795,	0,		0,	
yycrank+-12315,	yysvec+2446,	0,	
yycrank+-12316,	yysvec+2690,	0,	
yycrank+-12318,	yysvec+2561,	0,	
yycrank+-28641,	yysvec+3098,	0,	
yycrank+-12320,	yysvec+2696,	0,	
yycrank+-12325,	yysvec+2564,	0,	
yycrank+-28758,	yysvec+3101,	0,	
yycrank+-12373,	yysvec+2260,	0,	
yycrank+-12317,	yysvec+2394,	0,	
yycrank+-12342,	yysvec+3397,	0,	
yycrank+-12340,	yysvec+3268,	0,	
yycrank+-28839,	yysvec+3107,	0,	
yycrank+-12377,	yysvec+2708,	0,	
yycrank+-12416,	yysvec+2573,	0,	
yycrank+-12472,	yysvec+2156,	0,	
yycrank+-28877,	yysvec+3112,	0,	
yycrank+-12343,	yysvec+3341,	0,	
yycrank+-12378,	yysvec+3222,	0,	
yycrank+-12418,	yysvec+2215,	0,	
yycrank+-28999,	0,		0,	
yycrank+-12334,	yysvec+2527,	0,	
yycrank+-12422,	yysvec+2219,	yyvstop+1806,
yycrank+-28962,	yysvec+3120,	yyvstop+1808,
yycrank+-12423,	yysvec+3351,	yyvstop+1810,
yycrank+-12424,	yysvec+3230,	yyvstop+1812,
yycrank+-12425,	yysvec+2224,	yyvstop+1814,
yycrank+-12427,	yysvec+2659,	yyvstop+1816,
yycrank+-12438,	yysvec+2535,	yyvstop+1818,
yycrank+-29088,	yysvec+1941,	0,	
yycrank+-12426,	yysvec+2230,	0,	
yycrank+-29051,	yysvec+3130,	0,	
yycrank+-12432,	yysvec+3363,	0,	
yycrank+-12431,	yysvec+3240,	0,	
yycrank+-29134,	yysvec+3411,	0,	
yycrank+-29257,	yysvec+2863,	0,	
yycrank+-29267,	yysvec+3436,	0,	
yycrank+-12435,	yysvec+2607,	0,	
yycrank+-12443,	yysvec+3030,	0,	
yycrank+-12434,	yysvec+3374,	0,	
yycrank+-12442,	yysvec+2242,	yyvstop+1820,
yycrank+-12441,	yysvec+2243,	0,	
yycrank+-29294,	yysvec+3142,	0,	
yycrank+-12473,	yysvec+3378,	0,	
yycrank+-12450,	yysvec+3252,	0,	
yycrank+-7444,	yysvec+2081,	0,	
yycrank+-29324,	0,		0,	
yycrank+-12475,	yysvec+2753,	0,	
yycrank+-12477,	yysvec+2446,	0,	
yycrank+-12444,	yysvec+2690,	0,	
yycrank+-12457,	yysvec+2561,	0,	
yycrank+-12446,	yysvec+2255,	0,	
yycrank+-12453,	yysvec+2696,	0,	
yycrank+-12459,	yysvec+2564,	0,	
yycrank+-12482,	yysvec+2258,	0,	
yycrank+-12478,	yysvec+2260,	0,	
yycrank+-29376,	yysvec+3158,	0,	
yycrank+-12476,	yysvec+3397,	0,	
yycrank+-12496,	yysvec+3268,	0,	
yycrank+-12492,	yysvec+2265,	0,	
yycrank+-12498,	yysvec+2708,	0,	
yycrank+-12470,	yysvec+2573,	0,	
yycrank+-12592,	yysvec+2156,	0,	
yycrank+-12593,	yysvec+2271,	0,	
yycrank+-12510,	yysvec+3341,	0,	
yycrank+-12501,	yysvec+3222,	0,	
yycrank+-12486,	yysvec+2215,	0,	
yycrank+-12481,	yysvec+3062,	0,	
yycrank+-12504,	yysvec+2527,	0,	
yycrank+-12567,	yysvec+2219,	yyvstop+1822,
yycrank+-12565,	yysvec+2353,	yyvstop+1824,
yycrank+-12566,	yysvec+3351,	yyvstop+1826,
yycrank+-12574,	yysvec+3230,	yyvstop+1828,
yycrank+-12576,	yysvec+2224,	yyvstop+1830,
yycrank+-12581,	yysvec+2659,	yyvstop+1832,
yycrank+-12579,	yysvec+2535,	yyvstop+1834,
yycrank+-12590,	yysvec+2230,	0,	
yycrank+-12603,	yysvec+2364,	0,	
yycrank+-12596,	yysvec+3363,	0,	
yycrank+-12606,	yysvec+3240,	0,	
yycrank+-29458,	yysvec+2898,	0,	
yycrank+-29500,	yysvec+2921,	0,	
yycrank+-29519,	yysvec+3490,	0,	
yycrank+-12623,	yysvec+2607,	0,	
yycrank+-29529,	0,		0,	
yycrank+-12610,	yysvec+2493,	0,	
yycrank+-12615,	yysvec+2242,	yyvstop+1836,
yycrank+-12618,	yysvec+2243,	0,	
yycrank+-12614,	yysvec+2377,	0,	
yycrank+-12619,	yysvec+3378,	0,	
yycrank+-12626,	yysvec+3252,	0,	
yycrank+-12616,	yysvec+2081,	0,	
yycrank+-12577,	yysvec+2872,	0,	
yycrank+-12637,	yysvec+2753,	0,	
yycrank+-12575,	yysvec+2446,	0,	
yycrank+-12627,	yysvec+2690,	0,	
yycrank+-12624,	yysvec+2561,	0,	
yycrank+-12630,	yysvec+2255,	0,	
yycrank+-12639,	yysvec+2696,	0,	
yycrank+-12647,	yysvec+2564,	0,	
yycrank+-12633,	yysvec+2258,	0,	
yycrank+-12671,	yysvec+2260,	0,	
yycrank+-12657,	yysvec+2394,	0,	
yycrank+-12670,	yysvec+3397,	0,	
yycrank+-12664,	yysvec+3268,	0,	
yycrank+-12635,	yysvec+2265,	0,	
yycrank+-12682,	yysvec+2708,	0,	
yycrank+-12707,	yysvec+2573,	0,	
yycrank+-11052,	yysvec+2156,	0,	
yycrank+-12737,	yysvec+2271,	0,	
yycrank+-12711,	yysvec+3341,	0,	
yycrank+-12710,	yysvec+3222,	0,	
yycrank+-12719,	yysvec+2215,	0,	
yycrank+-29548,	0,		0,	
yycrank+-12714,	yysvec+2527,	0,	
yycrank+-7528,	yysvec+2219,	yyvstop+1838,
yycrank+-12715,	yysvec+2353,	yyvstop+1840,
yycrank+-12717,	yysvec+3351,	yyvstop+1842,
yycrank+-12735,	yysvec+3230,	yyvstop+1844,
yycrank+-12749,	yysvec+2224,	yyvstop+1846,
yycrank+-12720,	yysvec+2659,	yyvstop+1848,
yycrank+-12716,	yysvec+2535,	yyvstop+1850,
yycrank+-7556,	yysvec+2230,	0,	
yycrank+-12718,	yysvec+2364,	0,	
yycrank+-12722,	yysvec+3363,	0,	
yycrank+-12751,	yysvec+3240,	0,	
yycrank+-29590,	yysvec+2954,	0,	
yycrank+-29619,	yysvec+3539,	0,	
yycrank+-29663,	yysvec+2643,	0,	
yycrank+-12807,	yysvec+2607,	0,	
yycrank+-29786,	0,		0,	
yycrank+-12755,	yysvec+2744,	0,	
yycrank+-12757,	yysvec+2242,	yyvstop+1852,
yycrank+-7558,	yysvec+2243,	0,	
yycrank+-12752,	yysvec+2377,	0,	
yycrank+-12760,	yysvec+3378,	0,	
yycrank+-12780,	yysvec+3252,	0,	
yycrank+-12758,	yysvec+2872,	0,	
yycrank+-12763,	yysvec+2753,	0,	
yycrank+-29749,	yysvec+3257,	0,	
yycrank+-12806,	yysvec+2690,	0,	
yycrank+-12721,	yysvec+2561,	0,	
yycrank+-12809,	yysvec+2255,	0,	
yycrank+-12808,	yysvec+2696,	0,	
yycrank+-12772,	yysvec+2564,	0,	
yycrank+-12812,	yysvec+2258,	0,	
yycrank+-7563,	yysvec+2260,	0,	
yycrank+-12797,	yysvec+2394,	0,	
yycrank+-12819,	yysvec+3397,	0,	
yycrank+-12861,	yysvec+3268,	0,	
yycrank+-12890,	yysvec+2265,	0,	
yycrank+-12815,	yysvec+2708,	0,	
yycrank+-12831,	yysvec+2573,	0,	
yycrank+-12925,	yysvec+2156,	0,	
yycrank+-12894,	yysvec+2271,	0,	
yycrank+-12895,	yysvec+3341,	0,	
yycrank+-12698,	yysvec+3222,	0,	
yycrank+-7567,	yysvec+2215,	0,	
yycrank+-29875,	0,		0,	
yycrank+-12822,	yysvec+2527,	0,	
yycrank+-12929,	yysvec+2219,	yyvstop+1854,
yycrank+-12914,	yysvec+2353,	yyvstop+1856,
yycrank+-12922,	yysvec+3351,	yyvstop+1858,
yycrank+-12837,	yysvec+3230,	yyvstop+1860,
yycrank+-7574,	yysvec+2224,	yyvstop+1862,
yycrank+-12834,	yysvec+2659,	yyvstop+1864,
yycrank+-12866,	yysvec+2535,	yyvstop+1866,
yycrank+-12938,	yysvec+2230,	0,	
yycrank+-12931,	yysvec+2364,	0,	
yycrank+-12942,	yysvec+3363,	0,	
yycrank+-12878,	yysvec+3240,	0,	
yycrank+-29885,	yysvec+3568,	0,	
yycrank+-29904,	yysvec+3030,	0,	
yycrank+-29946,	yysvec+3374,	0,	
yycrank+-12855,	yysvec+2607,	0,	
yycrank+-29965,	0,		0,	
yycrank+-29994,	yysvec+1798,	0,	
yycrank+-7703,	yysvec+2242,	yyvstop+1868,
yycrank+-12940,	yysvec+2243,	0,	
yycrank+-12947,	yysvec+2377,	0,	
yycrank+-12951,	yysvec+3378,	0,	
yycrank+-12883,	yysvec+3252,	0,	
yycrank+-12801,	yysvec+2872,	0,	
yycrank+-12958,	yysvec+2753,	0,	
yycrank+-12928,	yysvec+2446,	0,	
yycrank+-12933,	yysvec+2690,	0,	
yycrank+-12906,	yysvec+2561,	0,	
yycrank+-7708,	yysvec+2255,	0,	
yycrank+-12935,	yysvec+2696,	0,	
yycrank+-12949,	yysvec+2564,	0,	
yycrank+-7717,	yysvec+2258,	0,	
yycrank+-12952,	yysvec+2260,	0,	
yycrank+-13003,	yysvec+2394,	0,	
yycrank+-13005,	yysvec+3397,	0,	
yycrank+-12950,	yysvec+3268,	0,	
yycrank+-7813,	yysvec+2265,	0,	
yycrank+-12953,	yysvec+2708,	0,	
yycrank+-12955,	yysvec+2573,	0,	
yycrank+-30036,	0,		0,	
yycrank+-11063,	yysvec+2271,	0,	
yycrank+-12954,	yysvec+3341,	0,	
yycrank+-12961,	yysvec+3222,	0,	
yycrank+-12992,	yysvec+2215,	0,	
yycrank+-30065,	0,		0,	
yycrank+-30092,	yysvec+3347,	0,	
yycrank+-30126,	0,		yyvstop+1870,
yycrank+-7815,	yysvec+2353,	yyvstop+1872,
yycrank+-12956,	yysvec+3351,	yyvstop+1874,
yycrank+-12996,	yysvec+3230,	yyvstop+1876,
yycrank+-13030,	yysvec+2224,	yyvstop+1878,
yycrank+-13007,	yysvec+2659,	yyvstop+1880,
yycrank+-30173,	yysvec+3357,	yyvstop+1882,
yycrank+-30295,	0,		yyvstop+1884,
yycrank+-7831,	yysvec+2364,	0,	
yycrank+-13001,	yysvec+3363,	0,	
yycrank+-12998,	yysvec+3240,	0,	
yycrank+-30314,	yysvec+3062,	0,	
yycrank+-30324,	yysvec+3632,	0,	
yycrank+-30343,	yysvec+2493,	0,	
yycrank+-13009,	yysvec+2607,	0,	
yycrank+-30385,	yysvec+3347,	0,	
yycrank+-30508,	yysvec+1798,	0,	
yycrank+-13041,	yysvec+2242,	yyvstop+1886,
yycrank+-30518,	0,		yyvstop+1888,
yycrank+-7839,	yysvec+2377,	0,	
yycrank+-13010,	yysvec+3378,	0,	
yycrank+-13013,	yysvec+3252,	0,	
yycrank+-13024,	yysvec+2872,	0,	
yycrank+-13016,	yysvec+2753,	0,	
yycrank+-13019,	yysvec+2446,	0,	
yycrank+-13021,	yysvec+2690,	0,	
yycrank+-30545,	yysvec+3389,	0,	
yycrank+-13056,	yysvec+2255,	0,	
yycrank+-13029,	yysvec+2696,	0,	
yycrank+-30572,	yysvec+3392,	0,	
yycrank+-13068,	yysvec+2258,	0,	
yycrank+-30694,	0,		0,	
yycrank+-8051,	yysvec+2394,	0,	
yycrank+-13028,	yysvec+3397,	0,	
yycrank+-13037,	yysvec+3268,	0,	
yycrank+-13073,	yysvec+2265,	0,	
yycrank+-13042,	yysvec+2708,	0,	
yycrank+-30657,	yysvec+3403,	0,	
yycrank+0,	0,		yyvstop+1890,
yycrank+-13077,	yysvec+3746,	0,	
yycrank+-13079,	yysvec+2271,	0,	
yycrank+-13039,	yysvec+3341,	0,	
yycrank+-13033,	yysvec+3222,	0,	
yycrank+-30738,	yysvec+3411,	0,	
yycrank+-13043,	yysvec+2527,	0,	
yycrank+0,	0,		yyvstop+1893,
yycrank+-13081,	yysvec+3753,	yyvstop+1897,
yycrank+-13100,	yysvec+2353,	yyvstop+1899,
yycrank+-13045,	yysvec+3351,	yyvstop+1901,
yycrank+-13074,	yysvec+3230,	yyvstop+1903,
yycrank+-30764,	yysvec+3420,	yyvstop+1905,
yycrank+-13080,	yysvec+2535,	yyvstop+1907,
yycrank+-8052,	yysvec+3760,	0,	
yycrank+0,	yysvec+170,	yyvstop+1909,
yycrank+-13102,	yysvec+3760,	0,	
yycrank+-13103,	yysvec+2364,	0,	
yycrank+-13088,	yysvec+3363,	0,	
yycrank+-13075,	yysvec+3240,	0,	
yycrank+-30886,	yysvec+3661,	0,	
yycrank+-30896,	yysvec+3678,	0,	
yycrank+-30915,	yysvec+2744,	0,	
yycrank+-30957,	yysvec+3411,	0,	
yycrank+-13091,	yysvec+3632,	0,	
yycrank+-8152,	yysvec+3771,	0,	
yycrank+0,	yysvec+178,	yyvstop+1912,
yycrank+-13178,	yysvec+3771,	0,	
yycrank+-13185,	yysvec+2377,	0,	
yycrank+-13094,	yysvec+3378,	0,	
yycrank+-13093,	yysvec+3252,	0,	
yycrank+-13097,	yysvec+2872,	0,	
yycrank+-13095,	yysvec+2753,	0,	
yycrank+-13060,	yysvec+2446,	0,	
yycrank+-30984,	yysvec+3448,	0,	
yycrank+-13106,	yysvec+2561,	0,	
yycrank+-31011,	yysvec+3451,	0,	
yycrank+-13111,	yysvec+2564,	0,	
yycrank+0,	0,		yyvstop+1915,
yycrank+-13187,	yysvec+3784,	0,	
yycrank+-13195,	yysvec+2394,	0,	
yycrank+-13144,	yysvec+3397,	0,	
yycrank+-13155,	yysvec+3268,	0,	
yycrank+-31065,	yysvec+3461,	0,	
yycrank+-13148,	yysvec+2573,	0,	
yycrank+-13189,	yysvec+3746,	0,	
yycrank+-31187,	0,		0,	
yycrank+-13158,	yysvec+3341,	0,	
yycrank+-13165,	yysvec+3222,	0,	
yycrank+-13166,	yysvec+3661,	0,	
yycrank+-13167,	yysvec+2527,	0,	
yycrank+-13201,	yysvec+3753,	yyvstop+1919,
yycrank+-31197,	0,		yyvstop+1921,
yycrank+-13170,	yysvec+3351,	yyvstop+1923,
yycrank+-13169,	yysvec+3230,	yyvstop+1925,
yycrank+-13175,	yysvec+2659,	yyvstop+1927,
yycrank+-13171,	yysvec+2535,	yyvstop+1929,
yycrank+-13213,	yysvec+3760,	0,	
yycrank+-31207,	0,		yyvstop+1931,
yycrank+-13197,	yysvec+3363,	0,	
yycrank+-13210,	yysvec+3240,	0,	
yycrank+-31267,	yysvec+3706,	0,	
yycrank+-31277,	yysvec+3723,	0,	
yycrank+-31287,	yysvec+1798,	0,	
yycrank+-13193,	yysvec+2607,	0,	
yycrank+-13173,	yysvec+2803,	0,	
yycrank+-13262,	yysvec+3771,	0,	
yycrank+-31357,	0,		yyvstop+1933,
yycrank+-13202,	yysvec+3378,	0,	
yycrank+-13212,	yysvec+3252,	0,	
yycrank+-13206,	yysvec+2872,	0,	
yycrank+-13174,	yysvec+2753,	0,	
yycrank+-8166,	yysvec+2446,	0,	
yycrank+-13211,	yysvec+2690,	0,	
yycrank+-13205,	yysvec+2561,	0,	
yycrank+-13215,	yysvec+2696,	0,	
yycrank+-13207,	yysvec+2564,	0,	
yycrank+-13267,	yysvec+3784,	0,	
yycrank+-31376,	0,		0,	
yycrank+-13204,	yysvec+3397,	0,	
yycrank+-13220,	yysvec+3268,	0,	
yycrank+-13218,	yysvec+2708,	0,	
yycrank+-13221,	yysvec+2573,	0,	
yycrank+-12586,	yysvec+3746,	0,	
yycrank+0,	0,		yyvstop+1935,
yycrank+-13258,	yysvec+3837,	0,	
yycrank+-13227,	yysvec+3341,	0,	
yycrank+-13219,	yysvec+3222,	0,	
yycrank+-13236,	yysvec+2838,	0,	
yycrank+-13298,	yysvec+2527,	0,	
yycrank+-13222,	yysvec+3753,	yyvstop+1938,
yycrank+0,	0,		yyvstop+1940,
yycrank+-13289,	yysvec+3843,	yyvstop+1944,
yycrank+-13257,	yysvec+3351,	yyvstop+1946,
yycrank+-13268,	yysvec+3230,	yyvstop+1948,
yycrank+-13305,	yysvec+2659,	yyvstop+1950,
yycrank+-13306,	yysvec+2535,	yyvstop+1952,
yycrank+-13307,	yysvec+3760,	0,	
yycrank+-8169,	yysvec+3849,	0,	
yycrank+0,	yysvec+170,	yyvstop+1954,
yycrank+-13315,	yysvec+3849,	0,	
yycrank+-13276,	yysvec+3363,	0,	
yycrank+-13313,	yysvec+3240,	0,	
yycrank+-31347,	yysvec+3751,	0,	
yycrank+-31418,	yysvec+3347,	0,	
yycrank+-31541,	yysvec+1798,	0,	
yycrank+-13314,	yysvec+2607,	0,	
yycrank+-13321,	yysvec+3030,	0,	
yycrank+-13312,	yysvec+3771,	0,	
yycrank+-8303,	yysvec+3858,	0,	
yycrank+0,	yysvec+178,	yyvstop+1957,
yycrank+-13318,	yysvec+3858,	0,	
yycrank+-13283,	yysvec+3378,	0,	
yycrank+-13317,	yysvec+3252,	0,	
yycrank+-13290,	yysvec+2872,	0,	
yycrank+-31455,	yysvec+3548,	0,	
yycrank+-13376,	yysvec+2446,	0,	
yycrank+-13319,	yysvec+2690,	0,	
yycrank+-13332,	yysvec+2561,	0,	
yycrank+-13324,	yysvec+2696,	0,	
yycrank+-13336,	yysvec+2564,	0,	
yycrank+-13325,	yysvec+3784,	0,	
yycrank+0,	0,		yyvstop+1960,
yycrank+-13412,	yysvec+3869,	0,	
yycrank+-13329,	yysvec+3397,	0,	
yycrank+-13327,	yysvec+3268,	0,	
yycrank+-13328,	yysvec+2708,	0,	
yycrank+-13341,	yysvec+2573,	0,	
yycrank+-13333,	yysvec+3746,	0,	
yycrank+-13413,	yysvec+3837,	0,	
yycrank+-13345,	yysvec+3341,	0,	
yycrank+-31583,	0,		0,	
yycrank+-13400,	yysvec+3062,	0,	
yycrank+-8307,	yysvec+2527,	0,	
yycrank+-13334,	yysvec+3753,	yyvstop+1964,
yycrank+-13414,	yysvec+3843,	yyvstop+1966,
yycrank+-13393,	yysvec+3351,	yyvstop+1968,
yycrank+-31706,	0,		yyvstop+1970,
yycrank+-13408,	yysvec+2659,	yyvstop+1972,
yycrank+-8456,	yysvec+2535,	yyvstop+1974,
yycrank+-13377,	yysvec+3760,	0,	
yycrank+-13427,	yysvec+3849,	0,	
yycrank+-13403,	yysvec+3363,	0,	
yycrank+-31829,	0,		0,	
yycrank+-31952,	yysvec+3411,	0,	
yycrank+-32075,	yysvec+3632,	0,	
yycrank+-13451,	yysvec+2607,	0,	
yycrank+-32085,	yysvec+2527,	0,	
yycrank+-13405,	yysvec+3771,	0,	
yycrank+-13429,	yysvec+3858,	0,	
yycrank+-13419,	yysvec+3378,	0,	
yycrank+-32144,	0,		0,	
yycrank+-31669,	yysvec+3594,	0,	
yycrank+-13382,	yysvec+2753,	0,	
yycrank+-13431,	yysvec+2690,	0,	
yycrank+-8458,	yysvec+2561,	0,	
yycrank+-13434,	yysvec+2696,	0,	
yycrank+-8585,	yysvec+2564,	0,	
yycrank+-13453,	yysvec+3784,	0,	
yycrank+-13489,	yysvec+3869,	0,	
yycrank+-13423,	yysvec+3397,	0,	
yycrank+-32267,	0,		0,	
yycrank+-13435,	yysvec+2708,	0,	
yycrank+-8587,	yysvec+2573,	0,	
yycrank+-13457,	yysvec+3746,	0,	
yycrank+-13458,	yysvec+3837,	0,	
yycrank+-32390,	0,		0,	
yycrank+-13461,	yysvec+3222,	0,	
yycrank+-32513,	yysvec+2607,	0,	
yycrank+-13459,	yysvec+2527,	0,	
yycrank+-13462,	yysvec+3753,	yyvstop+1976,
yycrank+-13463,	yysvec+3843,	yyvstop+1978,
yycrank+-32540,	0,		yyvstop+1980,
yycrank+-13464,	yysvec+3230,	yyvstop+1982,
yycrank+-8634,	yysvec+2659,	yyvstop+1984,
yycrank+-13472,	yysvec+2535,	yyvstop+1986,
yycrank+-13466,	yysvec+3760,	0,	
yycrank+-13474,	yysvec+3849,	0,	
yycrank+-32663,	0,		0,	
yycrank+-13476,	yysvec+3240,	0,	
yycrank+-32786,	yysvec+3661,	0,	
yycrank+-32796,	yysvec+2803,	0,	
yycrank+-13446,	yysvec+2607,	0,	
yycrank+-32806,	yysvec+2527,	0,	
yycrank+-13477,	yysvec+3771,	0,	
yycrank+-13479,	yysvec+3858,	0,	
yycrank+-32886,	0,		0,	
yycrank+-13480,	yysvec+3252,	0,	
yycrank+-13481,	yysvec+2872,	0,	
yycrank+-13482,	yysvec+2753,	0,	
yycrank+-8727,	yysvec+2690,	0,	
yycrank+-13485,	yysvec+2561,	0,	
yycrank+-8746,	yysvec+2696,	0,	
yycrank+-13561,	yysvec+2564,	0,	
yycrank+-13483,	yysvec+3784,	0,	
yycrank+-13484,	yysvec+3869,	0,	
yycrank+-33009,	0,		0,	
yycrank+-13486,	yysvec+3268,	0,	
yycrank+-8906,	yysvec+2708,	0,	
yycrank+-13574,	yysvec+2573,	0,	
yycrank+-13428,	yysvec+3746,	0,	
yycrank+-13539,	yysvec+3837,	0,	
yycrank+-13488,	yysvec+3341,	0,	
yycrank+-13490,	yysvec+3222,	0,	
yycrank+-33132,	yysvec+2607,	0,	
yycrank+-13493,	yysvec+3753,	yyvstop+1988,
yycrank+-13543,	yysvec+3843,	yyvstop+1990,
yycrank+-13544,	yysvec+3351,	yyvstop+1992,
yycrank+-13556,	yysvec+3230,	yyvstop+1994,
yycrank+-13578,	yysvec+2659,	yyvstop+1996,
yycrank+-13610,	yysvec+3760,	0,	
yycrank+-13576,	yysvec+3849,	0,	
yycrank+-13546,	yysvec+3363,	0,	
yycrank+-13611,	yysvec+3240,	0,	
yycrank+-33142,	yysvec+2838,	0,	
yycrank+-33161,	yysvec+3030,	0,	
yycrank+-13581,	yysvec+2607,	0,	
yycrank+-13613,	yysvec+3771,	0,	
yycrank+-13577,	yysvec+3858,	0,	
yycrank+-13579,	yysvec+3378,	0,	
yycrank+-13614,	yysvec+3252,	0,	
yycrank+-13582,	yysvec+2872,	0,	
yycrank+-13440,	yysvec+2753,	0,	
yycrank+-13685,	yysvec+2690,	0,	
yycrank+-13687,	yysvec+2696,	0,	
yycrank+-13651,	yysvec+3784,	0,	
yycrank+-13658,	yysvec+3869,	0,	
yycrank+-13660,	yysvec+3397,	0,	
yycrank+-13664,	yysvec+3268,	0,	
yycrank+-13692,	yysvec+2708,	0,	
yycrank+-12843,	yysvec+3746,	0,	
yycrank+-13661,	yysvec+3837,	0,	
yycrank+-13665,	yysvec+3341,	0,	
yycrank+-13663,	yysvec+3222,	0,	
yycrank+-13671,	yysvec+3753,	yyvstop+1998,
yycrank+-13667,	yysvec+3843,	yyvstop+2000,
yycrank+-13666,	yysvec+3351,	yyvstop+2002,
yycrank+-13668,	yysvec+3230,	yyvstop+2004,
yycrank+-13676,	yysvec+3760,	0,	
yycrank+-13674,	yysvec+3849,	0,	
yycrank+-13677,	yysvec+3363,	0,	
yycrank+-13679,	yysvec+3240,	0,	
yycrank+-33231,	yysvec+3062,	0,	
yycrank+-33241,	yysvec+2527,	0,	
yycrank+-13678,	yysvec+3771,	0,	
yycrank+-13680,	yysvec+3858,	0,	
yycrank+-13690,	yysvec+3378,	0,	
yycrank+-13681,	yysvec+3252,	0,	
yycrank+-13696,	yysvec+2872,	0,	
yycrank+-8921,	yysvec+2753,	0,	
yycrank+-13694,	yysvec+3784,	0,	
yycrank+-13727,	yysvec+3869,	0,	
yycrank+-13697,	yysvec+3397,	0,	
yycrank+-13699,	yysvec+3268,	0,	
yycrank+-13708,	yysvec+3746,	0,	
yycrank+-13700,	yysvec+3837,	0,	
yycrank+-13702,	yysvec+3341,	0,	
yycrank+-13711,	yysvec+3222,	0,	
yycrank+-13713,	yysvec+3753,	yyvstop+2006,
yycrank+-13704,	yysvec+3843,	yyvstop+2008,
yycrank+-13707,	yysvec+3351,	yyvstop+2010,
yycrank+-13729,	yysvec+3230,	yyvstop+2012,
yycrank+-13762,	yysvec+3760,	0,	
yycrank+-13705,	yysvec+3849,	0,	
yycrank+-13746,	yysvec+3363,	0,	
yycrank+-13768,	yysvec+3240,	0,	
yycrank+-33251,	yysvec+2607,	0,	
yycrank+-33311,	yysvec+2527,	0,	
yycrank+-13809,	yysvec+3771,	0,	
yycrank+-13751,	yysvec+3858,	0,	
yycrank+-13747,	yysvec+3378,	0,	
yycrank+-13812,	yysvec+3252,	0,	
yycrank+-9063,	yysvec+2872,	0,	
yycrank+-13750,	yysvec+2753,	0,	
yycrank+-13813,	yysvec+3784,	0,	
yycrank+-13755,	yysvec+3869,	0,	
yycrank+-13753,	yysvec+3397,	0,	
yycrank+-13825,	yysvec+3268,	0,	
yycrank+-13819,	yysvec+3746,	0,	
yycrank+-13766,	yysvec+3837,	0,	
yycrank+-13830,	yysvec+3341,	0,	
yycrank+-13821,	yysvec+3222,	0,	
yycrank+-13822,	yysvec+3753,	yyvstop+2014,
yycrank+-13800,	yysvec+3843,	yyvstop+2016,
yycrank+-13834,	yysvec+3351,	yyvstop+2018,
yycrank+-13823,	yysvec+3230,	yyvstop+2020,
yycrank+-13835,	yysvec+3760,	0,	
yycrank+-13828,	yysvec+3849,	0,	
yycrank+-13846,	yysvec+3363,	0,	
yycrank+-13847,	yysvec+3240,	0,	
yycrank+-33321,	yysvec+2607,	0,	
yycrank+-13840,	yysvec+3771,	0,	
yycrank+-13844,	yysvec+3858,	0,	
yycrank+-13860,	yysvec+3378,	0,	
yycrank+-13857,	yysvec+3252,	0,	
yycrank+-13862,	yysvec+2872,	0,	
yycrank+-13854,	yysvec+3784,	0,	
yycrank+-13852,	yysvec+3869,	0,	
yycrank+-13874,	yysvec+3397,	0,	
yycrank+-13868,	yysvec+3268,	0,	
yycrank+-13869,	yysvec+3746,	0,	
yycrank+-13881,	yysvec+3837,	0,	
yycrank+-13870,	yysvec+3341,	0,	
yycrank+-13873,	yysvec+3222,	0,	
yycrank+-13872,	yysvec+3753,	yyvstop+2022,
yycrank+-13885,	yysvec+3843,	yyvstop+2024,
yycrank+-13878,	yysvec+3351,	yyvstop+2026,
yycrank+-13877,	yysvec+3230,	yyvstop+2028,
yycrank+-13888,	yysvec+3760,	0,	
yycrank+-13909,	yysvec+3849,	0,	
yycrank+-13882,	yysvec+3363,	0,	
yycrank+-13884,	yysvec+3240,	0,	
yycrank+-13891,	yysvec+3771,	0,	
yycrank+-13926,	yysvec+3858,	0,	
yycrank+-13886,	yysvec+3378,	0,	
yycrank+-13917,	yysvec+3252,	0,	
yycrank+-13925,	yysvec+3784,	0,	
yycrank+-13932,	yysvec+3869,	0,	
yycrank+-13921,	yysvec+3397,	0,	
yycrank+-13924,	yysvec+3268,	0,	
yycrank+-13837,	yysvec+3746,	0,	
yycrank+-13893,	yysvec+3837,	0,	
yycrank+-13955,	yysvec+3341,	0,	
yycrank+-13985,	yysvec+3222,	0,	
yycrank+-13957,	yysvec+3753,	yyvstop+2030,
yycrank+-13927,	yysvec+3843,	yyvstop+2032,
yycrank+-13989,	yysvec+3351,	yyvstop+2034,
yycrank+-14023,	yysvec+3230,	yyvstop+2036,
yycrank+-13991,	yysvec+3760,	0,	
yycrank+-14022,	yysvec+3849,	0,	
yycrank+-14027,	yysvec+3363,	0,	
yycrank+-14028,	yysvec+3240,	0,	
yycrank+-14026,	yysvec+3771,	0,	
yycrank+-14031,	yysvec+3858,	0,	
yycrank+-14032,	yysvec+3378,	0,	
yycrank+-14033,	yysvec+3252,	0,	
yycrank+-14034,	yysvec+3784,	0,	
yycrank+-14036,	yysvec+3869,	0,	
yycrank+-14035,	yysvec+3397,	0,	
yycrank+-14041,	yysvec+3268,	0,	
yycrank+-14040,	yysvec+3746,	0,	
yycrank+-14044,	yysvec+3837,	0,	
yycrank+-14043,	yysvec+3341,	0,	
yycrank+-31792,	yysvec+3922,	0,	
yycrank+-14046,	yysvec+3753,	yyvstop+2038,
yycrank+-14049,	yysvec+3843,	yyvstop+2040,
yycrank+-14050,	yysvec+3351,	yyvstop+2042,
yycrank+-31915,	yysvec+3928,	yyvstop+2044,
yycrank+-14051,	yysvec+3760,	0,	
yycrank+-14052,	yysvec+3849,	0,	
yycrank+-14055,	yysvec+3363,	0,	
yycrank+-32113,	yysvec+3934,	0,	
yycrank+-14060,	yysvec+3771,	0,	
yycrank+-14063,	yysvec+3858,	0,	
yycrank+-14067,	yysvec+3378,	0,	
yycrank+-32230,	yysvec+3942,	0,	
yycrank+-14070,	yysvec+3784,	0,	
yycrank+-14071,	yysvec+3869,	0,	
yycrank+-14069,	yysvec+3397,	0,	
yycrank+-32353,	yysvec+3952,	0,	
yycrank+-13492,	yysvec+3746,	0,	
yycrank+-14053,	yysvec+3837,	0,	
yycrank+-32626,	yysvec+3957,	0,	
yycrank+-14054,	yysvec+3222,	0,	
yycrank+-13879,	yysvec+3753,	yyvstop+2046,
yycrank+-14065,	yysvec+3843,	yyvstop+2048,
yycrank+-32850,	yysvec+3963,	yyvstop+2050,
yycrank+-14072,	yysvec+3230,	yyvstop+2052,
yycrank+-14037,	yysvec+3760,	0,	
yycrank+-14073,	yysvec+3849,	0,	
yycrank+-32972,	yysvec+3969,	0,	
yycrank+-14116,	yysvec+3240,	0,	
yycrank+-14114,	yysvec+3771,	0,	
yycrank+-14123,	yysvec+3858,	0,	
yycrank+-33348,	yysvec+3977,	0,	
yycrank+-14118,	yysvec+3252,	0,	
yycrank+-14125,	yysvec+3784,	0,	
yycrank+-14127,	yysvec+3869,	0,	
yycrank+-33375,	yysvec+3987,	0,	
yycrank+-14134,	yysvec+3268,	0,	
yycrank+-33497,	0,		0,	
yycrank+-14076,	yysvec+3837,	0,	
yycrank+-14136,	yysvec+3341,	0,	
yycrank+-14131,	yysvec+3222,	0,	
yycrank+-33620,	0,		yyvstop+2054,
yycrank+-14078,	yysvec+3843,	yyvstop+2056,
yycrank+-14174,	yysvec+3351,	yyvstop+2058,
yycrank+-14173,	yysvec+3230,	yyvstop+2060,
yycrank+-33743,	0,		0,	
yycrank+-14172,	yysvec+3849,	0,	
yycrank+-14176,	yysvec+3363,	0,	
yycrank+-14175,	yysvec+3240,	0,	
yycrank+-33866,	0,		0,	
yycrank+-14177,	yysvec+3858,	0,	
yycrank+-14178,	yysvec+3378,	0,	
yycrank+-14181,	yysvec+3252,	0,	
yycrank+-33989,	0,		0,	
yycrank+-14188,	yysvec+3869,	0,	
yycrank+-14183,	yysvec+3397,	0,	
yycrank+-14185,	yysvec+3268,	0,	
yycrank+-14139,	yysvec+3746,	0,	
yycrank+-14187,	yysvec+3837,	0,	
yycrank+-14189,	yysvec+3341,	0,	
yycrank+-14084,	yysvec+3222,	0,	
yycrank+-14190,	yysvec+3753,	yyvstop+2062,
yycrank+-14196,	yysvec+3843,	yyvstop+2064,
yycrank+-14199,	yysvec+3351,	yyvstop+2066,
yycrank+-14087,	yysvec+3230,	yyvstop+2068,
yycrank+-14201,	yysvec+3760,	0,	
yycrank+-14208,	yysvec+3849,	0,	
yycrank+-14203,	yysvec+3363,	0,	
yycrank+-14219,	yysvec+3240,	0,	
yycrank+-14210,	yysvec+3771,	0,	
yycrank+-14215,	yysvec+3858,	0,	
yycrank+-14278,	yysvec+3378,	0,	
yycrank+-14227,	yysvec+3252,	0,	
yycrank+-14274,	yysvec+3784,	0,	
yycrank+-14277,	yysvec+3869,	0,	
yycrank+-14279,	yysvec+3397,	0,	
yycrank+-14230,	yysvec+3268,	0,	
yycrank+-14192,	yysvec+3746,	0,	
yycrank+-34112,	0,		0,	
yycrank+-14233,	yysvec+3341,	0,	
yycrank+-9148,	yysvec+3222,	0,	
yycrank+-14193,	yysvec+3753,	yyvstop+2070,
yycrank+-34235,	0,		yyvstop+2072,
yycrank+-14234,	yysvec+3351,	yyvstop+2074,
yycrank+-9159,	yysvec+3230,	yyvstop+2076,
yycrank+-14194,	yysvec+3760,	0,	
yycrank+-34358,	0,		0,	
yycrank+-14235,	yysvec+3363,	0,	
yycrank+-9167,	yysvec+3240,	0,	
yycrank+-14222,	yysvec+3771,	0,	
yycrank+-34481,	0,		0,	
yycrank+-14260,	yysvec+3378,	0,	
yycrank+-9197,	yysvec+3252,	0,	
yycrank+-14226,	yysvec+3784,	0,	
yycrank+-34604,	0,		0,	
yycrank+-14271,	yysvec+3397,	0,	
yycrank+-9283,	yysvec+3268,	0,	
yycrank+-14228,	yysvec+3746,	0,	
yycrank+-14283,	yysvec+3837,	0,	
yycrank+-9632,	yysvec+3341,	0,	
yycrank+-14270,	yysvec+3222,	0,	
yycrank+-14354,	yysvec+3753,	yyvstop+2078,
yycrank+-14288,	yysvec+3843,	yyvstop+2080,
yycrank+-9654,	yysvec+3351,	yyvstop+2082,
yycrank+-14386,	yysvec+3230,	yyvstop+2084,
yycrank+-14363,	yysvec+3760,	0,	
yycrank+-14291,	yysvec+3849,	0,	
yycrank+-9661,	yysvec+3363,	0,	
yycrank+-14415,	yysvec+3240,	0,	
yycrank+-14364,	yysvec+3771,	0,	
yycrank+-14360,	yysvec+3858,	0,	
yycrank+-9667,	yysvec+3378,	0,	
yycrank+-14431,	yysvec+3252,	0,	
yycrank+-14367,	yysvec+3784,	0,	
yycrank+-14361,	yysvec+3869,	0,	
yycrank+-9678,	yysvec+3397,	0,	
yycrank+-14401,	yysvec+3268,	0,	
yycrank+-14379,	yysvec+3746,	0,	
yycrank+-14370,	yysvec+3837,	0,	
yycrank+-14404,	yysvec+3341,	0,	
yycrank+-14383,	yysvec+3753,	yyvstop+2086,
yycrank+-14378,	yysvec+3843,	yyvstop+2088,
yycrank+-14432,	yysvec+3351,	yyvstop+2090,
yycrank+-14426,	yysvec+3760,	0,	
yycrank+-14389,	yysvec+3849,	0,	
yycrank+-14447,	yysvec+3363,	0,	
yycrank+-14427,	yysvec+3771,	0,	
yycrank+-14402,	yysvec+3858,	0,	
yycrank+-14466,	yysvec+3378,	0,	
yycrank+-14438,	yysvec+3784,	0,	
yycrank+-14423,	yysvec+3869,	0,	
yycrank+-14463,	yysvec+3397,	0,	
yycrank+-14454,	yysvec+3746,	0,	
yycrank+-14440,	yysvec+3837,	0,	
yycrank+-14459,	yysvec+3753,	yyvstop+2092,
yycrank+-14449,	yysvec+3843,	yyvstop+2094,
yycrank+-14467,	yysvec+3760,	0,	
yycrank+-14473,	yysvec+3849,	0,	
yycrank+-14474,	yysvec+3771,	0,	
yycrank+-14476,	yysvec+3858,	0,	
yycrank+-14475,	yysvec+3784,	0,	
yycrank+-14480,	yysvec+3869,	0,	
yycrank+-14376,	yysvec+3746,	0,	
yycrank+-14487,	yysvec+3837,	0,	
yycrank+-14484,	yysvec+3753,	yyvstop+2096,
yycrank+-14491,	yysvec+3843,	yyvstop+2098,
yycrank+-14485,	yysvec+3760,	0,	
yycrank+-14493,	yysvec+3849,	0,	
yycrank+-14486,	yysvec+3771,	0,	
yycrank+-14500,	yysvec+3858,	0,	
yycrank+-14489,	yysvec+3784,	0,	
yycrank+-14505,	yysvec+3869,	0,	
yycrank+-14075,	yysvec+3746,	0,	
yycrank+-14509,	yysvec+3837,	0,	
yycrank+-14492,	yysvec+3753,	yyvstop+2100,
yycrank+-14518,	yysvec+3843,	yyvstop+2102,
yycrank+-14508,	yysvec+3760,	0,	
yycrank+-14521,	yysvec+3849,	0,	
yycrank+-14512,	yysvec+3771,	0,	
yycrank+-14522,	yysvec+3858,	0,	
yycrank+-14519,	yysvec+3784,	0,	
yycrank+-14524,	yysvec+3869,	0,	
yycrank+-33460,	yysvec+4171,	0,	
yycrank+-14494,	yysvec+3837,	0,	
yycrank+-33583,	yysvec+4175,	yyvstop+2104,
yycrank+-14526,	yysvec+3843,	yyvstop+2106,
yycrank+-33706,	yysvec+4179,	0,	
yycrank+-14530,	yysvec+3849,	0,	
yycrank+-33829,	yysvec+4183,	0,	
yycrank+-14537,	yysvec+3858,	0,	
yycrank+-33952,	yysvec+4187,	0,	
yycrank+-14539,	yysvec+3869,	0,	
yycrank+-14544,	yysvec+3746,	0,	
yycrank+-14529,	yysvec+3837,	0,	
yycrank+-14545,	yysvec+3753,	yyvstop+2108,
yycrank+-14543,	yysvec+3843,	yyvstop+2110,
yycrank+-14546,	yysvec+3760,	0,	
yycrank+-14547,	yysvec+3849,	0,	
yycrank+-14556,	yysvec+3771,	0,	
yycrank+-14589,	yysvec+3858,	0,	
yycrank+-14605,	yysvec+3784,	0,	
yycrank+-14597,	yysvec+3869,	0,	
yycrank+-14542,	yysvec+3746,	0,	
yycrank+-34075,	yysvec+4212,	0,	
yycrank+-14557,	yysvec+3753,	yyvstop+2112,
yycrank+-34198,	yysvec+4216,	yyvstop+2114,
yycrank+-14577,	yysvec+3760,	0,	
yycrank+-34321,	yysvec+4220,	0,	
yycrank+-14579,	yysvec+3771,	0,	
yycrank+-34444,	yysvec+4224,	0,	
yycrank+-14583,	yysvec+3784,	0,	
yycrank+-34567,	yysvec+4228,	0,	
yycrank+-14635,	yysvec+3746,	0,	
yycrank+-14617,	yysvec+3837,	0,	
yycrank+-14642,	yysvec+3753,	yyvstop+2116,
yycrank+-14624,	yysvec+3843,	yyvstop+2118,
yycrank+-14658,	yysvec+3760,	0,	
yycrank+-14637,	yysvec+3849,	0,	
yycrank+-14670,	yysvec+3771,	0,	
yycrank+-14641,	yysvec+3858,	0,	
yycrank+-14674,	yysvec+3784,	0,	
yycrank+-14644,	yysvec+3869,	0,	
yycrank+-9680,	yysvec+3746,	0,	
yycrank+-14603,	yysvec+3837,	0,	
yycrank+-9778,	yysvec+3753,	yyvstop+2120,
yycrank+-14628,	yysvec+3843,	yyvstop+2122,
yycrank+-9781,	yysvec+3760,	0,	
yycrank+-14629,	yysvec+3849,	0,	
yycrank+-9783,	yysvec+3771,	0,	
yycrank+-14675,	yysvec+3858,	0,	
yycrank+-9785,	yysvec+3784,	0,	
yycrank+-14704,	yysvec+3869,	0,	
yycrank+-14688,	yysvec+3746,	0,	
yycrank+-14678,	yysvec+3837,	0,	
yycrank+-14692,	yysvec+3753,	yyvstop+2124,
yycrank+-14682,	yysvec+3843,	yyvstop+2126,
yycrank+-14712,	yysvec+3760,	0,	
yycrank+-14691,	yysvec+3849,	0,	
yycrank+-14815,	yysvec+3771,	0,	
yycrank+-14709,	yysvec+3858,	0,	
yycrank+-14746,	yysvec+3784,	0,	
yycrank+-14716,	yysvec+3869,	0,	
yycrank+-9790,	yysvec+3837,	0,	
yycrank+-9794,	yysvec+3843,	yyvstop+2128,
yycrank+-9798,	yysvec+3849,	0,	
yycrank+-9895,	yysvec+3858,	0,	
yycrank+-9896,	yysvec+3869,	0,	
yycrank+-14811,	yysvec+3837,	0,	
yycrank+-14812,	yysvec+3843,	yyvstop+2130,
yycrank+-14825,	yysvec+3849,	0,	
yycrank+-14832,	yysvec+3858,	0,	
yycrank+-14822,	yysvec+3869,	0,	
0,	0,	0};
struct yywork *yytop = yycrank+34727;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,'#' ,01  ,01  ,'#' ,01  ,
01  ,')' ,01  ,01  ,',' ,01  ,'.' ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,';' ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,']' ,01  ,'_' ,
01  ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,
'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,
'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,'a' ,
'a' ,'a' ,'a' ,'{' ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,1,1,0,0,
0,0,0,0,0,0,0,0,
1,0,0,1,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/* #ident	"@(#)libl:lib/ncform	1.3" */
#ident	"$Header: /src_trees/lonestar/att/usr/src/lib/libl/RCS/ncform,v 1.5 1991/08/06 11:04:55 jfw Exp $"
int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
int yyback(int * p, int m) {
if (p==0) return(0);
while (*p)
	{
	if (*p++ == m)
		return(1);
	}
return(0);
}
	/* the following are only used in the lex library */
int yyinput(){
	return(input());
	}
void yyoutput(int c) {
	output(c);
	}
void yyunput(int c) {
	unput(c);
	}

int yylook(){
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}


